unit config;
interface

procedure LoadConfig;
procedure SaveConfig;

implementation
uses params,menu,dos,crt;

function SelectSlot(title:string;all:boolean):integer;
var MenuInfo:PMenuInfo;
    Choice:integer;
    DirInfo,MessDirInfo: SearchRec;
    old:text;
    line,iDummy,iBack:integer;
    description:string;
    Dir:char;
    dt : DateTime;
    yearb,dayb,monthb,hourb,minb,buf:string;
begin
  line:=0;
  choice:=-1;
  NewMenu(MenuInfo);
  repeat
    dir:=char(line+byte('A'));
    FindFirst(ConfigurationsDirectory+'\SLOT'+dir, Directory, DirInfo);
    if DosError = 0 then begin
      FindFirst(ConfigurationsDirectory+'\'+DirInfo.Name+'\Info.dat', AnyFile, MessDirInfo);
      if DosError = 0 then begin
        assign(old,ConfigurationsDirectory+'\'+DirInfo.Name+'\'+MessDirInfo.Name);
        reset(old);
        readln(old,description);
        close(old);
        UnpackTime(MessDirInfo.Time,dt);
        str(dt.Year:2,yearb);
        str(dt.Day:2,dayb);
        str(dt.Month:2,monthb);
        str(dt.Hour:2,hourb);
        str(dt.Min:2,minb);
        buf:=dayb+'.'+monthb+'.'+yearb+' '+hourb+':'+minb+' : '+description;
        AddChoice(stdtcolor,' ',stdtcolor,MenuInfo,buf,buf,dir,iDummy);
      end else AddChoice(stdtcolor,' ',stdtcolor,MenuInfo,'Error','Info.dat doesn''t exist',dir,iDummy);
      inc(line);
    end;
  until (DosError<>0) or (line>20);
  while (line<=20) and all do begin
    AddChoice(stdtcolor,' ',stdtcolor,MenuInfo,'Empty','Empty',char(byte('A')+line),iDummy);
    inc(Line);
  end;
  AddChoice(stdtcolor,' ',stdtcolor,MenuInfo,'Back                                                      [B]',
    'Back','B',iBack);
  DoMenu(MenuInfo,title,Choice);
  DeleteMenu(MenuInfo);
  if (choice<>iBack) and (Choice<>0) then SelectSlot:=Choice-1 else SelectSlot:=-1;
end;

procedure Title(t:string);
begin
  textBackground(blue);
  textcolor(yellow);
  clrscr;
  writeln('* ',t,' *');
  writeln;
end;


procedure LoadConfig;
var slot:integer;
    dir:char;
begin
  slot:=SelectSlot(' Load Configuration ',false);
  if slot>=0 then begin
    Title('Load Configuration');
    dir:=char(slot+byte('A'));
    Writeln('Loading Configuration from Slot '+dir+' ...');
    LoadParameters(ConfigurationsDirectory+'\Slot'+dir+'\');
  end;
end;

procedure SaveConfig;
var Slot:integer;
    Dir:char;
    description:string;
    out:text;
begin
  Slot:=SelectSlot(' Save Configuration ',true);
  if slot>=0 then begin
    Title('Save Configuration');
    write('Description : ');
    readln(description);
    writeln;
    dir:=char(slot+byte('A'));
    Writeln('Saving Configuration to Slot '+dir+' ...');
    {$I-}
    mkdir(ConfigurationsDirectory+'\Slot'+dir);
    SaveParameters(ConfigurationsDirectory+'\Slot'+dir+'\');
    assign(out,ConfigurationsDirectory+'\Slot'+dir+'\Info.dat');
    rewrite(out);
    writeln(out,description);
    system.close(out);
  end;
end;

end.