unit DDA06;

{ -------------------------------------------------------------------------- }
{ |                       DDA-06 Interface                                 | }
{ -------------------------------------------------------------------------- }

interface
const AIBICI=$9B;  {Control codes to Configer Ports A,B,C as Input or Output}
      AIBICO=$92;
      AIBOCI=$99;
      AIBOCO=$90;
      AOBICI=$8B;
      AOBICO=$82;
      AOBOCI=$89;
      AOBOCO=$80;

procedure DDA06initialize(InOut:byte);
procedure DDA06analogOut(Canal: byte; Value: word );    {canal: 0..5; valeur:0..4095}
Procedure DDA06digitalOut(canal:byte;Value:byte);       {canal: 0..2 }
Function DDA06digitalIn(canal:byte;bitNR:byte):boolean; {canal: 0..2, bitNr:0..7 }

implementation
uses Portlist;

const BaseAddrDDA06 = 768;    {&H300}

Var
   Chl,Val  : integer;                 {* channel and value to write *}
   HighByte, LowByte  : integer;       {* value converted into high/low byte *}

procedure DDA06analogOut(Canal: byte; Value: word );
var HighByte : byte;
    LowByte  : byte;
begin
  If (Canal >= 0) and (Canal < 6) and (Value >= 0) and (Value<4096) then
  Begin
    HighByte:= Value div 256;             {* Convert to high byte *}
    LowByte := Value and $FF;             {* Convert to low byte  *}
    if PortListRegister then begin
      PortListPort(BaseAddrDDA06+Canal*2,LowByte);
      PortListPort(BaseAddrDDA06+Canal*2+1,HighByte);
    end else begin
      Port[BaseAddrDDA06+Canal*2]:= LowByte;   {* Write to register    *}
      Port[BaseAddrDDA06+Canal*2+1]:= HighByte;{* Write for high byte  *}
    end;
  End else writeln('DDA6 : DDA6analogOut : range error channel:',canal,' value:',value);
end;

procedure DDA06initialize(InOut:byte);
begin
   Port[BaseAddrDDA06+$F] := InOut;
end; {DDA06initialize}

Procedure DDA06digitalOut(canal:byte;Value:byte);
begin
  if (canal>2) then writeln('DDA06.PAS: DDA06setbit : range error ',canal);
  if PortListRegister then begin
    PortListPort(BaseAddrDDA06+$C+canal,value);
  end else begin
    Port[BaseAddrDDA06+$C+canal] := Value;
  end;
end; {DDA06writeport}

Function DDA06digitalIn(canal:byte;bitNR:byte):boolean;
begin
   if (canal>2) or (bitNR>7) then writeln('DDA06.PAS: DDA06readport : range error channel:',canal,' bitNR:',bitNR);
   DDA06digitalIn := (Port[BaseAddrDDA06+$C+canal] and (1 shl bitNR))>0;            {* Lis un mot au port *}
end; {DDA06readport}

begin
  DDA06initialize(AOBOCO);
end.
