unit Exptest;

interface

procedure GenerateRectangle;
procedure TestSpeed;
procedure TestAnalogOut;
procedure AnalogOut2;
procedure TestDigitalOut;
procedure TestAnalogIn;
procedure TestDigitalIn;
procedure TestGPIB;
procedure InitExp;
procedure beep;

implementation
uses crt,IO,ExpIO,Params,IEEE;
var oldexitproc:pointer;


procedure TestAnalogOut;
var n:word;
    c:byte;
begin
  clrscr;
  n:=0;
  for c:=0 to MaxAnaOut-1 do begin
    writeln('Testing Analog Channel ',c);
    repeat
      IOanalogOutdirect(c,n);
      n:=n+16;
    until keypressed;
    while keypressed do readkey;
  end;
  writeln('Testing All Analog Channels');
  repeat
    for n:=0 to MaxAnaOut-1 do IOanalogOut(n,0);
    IOUpdate;
    for n:=0 to MaxAnaOut-1 do IOanalogOut(n,10000);
    IOUpdate;
  until keypressed;
  while keypressed do readkey;
end;

procedure AnalogOut2;
var n:word;
    c:byte;
begin
  clrscr;
  for n:=1 to 13 do begin
    IOanalogOutdirect(13,n*5000);
    writeln(n*5000);
    readln;
  end;
end;

procedure TestAnalogIn;
var n:word;
    c:byte;
begin
  clrscr;
  for c:=0 to MaxAnaIn-1 do begin
    writeln('Connect Analog Out 0 to Analog In ',c);
    writeln('Testing analog Input Channel ',c);
    repeat
      IOanalogOut(12,n);
      IOUpdate;
      n:=n+16;
      write(IOanalogIn(c),'         ');
      gotoxy(1,wherey);
    until keypressed;
    while keypressed do readkey;
  end;
end;


procedure testDigitalOut;
var n:word;
    b:byte;
begin
  clrscr;
  writeln('Testing Digital Channels');
  StartCounter;
  repeat
    for n:=0 to MaxDigOut-1 do for b:=0 to IOgetMaxOutBitNr(n)-1 do IOdigitalOut(n,b,true);
    Wait(2000);
    for n:=0 to MaxDigOut-1 do for b:=0 to IOgetMaxOutBitNr(n)-1 do IOdigitalOut(n,b,false);
    Wait(2000);
  until keypressed;
  while keypressed do readkey;
end;

procedure testDigitalIn;
var n:word;
    b:byte;
begin
  clrscr;
  writeln('Connect Digital Output Bits 0 or 1 Channel 0 to Input Channels');
  writeln('Testing Digital Input Channels');
  IOdigitalOutDirect(7,0,false);
  IOdigitalOutDirect(7,1,true);
  repeat
    write(IOdigitalIn(0,0):5,' ',IOdigitalIn(0,1):5,' ',IOdigitalIn(0,2):5,' ',IOdigitalIn(0,3):5);
    gotoxy(1,wherey);
  until keypressed;
end;


procedure testSpeed;
var n:word;
begin
  clrscr;
  writeln('Testing Speed of Digital Channels, DDA06');
  repeat
    IOdigitalOut(7,0,true);
    IOUpdate;
    IOdigitalOut(7,0,false);
    IOUpdate;
  until keypressed;
  while keypressed do readkey;
  writeln('Testing Speed of Digital Channels, DDA06 + DDA06');
  repeat
    IOdigitalOut(7,0,true);
    IOdigitalOut(8,0,true);
    IOUpdate;
    IOdigitalOut(7,0,false);
    IOdigitalOut(8,0,false);
    IOUpdate;
  until keypressed;
  while keypressed do readkey;
  writeln('Testing Speed of Digital Channels, DDA06 + MultiOut');
  repeat
    IOdigitalOut(7,0,true);
    IOdigitalOut(0,0,true);
    IOUpdate;
    IOdigitalOut(7,0,false);
    IOdigitalOut(0,0,false);
    IOUpdate;
  until keypressed;
  while keypressed do readkey;
  writeln('Testing Speed of Digital Channels, DDA06 + DAS1601');
  repeat
    IOdigitalOut(7,0,true);
    IOdigitalOut(6,0,true);
    IOUpdate;
    IOdigitalOut(7,0,false);
    IOdigitalOut(6,0,false);
    IOUpdate;
  until keypressed;
  while keypressed do readkey;
  writeln('Testing Speed of Analog Channels, DDA06 + MultiOut');
  repeat
    IOdigitalOut(7,0,true);
    IOanalogOut(0,0);
    IOUpdate;
    IOdigitalOut(7,0,false);
    IOanalogOut(0,1000);
    IOUpdate;
  until keypressed;
  while keypressed do readkey;
  writeln('Testing Speed of Analog Channels, DDA06 + DDA06');
  repeat
    IOdigitalOut(7,0,true);
    IOanalogOut(12,0);
    IOUpdate;
    IOdigitalOut(7,0,false);
    IOanalogOut(12,1000);
    IOUpdate;
  until keypressed;
  while keypressed do readkey;
  writeln('Testing Speed of Analog Channels, DDA06 + DAS1601');
  repeat
    IOdigitalOut(7,0,true);
    IOanalogOut(18,0);
    IOUpdate;
    IOdigitalOut(7,0,false);
    IOanalogOut(18,1000);
    IOUpdate;
  until keypressed;
  while keypressed do readkey;
end;


procedure GenerateRectangle;
var delay:double;
begin
{  delay:=500/frequency;
  startCounter;}
  repeat
    IOdigitalOutDirect(7,0,ON);
    {LaserOn;
    IOUpdate;}
    crt.Delay(1);
    {Wait(delay);}
    IOdigitalOutDirect(7,0,OFF);
    {LaserOff;
    IOUpdate;}
    crt.Delay(1);
    {Wait(delay);}
  until keypressed;
  while keypressed do readkey;
end;

procedure TestGPIB;
var status:integer;
begin
  clrscr;
  writeln('TestGPIB');
  IEEE.Initialize(21,0);
  startCounter;
  IEEE.Send(19,'FUNC 1',status);
  IEEE.Send(19,'FREQ 2345.678',status);
  Wait(5000);
  IEEE.Send(19,'FUNC 0',status);
  IEEE.Send(19,'FREQ 245.34',status);
end;

procedure Beep;
var n:integer;
begin
  for n:=500 to 1000 do begin
    sound(n);
    delay(1);
  end;
  nosound;
end;

procedure InitExp;
begin
  {everything that has to be initialised has to stand here}
  Beep;
end;

procedure CloseExp;
begin
  {everything that has to done to set the experiment in a stable state
   after the termination of the program has to be done here}

end;

procedure Myexitproc;far;
begin
  exitproc:=oldexitproc;
  CloseExp;
end;

begin
  oldexitproc:=exitproc;
  exitproc:=@myexitproc;
end.