unit HP8563A;
interface


type TTrace=record
              trace:array[1..601] of real;
              startfrequency:real;
              stopfrequency:real;
              referencelevel:real;
              resolutionbandwidth:real;
              videobandwidth:real;
              logarithmicscale:real;
            end;

procedure ReadTrace(adress:byte;var trace:TTrace);
procedure storeTrace(adress:word;name:string);

implementation
uses IEEE;

procedure IEEEGetReal(adress:word;name:string;var r:real);
var s:string;
    len:word;
    error,status:integer;
begin
  IEEE.Send(adress,name+'?',status);
  IEEE.Enter(s,50,len,adress,status);
  val(s,r,error);
end;

procedure ReadTrace(adress:byte;var trace:TTrace);
var h,s:string;
    n,len:word;
    code,status:integer;
    ende:boolean;
begin
  Initialize(21,0);
  with trace do begin
    IEEEGetReal(adress,'FA',startfrequency);
    IEEEGetReal(adress,'FB',stopfrequency);
    IEEEGetReal(adress,'RL',referencelevel);
    IEEEGetReal(adress,'RB',resolutionbandwidth);
    IEEEGetReal(adress,'VB',videobandwidth);
    IEEEGetReal(adress,'LG',logarithmicscale);
  end;
  IEEE.Send(adress,'TDF P;TRA?',status);
  n:=1;
  h:='';
  ende:=false;
  while not ende do begin
    IEEE.Enter(s,100,len,adress,status);
    h:=h+s;
    while pos(',',h)<>0 do begin
      s:=copy(h,1,pos(',',h)-1);
      val(s,trace.trace[n],code);
      inc(n);
      h:=copy(h,pos(',',h)+1,255);
    end;
    ende:=(len<100) or (n=601);
  end;
end;

procedure storeTrace(adress:word;name:string);
var trace:TTrace;
    out:text;
    n:word;
begin
  ReadTrace(adress,trace);
  assign(out,name);
  rewrite(out);
  with trace do begin
    writeln(out,'StartFrequency ',startfrequency);
    writeln(out,'StopFrequency ',stopfrequency);
    writeln(out,'ReferenceLevel ',referencelevel);
    writeln(out,'ResolutionBandwidth ',resolutionbandwidth);
    writeln(out,'VideoBandwidth ',videobandwidth);
    writeln(out,'logarithmicscale ',logarithmicscale);
    for n:=1 to 600 do writeln(out,trace[n]:6:6);
  end;
  close(out);
end;

end.