program Lithium;
{
  This is the main program. It contains only the menu structure.
}
uses crt,Menu,Params,Exp,IO,ExpIo,Vision;

procedure MenuParams1;
var InfoDialog   : tDialogInfo;
    UpdateDialog : boolean;
begin
  NewDialog(InfoDialog);
  AddT(InfoDialog,'Parameters 1');

  AddR(InfoDialog,AOM3Frequency,'AOM3 Frequency [MHz]','AOM3 has normally 194.43 MHz',130,250,1);
  AddR(InfoDialog,AOM6Frequency,'AOM6 Frequency [MHz]','AOM6 has normally  79.01 MHz',50,250,1);
  AddR(InfoDialog,AOM7Frequency,'AOM7 Frequency [MHz]','AOM7 has normally  79.01 MHz',50,250,1);
  AddR(InfoDialog,AOM8Frequency,'AOM8 Frequency [MHz]','AOM8 has normally  79.01 MHz',50,250,1);
  AddR(InfoDialog,AOM9Frequency,'AOM9 Frequency [MHz]','AOM9 has normally  79.01 MHz',50,250,1);

  AddR(InfoDialog,TrapPrincipalDetuning,'Trap Principal Detuning [MHz]','TrapPrincipalDetuning ? MHz',-100,0,1);
  AddR(InfoDialog,TrapRepumpDetuning,'Trap Repump Detuning [MHz]','TrapRepumpDetuning? MHz',-100,0,1);
  AddR(InfoDialog,TrapIntensity,'Trap Intensity [0..1]','TrapIntensity',0,1,1);
  AddR(InfoDialog,MolassePrincipalDetuning,'Molasse Principal Detuning [MHz]','MolassePrincipalDetuning ? MHz',-100,0,1);
  AddR(InfoDialog,MolasseRepumpDetuning,'Molasse Repump Detuning [MHz]','MolasseRepumpDetuning? MHz',-100,0,1);
  AddR(InfoDialog,MolasseTime,'Molasse Time [ms]','Molasse Time [ms]',0,100,1);
  AddR(InfoDialog,MolasseIntensity,'Molasse Intensity [0..1]','MolasseIntensity',0,1,1);
  AddR(InfoDialog,SlowerPrincipalDetuning,'Slower Principal Detuning [MHz]','SlowerPrincipalDetuning? MHz',-2000,0,1);
  AddR(InfoDialog,SlowerRepumpDetuning,'Slower Repump Detuning [MHz]','SlowerRepumpDetuning? MHz',-2000,0,1);

  BackupVars(InfoDialog);
  DoDialog(InfoDialog,'Parameters 1',UpdateDialog);
  SetTrapIntensity(TrapIntensity);
  SetAOMfrequencies;
end;

procedure MenuParams2;
var InfoDialog   : tDialogInfo;
    UpdateDialog : boolean;
    h:double;
begin
  NewDialog(InfoDialog);
  AddT(InfoDialog,'Parameters 2');

  AddR(InfoDialog,ProbeOffset,'Probe Offset [MHz]','Probe Offset? MHz',-100,100,1);
  AddR(InfoDialog,ProbePrincipalDetuning,'Detecion Principal Detuning [MHz]','ProbePrincipalDetuning? MHz',-100,100,1);
  AddR(InfoDialog,ProbeRepumpDetuning,'Detecion Repump Detuning [MHz]','ProbeRepumpDetuning? MHz',-100,100,1);
  AddR(InfoDialog,ChargingTime,'Charging time of trap [ms]','Charging time ? [ms]',0,100000,1);
  AddR(InfoDialog,DeChargingTime,'DeCharging time of trap [ms]','DeCharging time ? [ms]',0,100000,1);
  AddR(InfoDialog,ExpansionTime,'Expansion time of trap [ms]','Expansion time ? [ms]',0,100000,1);
  AddR(InfoDialog,ExposureTime,'Exposure time [ms]','Exposure time ? [ms]',0,100000,1);
  AddR(InfoDialog,Frequency,'Blink Frequency [Hz]','Blink Frequency',0.0001,10000,1);
  h:=LithiumIsotop;
  AddR(InfoDialog,h,'Mass of Lithium Isotope [amu]','Lithium 6 or 7',6,7,1);
  BackupVars(InfoDialog);
  DoDialog(InfoDialog,'Parameters 2',UpdateDialog);
  LithiumIsotop:=round(h);
  SetAOMfrequencies;
  VisionLithium(LithiumIsotop);
end;

procedure MenuTemperature;

  procedure TempParams;
  var InfoDialog   : tDialogInfo;
      UpdateDialog : boolean;
      h1,h2:double;
  begin
    NewDialog(InfoDialog);
    AddT(InfoDialog,'Temperature Measurement Parameters');
    AddR(InfoDialog,Tempt0,'start expansion time','start expansion time',0.1,100,1);
    AddR(InfoDialog,Tempdt,'delta t expansion time','delta t expansion time',0,100,1);
    h1:=Tempnt;
    h2:=Tempnr;
    AddR(InfoDialog,h1,'number of points','number of points',1,100,1);
    AddR(InfoDialog,h2,'number of repetitions','number of repetitions',1,100,1);
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'Temperature Measurement Parameters',UpdateDialog);
    Tempnt:=round(h1);
    Tempnr:=round(h2);
  end;

var MenuInfo   : tMenuInfo;
    iMain,iTemp,iParam,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(MenuInfo,'Temperature Measurement          [1]',
    'Temperature Measurement','1',iTemp);
  AddChoice(MenuInfo,'Parameters                       [2]',
    'Temperature Measurement Parameters','2',iParam);
  AddChoice(MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Temperature Measurement Menu ',Choice);
    if Choice=iTemp then TemperatureMeasurement
    else if Choice=iParam then TempParams;
  until (Choice=0) or (Choice=iMain);
end;

procedure MenuChargingTime;

  procedure ChargingTimeParams;
  var InfoDialog   : tDialogInfo;
      UpdateDialog : boolean;
      h1,h2:double;
  begin
    NewDialog(InfoDialog);
    AddT(InfoDialog,'Charging Time Measurement Parameters');
    AddR(InfoDialog,Chargingt0,'start (de)charging time','start charging time',0,10000,1);
    AddR(InfoDialog,Chargingdt,'delta t (de)charging time','delta t charging time',0,10000,1);
    h1:=Chargingnt;
    h2:=Chargingnr;
    AddR(InfoDialog,h1,'number of points','number of points',1,100,1);
    AddR(InfoDialog,h2,'number of repetitions','number of repetitions',1,100,1);
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'(De)Charging Time Measurement Parameters',UpdateDialog);
    Chargingnt:=round(h1);
    Chargingnr:=round(h2);
  end;

var MenuInfo   : tMenuInfo;
    iMain,iChargingTime,iDeChargingTime,iParam,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(MenuInfo,'Charging Time Measurement        [1]',
    'Charging Time Measurement','1',iChargingTime);
  AddChoice(MenuInfo,'Decharging Time Measurement      [2]',
    'Lifetime Measurement','2',iDeChargingTime);
  AddChoice(MenuInfo,'Parameters                       [3]',
    'Charging Time Parameters','3',iParam);
  AddChoice(MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' De/Charging Time Measurement Menu ',Choice);
    if Choice=iChargingTime then ChargingTimeMeasurement
    else if Choice=iDeChargingTime then DeChargingTimeMeasurement
    else if Choice=iParam then ChargingTimeParams;
  until (Choice=0) or (Choice=iMain);
end;

procedure MenuNumber;

  procedure NumbParams;
  var InfoDialog   : tDialogInfo;
      UpdateDialog : boolean;
      h1,h2:double;
  begin
    NewDialog(InfoDialog);
    AddT(InfoDialog,'Atom Number Measurement Parameters');
    AddR(InfoDialog,NumbDet0,'start probe detuning','start Detuning',-50,50,1);
    AddR(InfoDialog,NumbdDet,'delta detuning','delta detunig',0.001,100,1);
    h1:=Numbnt;
    h2:=Numbnr;
    AddR(InfoDialog,h1,'number of points','number of points',1,100,1);
    AddR(InfoDialog,h2,'number of repetitions','number of repetitions',1,100,1);
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'Temperature Measurement Parameters',UpdateDialog);
    Numbnt:=round(h1);
    Numbnr:=round(h2);
  end;

var MenuInfo   : tMenuInfo;
    iMain,iNumb,iParam,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(MenuInfo,'Atom Number Measurement          [1]',
    'Atom Number Measurement','1',iNumb);
  AddChoice(MenuInfo,'Parameters                       [2]',
    'Atom Number Measurement Parameters','2',iParam);
  AddChoice(MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Atom Number Measurement Menu ',Choice);
    if Choice=iNumb then NumberMeasurement
    else if Choice=iParam then NumbParams;
  until (Choice=0) or (Choice=iMain);
end;

procedure Menu2DSweepMeasurement;

  procedure Sweep2DMeasureParams;
  var InfoDialog   : tDialogInfo;
      UpdateDialog : boolean;
      h1,h2,h3:double;
  begin
    NewDialog(InfoDialog);
    AddT(InfoDialog,'2D Sweep Measurement Parameters');
    AddR(InfoDialog,Sweep2DDet0T,'trap start  detuning','trap start Detuning',-50,50,1);
    AddR(InfoDialog,Sweep2DdDetT,'trap delta detuning','trap delta detunig',0.001,100,1);
    h1:=Sweep2DntT;
    AddR(InfoDialog,h1,'Trap Number of points','trap number of points',1,100,1);
    AddR(InfoDialog,Sweep2DDet0S,'slower start  detuning','slower start Detuning',-50,50,1);
    AddR(InfoDialog,Sweep2DdDetS,'slower delta detuning','slower delta detunig',0.001,100,1);
    h2:=Sweep2DntS;
    AddR(InfoDialog,h2,'slower Number of points','slower number of points',1,100,1);
    h3:=Sweep2Dnr;
    AddR(InfoDialog,h3,'number of repetitions','number of repetitions',1,100,1);
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'2D Sweep Measurement Parameters',UpdateDialog);
    Sweep2DntT:=round(h1);
    Sweep2DntS:=round(h2);
    Sweep2Dnr:=round(h3);
  end;

var MenuInfo   : tMenuInfo;
    iMain,iNumb,iParam,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(MenuInfo,'Sweep 2D Measurement             [1]',
    'Sweep 2D Measurement','1',iNumb);
  AddChoice(MenuInfo,'Parameters                       [2]',
    'Sweep 2D Measurement Parameters','2',iParam);
  AddChoice(MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Sweep 2D Measurement Menu ',Choice);
    if Choice=iNumb then Sweep2DMeasurement
    else if Choice=iParam then Sweep2DMeasureParams;
  until (Choice=0) or (Choice=iMain);
end;

procedure MenuSweepMeasurement;

  procedure SweepMeasureParams;
  var InfoDialog   : tDialogInfo;
      UpdateDialog : boolean;
      h1,h2:double;
  begin
    NewDialog(InfoDialog);
    AddT(InfoDialog,'Sweep Measurement Parameters');
    AddR(InfoDialog,SweepDet0,'start Detuning','start Detuning',-100,100,1);
    AddR(InfoDialog,SweepdDet,'delta Detuning','delta Detuning',0,100,1);
    h1:=Sweepnt;
    h2:=Sweepnr;
    AddR(InfoDialog,h1,'number of points','number of points',1,100,1);
    AddR(InfoDialog,h2,'number of repetitions','number of repetitions',1,100,1);
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'Sweep Measurement Parameters',UpdateDialog);
    Sweepnt:=round(h1);
    Sweepnr:=round(h2);
  end;

var MenuInfo   : tMenuInfo;
    iMain,iTPD,iTRD,iSRD,iSPD,iTD,iSD,iParam,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(MenuInfo,'Trap Detuning                    [1]',
    'Sweep Trap Detuning','1',iTD);
  AddChoice(MenuInfo,'Trap Principal Detuning          [2]',
    'Sweep Trap Principal Detuning','2',iTPD);
  AddChoice(MenuInfo,'Trap Repump Detuning             [3]',
    'Sweep Trap Repump Detuning','3',iTRD);
  AddChoice(MenuInfo,'Slower Detuning                  [4]',
    'Sweep Slower Detuning','4',iSD);
  AddChoice(MenuInfo,'Slower Principal Detuning        [5]',
    'Sweep Slower Principal Detuning','5',iSPD);
  AddChoice(MenuInfo,'Slower Repump Detuning           [6]',
    'Sweep Slower Repump Detuning','6',iSRD);
  AddChoice(MenuInfo,'Sweep Measurement Parameters     [P]',
    'Sweep Measurement Parameters','P',iParam);
  AddChoice(MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Sweep Measurement Menu ',Choice);
    case Choice of
      1:SweepMeasurement([1,2]);
      2:SweepMeasurement([1]);
      3:SweepMeasurement([2]);
      4:SweepMeasurement([3,4]);
      5:SweepMeasurement([3]);
      6:SweepMeasurement([4]);
    end;
    if Choice=iParam then SweepMeasureParams;
  until (Choice=0) or (Choice=iMain);
end;

procedure MenuMeasure;
var MenuInfo   : tMenuInfo;
    iMain,iTemp,iNumb,iBig,iSweep,i2DSweep,iCharging,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(MenuInfo,'Temperature measurement          [T]',
    'Measures the temperature','T',iTemp);
  AddChoice(MenuInfo,'Atom number measurement          [N]',
    'Measures the particle number','N',iNumb);
  AddChoice(MenuInfo,'Charging time measurement        [C]',
    'Charging time measurement','C',iCharging);
  AddChoice(MenuInfo,'Frequency sweep measurement      [S]',
    'Frequency sweep measurement','S',iSweep);
  AddChoice(MenuInfo,'2D Frequency sweep measurement   [2]',
    '2D Frequency sweep measurement','2',i2DSweep);
  AddChoice(MenuInfo,'Test Big Measurement             [B]',
    'Big Measure','B',iBig);
  AddChoice(MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Temperature Measurement Menu ',Choice);
    if Choice=iTemp then MenuTemperature
    else if Choice=iNumb then MenuNumber
    else if Choice=iBig then BigMeasurement
    else if Choice=iCharging then MenuChargingTime
    else if Choice=iSweep then MenuSweepMeasurement
    else if Choice=i2DSweep then Menu2DSweepMeasurement;
  until (Choice=0) or (Choice=iMain);
end;

procedure MenuSweep;
var MenuInfo   : tMenuInfo;
    iMain,iTPD,iTRD,iSRD,iSPD,iTD,iSD,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(MenuInfo,'Trap Detuning                    [1]',
    'Sweep Trap Detuning','1',iTD);
  AddChoice(MenuInfo,'Trap Principal Detuning          [2]',
    'Sweep Trap Principal Detuning','2',iTPD);
  AddChoice(MenuInfo,'Trap Repump Detuning             [3]',
    'Sweep Trap Repump Detuning','3',iTRD);
  AddChoice(MenuInfo,'Slower Detuning                  [4]',
    'Sweep Slower Detuning','4',iSD);
  AddChoice(MenuInfo,'Slower Principal Detuning        [5]',
    'Sweep Slower Principal Detuning','5',iSPD);
  AddChoice(MenuInfo,'Slower Repump Detuning           [6]',
    'Sweep Slower Repump Detuning','6',iSRD);
  AddChoice(MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Sweep Menu ',Choice);
    case Choice of
      1:SweepDetuning([1,2]);
      2:SweepDetuning([1]);
      3:SweepDetuning([2]);
      4:SweepDetuning([3,4]);
      5:SweepDetuning([3]);
      6:SweepDetuning([4]);
    end;
  until (Choice=0) or (Choice=iMain);
end;

procedure DisplayFrequencies;
Var
  iTPD,iTRD,iSRD,iSPD,iDPD,iDRD,
  iFrequAOM4,iFrequAOM5,iFrequAOM3,iFrequAOM8,iFrequAOM7,iFrequAOM6,
  iFrequAOM1,iFrequAOM2,iQuit,Dummy:integer;
  MenuInfo:tMenuInfo;
  Choice:integer;
  Rep:char;
  buf:string;
begin
  NewMenu(MenuInfo);
  AddChoice(MenuInfo,'Main Menu                      [M]',
    'Exit the program','M',iQuit);
  AddText(MenuInfo,
    '',Dummy);
  AddText(MenuInfo,'',iFrequAOM1);
  AddText(MenuInfo,'',iFrequAOM2);
  AddText(MenuInfo,'',iFrequAOM3);
  AddText(MenuInfo,'',iFrequAOM4);
  AddText(MenuInfo,'',iFrequAOM5);
  AddText(MenuInfo,'',iFrequAOM6);
  AddText(MenuInfo,'',iFrequAOM7);
  AddText(MenuInfo,'',iFrequAOM8);
  AddText(MenuInfo,
    '',Dummy);
  AddText(MenuInfo,'',iTPD);
  AddText(MenuInfo,'',iTRD);
  AddText(MenuInfo,'',iDPD);
  AddText(MenuInfo,'',iDRD);
  AddText(MenuInfo,'',iSPD);
  AddText(MenuInfo,'',iSRD);
  AddText(MenuInfo,
    '',Dummy);
  repeat
    with MenuInfo do begin
      str(AOM4frequency:5:2,buf);
      Desc[iFrequAOM4]:='AOM4 Frequency : '+buf+' MHz';
      str(AOM5frequency:5:2,buf);
      Desc[iFrequAOM5]:='AOM5 Frequency : '+buf+' MHz';
      str(AOM6frequency:5:2,buf);
      Desc[iFrequAOM6]:='AOM6 Frequency : '+buf+' MHz';
      str(AOM7frequency:5:2,buf);
      Desc[iFrequAOM7]:='AOM7 Frequency : '+buf+' MHz';
      str(AOM8frequency:5:2,buf);
      Desc[iFrequAOM8]:='AOM8 Frequency : '+buf+' MHz';
      str(AOM1frequency:5:2,buf);
      Desc[iFrequAOM1]:='AOM1 Frequency : '+buf+' MHz';
      str(AOM2frequency:5:2,buf);
      Desc[iFrequAOM2]:='AOM2 Frequency : '+buf+' MHz';
      str(AOM3frequency:5:2,buf);
      Desc[iFrequAOM3]:='AOM3 Frequency : '+buf+' MHz';

      str(TrapPrincipalDetuning:6:2,buf);
      Desc[iTPD]:='Trap Principal Detuning  : '+buf+' MHz';
      str(TrapRepumpDetuning:6:2,buf);
      Desc[iTRD]:='Trap Repump Detuning     : '+buf+' MHz';
      str(ProbePrincipalDetuning:6:2,buf);
      Desc[iDPD]:='Probe Principal Detuning : '+buf+' MHz';
      str(ProbeRepumpDetuning:6:2,buf);
      Desc[iDRD]:='Probe Repump Detuning    : '+buf+' MHz';
      str(SlowerPrincipalDetuning:6:2,buf);
      Desc[iSPD]:='Slower Principal Detuning: '+buf+' MHz';
      str(SlowerRepumpDetuning:6:2,buf);
      Desc[iSRD]:='Slower Repump Detuning   : '+buf+' MHz';
    end;
    DoMenu(MenuInfo,' Frequency Display ',Choice);
  until (Choice=0) or (Choice=iQuit);
end;

procedure MainMenu;
Var
  iTPD,iTRD,iSRD,iSPD,iDPD,iDRD,iGen,iFrequ,iSetAOM,iDetOn,iDetOff,
  iFrequAOM4,iFrequAOM5,iFrequAOM3,iFrequAOM6,iFrequAOM1,iFrequAOM2,
  iParam1,iParam2,iDispFrequ,iAOM,iAOM4,iAOM5,iQuit,iTemp,iSweep,
  iChargeDetectTrap,iCalibrateVCO,iRecapture,iAbs,iMess,iCalProbe,
  iInit,Dummy:integer;
  MenuInfo:tMenuInfo;
  Choice:integer;
  Rep:char;
  buf:string;
begin
  NewMenu(MenuInfo);
  AddChoice(MenuInfo,'Measurements                   [0]',
    'Measurements','0',iMess);
  AddChoice(MenuInfo,'Probe on                       [1]',
    'Set AOM frequencys','1',iDetOn);
  AddChoice(MenuInfo,'Probe off                      [2]',
    'Set AOM frequencys','2',iDetOff);
  AddChoice(MenuInfo,'Sweep frequencies              [3]',
    'Sweeps AOM frequencys','3',iSweep);
  AddChoice(MenuInfo,'Blinking AOMs                  [4]',
    'Blinking AOMs','4',iGen);
{  AddChoice(MenuInfo,'Charge and detect trap         [5]',
    'Charge and detect trap','5',iChargeDetectTrap);
  AddChoice(MenuInfo,'Charge and recapture trap      [6]',
    'Charge and recapture trap','6',iRecapture);}
  AddChoice(MenuInfo,'Calibrate Probe                [5]',
    'Calibrate Probe','5',iCalProbe);
  AddChoice(MenuInfo,'Setup Parameters 1             [6]',
    'The parameter submenu 1','6',iParam1);
  AddChoice(MenuInfo,'Setup Parameters 2             [7]',
    'The parameter submenu 2','7',iParam2);
  AddChoice(MenuInfo,'Display AOM frequencies        [8]',
    'Shows the calculated frequencies','8',iDispfrequ);
  AddChoice(MenuInfo,'Calibrate VCO                  [9]',
    'Utility to calibrate an VCO','9',iCalibrateVCO);
  AddChoice(MenuInfo,'Take Absorption Picture        [P]',
    'Takes absorption pictures','P',iAbs);
  AddChoice(MenuInfo,'Initialize System              [I]',
    'Initialize System','I',iInit);
  AddChoice(MenuInfo,'Quit                           [Q]',
    'Exit the program','Q',iQuit);
  AddText(MenuInfo,
    '',Dummy);
  AddText(MenuInfo,'',iTPD);
  AddText(MenuInfo,'',iTRD);
  AddText(MenuInfo,'',iDPD);
  AddText(MenuInfo,'',iDRD);
  AddText(MenuInfo,'',iSPD);
  AddText(MenuInfo,'',iSRD);
  AddText(MenuInfo,
    '',Dummy);
  repeat
    with MenuInfo do begin
      str(TrapPrincipalDetuning:6:2,buf);
      Desc[iTPD]:='Trap Principal Detuning  : '+buf+' MHz';
      str(TrapRepumpDetuning:6:2,buf);
      Desc[iTRD]:='Trap Repump Detuning     : '+buf+' MHz';
      str(ProbePrincipalDetuning:6:2,buf);
      Desc[iDPD]:='Probe Principal Detuning : '+buf+' MHz';
      str(ProbeRepumpDetuning:6:2,buf);
      Desc[iDRD]:='Probe Repump Detuning    : '+buf+' MHz';
      str(SlowerPrincipalDetuning:6:2,buf);
      Desc[iSPD]:='Slower Principal Detuning: '+buf+' MHz';
      str(SlowerRepumpDetuning:6:2,buf);
      Desc[iSRD]:='Slower Repump Detuning   : '+buf+' MHz';
    end;
    DoMenu(MenuInfo,' Main Menu ',Choice);
    if Choice=iGen        then GenerateRectangle
    else if Choice=iParam1 then MenuParams1
    else if Choice=iParam2 then MenuParams2
    else if Choice=iCalProbe then CalibrateProbe
    else if Choice=iMess then MenuMeasure
    else if Choice=iDispFrequ then DisplayFrequencies
    else if Choice=iDetOn then SwitchProbeBeam(on)
    else if Choice=iDetOff then SwitchProbeBeam(off)
    else if Choice=iSweep then MenuSweep
    else if Choice=iAbs then TakeAbsorptionPicture
    else if Choice=iCalibrateVCO then CalibrateVCO
    else if Choice=iInit then begin InitCards;InitExp; end
    else if (Choice=0) or (Choice=iQuit) then begin
      WriteMessage('ATTENTION','Really quit?||(O,Y/N)');
      Rep:=UpCase(ReadKey);
      if (Rep <> 'Y') and (Rep<>'O') then Choice:=-1 else Choice:=0;
    end;
  until Choice=0;
end;

begin
  InitExp;
  SetAOMfrequency(9,90);
  SetAOMfrequency(2,230);
  SetAOMfrequency(10,80);
  IOupdate;
  MainMenu;
end.