unit MagTrap;
interface
uses IO,Params,Sequence,ExpIO,Exp,crt,timing,debug,exponent;

type TDoubleArgProc=procedure(y:double);

procedure PrepareOpticalPumping;
procedure OpticalPumping;
procedure MagneticTrap;
procedure LastMillisecondExperiments;
procedure InitMagTrap;
procedure SwitchIGBTsToMOT;
procedure SwitchIGBTsOff;
procedure SwitchIGBTsToIoffe;
procedure SwitchIGBTsToMagTrap;
procedure SwitchTrapOff;
procedure SwitchMagTrapCompletelyOff;
procedure SwitchMagTrapSlowlyCompletelyOff;
procedure ChangeIoffeTrap(aBarCurrent:double;aPinchCurrent:double;
    aCompCurrent:double;aPinchOffsetCurrent:double;RampTime:double);
procedure PrepareSmoothMicroWaveSweep(nr:byte);
procedure PrepareRFPulsSequence(Sequencenr:byte);
procedure ExecuteRFPulsSequence(SequenceNr:byte;LastMillisecondExperiment:boolean);
procedure SendCommandToVCORFSweep;
procedure ExecuteVCORFSweep;
procedure Ramp(proc:TDoubleArgProc;start:double;stop:double;time:double;AktCommandTime:double);
function ScaleHorizontalNdYagIntensity(h:double):double;
function ScaleVerticalNdYagIntensity(h:double):double;

implementation
uses RFSweep,SigGen,Pulsgen;

const commandtime=0.2;

procedure SwitchIGBTsToMOT;
begin
  SwitchIGBT(1,on);
  SwitchIGBT(2,off);
  SwitchIGBT(3,on);
  SwitchIGBT(4,off);
  SwitchIGBT(5,off);
  SwitchIGBT(6,on);
  SwitchIGBT(7,off);
  SwitchIGBT(8,off);
  SwitchIGBT(9,off);
  SwitchIGBT(10,off);
end;

procedure SwitchIGBTsToMagTrap;
begin
  SwitchIGBT(1,off);
  SwitchIGBT(2,off);
  SwitchIGBT(3,off);
  SwitchIGBT(4,off);
  SwitchIGBT(5,off);
  SwitchIGBT(6,on);
  SwitchIGBT(7,off);
  SwitchIGBT(8,off);
  SwitchIGBT(9,off);
  SwitchIGBT(10,off);
end;

procedure SwitchIGBTsToTransfer;

begin
  SwitchIGBT(1,on);
  SwitchIGBT(2,off);
  SwitchIGBT(3,on);
  SwitchIGBT(4,off);
  SwitchIGBT(5,off);
  SwitchIGBT(6,on);
  SwitchIGBT(7,off);
  SwitchIGBT(8,off);
  SwitchIGBT(9,off);
  SwitchIGBT(10,off);
end;

procedure SwitchIGBTsToPumping;
begin
  SwitchIGBT(1,off);
  SwitchIGBT(2,off);
  SwitchIGBT(3,off);
  SwitchIGBT(4,off);
  SwitchIGBT(5,off);
  SwitchIGBT(6,off);
  SwitchIGBT(7,off);
  SwitchIGBT(8,off);
  SwitchIGBT(9,off);
  SwitchIGBT(10,off);
end;

procedure SwitchIGBTsOff;
begin
  SwitchIGBT(1,off);
  SwitchIGBT(2,off);
  SwitchIGBT(3,off);
  SwitchIGBT(4,off);
  SwitchIGBT(5,off);
  SwitchIGBT(6,off);
  SwitchIGBT(7,off);
  SwitchIGBT(8,off);
  SwitchIGBT(9,off);
  SwitchIGBT(10,off);
end;

procedure SwitchIGBTsToIoffe;
begin
  SwitchIGBT(1,off);
  SwitchIGBT(2,on);
  SwitchIGBT(3,off);
  SwitchIGBT(4,on);
  SwitchIGBT(5,on);
  SwitchIGBT(6,off);
  SwitchIGBT(7,on);
  SwitchIGBT(8,on);
  SwitchIGBT(9,off);
  SwitchIGBT(10,off);
end;

Type TTrapOffMode=(Normal,Ioffe,CompensatedIoffe,FeshbachPinch,FeshbachComp);
const TrapOffMode:TTrapOffMode=Normal;

procedure SwitchTrapOff;
begin
  case TrapOffMode of
    Normal:begin
      if not PictureWithAxialConfinementOn then SwitchIGBT(4,off);
      if not PictureWithAxialConfinementOn then begin
        SwitchIGBT(5,off);
        SwitchIGBT(10,off);
      end;
    end;
    Ioffe:begin
      if not PictureWithAxialConfinementOn then SwitchIGBT(4,off);
      if not PictureWithAxialConfinementOn then begin
        SwitchIGBT(5,off);
        SwitchIGBT(10,off);
      end;
    end;
    CompensatedIoffe:begin
      if not PictureWithAxialConfinementOn then begin
        SwitchIGBT(5,off);
        SwitchIGBT(10,off);
      end;
      {if not PictureWithAxialConfinementOn then SwitchIGBT(4,off);}
    end;
    FeshbachComp:begin
      SwitchIGBT(2,off);
      Wait(0.8);
      SwitchIGBT(9,off);
    end;
    FeshbachPinch:begin
      SwitchIGBT(4,off);
      {Wait(0.8);
      SwitchIGBT(5,off);}
      SwitchIGBT(10,off);
    end;
  end;
  if not PictureWithAxialConfinementOn then SwitchIGBT(2,off);
  SwitchIGBT(1,off);
  SwitchIGBT(3,off);
  SwitchIGBT(6,off);
  SwitchIGBT(7,off);
  if not PictureWithRadialConfinementOn then SwitchIGBT(8,off);
  SwitchIGBT(9,off);
  if DoAxialGradient then SwitchAxialGradient(off);
end;

procedure InitMagTrap;
begin
  TrapOffMode:=Normal;
  SwitchIGBTsToMOT;
  SwitchOpticalPumpingField(off);
  SwitchOpticalPumpingBeam(off);
  SwitchTransferDecharging(off);
  SwitchMOTDecharging(off);
  IOUpdate;
  SetMOTCurrent(MOTMOTCurrent);
  SetMOTVoltage(MOTMOTVoltage);
  SetTransfer1Current(MaxTransfer1Current);
  SetTransfer2Voltage(MOTTransfer2Voltage);
  SetTransfer1Voltage(0);
  SetBarsCurrent(MaxBarCurrent);
  SetBarsVoltage(0);
  IOUpdate;
end;

procedure Ramp(proc:TDoubleArgProc;start:double;stop:double;time:double;AktCommandTime:double);
var n,maxn:longint;
    resttime:double;
begin
  if time=0 then begin
    proc(stop);
    exit;
  end;
  maxn:=trunc(time/Aktcommandtime);
  resttime:=time-(maxn*Aktcommandtime);
  if (resttime<0.1) then begin
    maxn:=maxn-1;
    resttime:=Time-(maxn*Aktcommandtime);
  end;
  if maxn<1 then writeln('Error : MagTrap : ramp : time too short ',time:2:3);
  Wait(110*ID+1);
  for n:=1 to maxn do begin
    proc(n/maxn*(stop-start)+start);
    Wait(111*ID+Aktcommandtime);
  end;
  Wait(112*ID+resttime);
end;


procedure RampCornerLess(proc:TDoubleArgProc;start:double;stop:double;cornerconst:double;time:double;AktCommandTime:double);
var n,maxn:longint;
    resttime:double;
    m:longint;

begin
  if time=0 then begin
    proc(stop);
    exit;
  end;
  maxn:=trunc(time/Aktcommandtime);
  resttime:=time-(maxn*Aktcommandtime);
  if (resttime<0.1) then begin
    maxn:=maxn-1;
    resttime:=Time-(maxn*Aktcommandtime);
  end;
  if maxn<1 then writeln('Error : MagTrap : ramp : time too short ',time:2:3);
  Wait(110*ID+1);
  for n:=1 to maxn do begin
    proc( start + (stop-start)*(1/(1-Exponential(-cornerconst)))*(1-Exponential(-cornerconst*n/maxn)));
    Wait(111*ID+Aktcommandtime);
  end;

  Wait(112*ID+resttime);
end;


procedure CleanMagTrap;far;
var initMOTVoltage:double;
begin
  FinalTrap:='Cleaned MagTrap';
  AtomPath:=AtomPath+'Cl';
  SequenceStartBlockNoArg(CleanMagTrap);
  initMOTVoltage:=aktMOTVoltage;
  Ramp(SetMOTVoltage,initMOTVoltage,CleaningVoltage1,CleaningSweepTime,0.2);
  Wait(113*ID+CleaningTime1);
  if CleaningTime2=0 then begin
    Ramp(SetMOTVoltage,CleaningVoltage1,initMOTVoltage,CleaningSweepTime,0.2);
  end else begin
    Ramp(SetMOTVoltage,CleaningVoltage1,CleaningVoltage2,CleaningSweepTime,0.2);
    Wait(114*ID+CleaningTime2);
    Ramp(SetMOTVoltage,CleaningVoltage2,initMOTVoltage,CleaningSweepTime,0.2);
  end;
  SequenceEndBlock;
end;

  procedure CompressMagTrap;far;
  var n,maxn:longint;
      resttime:double;
  begin
    if CompressMagTrapTime>0 then begin
      FinalTrap:='Compressed MagTrap';
      AtomPath:=AtomPath+'Co';
      Wait(115*ID+1);
      SequenceStartBlockNoArg(CompressMagTrap);
        maxn:=trunc(CompressMagTrapTime/commandtime);
        resttime:=CompressMagTrapTime-(maxn*commandtime);
        if (resttime<0.1) then begin
          maxn:=maxn-1;
          resttime:=CompressMagTrapTime-(maxn*commandtime);
        end;
        if maxn<1 then writeln('Error : MagTrap : MagneticTrap : Magnetic trap compression time too short');
        for n:=1 to maxn do begin
          SetMOTVoltage(n/maxn*(MagTrapMOTVoltageCompressed-MagTrapMOTVoltage)+MagTrapMOTVoltage);
          Wait(116*ID+commandtime);
        end;
        Wait(117*ID+resttime);
      SequenceEndBlock;
    end;
  end;

  procedure DeCompressMagTrap;far;
  var n,maxn:longint;
      resttime:double;
  begin
    FinalTrap:='decompressed MagTrap';
    AtomPath:=AtomPath+'D';
    SequenceStartBlockNoArg(DeCompressMagTrap);
      Wait(118*ID+1);
      if CompressMagTrapTime>0 then begin
        maxn:=trunc(DeCompressMagTrapTime/commandtime);
        resttime:=DeCompressMagTrapTime-(maxn*commandtime);
        if (resttime<0.1) then begin
          maxn:=maxn-1;
          resttime:=DeCompressMagTrapTime-(maxn*commandtime);
        end;
        if maxn<1 then writeln('Error : MagTrap : MagneticTrap : Magnetic trap compression time too short');
        for n:=1 to maxn do begin
          SetMOTVoltage(n/maxn*(MagTrapMOTVoltageDeCompressed-MagTrapMOTVoltageCompressed)+MagTrapMOTVoltageCompressed);
          Wait(119*ID+commandtime);
        end;
        Wait(120*ID+resttime);
      end;
    SequenceEndBlock;
  end;

  procedure ReCompressMagTrap;far;
  var n,maxn:longint;
      resttime:double;
  begin
    SequenceStartBlockNoArg(ReCompressMagTrap);
      Wait(121*ID+1);
      if CompressMagTrapTime>0 then begin
        maxn:=trunc(DeCompressMagTrapTime/commandtime);
        resttime:=DeCompressMagTrapTime-(maxn*commandtime);
        if (resttime<0.1) then begin
          maxn:=maxn-1;
          resttime:=DeCompressMagTrapTime-(maxn*commandtime);
        end;
        if maxn<1 then writeln('Error : MagTrap : MagneticTrap : Magnetic trap compression time too short');
        for n:=1 to maxn do begin
          SetMOTVoltage(n/maxn*(MagTrapMOTVoltageCompressed-MagTrapMOTVoltageDeCompressed)+MagTrapMOTVoltageDeCompressed);
          Wait(122*ID+commandtime);
        end;
        Wait(123*ID+resttime);
      end;
    SequenceEndBlock;
  end;


  procedure TranslateMagTrap;far;
  begin
    FinalTrap:='translated MagTrap';
    AtomPath:=AtomPath+'T';
    SequenceStartBlockNoArg(TranslateMagTrap);
      SwitchSlowerCompensation(on);
      Wait(124*ID+10);
      SwitchFinalSlowerVoltage(on);
      Wait(125*ID+1);
      Ramp(SetFinalSlowerCurrent,3,SlowerCompensationCurrent[0],SlowerCompensationRampTime,0.2);
    SequenceEndBlock;
  end;

  procedure DeTranslateMagTrap;far;
  begin
    FinalTrap:='Detranslated MagTrap';
    AtomPath:=AtomPath+'Dt';
    SequenceStartBlockNoArg(DeTranslateMagTrap);
      Ramp(SetFinalSlowerCurrent,SlowerCompensationCurrent[0],0,SlowerCompensationRampTime,0.2);
      SwitchSlowerCompensation(off);
      SwitchFinalSlowerVoltage(off);
      Wait(126*ID+1);
    SequenceEndBlock;
  end;

  procedure AddCurrent;far;
  begin
    if DoAddCurrent then begin
      FinalTrap:='Added current MagTrap';
      AtomPath:=AtomPath+'A';
    end;
    SequenceStartBlockNoArg(AddCurrent);
    if DoAddCurrent then begin
      SetTransfer2Voltage(0);
      SwitchTransferDecharging(off);
      IOUpdate;
      {SetTransfer1Voltage(AddCurrentStartVoltage);
      Wait(127*ID+10);}
      SetTransfer1Current(0);
      Wait(128*ID+1);
      SetMOTCurrent(MaxMOTCurrent);
      Ramp(SetMOTVoltage,MagTrapMOTVoltageCompressed,AddCurrentMOTVoltageRamp1MOTEndVoltage,
        LowerMagTrapMOTVoltageRampTime1,0.2);
      Ramp(SetMOTVoltage,AddCurrentMOTVoltageRamp1MOTEndVoltage,MaxMOTVoltage,LowerMagTrapMOTVoltageRampTime2,0.2);
      SwitchIGBT(7,on);
      SwitchIGBT(9,on);
      Wait(129*ID+1);
      Ramp(SetTransfer1Voltage,0{AddCurrentStartVoltage},MaxTransfer1Voltage,LowerMagTrapTransferVoltageRampTime,0.2);
      if (MaxTotalLowerMagTrapCurrent-MaxMotCurrent)<0 then MaxTotalLowerMagTrapCurrent:=MaxMotCurrent;
      if (MaxTotalLowerMagTrapCurrent-MaxMotCurrent)>300 then MaxTotalLowerMagTrapCurrent:=300+MaxMotCurrent;
      LockIGBTs;
      Ramp(SetTransfer1Current,0,MaxTotalLowerMagTrapCurrent-MaxMotCurrent,LowerMagTrapCurrentRampTime1,0.2);
    end else begin
      SetTransfer1Voltage(0);
      SetTransfer2Voltage(0);
      SetTransfer1Current(MaxTransfer1Current);
      SwitchTransferDecharging(on);
    end;
    SequenceEndBlock;
  end;

  procedure DeAddCurrent;far;
  begin
    SequenceStartBlockNoArg(DeAddCurrent);
      if DoAddCurrent then begin
        Ramp(SetTransfer1Current,MaxTotalLowerMagTrapCurrent-MaxMotCurrent,0,LowerMagTrapCurrentRampTime2,0.2);
        UnlockIGBTs;
        Wait(130*ID+10);
        SwitchIGBT(7,off);
        SwitchIGBT(9,off);
        IOUpdate;
        SetTransfer1Voltage(0);
        SetTransfer2Voltage(0);
        SetTransfer1Current(MaxTransfer1Current);
        SwitchTransferDecharging(on);
        Wait(131*ID+1);
        Ramp(SetMOTVoltage,MaxMOTVoltage,AddCurrentMOTVoltageRamp1MOTEndVoltage,LowerMagTrapMOTVoltageRampTime2,0.2);
        Ramp(SetMOTVoltage,AddCurrentMOTVoltageRamp1MOTEndVoltage,
          MagTrapMOTVoltageCompressed,LowerMagTrapMOTVoltageRampTime1,0.2);
        SwitchTransferDecharging(off);
      end;{ else SwitchTransferDecharging(off);}
    SequenceEndBlock;
  end;

  procedure SetTranslateCurrent(y:double);{y is position scaled from 0 to 1}
  var n:byte;
      hy,Current:double;
  begin
    n:=trunc(y*MaxSlowerCompCurrent);
    hy:=y*MaxSlowerCompCurrent-n;
    if n<MaxSlowerCompCurrent then begin
      current:=hy*(SlowerCompensationCurrent[n+1]-SlowerCompensationCurrent[n])+
        SlowerCompensationCurrent[n];
    end else Current:=SlowerCompensationCurrent[MaxSlowerCompCurrent];
    SetFinalSlowerCurrent(Current);
  end;

  procedure Transfer;far;
  var n,maxn,startn:longint;
      y,x,helpTransfer1Current,helpTransfer2Voltage,helpMOTCurrent,resttime:double;
      TransferFraction,TransferEndCurrentMOT,
      aktRampTransferCoilsTime,aktRampMOTCoilsTime,aktTransfer2EndVoltage,
      aktTransferCurrentMiddle:double;
      MagTrapTransfer1CurrentCC:double;
      aktTransferPercent:double;
      WaitTime:double;
  begin
    FinalTrap:='transfered MagTrap';
    AtomPath:=AtomPath+'Tr';
    SequenceStartBlockNoArg(Transfer);
      {SwitchOszilloskopTrigger(off);
      IOUpdate;}
      SwitchTransferDecharging(off);
      SwitchIGBTsToTransfer;
      Wait(132*ID+1);
      {if DoIoffeTrap then TransferFraction:=1 else}
      TransferFraction:=TransferPercent/100;
      if StartBarsTransferPercent<=TransferFraction*100 then begin
        SetBarsCurrent(MaxBarCurrent);
        SetBarsVoltage(0);
        SwitchIGBT(8,on);
      end;
      if TransferFraction<0.5 then begin
        x:=TransferFraction/0.5;
        aktTransferCurrentMiddle:=TransferCurrentMiddle*x;
        if DoTransferParabolic
        then aktRampTransferCoilsTime:=(TransferTime/(2*TransferTimeRatio))*sqrt(x)
        else aktRampTransferCoilsTime:=(TransferTime/(2*TransferTimeRatio))*x;
      end else begin
        FinalPosition:=HigherTrap;
        x:=(TransferFraction-0.5)/0.5;
        aktTransferCurrentMiddle:=TransferCurrentMiddle;
        aktRampTransferCoilsTime:=(TransferTime/(2*TransferTimeRatio));
        if DoTransferParabolic
        then aktRampMOTCoilsTime:=(TransferTime*(1-1/(2*TransferTimeRatio)))*(1-sqrt(1-x))
        else aktRampMOTCoilsTime:=(TransferTime*(1-1/(2*TransferTimeRatio)))*(1-(1-x));
      end;
      MagTrapTransfer1CurrentCC:=0;
      maxn:=trunc(aktRampTransferCoilsTime/(2*commandtime));
      resttime:=aktRampTransferCoilsTime-(maxn*2*commandtime);
      if (resttime<0.03) then begin
        maxn:=maxn-1;
        resttime:=aktRampTransferCoilsTime-(maxn*2*commandtime);
      end;
      if maxn<1 then writeln('Error : MagTrap : MagneticTrap : Transfer Coils time too short or Transfer percent too low');
      for n:=1 to maxn do begin
        if DoTransferParabolic
        then helpTransfer1Current:=n*n/(maxn*maxn)*
          (aktTransferCurrentMiddle-MagTrapTransfer1CurrentCC)+MagTrapTransfer1CurrentCC
        else helpTransfer1Current:=n/maxn*(aktTransferCurrentMiddle-MagTrapTransfer1CurrentCC)+MagTrapTransfer1CurrentCC;
        SetTransferCurrentControlVoltage(helpTransfer1Current);
        if DoTranslateMagTrap then begin
          y:=helpTransfer1Current/TransferCurrentMiddle;
          SetTranslateCurrent(y*0.5);
        end;
        Wait(133*ID+2*commandtime);
      end;
      Wait(134*ID+resttime);
      Wait(135*ID+TransferHalfWayWait);
      if TransferFraction>0.5 then begin
        WaitTime:=2*commandtime;
        maxn:=trunc(aktRampMOTCoilsTime/WaitTime);
        resttime:=aktRampMOTCoilsTime-(maxn*WaitTime);
        if (resttime<0.1) then begin
          maxn:=maxn-1;
          resttime:=aktRampMOTCoilsTime-(maxn*WaitTime);
        end;
        if maxn<1 then writeln('Error : MagTrap : MagneticTrap : MOT Coils time too short or Transfer percent too low');
        for n:=1 to maxn do begin
          if DoTransferParabolic
          then helpMOTCurrent:=(sqr((TransferTime*(1-1/(2*TransferTimeRatio)))
            -n*aktRampMOTCoilsTime/maxn)
            /sqr((TransferTime*(1-1/(2*TransferTimeRatio)))))
            *(MOTTransferStartCurrent-MOTTransferEndCurrent)+MOTTransferEndCurrent
          else helpMOTCurrent:=(((TransferTime*(1-1/(2*TransferTimeRatio)))-
            n*aktRampMOTCoilsTime/maxn)/((TransferTime*(1-1/(2*TransferTimeRatio)))))
            *(MOTTransferStartCurrent-MOTTransferEndCurrent)+MOTTransferEndCurrent;
          SetMOTCurrentControlVoltage(helpMOTCurrent);
          aktTransferPercent:=50+(1-helpMOTCurrent/MOTTransferStartCurrent)*50;
          if aktTransferPercent>StartBarsTransferPercent
          then SetBarsCurrentControlVoltage(BarsTransferEndCurrent*
            (aktTransferPercent-StartBarsTransferPercent)/(100-StartBarsTransferPercent));
          SetTransferCurrentControlVoltage((n/maxn)*(TransferCurrentEnd-TransferCurrentMiddle)+TransferCurrentMiddle);
          if DoTranslateMagTrap then begin
            y:=1-helpMOTCurrent/MOTTransferStartCurrent;
            SetTranslateCurrent(0.5+y*0.5);
          end;
          Wait(136*ID+WaitTime);
        end;
        Wait(137*ID+resttime);
      end;
      {SwitchOszilloskopTrigger(off);
      IOUpdate;}
      if (TransferFraction>=1) and (MOTTransferEndCurrent=0) then begin
        SwitchIGBT(6,off);
        IOUpdate;
        If DoIoffeTrap then begin
          SetMOTVoltage(0);
          SetMOTCurrent(0);
          SwitchMOTDecharging(on);
          {Wait(138*ID+50);
          SwitchMOTDecharging(off);
          SetMOTCurrent(MaxMOTCurrent);}
          {SetMOTVoltage(PinchCapacitorVoltageStart);}
        end;
      end;
      Wait(139*ID+2*commandtime);
    SequenceEndBlock;
  end;

  const OldMOTVoltage:double=0;

  procedure RampMOTCoilsOff;far;
  begin
    FinalTrap:='transfered MagTrap';
    AtomPath:=AtomPath+'M-';
    SequenceStartBlockNoArg(RampMOTCoilsOff);
      if ((TransferPercent/100)<1) or (MOTTransferEndCurrent<>0) then begin
        OldMOTVoltage:=AktMOTVoltage;
        Ramp(SetMOTVoltage,AktMOTVoltage,0,RampMOTCoilsOffTime,0.3);
        SwitchIGBT(6,off);
        IOUpdate;
        If DoIoffeTrap then begin
          SetMOTVoltage(0);
          SetMOTCurrent(0);
          SwitchMOTDecharging(on);
          {Wait(140*ID+50);
          SwitchMOTDecharging(off);
          SetMOTCurrent(MaxMOTCurrent);}
          {SetMOTVoltage(PinchCapacitorVoltageStart);}
        end;
      end;
      Wait(141*ID+2*commandtime);
    SequenceEndBlock;
  end;

  procedure RampMOTCoilsOn;far;
  begin
    FinalTrap:='transfered MagTrap';
    AtomPath:=AtomPath+'M+';
    SequenceStartBlockNoArg(RampMOTCoilsOn);
      SwitchMOTDecharging(off);
      IOUpdate;
      SetMOTVoltage(0);
      SetMOTCurrent(500);
      IOUpdate;
      if (TransferPercent<100) or (MOTTransferEndCurrent<>0) then begin
        SwitchIGBT(6,on);
        Wait(142*ID+1);
        Ramp(SetMOTVoltage,0,OldMOTVoltage,RampMOTCoilsOffTime,0.3);
      end;
      Wait(143*ID+2*commandtime);
    SequenceEndBlock;
  end;

  procedure DeTransfer;far;
  var n,maxn,endn:longint;
      y,x,helpTransfer1Current,helpTransfer2Voltage,helpMOTCurrent,resttime:double;
      TransferFraction,TransferEndCurrentMOT,aktTransfer2EndVoltage,
      aktRampTransferCoilsTime,aktRampMOTCoilsTime,
      aktTransferCurrentMiddle:double;
      MagTrapTransfer1CurrentCC:double;
      aktTransferPercent:double;
      WaitTime:double;
  begin
    FinalTrap:='QP Magtrap Up/down';
    AtomPath:=AtomPath+'Td';
    SequenceStartBlockNoArg(DeTransfer);
      FinalPosition:=LowerTrap;
      if DoIoffeTrap then TransferFraction:=1 else TransferFraction:=TransferPercent/100;
      if TransferFraction<0.5 then begin
        x:=TransferFraction/0.5;
        aktTransferCurrentMiddle:=TransferCurrentMiddle*x;
        if DoTransferParabolic
        then aktRampTransferCoilsTime:=(TransferTime/(2*TransferTimeRatio))*sqrt(x)
        else aktRampTransferCoilsTime:=(TransferTime/(2*TransferTimeRatio))*(x);
      end else begin
        x:=(TransferFraction-0.5)/0.5;
        aktTransferCurrentMiddle:=TransferCurrentMiddle;
        aktRampTransferCoilsTime:=(TransferTime/(2*TransferTimeRatio));
        if DoTransferParabolic
        then aktRampMOTCoilsTime:=(TransferTime*(1-1/(2*TransferTimeRatio)))*(1-sqrt(1-x))
        else aktRampMOTCoilsTime:=(TransferTime*(1-1/(2*TransferTimeRatio)))*(1-(1-x));
      end;
      MagTrapTransfer1CurrentCC:=0;
      SwitchMOTDecharging(off);
      IOUpdate;
      if (TransferFraction>=1) and (MOTTransferEndCurrent=0) then begin
        {SetMOTCurrent(MaxMOTCurrent);
        IOUpdate;
        SetMOTVoltage(MOTVoltageOffset);}
        SwitchIGBT(6,on);
      end;
      Wait(144*ID+2*commandtime);
      if TransferFraction>0.5 then begin
        WaitTime:=2*commandtime;
        maxn:=trunc(aktRampMOTCoilsTime/WaitTime);
        resttime:=aktRampMOTCoilsTime-(maxn*WaitTime);
        if (resttime<0.1) then begin
          maxn:=maxn-1;
          resttime:=aktRampMOTCoilsTime-(maxn*WaitTime);
        end;
        if maxn<1 then writeln('Error : MagTrap : MagneticTrap : MOT Coils time too short or Transfer percent too low');
        for n:=maxn-1 downto 0 do begin
          if DoTransferParabolic
          then helpMOTCurrent:=(sqr((TransferTime*(1-1/(2*TransferTimeRatio)))-
            n*aktRampMOTCoilsTime/maxn)/sqr((TransferTime*(1-1/(2*TransferTimeRatio)))))
             *(MOTTransferStartCurrent-MOTTransferEndCurrent)+MOTTransferEndCurrent
          else helpMOTCurrent:=(((TransferTime*(1-1/(2*TransferTimeRatio)))-
            n*aktRampMOTCoilsTime/maxn)/((TransferTime*(1-1/(2*TransferTimeRatio)))))
            *(MOTTransferStartCurrent-MOTTransferEndCurrent)+MOTTransferEndCurrent;
          SetMOTCurrentControlVoltage(helpMOTCurrent);
          aktTransferPercent:=50+(1-helpMOTCurrent/MOTTransferStartCurrent)*50;
          if aktTransferPercent>StartBarsTransferPercent
          then SetBarsCurrentControlVoltage(BarsTransferEndCurrent*
            (aktTransferPercent-StartBarsTransferPercent)/(100-StartBarsTransferPercent));
          SetTransferCurrentControlVoltage((n/maxn)*(TransferCurrentEnd-TransferCurrentMiddle)+TransferCurrentMiddle);
          if DoTranslateMagTrap then begin
            y:=1-helpMOTCurrent/MOTTransferStartCurrent;
            SetTranslateCurrent(0.5+y*0.5);
          end;
          Wait(145*ID+WaitTime);
        end;
        Wait(146*ID+resttime);
      end;
      Wait(147*ID+TransferHalfWayWait);
      maxn:=trunc(aktRampTransferCoilsTime/(2*commandtime));
      resttime:=aktRampTransferCoilsTime-(maxn*2*commandtime);
      if (resttime<0.03) then begin
        maxn:=maxn-1;
        resttime:=aktRampTransferCoilsTime-(maxn*2*commandtime);
      end;
      if maxn<1 then writeln('Error : MagTrap : MagneticTrap : Transfer Coils time too short or Transfer percent too low');
      if (DeTransferPercent>50) and (DeTransferPercent<100) then endn:=round(maxn-maxn*(DeTransferPercent-50)/50)
      else endn:=0;
      for n:=maxn-1 downto endn do begin
        if DoTransferParabolic
        then helpTransfer1Current:=n*n/(maxn*maxn)*
          (aktTransferCurrentMiddle-MagTrapTransfer1CurrentCC)+MagTrapTransfer1CurrentCC
        else helpTransfer1Current:=n/(maxn)*(aktTransferCurrentMiddle-MagTrapTransfer1CurrentCC)+MagTrapTransfer1CurrentCC;
        SetTransferCurrentControlVoltage(helpTransfer1Current);
        {SetTransfer1Current(helpTransfer1Current);
        helpTransfer2Voltage:=(helpTransfer1Current-Transfer2CurrentOffset)/
          (MaxTransfer1Current-Transfer2CurrentOffset)*Transfer2EndVoltage;
        if helpTransfer2Voltage>0 then SetTransfer2Voltage(helpTransfer2Voltage);}
        if DoTranslateMagTrap then begin
          y:=helpTransfer1Current/TransferCurrentMiddle;
          SetTranslateCurrent(y*0.5);
        end;
        Wait(148*ID+2*commandtime);
      end;
      Wait(149*ID+resttime);
    SequenceEndBlock;
  end;

  procedure SetFinalSlowerAndMOTCurrent(f:double);far;
  begin
    if DoTranslateMagTrap then SetFinalSlowerCurrent(f*SlowerCompensationCurrent[MaxSlowerCompCurrent]);
    if (MOTTransferEndCurrent<>0) then SetMOTCurrent(f*MOTTransferEndCurrent);
  end;

  procedure DeTranslateUpperMagTrap;far;
  var TransferCurrentAtHop,TransferGradiantZAtHop:double;
      FirstRampTime,TransferEndCurrentFirstRamp:double;
      SecondRampTime,TransferEndCurrentSecondRamp:double;
  begin
    FinalTrap:='detranslated MagTrap';
    AtomPath:=AtomPath+'dT';
    SequenceStartBlockNoArg(DeTranslateUpperMagTrap);
      if DoTranslateMagTrap or (MOTTransferEndCurrent<>0)
      then Ramp(SetFinalSlowerCurrent,1,0,FinalSlowerEndRampTime,0.2);
      SwitchSlowerCompensation(off);
      SwitchIGBT(6,off);
    SequenceEndBlock;
  end;

  var DefTransStart,DefTransEnd,DefBarStart,DefBarEnd:double;

  procedure SetDeformationCurrent(f:double);far;
  begin
    SetTransferCurrentControlVoltage(f*(DefTransEnd-DefTransStart)+DefTransStart);
    SetBarsCurrentControlVoltage(f*(DefBarEnd-DefBarStart)+DefBarStart);
  end;

  procedure TransferQuadrupolDeformation;far;
  var TransferCurrentAtHop,TransferGradiantZAtHop:double;
      FirstRampTime,TransferEndCurrentFirstRamp:double;
      SecondRampTime,TransferEndCurrentSecondRamp:double;
  begin
    FinalTrap:='transfered MagTrap with Quadrupol Deformation';
    AtomPath:=AtomPath+'Qd';
    SequenceStartBlockNoArg(TransferQuadrupolDeformation);
      SetBarsCurrent(MaxBarCurrent);
      IOUpdate;
      SetBarsCurrentControlVoltage(BarCurrentAfterHop);
      SwitchIGBT(8,on);
      DefBarStart:=BarCurrentAfterHop;
      DefBarEnd:=EndDeformationBarCurrent;
      DefTransStart:=TransferCurrentEnd;
      DefTransEnd:=EndDeformationTransferCurrent;
      Wait(150*ID+0.5);
      if ((DeformationPercent>0) and (DeformationTime>0)) then
        Ramp(SetDeformationCurrent,0,DeformationPercent/100.0,
             DeformationTime*DeformationPercent/100,0.3);
    SequenceEndBlock;
  end;

  procedure DeTransferQuadrupolDeformation;far;
  var TransferCurrentAtHop,TransferGradiantZAtHop:double;
      FirstRampTime,TransferEndCurrentFirstRamp:double;
      SecondRampTime,TransferEndCurrentSecondRamp:double;
  begin
    SequenceStartBlockNoArg(DeTransferQuadrupolDeformation);
      if DoTranslateMagTrap then SwitchSlowerCompensation(on);
      if (MOTTransferEndCurrent<>0) then SwitchIGBT(6,on);
      Ramp(SetFinalSlowerCurrent,0,1,FinalSlowerEndRampTime,0.2);
      DefBarStart:=BarCurrentAfterHop;
      DefBarEnd:=EndDeformationBarCurrent;
      DefTransStart:=TransferCurrentEnd;
      DefTransEnd:=EndDeformationBarCurrent;
      Wait(151*ID+0.5);
      if ((DeformationPercent>0) and (DeformationTime>0)) then
        Ramp(SetDeformationCurrent,DeformationPercent/100.0,0,
             DeformationTime*DeformationPercent/100,0.3);
      if StartBarsTransferPercent>100 then begin
        SwitchIGBT(8,off);
        Wait(152*ID+0.5);
      end else begin
        SetBarsCurrentControlVoltage(BarsTransferEndCurrent);
        Wait(153*ID+0.5);
      end;
    SequenceEndBlock;
  end;

  procedure ReTranslateUpperMagTrap;far;
  var TransferCurrentAtHop,TransferGradiantZAtHop:double;
      FirstRampTime,TransferEndCurrentFirstRamp:double;
      SecondRampTime,TransferEndCurrentSecondRamp:double;
  begin
    SequenceStartBlockNoArg(ReTranslateUpperMagTrap);
      if DoTranslateMagTrap then SwitchSlowerCompensation(on);
      if (MOTTransferEndCurrent<>0) then SwitchIGBT(6,on);
      Ramp(SetFinalSlowerCurrent,0,1,FinalSlowerEndRampTime,0.2);
    SequenceEndBlock;
  end;

  procedure IoffeBarRamp;far;
  begin
    FinalTrap:='transfered MagTrap with Ioffe Bars';
    AtomPath:=AtomPath+'Ib';
    SequenceStartBlockNoArg(IoffeBarRamp);
      Ramp(SetBarsCurrentControlVoltage,BarsTransferEndCurrent,
      IoffeBarRampEndCurrent,IoffeBarRampTime,commandTime);
    SequenceEndBlock;
  end;

  procedure DeIoffeBarRamp;far;
  begin
    FinalTrap:='transfered MagTrap';
    AtomPath:=AtomPath+'Di';
    SequenceStartBlockNoArg(DeIoffeBarRamp);
      Ramp(SetBarsCurrentControlVoltage,IoffeBarRampEndCurrent,
        BarsTransferEndCurrent,IoffeBarRampTime,commandTime);
    SequenceEndBlock;
  end;

  procedure TransferQuadrupolExpansion;far;
  begin
    FinalTrap:='transfered MagTrap with Quadrupol Expansion';
    AtomPath:=AtomPath+'Qe';
    SequenceStartBlockNoArg(TransferQuadrupolExpansion);
      Ramp(SetTransferCurrentControlVoltage,TransferCurrentEnd,
        TransferQuadrupolEndCurrent,TransferQuadrupolExpansionTime,2);
    SequenceEndBlock;
  end;

  procedure DeTransferQuadrupolExpansion;far;
  begin
    FinalTrap:='transfered MagTrap';
    AtomPath:=AtomPath+'De';
    SequenceStartBlockNoArg(TransferQuadrupolExpansion);
      Ramp(SetTransferCurrentControlVoltage,TransferQuadrupolEndCurrent,
        TransferCurrentEnd,TransferQuadrupolExpansionTime,2);
    SequenceEndBlock;
  end;

  procedure IoffeTrapF2;far;
  var n,maxn:longint;
      resttime:double;
  begin
    FinalTrap:='F2 in Ioffe trap';
    AtomPath:=AtomPath+'I2';
    FinalTrapType:=IoffePritchard;
    SequenceStartBlockNoArg(IoffeTrapF2);
      {SwitchOszilloskopTrigger(off);
      IOUpdate;}
      SequenceStartPortListDuringWait(159*ID+2);
      SwitchMOTDecharging(off);
      IOUpdate;
      SetMOTVoltage(PinchCapacitorVoltageStart);
      SetMOTCurrent(MaxMOTCurrent);
      Wait(160*ID+PinchCapacitorChargingTime);
      SwitchIGBT(1,off);
      SwitchIGBT(2,off);
      SwitchIGBT(3,off);
      SwitchIGBT(4,on);
      SwitchIGBT(5,on);
      SwitchIGBT(10,off);
      {Wait(161*ID+0.2);}
      SwitchIGBT(8,on);
      TrapOffMode:=Ioffe;
      IOUpdate;
      SetBarsCurrentControlVoltage(F2IoffeTrapBarStartCurrent);
      IOUpdate;
      Wait(162*ID+PinchStartTime);
      SetMOTVoltage(PinchVoltageStart);
      IOUpdate;
      SetTransfer1Voltage(0);
      SetTransfer2Voltage(0);
      IOUpdate;
      SetTransfer1Current(0);
      IOUpdate;
      SwitchTransferDecharging(on);
      Wait(163*ID+IoffeTrapStartTime);
      SequenceStopPortList;
    SequenceEndBlock;
  end;

  procedure SetCompressIoffeTrapCV(f:double);far;
  begin
    SetBarsCurrentControlVoltage(f*(BarCompCVCurrent-F2IoffeTrapBarStartCurrent)+F2IoffeTrapBarStartCurrent);
    SetMOTVoltage(f*(PinchCompCVVoltage-PinchVoltageStart)+PinchVoltageStart);
  end;

  procedure CompressIoffeTrapCV;far;
  begin
    FinalTrap:='CV compressed Ioffe trap';
    AtomPath:=AtomPath+'Cv';
    SequenceStartBlockNoArg(CompressIoffeTrapCV);
      Wait(164*ID+1);
      Ramp(SetCompressIoffeTrapCV,0,1,IoffeCVCompressionTime,0.3);
      Wait(165*ID+1);
    SequenceEndBlock;
  end;

  var BarVoltageAfterCVCCTransition:double;

  procedure CVCCTransitionF2;far;
  begin
    SequenceStartBlockNoArg(CVCCTransitionF2);
      Ramp(SetMOTCurrent,MaxMOTCurrent,PinchCurrentAfterCVCCTransition,PinchCVCCCurrentRampTime,CommandTime);
      {Ramp(SetMOTVoltage,aktMOTVoltage,MaxMOTVoltage,PinchCVCCVoltageRampTime,CommandTime);}
      Ramp(SetBarsCurrent,MaxBarCurrent,BarCurrentAfterCVCCTransition,BarCVCCCurrentRampTime,CommandTime);
      BarVoltageAfterCVCCTransition:=aktBarVoltage;
      {Ramp(SetBarsVoltage,aktBarVoltage,MaxBarVoltage,BarCVCCVoltageRampTime,CommandTime);}

      SwitchIGBT(2,on);
      Wait(166*ID+1.0000001);
      TrapOffMode:=CompensatedIoffe;
      Ramp(SetTransfer1Voltage,0,MaxTransfer1Voltage,TransferRaiseVoltageTime,0.3);
      SetTransfer1Voltage(MaxTransfer1Voltage);
      Wait(167*ID+0.5);
      SwitchTransferDecharging(off);
      Wait(168*ID+1.0000002);

    SequenceEndBlock;
  end;

  var ChangeIoffeStartMOTVoltage:double;
      ChangeIoffeStartPinchCurrent:double;
      ChangeIoffeStartBarCurrent:double;
      ChangeIoffeStartBarVoltage:double;
      ChangeIoffeStartCompCurrent:double;
      ChangeIoffeStartPinchOffsetCurrent:double;
      ChangeIoffeMOTVoltage:boolean;
      ChangeIoffeEndPinchCurrent:double;
      ChangeIoffeEndBarCurrent:double;
      ChangeIoffeEndCompCurrent:double;
      ChangeIoffeEndPinchOffsetCurrent:double;
      ChangeIoffeStartFrequ1:double;
      ChangeIoffeStopFrequ1:double;
      ChangeIoffeStartFrequ2:double;
      ChangeIoffeStopFrequ2:double;
      ChangeIoffeAktCycle1:longint;
      ChangeIoffeAktCycle2:longint;
      ChangeIoffeMaxCycle:longint;


  procedure ChangeIoffeSetPinchCompAndBarCurrents(f:double);far;
  var compCurrent,AktPinchCurrent:double;
  begin
    if (ChangeIoffeStartBarVoltage<>MaxBarVoltage) then
      SetBarsVoltage(f*(MaxBarVoltage-ChangeIoffeStartBarVoltage)+ChangeIoffeStartBarVoltage);
    if ChangeIoffeMOTVoltage and (ChangeIoffeStartMOTVoltage<>MaxMOTVoltage) then
      SetMOTVoltage(f*(MaxMOTVoltage-ChangeIoffeStartMOTVoltage)+ChangeIoffeStartMOTVoltage);
    compCurrent:=f*(ChangeIoffeEndCompCurrent-ChangeIoffeStartCompCurrent)+ChangeIoffeStartCompCurrent;
    AktPinchCurrent:=f*(ChangeIoffeEndPinchCurrent-ChangeIoffeStartPinchCurrent)+ChangeIoffeStartPinchCurrent;
    SetTransferCurrent(CompCurrent);
    SetMOTCurrent(AktPinchCurrent-CompCurrent);
    SetBarsCurrent(f*(ChangeIoffeEndBarCurrent-ChangeIoffeStartBarCurrent)+ChangeIoffeStartBarCurrent);
    if (ChangeIoffeEndPinchOffsetCurrent<>ChangeIoffeStartPinchOffsetCurrent)
    then SetPinchOffsetCurrent(f*(ChangeIoffeEndPinchOffsetCurrent-
      ChangeIoffeStartPinchOffsetCurrent)+ChangeIoffeStartPinchOffsetCurrent);
  end;

  procedure ChangeIoffeTrap(aBarCurrent:double;aPinchCurrent:double;
    aCompCurrent:double;aPinchOffsetCurrent:double;RampTime:double);
  var RampDeltaTime:double;
  begin
    ChangeIoffeMOTVoltage:=not GetMOTDecharging;
    ChangeIoffeStartMOTVoltage:=aktMOTVoltage;
    ChangeIoffeStartPinchCurrent:=aktMOTCurrent+aktTransfer1Current;
    ChangeIoffeStartBarCurrent:=aktBarCurrent;
    ChangeIoffeStartBarVoltage:=aktBarVoltage;
    ChangeIoffeStartCompCurrent:=aktTransfer1Current;
    ChangeIoffeStartPinchOffsetCurrent:=aktPinchOffsetCurrent;
    ChangeIoffeEndPinchCurrent:=aPinchCurrent;
    ChangeIoffeEndBarCurrent:=aBarCurrent;
    ChangeIoffeEndCompCurrent:=aCompCurrent;
    ChangeIoffeEndPinchOffsetCurrent:=aPinchOffsetCurrent;
    if (aktMOTVoltage<>MaxMOTVoltage) or (aktBarVoltage<>MaxBarVoltage) then RampDeltaTime:=0.5
    else RampDeltaTime:=0.4;
    Wait(169*ID+10);
    Ramp(ChangeIoffeSetPinchCompAndBarCurrents,0,1,RampTime,RampDeltaTime);
    Wait(170*ID+1);
  end;

  procedure ChangeIoffeAndMicroWaveSetPinchCompAndBarCurrents(f:double);far;
  var compCurrent,AktPinchCurrent:double;
  begin
    if (ChangeIoffeStartBarVoltage<>MaxBarVoltage) then
      SetBarsVoltage(f*(MaxBarVoltage-ChangeIoffeStartBarVoltage)+ChangeIoffeStartBarVoltage);
    if (ChangeIoffeStartMOTVoltage<>MaxMOTVoltage) and ChangeIoffeMOTVoltage then
      SetMOTVoltage(f*(MaxMOTVoltage-ChangeIoffeStartMOTVoltage)+ChangeIoffeStartMOTVoltage);
    compCurrent:=f*(ChangeIoffeEndCompCurrent-ChangeIoffeStartCompCurrent)+ChangeIoffeStartCompCurrent;
    AktPinchCurrent:=f*(ChangeIoffeEndPinchCurrent-ChangeIoffeStartPinchCurrent)+ChangeIoffeStartPinchCurrent;
    SetTransferCurrent(CompCurrent);
    SetMOTCurrent(AktPinchCurrent-CompCurrent);
    SetBarsCurrent(f*(ChangeIoffeEndBarCurrent-ChangeIoffeStartBarCurrent)+ChangeIoffeStartBarCurrent);
    if (ChangeIoffeEndPinchOffsetCurrent<>ChangeIoffeStartPinchOffsetCurrent)
    then SetPinchOffsetCurrent(f*(ChangeIoffeEndPinchOffsetCurrent-
      ChangeIoffeStartPinchOffsetCurrent)+ChangeIoffeStartPinchOffsetCurrent);
    if (ChangeIoffeStopFrequ1<>ChangeIoffeStartFrequ1) then begin
      inc(ChangeIoffeAktCycle1);
      if (ChangeIoffeAktCycle1>ChangeIoffeMaxCycle) then begin
        ChangeIoffeAktCycle1:=0;
        SetFrequency(0,f*(ChangeIoffeStopFrequ1-ChangeIoffeStartFrequ1)+ChangeIoffeStartFrequ1);
        Wait(171*ID+MinGPIBCommandTime);
      end;
    end;
    if (ChangeIoffeStopFrequ2<>ChangeIoffeStartFrequ2) then begin
      inc(ChangeIoffeAktCycle2);
      if (ChangeIoffeAktCycle2>1.5*ChangeIoffeMaxCycle) then begin
        ChangeIoffeAktCycle2:=round(0.5*ChangeIoffeMaxCycle);
        SetFrequency(1,f*(ChangeIoffeStopFrequ2-ChangeIoffeStartFrequ2)+ChangeIoffeStartFrequ2);
        Wait(172*ID+MinGPIBCommandTime);
      end;
    end;
  end;

  procedure ChangeIoffeTrapAndMicroWave(aBarCurrent:double;aPinchCurrent:double;
    aCompCurrent:double;aPinchOffsetCurrent:double;
    StartFrequ1,StopFrequ1:double;StartFrequ2,StopFrequ2:double;
    RampTime:double);
  var RampDeltaTime:double;
      TotalRampTime:double;
  begin
    ChangeIoffeStartMOTVoltage:=aktMOTVoltage;
    ChangeIoffeMOTVoltage:=not GetMOTDecharging;
    ChangeIoffeStartPinchCurrent:=aktMOTCurrent+aktTransfer1Current;
    ChangeIoffeStartBarCurrent:=aktBarCurrent;
    ChangeIoffeStartBarVoltage:=aktBarVoltage;
    ChangeIoffeStartCompCurrent:=aktTransfer1Current;
    ChangeIoffeStartPinchOffsetCurrent:=aktPinchOffsetCurrent;
    ChangeIoffeStartFrequ1:=StartFrequ1;
    ChangeIoffeStartFrequ2:=StartFrequ2;
    ChangeIoffeEndPinchCurrent:=aPinchCurrent;
    ChangeIoffeEndBarCurrent:=aBarCurrent;
    ChangeIoffeEndCompCurrent:=aCompCurrent;
    ChangeIoffeEndPinchOffsetCurrent:=aPinchOffsetCurrent;
    ChangeIoffeStopFrequ1:=StopFrequ1;
    ChangeIoffeStopFrequ2:=StopFrequ2;
    RampDeltaTime:=0.4;
    ChangeIoffeMaxCycle:=round(GPIBCommandTime/RampDeltaTime);
    ChangeIoffeAktCycle1:=0;
    ChangeIoffeAktCycle2:=0;
    TotalRampTime:=RampTime;
    if (StopFrequ1<>StartFrequ1) then TotalRampTime:=TotalRampTime-(RampTime/GPIBCommandTime)*MinGPIBCommandTime;
    if (StopFrequ2<>StartFrequ2) then TotalRampTime:=TotalRampTime-(RampTime/GPIBCommandTime)*MinGPIBCommandTime;
    Wait(173*ID+1);
    Ramp(ChangeIoffeAndMicroWaveSetPinchCompAndBarCurrents,0,1,TotalRampTime,RampDeltaTime);
    Wait(174*ID+1);
  end;

  procedure PrepareNextDopplerCooling(aktnr:byte);
  var OtherDopplerCooling:boolean;
      Nr:byte;
      n:byte;
  begin
    OtherDopplerCooling:=false;
    Nr:=1;
    for n:=aktnr+1 to MaxDopplerCoolings do begin
      if (not OtherDopplerCooling) then Nr:=n;
      OtherDopplerCooling:=OtherDopplerCooling or DoDopplerCoolIoffeTrap[n];
    end;
    if OtherDopplerCooling then begin
      SetAOM20Intensity(DopplerCoolIntensity[nr]);
      ShutterAOM20(open);
      ShutterMOT(close);
      ShutterMOT6principal(close);
      ShutterMOT6repump(close);
      if DopplerCoolBeamIsPrincipal[nr] then begin
        ShutterMOT7principal(open);
        ShutterMOT7repump(close);
        SwitchMaster7Principal(on);
        SetDopplerCoolPrincipalFrequency(DopplerCoolStartFrequency[nr]);
      end else begin
        ShutterMOT7principal(close);
        ShutterMOT7repump(open);
        SwitchMaster7Repump(on);
        SetDopplerCoolRepumpFrequency(DopplerCoolStartFrequency[nr]);
      end;
      SwitchAOM20Frequency(on);
      Wait(175*ID+1);
    end;
  end;

  procedure FinishDopplerCooling;
  begin
    ShutterAOM20(close);
    SwitchAOM20Frequency(off);
    Wait(MOTShutterDelay);
    if KeepInjection then begin
      if (DetectIsotop=6) or TwoPictures then begin
        SwitchMaster6Repump(ProbeWithRepump);
        ShutterMOT6repump(ProbeWithRepump);
        SwitchMaster6Principal(on);
        ShutterMOT6principal(on);
        ShutterMOT6repump(on);
      end else begin
        ShutterMOT6principal(off);
        ShutterMOT6repump(off);
      end;
      if (DetectIsotop=7) or TwoPictures then  begin
        SwitchMaster7Repump(on);
        SwitchMaster7Principal(on);
        ShutterMOT7principal(on);
        ShutterMOT7repump(on);
      end else begin
        ShutterMOT7principal(off);
        ShutterMOT7repump(off);
      end;
    end else begin
      SwitchMaster7Repump(KeepMasterAOMsOn);
      SwitchMaster7Principal(KeepMasterAOMsOn);
      ShutterMOT7repump(close);
      ShutterMOT7principal(close);
      ShutterMaster7AndMOT7LiPrincipal(off);
    end;
    SetProbeDetuning(DetectIsotop);
    if DoSwitchMaster7PrincipalOff then SwitchMaster7Principal(off);
    if KeepMOTAOMOn then SwitchAOM20Delayed(on);
  end;

  procedure DopplerCoolIoffeTrap(nr:byte);far;
  var n:integer;
      OtherDopplerCooling:boolean;
      nextDopplerCoolingNr:byte;
  begin
    FinalTrap:='cooled Ioffe trap';
    AtomPath:=AtomPath+'D'+char(nr+byte('0'));
    SequenceStartBlockByteArg(DopplerCoolIoffeTrap,nr);
      Wait(176*ID+1);
      if DopplerCoolBeamIsPrincipal[nr] then SetDopplerCoolPrincipalFrequency(DopplerCoolStartFrequency[nr])
      else SetDopplerCoolRepumpFrequency(DopplerCoolStartFrequency[nr]);
      Wait(177*ID+1);
      if (DopplerCoolTime[nr]>0) then begin
        if (DopplerCoolRamp[nr]>0) then begin
          SetAOM20Intensity(0);
          Wait(1);
        end;
        SwitchAOM20(on);
        if (DopplerCoolRamp[nr]>0) then begin
          Ramp(SetAOM20Intensity,0,DopplerCoolIntensity[nr],DopplerCoolRamp[nr],0.3);
        end;
        if DopplerCoolStopFrequency[nr]<>0 then begin
          if DopplerCoolBeamIsPrincipal[nr] then Ramp(SetDopplerCoolPrincipalFrequency,
            DopplerCoolStartFrequency[nr],DopplerCoolStopFrequency[nr],DopplerCoolTime[nr],0.5)
          else Ramp(SetDopplerCoolRepumpFrequency,DopplerCoolStartFrequency[nr],
            DopplerCoolStopFrequency[nr],DopplerCoolTime[nr],0.5);
        end else begin
          if DopplerCoolBeamIsPrincipal[nr]
          then SetDopplerCoolPrincipalFrequency(DopplerCoolStartFrequency[nr])
          else SetDopplerCoolRepumpFrequency(DopplerCoolStartFrequency[nr]);
          Wait(DopplerCoolTime[nr]);
        end;
      end;
      if (DopplerCoolRamp[nr]>0) then begin
        Ramp(SetAOM20Intensity,DopplerCoolIntensity[nr],0,DopplerCoolRamp[nr],0.3);
      end;
      SwitchAOM20(off);
      PrepareNextDopplerCooling(nr);
      Wait(179*ID+1);
    SequenceEndBlock;
  end;

  procedure CompressIoffeTrap(nr:byte);far;
  begin
    FinalTrap:='compressed Ioffe Trap';
    AtomPath:=AtomPath+'C'+char(nr+byte('0'));;
    SequenceStartBlockByteArg(CompressIoffeTrap,nr);
      if (CompressIoffeTrapTime[nr]>0) then ChangeIoffeTrap(BarCurrentInCompIoffeTrap[nr],
        BiasCurrentInCompIoffeTrap[nr]+CompensationCurrentInCompIoffeTrap[nr],
        CompensationCurrentInCompIoffeTrap[nr],
        PinchOffsetCurrentInCompIoffeTrap[nr],
        CompressIoffeTrapTime[nr]);
      if BiasCurrentInCompIoffeTrap[nr]=0 then begin
        SwitchIGBT(5,off);
        SetMOTCurrent(0);
        SetMOTVoltage(0);
        Wait(1);
        SwitchMOTDecharging(on);
        if DoHideMagField then begin
          Wait(20);
          SwitchMOTDecharging(off);
          Wait(1);
          SetMOTCurrent(HideFieldPinchCurrent);
          SetMOTVoltage(HideFieldPinchVoltage);
        end;
      end;
    SequenceEndBlock;
  end;

  procedure AddIoffeOffset;far;
  begin
    FinalTrap:='Add Ioffe Offset Ioffe Trap';
    AtomPath:=AtomPath+'IO';
    SequenceStartBlockNoArg(AddIoffeOffset);
      Wait(180*ID+1);
      Wait(181*ID+1);
    SequenceEndBlock;
  end;

  procedure AddPinchOffset;far;
  begin
    FinalTrap:='Add Pinch Offset Ioffe Trap';
    AtomPath:=AtomPath+'PO';
    SequenceStartBlockNoArg(AddPinchOffset);
      Wait(182*ID+1.0002);
      SwitchIGBT(10,on);
      Wait(183*ID+0.2);
      if (PinchOffsetCurrentRampTime>0) then Ramp(SetPinchOffsetCurrent,0,PinchOffsetCurrent,PinchOffsetCurrentRampTime,0.3)
      else SetPinchOffsetCurrent(PinchOffsetCurrent);
      Wait(184*ID+1);
    SequenceEndBlock;
  end;

  procedure IoffeTrapF1;far;
  var n,maxn:longint;
      resttime:double;
  begin
    FinalTrap:='F1 in Ioffe trap';
    AtomPath:=AtomPath+'I1';
    FinalTrapType:=IoffePritchard;
    SequenceStartBlockNoArg(IoffeTrapF1);
      {SwitchOszilloskopTrigger(off);
      IOUpdate;}
      SequenceStartPortListDuringWait(186*ID+1);
      {SwitchIGBT(4,on);
      IOUpdate;}
      SwitchIGBT(1,off);
      SwitchIGBT(2,off);
      SwitchIGBT(3,off);
      SwitchIGBT(4,off);
      SwitchIGBT(5,off);
      SwitchIGBT(6,off);
      SwitchIGBT(7,off);
      SwitchIGBT(9,off);
      SwitchIGBT(10,off);
      TrapOffMode:=Ioffe;
      SwitchMOTDecharging(off);
      IOUpdate;
      SetTransfer1Voltage(MaxTransfer1Voltage);
      SetTransfer2Voltage(MaxTransfer2Voltage);
      SetTransfer1Current(MaxTransfer1Current);
      if (F1QuadrupolDecayTime<0.05) then F1QuadrupolDecayTime:=0.05;
      Wait(187*ID+F1QuadrupolDecayTime);
      SwitchIGBT(2,on);
      SwitchIGBT(4,on);
      SwitchIGBT(8,on);
      IOUpdate;
      {SwitchIGBT(1,off);
      SwitchIGBT(3,off);
      IOUpdate;}
      SetBarsCurrentControlVoltage(F1IoffeTrapBarStartCurrent);
      Wait(188*ID+F1PinchStartTime);
      if (F1PinchStartVoltage>15) then begin
        SetTransfer1Voltage(F1PinchStartVoltage-15);
        SetTransfer2Voltage(15);
      end else begin
        SetTransfer1Voltage(F1PinchStartVoltage);
        SetTransfer2Voltage(0);
      end;
      SequenceStopPortList;
    SequenceEndBlock;
  end;

  procedure CVCCTransitionF1;far;
  begin
    {SequenceStartBlockNoArg(CVCCTransitionF1);
      Ramp(SetMOTCurrent,MaxMOTCurrent,PinchCurrentAfterCVCCTransition,PinchCVCCCurrentRampTime,CommandTime);
      Ramp(SetBarsCurrent,MaxBarCurrent,BarCurrentAfterCVCCTransition,BarCVCCCurrentRampTime,CommandTime);
      BarVoltageAfterCVCCTransition:=aktBarVoltage;
    SequenceEndBlock;}
  end;

  procedure MicroWaveSweep(nr:byte);far;
  var n,maxn:integer;
      f:double;
  begin
    FinalTrap:='Evaporated Ioffe trap';
    AtomPath:=AtomPath+'E'+char(nr+byte('0'));
    SequenceStartBlockByteArg(MicroWaveSweep,nr);
      if DoMicrowaveSweepSynth0[nr] then begin
        SetFrequency(0,IoffeMicroWaveStartFrequency0[nr]);
       Wait(193*ID+GPIBCommandTime);
        SwitchRFGPIB(0,IoffeMicroWavePower0[nr],on);
        SwitchRF(0,on);
        Wait(194*ID+GPIBCommandTime);
      end;
      if DoMicrowaveSweepSynth1[nr] then begin
        SetFrequency(1,IoffeMicroWaveStartFrequency1[nr]);
        Wait(195*ID+GPIBCommandTime);
        SwitchRFGPIB(1,IoffeMicroWavePower1[nr],on);
        SwitchRF(1,on);
        Wait(196*ID+GPIBCommandTime);
      end;
      maxn:=round(IoffeMicroWaveSweepTime[nr]/GPIBCommandTime);
      for n:=0 to maxn do begin
        f:=n/maxn;
        if DoMicrowaveSweepSynth0[nr] then begin
          SetFrequency(0,f*(IoffeMicroWaveStopFrequency0[nr]-
            IoffeMicroWaveStartFrequency0[nr])+IoffeMicroWaveStartFrequency0[nr]);
          Wait(197*ID+MinSubsequentGPIBCommandTime);
        end;
        if DoMicrowaveSweepSynth1[nr] then begin
          SetFrequency(1,f*(IoffeMicroWaveStopFrequency1[nr]-
            IoffeMicroWaveStartFrequency1[nr])+IoffeMicroWaveStartFrequency1[nr]);
        end;
        Wait(198*ID+GPIBCommandTime-MinSubsequentGPIBCommandTime);
      end;
      if DoMicrowaveSweepSynth0[nr] then begin
        SwitchRFGPIB(0,MinRFLevel,off);
        Wait(199*ID+GPIBCommandTime);
      end;
      if DoMicrowaveSweepSynth1[nr] then begin
        SwitchRFGPIB(1,MinRFLevel,off); SwitchRF(1,off);
        Wait(200*ID+GPIBCommandTime);
      end;
    SequenceEndBlock;
  end;

  procedure PrepareSmoothMicroWaveSweep(nr:byte);
  var n,maxn:integer;
      f:double;
  begin
    FinalTrap:='Evaporated Ioffe trap';
    AtomPath:=AtomPath+'Es'+char(nr+byte('0'));
    SequenceStartBlockByteArg(PrepareSmoothMicroWaveSweep,nr);
      SigGen.PrepareSweep(0,SmoothStartFrequency[nr],SmoothStopFrequency[nr],
        SmoothSweepStepTime[nr],SmoothSweepSteps[nr]);
    SequenceEndBlock;
  end;

  procedure InitSmoothMicroWaveSweep(nr:byte);far;
  var n,maxn:integer;
      f:double;
  begin
    FinalTrap:='Evaporated Ioffe trap';
    AtomPath:=AtomPath+'Es'+char(nr+byte('0'));
    SequenceStartBlockByteArg(InitSmoothMicroWaveSweep,nr);
      SigGen.InitSweep(0);
      Wait(SmoothSweepTime[nr]);
      SwitchRFGPIB(0,MinRFLevel,off);
      Wait(200*ID+GPIBCommandTime);
    SequenceEndBlock;
  end;

  procedure TrapDeformMicroWaveEvaporation(nr:byte);far;
  begin
    FinalTrap:='Evaporated Ioffe trap';
    AtomPath:=AtomPath+'E'+char(nr+byte('0'));
    SequenceStartBlockByteArg(TrapDeformMicroWaveEvaporation,nr);
      if not RFon(0) then begin
        SwitchRF(0,on);
        IOUpdate;
        SetFrequency(0,IoffeMicroWaveStartFrequence0[nr]);
        Wait(201*ID+GPIBCommandTime);
        SwitchRFGPIB(0,MaxRFLevel,on);
        Wait(202*ID+GPIBCommandTime);
      end;
      if IoffeMicroWaveUseSynth1[nr] and (not RFon(1)) then begin
        SetFrequency(1,IoffeMicroWaveStartFrequence1[nr]);
        Wait(203*ID+GPIBCommandTime);
        SwitchRFGPIB(1,MaxRFLevel,on);
        SwitchRF(1,on);
        Wait(204*ID+GPIBCommandTime);
      end;
      if (IoffeMicroWaveStartFrequence0[nr]=IoffeMicroWaveStopFrequence0[nr]) then begin
        {Ramp(SetBarsCurrent,aktBarCurrent,EvaporationEndBarCurrent,System.Exp(IoffeEvaporationTime*ln(2))*1000,0.2);}
        {Ramp(SetBarsCurrent,aktBarCurrent,EvaporationEndBarCurrent,IoffeEvaporationTime*1000,0.2);}
        if (IoffeEvaporationTime[nr]>0) then ChangeIoffeTrap(
          EvaporationEndBarCurrent[nr],
          EvaporationEndBiasCurrent[nr]+EvaporationEndCompCurrent[nr],
          EvaporationEndCompCurrent[nr],EvaporationEndPinchOffsetCurrent[nr],
          IoffeEvaporationTime[nr]*1000);
      end else begin
        if (IoffeEvaporationTime[nr]>0) then ChangeIoffeTrapAndMicroWave(
          EvaporationEndBarCurrent[nr],
          EvaporationEndBiasCurrent[nr]+EvaporationEndCompCurrent[nr],
          EvaporationEndCompCurrent[nr],EvaporationEndPinchOffsetCurrent[nr],
          IoffeMicroWaveStartFrequence0[nr],IoffeMicroWaveStopFrequence0[nr],
          IoffeMicroWaveStartFrequence1[nr],IoffeMicroWaveStopFrequence1[nr],
          IoffeEvaporationTime[nr]*1000);
      end;
      if EvaporationEndBiasCurrent[nr]=0 then SwitchIGBT(5,off);
      {SwitchRFGPIB(0,MinRFLevel,off);
      Wait(205*ID+GPIBCommandTime);
      if IoffeMicroWaveUseSynth1[nr] then begin
        SwitchRFGPIB(1,MinRFLevel,off);
        Wait(206*ID+GPIBCommandTime);
      end;}
    SequenceEndBlock;
  end;

  procedure ShakeTrap;far;
  var n,maxn:word;
      ShakeStopFrequency:double;
  begin
    FinalTrap:='Shaked trap';
    AtomPath:=AtomPath+'S+';
    SequenceStartBlockNoArg(ShakeTrap);
      ShakeStopFrequency:=ShakeStartFrequency+ShakeDeltaFrequency;
      maxn:=round(ShakeTime/SRSGPIBCommandTime);
      for n:=1 to maxn do begin
        SRSSinus(2,(n/maxn)*(ShakeStopFrequency-ShakeStartFrequency)+ShakeStartFrequency,ShakeAmplitude,0,0);
        Wait(207*ID+SRSGPIBCommandTime);
      end;
      SRSSinus(2,ShakeStopFrequency,0,0,0);
      Wait(208*ID+SRSGPIBCommandTime);
    SequenceEndBlock;
  end;

  procedure OpticalPumping;
  var HelpMagTrapStartTime:double;
      n:byte;
      FirstTime:boolean;
      AktPump6Repump:boolean;
      mf:integer;
  begin
    FinalTrap:='optical pumping';
    if PumpToF_2 then AtomPath:=AtomPath+'O2'
    else AtomPath:=AtomPath+'O1';
    SwitchIGBTsOff;
    SwitchAOM20(off);
    SwitchOpticalPumpingField(on);
    SwitchRepumpAndOpticalPumpingEnable(on);
    IOUpdate;
    if (MOT7LiPrincipalFlashTime>0) then SwitchMaster7Principal(on);
    SetMOTVoltage(MagTrapStartMOTVoltage);
    if Use7RepumpForOpticalPumping then SetOpticalPumpingDetuning7Li(OpticalPumping7repumpDetuning);
    if Use6RepumpForOpticalPumping then SetOpticalPumpingDetuning6Li(OpticalPumping6repumpDetuning);
    SwitchMaster7Repump(Use7RepumpForOpticalPumping);
    SwitchMaster6Repump(Use6RepumpForOpticalPumping);
    SetAOM20Intensity(MOTIntensity);
    Set7PrincipalDetuning(Flash7PrincipalDetuning);
    Wait(211*ID+OpticalPumpingToggleFieldTime);
    if OpticalPumpingTime>0 then begin
      SwitchOpticalPumpingBeam(on);
      IOUpdate;
      if (OpticalPumpingTime>0.025) then Wait(214*ID+OpticalPumpingTime);
      if OpticalPumping7LiRepumpAloneTime>0 then begin
        SwitchMaster6Repump(off);
        SwitchMaster7Repump(on);
        Wait(215*ID+OpticalPumping7LiRepumpAloneTime);
      end else if OpticalPumping7LiRepumpAloneTime<0 then begin
        SwitchMaster7Repump(off);
        SwitchMaster6Repump(on);
        Wait(216*ID+-OpticalPumping7LiRepumpAloneTime);
      end;
      SwitchOpticalPumpingBeam(off);
      IOUpdate;
    end;
    if (MOT7LiPrincipalFlashTime>0) then begin
      SwitchMaster7Principal(on);
      SwitchMaster7Repump(off);
      Set7PrincipalDetuning(Flash7PrincipalDetuning);
      IOUpdate;
      SwitchAOM20(on);
      SetAOM20Intensity(MOTIntensity);
      Wait(217*ID+MOT7LiPrincipalFlashTime);
      SwitchAOM20(off);
      IOUpdate;
    end;
    if (MOT7LiPrincipalFlashTime<0) then begin
      if Do6LiRepumpFlash then begin
        SwitchMaster6Principal(off);
        SwitchMaster6Repump(on);
        Set6RepumpDetuning(0);
      end;
      SwitchMaster7Principal(off);
      SwitchMaster7Repump(on);
      Set7RepumpDetuning(Flash7RepumpDetuning);
      SetAOM20Intensity(FlashIntensity);
      IOUpdate;
      SwitchAOM20(on);
      Wait(218*ID+-MOT7LiPrincipalFlashTime);
      SwitchAOM20(off);
      IOUpdate;
    end;
    SwitchMaster7Repump(off);
    SwitchMaster6Repump(off);
    SwitchMaster7Principal(off);
    SwitchMaster6Principal(off);
    IOUpdate;
  end;

  procedure StartMagTrapWithOpticalPumping;
  begin
    OpticalPumping;
    FinalTrap:='QP MagTrap';
    AtomPath:=AtomPath+'Qp';
    FinalTrapType:=QP;
    SetMOTVoltage(MagTrapStartMOTVoltage);
    IOUpdate;
    SwitchIGBTsToMagTrap;
    if (MagTrapStartTime>OpticalPumpingFieldOverlapTime) then begin
      Wait(219*ID+OpticalPumpingFieldOverlapTime);
      SwitchOpticalPumpingField(off);
      Wait(220*ID+MagTrapStartTime-OpticalPumpingFieldOverlapTime);
      SetMOTVoltage(MagTrapMOTVoltage);
    end else begin
      Wait(221*ID+MagTrapStartTime);
      SetMOTVoltage(MagTrapMOTVoltage);
      Wait(222*ID+OpticalPumpingFieldOverlapTime-MagTrapStartTime);
      SwitchOpticalPumpingField(off);
    end;
    IOUpdate;
    {ShutterProbe6principal(DetectLithium6);
    ShutterProbe7principal(DetectLithium7);}
  end;

procedure PrepareOpticalPumping;
begin
  if ProbeAOMsDefaultOn then begin
    SwitchProbeAndRepumpAOMHeatingDirect(off);
    Wait(223*ID+ProbeAOMOffTimeBeforeShutterOpen);
    ShutterProbeRepumpAndOpticalPumpingBeam(open);
  end;
  ShutterMOT6repump(on);
  SwitchMaster6Repump(on);
  {if not TrapLithium6 then SetOpticalPumpingDetuning6Li(OpticalPumping6repumpDetuning);}
  if ProbeAOMsDefaultOn then Wait(224*ID+ShutterProbeAndRepumpDelay);
  SwitchRepumpAndOpticalPumpingEnable(on);
end;

procedure FinishOpticalPumping;
begin
  if ProbeAOMsDefaultOn then begin
    ShutterProbeRepumpAndOpticalPumpingBeam(off);
    ShutterProbe(off);
    Wait(225*ID+ShutterProbeAndRepumpDelay);
    SwitchProbeAndRepumpAOMHeatingDirect(on);
  end;
end;

procedure StartMagTrap;
begin
  {SwitchOszilloskopTrigger(off);
  Wait(226*ID+0.1);}
  FinalTrap:='QP MagTrap';
  AtomPath:=AtomPath+'Qp';
  FinalTrapType:=QP;
  SwitchIGBTsToMagTrap;
  SwitchAOM20(off);
  IOUpdate;
  SetMOTVoltage(MagTrapStartMOTVoltage);
  Wait(227*ID+MagTrapStartTime);
  SetMOTVoltage(MagTrapMOTVoltage);
  IOUpdate;
end;

procedure QuickProtect;
begin
  SwitchMaster7Repump(off);
  SwitchMaster7Principal(off);
  SwitchMaster6Repump(off);
  SwitchMaster6Principal(off);
  ShutterMOT(close);
  if DoProtectMagTrap then begin
    ShutterProbeRepumpAndOpticalPumpingBeam(close);
    ShutterProbe(close);
  end;
  IOUpdate;
end;

procedure ProtectMagTrap;
begin
  FinalTrap:='protected MagTrap';
  AtomPath:=AtomPath+'P+';
  ShutterMOT(close);
  ShutterProbeRepumpAndOpticalPumpingBeam(close);
  ShutterProbe(close);
  SwitchAOM20(off);
  if KeepInjection then begin
    Wait(ShutterProbeAndRepumpDelay);
    SwitchMaster7Repump(on);
    SwitchMaster7Principal(on);
    SwitchMaster6Repump(on);
    SwitchMaster6Principal(on);
  end else begin
    if KeepMasterAOMsOn then begin
      Wait(ShutterProbeAndRepumpDelay);
      SwitchMaster7Repump(on);
      SwitchMaster7Principal(on);
      SwitchMaster6Repump(on);
      SwitchMaster6Principal(on);
    end else begin
      SwitchMaster7Repump(off);
      SwitchMaster7Principal(off);
      SwitchMaster6Repump(off);
      SwitchMaster6Principal(off);
    end;
  end;
  if KeepMOTAOMOn and (not DoDopplerCoolIoffeTrap[1]) then begin
    ShutterAOM20(off);
    SwitchAOM20Delayed(on);
  end;
  ShutterMOT6principal(close);
  ShutterMOT6repump(close);
  if KeepInjection then begin
    ShutterMOT7principal(open);
    ShutterMOT7repump(open);
    ShutterMOT6principal(open);
    ShutterMOT6repump(open);
  end else begin
    if not DoDopplerCoolIoffeTrap[1] then begin
      ShutterMOT7repump(close);
      ShutterMOT7principal(close);
    end;
    ShutterMOT6principal(close);
    ShutterMOT6repump(close);
  end;
  if (not DoDopplerCoolIoffeTrap[1]) and (not KeepInjection)
  then ShutterMaster7AndMOT7LiPrincipal(off);
  ShutterProbe(close);
  IOUpdate;
  if DoSwitchMaster7PrincipalOff then SwitchMaster7Principal(off);
  if not DoDopplerCoolIoffeTrap[1] then SetProbeDetuning(DetectIsotop)
  else PrepareNextDopplerCooling(0);
  IOUpdate;
end;

procedure UnProtectMagTrap;
begin
  FinalTrap:='unprotected MagTrap';
  AtomPath:=AtomPath+'P-';
  if InjectProbeRepumpLast then begin
    SwitchMaster7Repump(off);
    SwitchMaster6Repump(off);
  end;
  wait(1);
  if (DetectIsotop=7) or TwoPictures then begin
    SwitchMaster7Principal(on);
    if not InjectProbeRepumpLast then SwitchMaster7Repump(ProbeWithRepump);
    ShutterMaster7AndMOT7LiPrincipal(on);
    ShutterMOT7repump(ProbeWithRepump);
  end;
  if (DetectIsotop=6) or TwoPictures then begin
    if not InjectProbeRepumpLast then SwitchMaster6Repump(ProbeWithRepump);
    ShutterMOT6repump(ProbeWithRepump);
    SwitchMaster6Principal(on);
    ShutterMOT6principal(open);
  end;
  Wait(UnProtectMagTrapStabilizationTimeInjection);
  ShutterProbe(open);
  Wait(3);
  if ProbeWithRepump then ShutterProbeRepumpAndOpticalPumpingBeam(not ProbeAOMsDefaultOn);
  Wait(232*ID+UnProtectMagTrapStabilizationTime-4);
end;

procedure QPDopplerCooling;
begin
  FinalTrap:='Cooled QP';
  AtomPath:=AtomPath+'DC';
  if (QPDCPrincipalDetuning>-100) then Set7PrincipalDetuning(QPDCPrincipalDetuning)
  else SwitchMaster7Principal(off);
  if (QPDCRepumpDetuning>-100) then Set7RepumpDetuning(QPDCRepumpDetuning)
  else SwitchMaster7Repump(off);
  SetAOM20Intensity(QPDCIntensity);
  IOUpdate;
  SwitchAOM20(on);
  Wait(233*ID+QPDCTime);
  SwitchAOM20(off);
  if not DoDopplerCoolIoffeTrap[1] then SetProbeDetuning(DetectIsotop)
  else PrepareNextDopplerCooling(0);
end;

procedure Recapture;
var n:word;
    Waittime:double;
begin
  {if DoCompressedMagTrap then CCCVTransition;}
  FinalTrap:='Recaptured';
  AtomPath:=AtomPath+'Re';
  SwitchMaster7Repump(off);
  SwitchMaster7Principal(off);
  IOUpdate;
  ShutterMaster7AndMOT7LiPrincipal(on);
  if TrapLithium7 then begin
    ShutterMOT7principal(open);
    ShutterMOT7repump(open);
  end else begin
    ShutterMOT7principal(close);
    ShutterMOT7repump(close);
  end;
  if TrapLithium6 then begin
    ShutterMOT6principal(open);
    ShutterMOT6repump(open);
  end else begin
    ShutterMOT6principal(close);
    ShutterMOT6repump(close);
  end;
  ShutterProbe(open);
  if ProbeWithRepump then ShutterProbeRepumpAndOpticalPumpingBeam(not ProbeAOMsDefaultOn);
  {ShutterProbeDirect(close);}
  ShutterMOT(open);
  ShutterAOM20(open);
  SetMOTDetuning;
  SetAOM20Intensity(MOTIntensity);
  SwitchMaster7Repump(on);
  SwitchMaster7Principal(on);
  SwitchMaster6Repump(on);
  SwitchMaster6Principal(on);
  EnableAOMs;
  SwitchAOM20Frequency(off);
  IOUpdate;
  SwitchIGBTsOff;
  SetMOTVoltage(MOTMOTVoltage);
  SwitchAOM20(on);
  IOUpdate;
  for n:=0 to 35 do begin
    SwitchIGBTsToMOT;
    WaitTime:=0.3+0.02*n;
    if n=0 then Waittime:=Waittime+0.1;
    Wait(234*ID+WaitTime);
    SwitchIGBTsOff;
    IOUpdate;
  end;
  SwitchTransferDecharging(off);
  IOUpdate;
  SwitchIGBTsToMOT;
  IOUpdate;
  SetTransfer2Voltage(MOTTransfer2Voltage);
  IOUpdate;
  if MeasureRecaptureFluo then begin
    SequenceStopPortList;
    MeasureFluorescence(1);
    for n:=1 to round(RecaptureTime/10) do begin
      MeasureIntegratedFluorescence(1);
      Wait(235*ID+10);
    end;
    NormalizeIntegratedFluorescence(1,round(RecaptureTime/10)+1);
    SequenceStartPortListDuringWait(236*ID+10);
  end else Wait(237*ID+RecaptureTime);
end;

procedure StartRFShield;
begin
  AtomPath:=AtomPath+'+';
  SetFrequency(0,RFShieldFrequency0);
  Wait(238*ID+GPIBCommandTime);
  SwitchRFGPIB(0,MaxRFLevel,on);
  SwitchRF(0,on);
  Wait(239*ID+GPIBCommandTime);
  if RFShieldFrequency1<>0 then begin
    SetFrequency(1,RFShieldFrequency1);
    Wait(240*ID+GPIBCommandTime);
    SwitchRFGPIB(1,MaxRFLevel,on);
    SwitchRF(1,on);
    Wait(241*ID+GPIBCommandTime);
  end;
end;

procedure SwitchRFShieldOff;far;
begin
  FinalTrap:='-';
  AtomPath:=AtomPath+'S+';
  SequenceStartBlockNoArg(SwitchRFShieldOff);
    if RFOn(0) or RFOn(1) or RFOn(2) or RFOn(3) then begin
      if RFOn(0) then begin
        SetFrequency(0,0.001);
        Wait(242*ID+GPIBCommandTime);
      end;
      if RFOn(1) then begin
        SetFrequency(1,0.001);
        Wait(242*ID+GPIBCommandTime);
      end;
      if RFOn(2) then begin
        SetFrequency(2,0.001);
        Wait(242*ID+GPIBCommandTime);
      end;
      Wait(500);
      if RFOn(0) then begin
        {SwitchRFOff(0);}
        Wait(242*ID+GPIBCommandTime);
      end;
      if RFOn(1) then begin
        {SwitchRFOff(1); }
        Wait(242*ID+GPIBCommandTime);
      end;
      if RFOn(2) then begin
        SwitchRFOff(2);SwitchRF(3,off);
        Wait(242*ID+GPIBCommandTime);
      end;
    end;
  SequenceEndBlock;
end;

procedure PrepareRFPulsSequence(SequenceNr:byte);
var RFSequence:string;
    nr:byte;
    times:array[0..3] of double;
    hdelay:double;
    n,m:byte;
    MaxPuls:byte;
    InverseTriggerTable:array[0..3] of byte;
    buf:string;
    Can1prog,Can3prog:boolean;
    PulsgenFired:boolean;
    AktTrigger:byte;

  procedure EatWhite(var Sentence:string);
  begin
    while Sentence[1]=' ' do sentence:=copy(Sentence,2,255);
  end;

  function GetWord(var Sentence:string):string;
  var help:string;
  begin
    help:='';
    EatWhite(sentence);
    if pos(' ',sentence)>1 then begin
      help:=copy(sentence,1,pos(' ',sentence)-1);
      sentence:=copy(sentence,pos(' ',sentence)+1,255);
    end else begin
      help:=sentence;
      sentence:='';
    end;
    EatWhite(help);
    GetWord:=help;
  end;

  procedure UpString(var buf:string);
  var n:byte;
  begin
    for n:=1 to length(buf) do buf[n]:=upcase(buf[n]);
  end;

  function Comp(buf:string;start:byte;substring:string):boolean;
  begin
    Comp:=(buf[start]=substring[1]) and (buf[start+1]=substring[2]);
  end;

  function GetTimetable:boolean;
  var add:byte;
      time:double;
      n:byte;
      Puls:string;
      PulsNr:byte;
     {PSTriggerTable:array[0..MaxRFPulsSequences,0..3] of record
           Trigger:byte;
           Delay:double;
         end;}
  begin
    GetTimetable:=false;
    for n:=0 to 3 do begin
      times[n]:=1;
      PSTriggerTable[SequenceNr,n].Trigger:=255;
      PSTriggerTable[SequenceNr,n].Delay:=0;
      InverseTriggerTable[n]:=255;
    end;
    Puls:=GetWord(RFSequence);
    PulsNr:=0;
    while Puls<>'' do begin
      if (length(Puls)<>5) or ((Puls[1]<>'7') and (Puls[1]<>'6'))
          then begin
        writeln('MagTrap : PrepareRFPulsSequence : Puls not correct length or species : '+Puls);
        delay(1000);
        exit;
      end;
      if Comp(Puls,4,'PI') then time:=1
      else if Comp(Puls,4,'P2') then time:=0.5
      else if Comp(Puls,4,'2P') then time:=2
      else begin
        writeln('MagTrap : PrepareRFPulsSequence : Puls duration not correct (Pi,P2,2P) : '+Puls);
        delay(1000);
        exit;
      end;
      if Comp(Puls,2,'ZE') then Add:=2
      else if Comp(Puls,2,'HF') then Add:=0
      else begin
        writeln('MagTrap : PrepareRFPulsSequence : Puls species not correct (Hf,Ze) : '+Puls);
        delay(1000);
        exit;
      end;
      if (Puls[1]='7') then begin
        times[Add]:=time;
        PSTriggerTable[SequenceNr,PulsNr].Trigger:=Add;
        InverseTriggerTable[Add]:=PulsNr;
      end else if (Puls[1]='6') then begin
        times[1+Add]:=time;
        PSTriggerTable[SequenceNr,PulsNr].Trigger:=Add+1;
        InverseTriggerTable[Add+1]:=PulsNr;
      end;
      Puls:=GetWord(RFSequence);
      inc(PulsNr);
    end;
    MaxPuls:=PulsNr;
    if PulsNr=0 then begin
      writeln('MagTrap : PrepareRFPulsSequence : no Pulses found : ',Sequencenr);
      delay(1000);
      exit;
    end;
    GetTimeTable:=true;
  end;

begin
  RFSequence:=RFPulsSequence[Sequencenr];
  UpString(RFSequence);
  buf:=GetWord(RFSequence);
  nr:=byte(buf[1])-byte('A')+1;
  if nr>MaxRFPulsSequenceValues then begin
    writeln('MagTrap : PrepareRFPulsSequence : Sequence has to start with field (A,B,...)');
    delay(1000);
    exit;
  end;
  if not GetTimetable then exit;
  for n:=0 to MaxPuls-1 do begin
    PSTriggerTable[SequenceNr,n].Delay:=
      PSValue[nr,PSTriggerTable[SequenceNr,n].Trigger].Time
      *times[PSTriggerTable[SequenceNr,n].Trigger];
  end;
  if InverseTriggerTable[2]<255 then PSTriggerTable[SequenceNr,InverseTriggerTable[2]].Delay:=1000*(
    PSTriggerTable[SequenceNr,InverseTriggerTable[2]].Delay/
    (PSValue[nr,2].Frequency*1000000));
  for n:=0 to MaxPuls-1 do begin
    if PSTriggerTable[SequenceNr,n].Delay<0.07 then PSTriggerTable[SequenceNr,n].Delay:=0.07
    else PSTriggerTable[SequenceNr,n].Delay:=PSTriggerTable[SequenceNr,n].Delay+0.02;
  end;
  hdelay:=0;
  Can1prog:=false;
  Can3prog:=false;
  PulsgenFired:=false;
  for n:=0 to MaxPuls-1 do begin
    AktTrigger:=PSTriggerTable[SequenceNr,n].Trigger;
    if (AktTrigger=1) then begin
      PulsGenPrepareChannelDirect(0,1,hdelay,PSValue[nr,1].Time*times[1]);
      Can1prog:=true;
      PulsgenFired:=true;
    end else if (AktTrigger=3) then begin
      PulsGenPrepareChannelDirect(0,3,hdelay,PSValue[nr,3].Time*times[3]);
      Can3prog:=true;
      PulsgenFired:=true;
    end;
    if PulsgenFired then hdelay:=hdelay+PSTriggerTable[SequenceNr,n].Delay;
  end;
  if not Can1prog then begin
    PulsGenPrepareChannelDirect(0,1,0,0.0004);
  end;
  if not Can3prog then begin
    PulsGenPrepareChannelDirect(0,3,0,0.0004);
  end;
  PulsgenStoreDirect(0,SequenceNr);
  ExpIO.PulsgenRecall(0,SequenceNr);
  Wait(100);
  if InverseTriggerTable[0]<255 then begin
    SwitchRFOff(0);
    Wait(277*ID+GPIBCommandTime);
    SetFrequency(0,PSValue[nr,0].Frequency);
    Wait(276*ID+GPIBCommandTime);
    PreparePuls(0,PSValue[nr,0].Time*times[0]);
    Wait(275*ID+GPIBCommandTime);
    SwitchRFGPIB(0,PSValue[nr,0].Level,on);
    Wait(277*ID+GPIBCommandTime);
  end;
  if InverseTriggerTable[2]<255 then begin
    PrepareRFBurstPuls(2,round(PSValue[nr,2].Time*times[2]),PSValue[nr,2].Frequency,PSValue[nr,2].Level,0);
  end;
  SwitchRF(1,off);
  Wait(270*ID+10);
  if InverseTriggerTable[1]<255 then begin
    SetFrequency(1,PSValue[nr,1].Frequency);
    Wait(272*ID+MinSubsequentGPIBCommandTime);
    SwitchRFGPIB(1,PSValue[nr,1].Level,on);
    Wait(274*ID+GPIBCommandTime);
  end;
  SwitchRF(3,off);
  Wait(270*ID+10);
  if InverseTriggerTable[3]<255 then begin
    SetFrequency(2,PSValue[nr,3].Frequency);
    Wait(272*ID+MinSubsequentGPIBCommandTime);
    SwitchRFGPIB(2,PSValue[nr,3].Level,on);
    Wait(274*ID+GPIBCommandTime);
  end;
end;

procedure ExecuteRFPulsSequence(SequenceNr:byte;LastMillisecondExperiment:boolean);
var n:byte;
    PulsgenFired:boolean;
    AktTrigger:byte;
begin
  SynchronizeToLine;
  SequenceStartPortListDuringWait(275*ID+10);
  Wait(276*ID+1);

  n:=0;
  PulsGenfired:=false;
  while PSTriggerTable[SequenceNr,n].Trigger<=3 do begin
    AktTrigger:=PSTriggerTable[SequenceNr,n].Trigger;
    if (AktTrigger=1) or (AktTrigger=3) then begin
      if not PulsgenFired then begin
        SynthTrigger(1,on);
        PulsgenFired:=true;
      end;
    end else SynthTrigger(AktTrigger,on);
    Wait(PSTriggerTable[SequenceNr,n].Delay);
    inc(n);
  end;

  AtomPath:=AtomPath+'H'+char(SequenceNr-byte('0'));

  for n:=0 to 3 do SynthTrigger(n,off);
  IOUpdate;

  if not LastMillisecondExperiment then begin
    Wait(281*ID+1);
    SequenceStopPortList;
  end;
end;

procedure SendCommandtoVCORFSweep;
var help:double;
    help2:double;

begin

  SequenceStartBlockNoArg(SendCommandtoVCORFSweep);

    help:=StartVCORFSweep1-StopVCORFSweep1;
    if (help<0) then begin
      help:=-1*help;
      SetFrequency(0,StartVCORFSweep1);
      SetVCORFSweepValue(0,0);
    end else begin
      SetFrequency(0,StopVCORFSweep1);
      SetVCORFSweepValue(0,1);
    end;
    Wait(506*ID+GPIBCommandTime);

    help2:=StartVCORFSweep2-StopVCORFSweep2;
    if (help2<0) then begin
      help2:=-1*help2;
      SetFrequency(1,StartVCORFSweep2);
      SetVCORFSweepValue(1,0);
    end else begin
      SetFrequency(1,StopVCORFSweep2);
      SetVCORFSweepValue(1,1);
    end;
    Wait(506*ID+GPIBCommandTime);

    PrepareVCORFSweep(0,help);
    Wait(507*ID+GPIBCommandTime);
    PrepareVCORFSweep(1,help2);
    Wait(507*ID+GPIBCommandTime);

{    SwitchRF(1,on);
}
    SwitchRFGPIB(1,LevelVCORFSweep2,on);
    Wait(505*ID+GPIBCommandTime);
    SwitchRFGPIB(0,LevelVCORFSweep1,on);
    Wait(505*ID+GPIBCommandTime);


    SequenceEndBlock;
end;

procedure ExecuteVCORFSweep;

var steps : word;
    value : double;
    value2 : double;
    n:word;
begin

    AtomPath:=AtomPath+'T';

    SequenceStartBlockNoArg(ExecuteVCORFSweep);

    SwitchRF(1,on);
    IOUpdate;

    steps:=round(TimeVCORFSweep/0.04);

    for n:=0 to steps do begin
      if (StartVCORFSweep1<StopVCORFSweep1) then begin
        value:=n/steps;
      end else begin
        value:=1-n/steps;
      end;
      if (StartVCORFSweep2<StopVCORFSweep2) then begin
        value2:=n/steps;
      end else begin
       value2:=1-n/steps;
      end;

      SetVCORFSweepValue(0,value);
      SetVCORFSweepValue(1,value2);
      IOUpdate; {Wait(0.2);}
    end;

    SwitchRF(1,off);
    IOUpdate;
    SwitchRFoff(0);
    Wait(508*ID+GPIBCommandTime);
    SwitchRFoff(1);
    Wait(508*ID+GPIBCommandTime);
    SetVCORFSweepValue(0,0);
    SetVCORFSweepValue(1,0);
    IOUpdate;

    SequenceEndBlock;
end;


procedure ProbeFlashUnprotectMagTrap;
begin
  SwitchMaster7Principal(on);
  ShutterMaster7AndMOT7LiPrincipal(on);
  SwitchMaster6Principal(on);
  ShutterMOT6principal(open);
  ShutterProbe(open);
  Wait(232*ID+UnProtectMagTrapStabilizationTime);
end;

procedure ProbeFlashProtectMagTrap;
begin
  QuickProtect;
  ShutterProbe(close);
  if KeepInjection then begin
    Wait(ShutterProbeAndRepumpDelay);
    SwitchMaster7Repump(on);
    SwitchMaster7Principal(on);
    SwitchMaster6Repump(on);
    SwitchMaster6Principal(on);
  end else begin
    if KeepMasterAOMsOn then begin
      Wait(ShutterProbeAndRepumpDelay);
      SwitchMaster7Repump(on);
      SwitchMaster7Principal(on);
      SwitchMaster6Repump(on);
      SwitchMaster6Principal(on);
    end else begin
      SwitchMaster7Repump(off);
      SwitchMaster7Principal(off);
      SwitchMaster6Repump(off);
      SwitchMaster6Principal(off);
    end;
  end;
  ShutterMOT6principal(close);
  ShutterMOT6repump(close);
  if KeepInjection then begin
    ShutterMOT7principal(open);
    ShutterMOT7repump(open);
    ShutterMOT6principal(open);
    ShutterMOT6repump(open);
  end else begin
    if not DoDopplerCoolIoffeTrap[1] then begin
      ShutterMOT7repump(close);
      ShutterMOT7principal(close);
    end;
    ShutterMOT6principal(close);
    ShutterMOT6repump(close);
  end;
  if (not KeepInjection) then ShutterMaster7AndMOT7LiPrincipal(off);
  Wait(1);
end;

procedure ProbeFlash;
begin
  ProbeFlashUnprotectMagTrap;
  SwitchRepumpAndOpticalPumpingEnable(false);
  Select7LiProbeBeam(true);
  Select6LiProbeBeam(true);
  wait(1);
  ExposureTrigger(on);
  wait(1);
  ExposureTrigger(off);
  Wait(1);
  if DoProtectMagTrap then ProbeFlashProtectMagTrap;
end;

procedure RepumpFlashUnprotectMagTrap;
begin
  SwitchMaster7Repump(on);
  {ShutterMaster7AndMOT7LiPrincipal(on);}
  SwitchMaster6Repump(on);
  ShutterMOT6repump(open);
  ShutterMOT7repump(open);
  ShutterProbeRepumpAndOpticalPumpingBeam(open);
  Wait(232*ID+UnProtectMagTrapStabilizationTime);
end;

procedure RepumpFlashProtectMagTrap;
begin
  QuickProtect;
  ShutterProbeRepumpAndOpticalPumpingBeam(close);
  if KeepInjection then begin
    Wait(ShutterProbeAndRepumpDelay);
    SwitchMaster7Repump(on);
    SwitchMaster7Principal(on);
    SwitchMaster6Repump(on);
    SwitchMaster6Principal(on);
  end else begin
    if KeepMasterAOMsOn then begin
      Wait(ShutterProbeAndRepumpDelay);
      SwitchMaster7Repump(on);
      SwitchMaster7Principal(on);
      SwitchMaster6Repump(on);
      SwitchMaster6Principal(on);
    end else begin
      SwitchMaster7Repump(off);
      SwitchMaster7Principal(off);
      SwitchMaster6Repump(off);
      SwitchMaster6Principal(off);
    end;
  end;
  ShutterMOT6principal(close);
  ShutterMOT6repump(close);
  if KeepInjection then begin
    ShutterMOT7principal(open);
    ShutterMOT7repump(open);
    ShutterMOT6principal(open);
    ShutterMOT6repump(open);
  end else begin
    if not DoDopplerCoolIoffeTrap[1] then begin
      ShutterMOT7repump(close);
      ShutterMOT7principal(close);
    end;
    ShutterMOT6principal(close);
    ShutterMOT6repump(close);
  end;
  if (not KeepInjection) then ShutterMaster7AndMOT7LiPrincipal(off);
  Wait(1);
end;

procedure RepumpFlash;
begin
  RepumpFlashUnprotectMagTrap;
  SwitchRepumpAndOpticalPumpingEnable(true);
  Select7LiProbeBeam(false);
  Select6LiProbeBeam(false);
  wait(1);
  ExposureTrigger(on);
  wait(1);
  ExposureTrigger(off);
  Wait(1);
  if DoProtectMagTrap then RepumpFlashProtectMagTrap;
end;

function ScaleHorizontalNdYagIntensity(h:double):double;
var help:double;
begin
  aktOptTrapIntensity[0]:=h;
  if h=0 then help:=0
  else begin
    help:=24168.9*Exponential(0.34541*Ln(h))-1972.19*h+40810.7*h*h;
    if (help<0) then help:=0;
    if (help>65535) then help:=65535;
  end;
  help:=help/65535;
  ScaleHorizontalNdYagIntensity:=help;
end;

function ScaleVerticalNdYagIntensity(h:double):double;
var help:double;
begin
  aktOptTrapIntensity[1]:=h;
  {if h=0 then help:=0}
  if h<3.28E-3 then help:=0
  else begin
    {help:=-15108+71525*Exponential(0.218154*Ln(h))-1104*h+10213*h*h*h;}
    help:=45135.4*Exponential(0.312459*Ln(h-0.19/58))+26.1459*h+4734.29*h*h+14879.2*h*h*h*h*h*h;
    if (help<0) then help:=0;
    if (help>65535) then help:=65535;
  end;
  help:=help/65535;
  ScaleVerticalNdYagIntensity:=help;
end;

procedure Start2BeamOpticalTrapIntensity(f:double);far;
begin
  SetNdYagIntensity(0,ScaleHorizontalNdYagIntensity(f*StartHorizontalNdYAGIntensity));
  SetNdYagIntensity(1,ScaleVerticalNdYagIntensity(f*StartVerticalNdYAGIntensity));
end;

procedure StartOpticalTrap;far;
begin
  FinalTrap:='Op';
  AtomPath:=AtomPath+'O+';
  SequenceStartBlockNoArg(StartOpticalTrap);
    Wait(1);
    if (OpticalTrapStartTime>0) then Start2BeamOpticalTrapIntensity(0)
    else Start2BeamOpticalTrapIntensity(MaxNdYAGIntensity);
    Wait(1);
    SwitchHorizontalNdYAG(on);
    SwitchVerticalNdYAG(on);
    Wait(1);
    if (OpticalTrapStartTime>0) then begin
      Ramp(Start2BeamOpticalTrapIntensity,0,MaxNdYAGIntensity,OpticalTrapStartTime,0.2);
      Wait(1);
    end;
  SequenceEndBlock;
end;

procedure ModeMatchTransferRadial;far;
begin
  FinalTrap:='Op';
  AtomPath:=AtomPath+'TR';
  SequenceStartBlockNoArg(ModeMatchTransferRadial);
    SwitchIGBT(8,off);
    IOUpdate;
    {SetNdYagIntensity(0,ModeMatchHorizontalNdYAGIntensity);}
    {SetNdYagIntensity(1,ModeMatchVerticalNdYAGIntensity);}
    Wait(1);
  SequenceEndBlock;
end;

procedure ExciteOpticalTrap;far;
var oldHorizInt,oldVertInt:double;
begin
  FinalTrap:='Op';
  AtomPath:=AtomPath+'TR';
  SequenceStartBlockNoArg(ExciteOpticalTrap);
    oldHorizInt:=aktOptTrapIntensity[0];
    oldVertInt:=aktOptTrapIntensity[1];
    SetNdYagIntensity(0,ScaleHorizontalNdYagIntensity(ExciteOptTrapHorizontalNdYAGIntensity));
    SetNdYagIntensity(1,ScaleVerticalNdYagIntensity(ExciteOptTrapVerticalNdYAGIntensity));
    Wait(ExciteOptTrapWait);
    SetNdYagIntensity(0,ScaleHorizontalNdYagIntensity(oldHorizInt));
    SetNdYagIntensity(1,ScaleVerticalNdYagIntensity(oldVertInt));
    IOUpdate;
  SequenceEndBlock;
end;


var aktOptTrapRampNr:byte;
    helph:double;
    helpv:double;

procedure Set2BeamOpticalTrapIntensity(f:double);far;
begin
  SetNdYagIntensity(0,ScaleHorizontalNdYagIntensity(f*helph+FinalHorizontalNdYagINtensity[aktOptTrapRampNr]));
  SetNdYagIntensity(1,ScaleVerticalNdYagIntensity(f*helpv+FinalVerticalNdYagINtensity[aktOptTrapRampNr]));
end;

procedure RampOpticalTrap(nr:byte);far;
begin
  FinalTrap:='Op1';
  AtomPath:=AtomPath+'O1+';
  SequenceStartBlockByteArg(RampOpticalTrap,Nr);
  Wait(1);
  if not DoOpticalTrap then exit;
  aktOptTrapRampNr:=nr;
  helph:=-1*(FinalHorizontalNdYAGIntensity[aktOptTrapRampNr]-aktOptTrapIntensity[0]);
  helpv:=-1*(FinalVerticalNdYAGIntensity[aktOptTrapRampNr]-aktOptTrapIntensity[1]);
  if (OpticalTrapRampTime[nr]>0) then begin
    Ramp(Set2BeamOpticalTrapIntensity,1,0,OpticalTrapRampTime[nr],0.2);
    Wait(1);
    if FinalHorizontalNdYAGIntensity[aktOptTrapRampNr]=0 then
      SwitchHorizontalNdYAG(off);
    if FinalVerticalNdYAGIntensity[aktOptTrapRampNr]=0 then
      SwitchVerticalNdYAG(off);
  end else Set2BeamOpticalTrapIntensity(0);
  SequenceEndBlock;
end;

procedure SwitchOffMagtrap;far;
var n:byte;
begin
  SequenceStartBlockNoArg(SwitchOffMagtrap);
    FinalTrap:='optical trap';
    AtomPath:=AtomPath+'M-';
    Wait(1);
    {SwitchTrapOff; Offset field is also off}

    {Offset field is kept on}
    for n:=1 to 3 do SwitchIGBT(n,off);
    for n:=5 to 9 do SwitchIGBT(n,off);
    if DoAxialGradient then SwitchAxialGradient(off);
    Wait(1);
    SwitchIGBT(4,off);
    Wait(1);
  SequenceEndBlock;
end;


procedure SeparationGradient;far;
var n:byte;
begin
  AtomPath:=AtomPath+'SG';
  SequenceStartBlockNoArg(SeparationGradient);
    Wait(1);
    for n:=1 to 3 do SwitchIGBT(n,off); {Offset field is kept on}
    for n:=5 to 9 do SwitchIGBT(n,off); {Offset field is kept on}
    Wait(1);
    SwitchIGBT(4,off);
    Wait(1);
    SetTransfer1Voltage(0);
    SetTransfer2Voltage(0);
    SetTransfer1Current(0);
    SwitchTransferDecharging(on);
    Wait(10);
    SwitchTransferDecharging(off);
    SetTransfer1Voltage(MaxTransfer1Voltage);
    Wait(1);
    SwitchIGBT(3,on);
    SwitchIGBT(1,on);
    Wait(1);
    Ramp(SetTransferCurrent,0,SeparationGradientCurrent,SeparationGradientRampTime,0.2);
    Wait(SeparationGradientTime);
    Ramp(SetTransferCurrent,SeparationGradientCurrent,0,SeparationGradientRampTime,0.2);
    Wait(1);
    SwitchIGBT(3,off);
    SwitchIGBT(1,off);
    SetTransfer1Voltage(0);
    SetTransfer2Voltage(0);
    SetTransfer1Current(0);
    SwitchTransferDecharging(on);
    Wait(1);
  SequenceEndBlock;
end;


procedure StartFeshbachField;far;
var n:byte;
begin
  FinalTrap:='optical trap with Feshbach field';
  AtomPath:=AtomPath+'F+';
  SequenceStartBlockNoArg(StartFeshbachField);
    Wait(1);
    for n:=1 to 3 do SwitchIGBT(n,off); {Offset field is kept on}
    for n:=5 to 9 do SwitchIGBT(n,off); {Offset field is kept on}
    Wait(1);
    SwitchIGBT(4,off);
    Wait(1);
    if UsePinchForFeshbachField then begin
      UsedFeshbachField:=Pinch;
      SetMOTCurrent(0);
      SetMotVoltage(0);
      SwitchMOTDecharging(on);
{      SequenceStartPortListDuringWait(399*ID+10);}
      SwitchMOTDecharging(off);
      IOUpdate;

      SwitchIGBT(4,on);
      SwitchIGBT(5,on);
{      SequenceStopPortList; }
      if StartFeshbachCurrent>MaxIGBT5Current then StartFeshbachCurrent:=MaxIGBT5Current;
      SetMOTVoltage(MaxMOTVoltage);
      RampCornerLess(SetMOTCurrent,0,StartFeshbachCurrent,EtaFeshbachStartRamp,FeshbachCurrentStartTime,0.2);
      IOUpdate;
{      Ramp(SetMOTVoltage,StartFeshbachFieldPrepareVoltage,FeshbachVoltageStart,FeshbachVoltageStartTime,0.2);
}
{      Ramp(SetPinchOffsetCurrent,aktPinchOffsetCurrent,0,FeshbachFieldStartTime,0.2);
      SwitchIGBT(10,off);
      Wait(1);           }
      TrapOffMode:=FeshbachPinch;
    end else begin
      if DoSpinMix then begin
        SetFinalSlowerCurrent(0);       {orthogonal field on}
        SwitchFinalSlowerVoltage(off);
        IOUpdate;
        SwitchSlowerCompensation(on);
        Wait(124*ID+10);
        SwitchFinalSlowerVoltage(on);
        Wait(125*ID+1);
        Ramp(SetFinalSlowerCurrent,0,OrthogonalFieldCurrent,OrthogonalFieldRampTime,0.2);

        SwitchIGBT(9,on); {Feshbach Field on}
        SwitchIGBT(2,on);
        Wait(1);
        Ramp(SetTransferCurrent,0,StartFeshbachCurrent,FeshbachCurrentStartTime,0.2);

        SwitchSlowerCompensation(off);
        SwitchFinalSlowerVoltage(off);
        SwitchIGBT(10,off);
        Wait(1);
      end else begin
        if UseOrthogonalField then begin
          SetFinalSlowerCurrent(0);
          SwitchFinalSlowerVoltage(off);
          IOUpdate;
          SwitchSlowerCompensation(on);
          Wait(124*ID+10);
          SwitchFinalSlowerVoltage(on);
          Wait(125*ID+1);
          Ramp(SetFinalSlowerCurrent,0,OrthogonalFieldCurrent,OrthogonalFieldRampTime,0.2);
        end;
          SwitchIGBT(9,on); {Feshbach Field on}
          SwitchIGBT(2,on);
          Ramp(SetPinchOffsetCurrent,aktPinchOffsetCurrent,0,10,0.2);
          SwitchIGBT(10,off);

          SetTransfer1Voltage(0);
          SetTransfer2Voltage(0);
          SetTransfer1Current(0);
          SwitchTransferDecharging(on);
          Wait(50);
          SwitchTransferDecharging(off);
          SetTransfer1Voltage(MaxTransfer1Voltage);
          IOUpdate;

          Wait(1);
          RampCornerLess(SetTransferCurrent,0,StartFeshbachCurrent,EtaFeshbachStartRamp,FeshbachCurrentStartTime,0.2);
          Wait(1);
  {      end;
  }      if UseOrthogonalField then begin
          Ramp(SetFinalSlowerCurrent,OrthogonalFieldCurrent,0,OrthogonalFieldRampTime,0.2);
          SwitchSlowerCompensation(off);
          SwitchFinalSlowerVoltage(off);
          Wait(126*ID+1);
        end;
      end;
      TrapOffMode:=FeshbachComp;
      UsedFeshbachField:=Comp;
    end;
  SequenceEndBlock;
end;

procedure RampFeshbachField(nr:byte);far;
begin
  AtomPath:=AtomPath+'F'+char(nr+byte('0'));;
  SequenceStartBlockByteArg(RampFeshbachField,nr);
    case UsedFeshbachField of
      Comp: begin
        Wait(1);
        RampCornerLess(SetTransferCurrent,aktTransfer1Current,FeshbachCurrent[nr],EtaFeshbachRamp[nr],
          FeshbachCurrentRampTime[nr],0.2);
        Wait(1);
        if FeshbachCurrent[nr]=0 then begin
          SwitchIGBT(2,off);
          Wait(1);
          SwitchIGBT(9,off);
          Wait(1);
        end;
      end;
      Pinch:begin
        Wait(1);
        if FeshbachCurrent[nr]>MaxIGBT5Current then FeshbachCurrent[nr]:=MaxIGBT5Current;
        RampCornerLess(SetMOTCurrent,aktMOTCurrent,FeshbachCurrent[nr],EtaFeshbachRamp[nr],
          FeshbachCurrentRampTime[nr],0.2);
        if FeshbachCurrent[nr]=0 then begin
          SwitchIGBT(4,off);
          Wait(1);
          SwitchIGBT(5,off);
          SetMOTVoltage(0);
          Wait(1);
        end;
      end;
      NotInitialised:begin
        writeln('MagTrap : RampFeshbachField : Use StartFeshbachField'+^G);
        delay(1000);
      end;
    end;
  SequenceEndBlock;
end;

procedure MagneticTrap;
var n:byte;
    helpMagTrapTime:double;
begin
  if DoProtectMagTrap then begin
    helpMagTrapTime:=MagTrapTime-UnProtectMagTrapStabilizationTime;
  end else helpMagTrapTime:=MagTrapTime;
  if (helpMagTrapTime<=0) and (not DoShortMagTrapTime) then begin
    helpMagTrapTime:=1;
    writeln('MagTrap : MagneticTrap : MagTrapTime too short');
  end;
  {SwitchOszilloskopTrigger(off);
  Wait(243*ID+1);}
  if DoOpticalPumping then StartMagTrapWithOpticalPumping
  else StartMagTrap;
  if DoShortMagTrapTime then begin
    FinalTrap:='short MagTrap';
    AtomPath:=AtomPath+'Ps';
    ShutterMOT(close);
    IOUpdate;
    SetProbeDetuning(DetectIsotop);
    Wait(244*ID+MagTrapTime);
    exit;
  end;
  QuickProtect;
  if RFShieldDuringMagTrap then StartRFShield;
  SetProbeDetuning(DetectIsotop);
  if CameraPosition=1 then begin
    Set6LiProbeIntensity(Probe6IoffeIntensity);
    Set7LiProbeIntensity(Probe7IoffeIntensity);
  end;
  if DoProtectMagTrap then ProtectMagTrap
  else if DoDopplerCoolIoffeTrap[1] then begin
    Wait(ShutterProbeAndRepumpDelay);
    PrepareNextDopplerCooling(0);
  end;
  if DoOpticalPumping then FinishOpticalPumping;
  {if not DoCompressedMagTrap then DoTransfer:=false;}
  if DoTransfer then RecaptureTime:=0;
  if (not DoTransfer) or (TransferPercent<>100) then DoIoffeBarRamp:=false;
  if not DoTransfer then begin
    DoIoffeTrap:=false;
    if TransferPercent>20 then DoDeCompressMagTrapBeforeTransfer:=false;
  end;
  if not DoIoffeTrap then begin
    DoIoffeCVCCTransition:=false;
  end;
  SequenceStopPortList;
  Wait(245*ID+0.5);
  {if DoAddCurrent then MagTrapMOTVoltageCompressed:=MaxMOTVoltage;}
  if DoCleaning then CleanMagTrap;
  if DoQuadrupolEvaporation and DoQPEvaporationbeforecompression then begin
    DoSweep(RFSweepData[2]);
    FinalTrap:='QP Magtrap after evaporation';
    AtomPath:=AtomPath+'Ev';
  end;
  if DoCompressedMagTrap then CompressMagTrap;
  Wait(246*ID+InitialMagTrapWaitTime);
  AddCurrent;
  if DoQPDopplerCooling then QPDopplerCooling;
  if DoQuadrupolEvaporation and (not DoQPEvaporationbeforecompression) then begin
    DoSweep(RFSweepData[2]);
    FinalTrap:='QP Magtrap after evaporation';
    AtomPath:=AtomPath+'Ev';
  end;
  if DoAddCurrent then Wait(247*ID+AddedCurrentWaitTime);
  DeAddCurrent;
  if DoDeCompressMagTrapBeforeTransfer then DeCompressMagTrap;
  if DoTranslateMagTrap then TranslateMagTrap;
  if DoTransfer then begin
    Transfer;
    if DoIoffeBarRamp then IoffeBarRamp;
    if DoTransferQuadrupolExpansion then TransferQuadrupolExpansion;
    if DoTransferQuadrupolDeformation then TransferQuadrupolDeformation;
    if DoRampMOTCoilsOff then RampMOTCoilsOff;
    if DoIoffeTrap then begin
      DeTranslateUpperMagTrap;
      if PumpToF_2 then begin
        IoffeTrapF2;
        if DoCompressIoffeTrapCV then CompressIoffeTrapCV;
        if DoIoffeCVCCTransition then begin
          CVCCTransitionF2;
          if DoCompressIoffeTrap[1] then CompressIoffeTrap(1);

          {if DoDebug and SequenceOut then StartDebug(MainDir+DebugFileName,DebugAsOszilloskop,OriginOffset);}

          if DoStartOpticalTrapHere1 then StartOpticalTrap;
          if DoDopplerCoolIoffeTrap[1] then DopplerCoolIoffeTrap(1);
          Wait(248*ID+CompressedIoffeTrapWait0);
          if DoCompressIoffeTrap[2] then CompressIoffeTrap(2);
          if DoStartOpticalTrapHere2 then StartOpticalTrap;
          if DoDopplerCoolIoffeTrap[2] then DopplerCoolIoffeTrap(2);
          Wait(249*ID+CompressedIoffeTrapWait);

          {if DoCompressIoffeTrap[7] then CompressIoffeTrap(7);
          if DoDopplerCoolIoffeTrap[3] then DopplerCoolIoffeTrap(3);}
          if DoCompressIoffeTrap[3] then CompressIoffeTrap(3);
          if DoStartOpticalTrapHere3 then StartOpticalTrap;
          if DoProtectMagTrap then FinishDopplerCooling;
          if DoAddPinchOffset then AddPinchOffset;
          if DoCompressIoffeTrap[4] then CompressIoffeTrap(4);
          if DoTrapDeformmicrowaveEvaporation[1] then TrapDeformMicroWaveEvaporation(1);
          if DoMicrowaveSweep[1] then MicroWaveSweep(1);

          if DoIoffeEvaporation1 then begin
            DoSweep(RFSweepData[1]);
            FinalTrap:='Ioffe trap after evaporation';
            AtomPath:=AtomPath+'e1';
          end;

          if DoTrapDeformmicrowaveEvaporation[2] then TrapDeformMicroWaveEvaporation(2);
          if DoCompressIoffeTrap[5] then CompressIoffeTrap(5);
          Wait(252*ID+CompressedIoffeTrapWait4);
          if DoIoffeEvaporation2 then DoSweep(RFSweepData[2]);
          if DoSmoothSweep[1] then InitSmoothMicroWaveSweep(1);
          if DoRFPulsSequence[1] then PrepareRFPulsSequence(1);
          if DoCompressIoffeTrap[6] then CompressIoffeTrap(6);
          Wait(253*ID+IoffeTrapWait[1]);
          if DoCompressIoffeTrap[7] then CompressIoffeTrap(7);
          Wait(253*ID+IoffeTrapWait[2]);
          if DoCompressIoffeTrap[8] then CompressIoffeTrap(8);
          Wait(253*ID+{system.exp(ln(10)*}IoffeTrapWait[3]);
          if DoCompressIoffeTrap[9] then CompressIoffeTrap(9);
          Wait(253*ID+IoffeTrapWait[4]);
          if DoRFPulsSequence[1] then ExecuteRFPulsSequence(1,false);
          if DoSwitchRFShieldOff then SwitchRFShieldOff;
          if DoProbeFlash then ProbeFlash;
          if DoCompressIoffeTrap[10] then CompressIoffeTrap(10);
          if DoCompressIoffeTrap[11] then CompressIoffeTrap(11);
          Wait(253*ID+IoffeTrapWait[5]);
          if DoCompressIoffeTrap[12] then CompressIoffeTrap(12);
          Wait(253*ID+IoffeTrapWait[6]);
          if DoIoffeEvaporation3 then DoSweep(RFSweepData[2]);
          if DoIoffeEvaporation4 then begin
            DoSweep(RFSweepData[3]);
            FinalTrap:='Ioffe trap after evaporation';
            AtomPath:=AtomPath+'e3';
          end;
          if DoCompressIoffeTrap[13] then CompressIoffeTrap(13);
          if DoCompressIoffeTrap[14] then CompressIoffeTrap(14);
          Wait(253*ID+IoffeTrapWait[7]);
          if DoSwitchRFShieldOff2 then SwitchRFShieldOff;
          if DoRepumpFlash then RepumpFlash;
          if DoCompressIoffeTrap[15] then CompressIoffeTrap(15);
          if DoCompressIoffeTrap[16] then CompressIoffeTrap(16);
          if DoRFPulsSequence[2] then PrepareRFPulsSequence(2);
          Wait(253*ID+IoffeTrapWait[8]);
          if DoMicrowaveSweep[2] then MicroWaveSweep(2);
          if DoOpticalTrap then begin
             FinalTrapIsOpticalTrap:=TRUE;
             if (DoVCORFSweepHere1 or DoVCORFSweepHere2) then SendCommandtoVCORFSWeep;
             StartOpticalTrap;
          end;
          if DoCompressIoffeTrap[17] then CompressIoffeTrap(17);
{          if DoModeMatchTransferRadial then ModeMatchTransferRadial;}
          if DoRFPulsSequence[2] then ExecuteRFPulsSequence(2,false);
          if DoSwitchOffMagTrap1 then SwitchOffMagtrap;
          Wait(253*ID+IoffeTrapWait[9]);
          if DoVCORFSweepHere1 then ExecuteVCORFSweep;
          if DoRampOpticalTrap[7] then RampOpticalTrap(7);
          if DoSeparationGradient then SeparationGradient;
          if DoRampOpticalTrap[8] then RampOpticalTrap(8);
          if DoAddFeshbachField then StartFeshbachField;
          Wait(254*ID+OpticalTrapWait[1]);
          if DoVCORFSweepHere2 then ExecuteVCORFSweep;
          if DoRampOpticalTrap[1] then RampOpticalTrap(1);
          if DoRampOpticalTrap[2] then RampOpticalTrap(2);
          Wait(254*ID+OpticalTrapWait[2]);
          if DoRampFeshbachField[1] then RampFeshbachField(1);
          if DoRampOpticalTrap[3] then RampOpticalTrap(3);
          Wait(254*ID+OpticalTrapWait[3]);
          if DoRampOpticalTrap[4] then RampOpticalTrap(4);
          if DoAxialGradient then SwitchAxialGradient(on);
          Wait(255*ID+OpticalTrapWait[4]);
          if DoRampFeshbachField[2] then RampFeshbachField(2);
          if DoFinalRFPulsSequence then PrepareRFPulsSequence(3);
          Wait(255*ID+OpticalTrapWait[5]);
          if DoRampOpticalTrap[5] then RampOpticalTrap(5);
          Wait(255*ID+OpticalTrapWait[6]);
          if DoRampFeshbachField[3] then RampFeshbachField(3);
          if DoSwitchOffMagtrap2 then SwitchOffMagtrap;
          if DoShakeTrap then ShakeTrap;
          Wait(256*ID+OpticalTrapWait[7]);
        end;
      end else begin
        IoffeTrapF1;
        if DoIoffeCVCCTransition then CVCCTransitionF1;
      end;
    end;
  end;
  {SwitchOszilloskopTrigger(off);
  IOUpdate;}
  if DoPushBeam then begin
    SwitchRepumpAndOpticalPumpingEnable(UsePushBeamWithRepump);
    ShutterAndorProbe(off);
    Wait(AndorProbeOffDelay+ID*505);
  end;
  SaveAktCurrents;
  if KeepMOTAOMOn then SwitchAOM20Delayed(on);
  SequenceStartPortListDuringWait(256*ID+helpMagTrapTime);
 { end;}
  if (RecaptureTime>0) and DoCompressedMagTrap then ReverseMagTrap:=true;
  if ReverseMagTrap and not DoIoffeTrap then begin
    SequenceStopPortList;
    {ReTranslateUpperMagTrap;}
    if DoRampMOTCoilsOff then RampMOTCoilsOn;
    if DoTransferQuadrupolDeformation then DeTransferQuadrupolDeformation;
    if DoTransferQuadrupolExpansion then DeTransferQuadrupolExpansion;
    if DoIoffeBarRamp then DeIoffeBarRamp;
    if DoTransfer then DeTransfer;
    if DoTranslateMagTrap then DeTranslateMagTrap;
    Wait(257*ID+FinalMagTrapTime);
    SequenceStartPortListDuringWait(258*ID+50);
  end;
  if (RFOn(0) or RFOn(1) or RFOn(2)) and (not DoRFPuls[1]) and
    (not PictureWithTrapOn) and (not DoFinalRFPulsSequence) then begin
    SequenceStopPortList;
    if RFOn(0) then SwitchRFOff(0);
    if RFOn(1) then begin SwitchRFOff(1); SwitchRF(1,off); end;
    if RFOn(2) then begin SwitchRFOff(2); SwitchRF(3,off); end;
    SequenceStartPortListDuringWait(259*ID+GPIBCommandTime);
  end;
  if (RecaptureTime>0) then Recapture
  else if DoProtectMagTrap then UnProtectMagTrap;
  if (RFOn(0) or RFOn(1) or RFOn(2))
    and (not DoRFPuls[1]) and (PictureWithTrapOn) and (not DoFinalRFPulsSequence) then begin
    SwitchRF(0,off);
    SwitchRF(1,off);
    SwitchRF(2,off);
    SwitchRF(3,off);
    Wait(1);
  end;
end;

procedure LastMillisecondExperiments;
begin
  if DoRFPuls[1] then begin
    SequenceStopPortList;
    SwitchRF(RFPulsSynth[1],off);
    Wait(1);
    SetFrequency(RFPulsSynth[1],RFPulsFrequency[1]);
    Wait(195*ID+GPIBCommandTime);
    SwitchRFGPIB(RFPulsSynth[1],RFPulsRFLevel[1],on);
    Wait(196*ID+GPIBCommandTime);
    SwitchRF(RFPulsSynth[1],on);
    Wait(RFPulsTime[1]);
    SwitchRF(RFPulsSynth[1],off);
    IOUpdate;
    SequenceStartPortListDuringWait(259*ID+RFThermalisationTime[1]);
  end;
  if DoFinalRFPulsSequence then begin
    SequenceStopPortList;
    ExecuteRFPulsSequence(3,true);
  end;
  if DoPushBeam then begin
{    if ((AndorProbeOnDelay-AndorProbeOnRiseTime)>PushBeamTime) then begin
      ShutterAndorProbe(on);
      Wait(AndorProbeOnDelay-AndorProbeOnRiseTime-PushBeamTime+ID*500);
      SwitchPushbeam(on);
      Wait(PushBeamTime+ID*501);
    end else begin
      SwitchPushbeam(on);
      Wait(PushBeamTime-(AndorProbeOnDelay-AndorProbeOnRiseTime)+ID*502);
      ShutterAndorProbe(on);
      Wait((AndorProbeOnDelay-AndorProbeOnRiseTime)+ID*503);
    end;
    SwitchPushbeam(off);
    IOUpdate;
    SwitchRepumpAndOpticalPumpingEnable(ProbeWithRepump);
    if ((AndorProbeOnRiseTime-ExpansionTime7)>0) then Wait(AndorProbeOnRiseTime-ExpansionTime7+ID*504);
}  end;
  if DoStartOpticalTrapHere4 then StartOpticalTrap;
  if DoExciteOpticalTrap then ExciteOpticalTrap;

  if DoRampFeshbachField[4] then RampFeshbachField(4);

  if DoRampOpticalTrap[6] then begin
    if (CloseVerticalNdYagShutter) {and (FinalVerticalNdYAGIntensity[6]=0)} then begin
      if ((VerticalNdYagShutterDelay-OpticalTrapRampTime[6])>1) then begin
        ShutterAndorProbe(off);
        Wait(VerticalNdYagShutterDelay-OpticalTrapRampTime[6]-1);
        RampOpticalTrap(6);
      end else begin
        RampOpticalTrap(6);
        ShutterAndorProbe(off);
      end;
    end else begin
     RampOpticalTrap(6);
    end;
  end;

  if DoRampFeshbachField[5] then RampFeshbachField(5);

  Wait(257*ID+OpticalTrapWait[8]);


{  if DoRampOpticalTrap[6] then RampOpticalTrap(6); }
  Wait(FinalWait);
end;

procedure SwitchMagTrapCompletelyOff;
begin
  SetMOTVoltage(0);
  SetMOTCurrent(0);
  SetTransfer1Current(0);
  SetTransfer1Voltage(0);
  SetTransfer2Voltage(0);
  SetBarsCurrent(0);
  SetBarsVoltage(0);
  IOUpdate;
  SwitchTransferDecharging(on);
  SwitchMOTDecharging(on);
  SwitchSlowerCompensation(off);
  Wait(260*ID+50);
  SwitchIGBTsOff;
  IOUpdate;
end;

  var IBar:double;
      IMot:double;
      ITrans:double;
      IOffset:double;

  procedure SetCurrents(f:double);far;
  begin
    SetMOTCurrent(f*IMOT);
    SetTransferCurrent(f*ITrans);
    SetBarsCurrent(f*IBar);
    SetPinchOffsetCurrent(f*IOffset);
  end;

procedure SwitchMagTrapSlowlyCompletelyOff;
begin
  IBar:=aktBarCurrent;
  IMot:=aktMOTCurrent;
  ITrans:=aktTransfer1Current;
  IOffset:=aktPinchOffsetCurrent;
  Ramp(SetCurrents,1,0,1000,1);
  SetMOTCurrent(0);
  SetTransferCurrent(0);
  SetBarsCurrent(0);
  SetMOTVoltage(0);
  SetTransfer1Voltage(0);
  SetTransfer2Voltage(0);
  SetBarsVoltage(0);
  IOUpdate;
  SwitchTransferDecharging(on);
  SwitchMOTDecharging(on);
  SwitchSlowerCompensation(off);
  Wait(260*ID+50);
  SwitchIGBTsOff;
  IOUpdate;
end;

end.
