unit Marconi;
interface

const on=true;
      off=false;
      MaxRFLevel=19;
      MinRFLevel=-140;

procedure SwitchRF(Synth:byte;Level:double;onoff:boolean);
procedure SetFrequency(Synth:byte;f:double);
procedure InitMarconi(Synth:byte);
function RFOn(Synth:byte):boolean;
procedure SwitchRFOff(Synth:byte);

implementation
uses crt,IEEE,sequence,ExpIO;

const MaxSynth=1;
      Marconi2030:array[0..MaxSynth] of byte=(2,0);
      LastFrequ:array[0..MaxSynth] of double=(0,0);

procedure eatWhite(var buf:string);
begin
  while (buf[length(buf)]=' ') and (length(buf)>1) do buf:=copy(buf,1,length(buf)-1);
  while (buf[1]=' ') and (length(buf)>1) do buf:=copy(buf,2,length(buf)-1);
end;

const RFison:array[0..MaxSynth] of boolean=(false,false);

function RFOn(Synth:byte):boolean;
begin
  RFOn:=RFison[Synth];
end;

procedure SwitchRFOff(Synth:byte);
var status:integer;
begin
  if SequenceOut then begin
    Send(Marconi2030[Synth],'RFLV:VALUE -144.0DBM;OFF;',status);
     {Send(Marconi2030,'LEVEL -140.0DBM;LEVEL:OFF;',status);}
    SetRFSweepCopyFrequency(Synth,0);
  end else SequenceByteArg(SwitchRFOff,Synth,0);
  RFison[Synth]:=off;
end;

procedure SwitchRF(Synth:byte;Level:double;onoff:boolean);
var status:integer;
    buf:string;
begin
  RFison[Synth]:=onoff;
  if SequenceOut then begin
    str(level:5:1,buf);
    EatWhite(buf);
    if onoff then begin
      Send(Marconi2030[Synth],'RFLV:VALUE '+buf+'DBM;ON;',status);
      SetRFSweepCopyFrequency(Synth,lastFrequ[Synth]);
    end else begin
      Send(Marconi2030[Synth],'RFLV:VALUE '+buf+'DBM;OFF;',status);
      SetRFSweepCopyFrequency(Synth,0);
    end;
    {if onoff then begin
      Send(Marconi2030,'LEVEL '+buf+'DBM; LEVEL:ON',status);
      SetRFSweepCopyFrequency(lastFrequ);
    end else begin
      Send(Marconi2030,'LEVEL '+buf+'DBM; LEVEL:OFF',status);
      SetRFSweepCopyFrequency(0);
    end;}
  end else SequenceBytedoublebooleanArg(SwitchRF,Synth,Level,onoff,0);
end;

procedure SetFrequency(Synth:byte;f:double);
var buf:string;
    status:integer;
begin
  if SequenceOut then begin
    str(f:4:4,buf);
    EatWhite(buf);
    Send(Marconi2030[Synth],'CFRQ '+buf+'MHZ',status);
    {Send(Marconi2030,'RF '+buf+'MHZ',status);}
    SetRFSweepCopyFrequency(Synth,f);
    LastFrequ[Synth]:=f;
  end else SequenceByteDoubleArg(Setfrequency,Synth,f,0);
end;

procedure InitMarconi(Synth:byte);
var status:integer;
begin
  if SequenceOut then begin
    Send(Marconi2030[Synth],'*RST',status);
    if (status<>0) then begin
      writeln('Marconi: Error talking to Synthesizer Nr ',Synth);
      delay(500);
    end else begin
      SwitchRF(Synth,MinRFLevel,off);
    end;
  end else SequenceByteArg(InitMarconi,Synth,0);
end;

begin
  InitMarconi(0);
  InitMarconi(1);
end.