unit Menusys;
interface

procedure MainMenu;

implementation
uses Register,crt,Menu,Params,Exp,IO,ExpIo,Vision,MagTrap,UniMess,Debug,
     MultiOut,Setups;

procedure MenuTemperature;

  procedure TempParams;
  var InfoDialog   : PDialogInfo;
      UpdateDialog : boolean;
      h1,h2,h3,h4,h5,h6:double;
  begin
    NewDialog(InfoDialog);
    AddT(yellow,InfoDialog,'7Li Temperature Measurement Parameters');
    AddR(yellow,InfoDialog,Temp7t0,'7Li start expansion time','start expansion time',0.01,100,1);
    AddR(yellow,InfoDialog,Temp7dt,'7Li delta t expansion time','delta t expansion time',0,100,1);
    h1:=Temp7nt;
    h2:=Temp7nr;
    AddR(yellow,InfoDialog,h1,'7Li number of points','number of points',1,100,1);
    AddR(yellow,InfoDialog,h2,'7Li number of repetitions','number of repetitions',1,100,1);
    AddR(yellow,InfoDialog,Temp7rt,'7Li Reference time [ms]','Reference Time',0,1000000,1);
    AddR(yellow,InfoDialog,Temp7rd,'7Li Reference detuning [MHz]','Reference Detuning',-100,100,1);
    AddR(yellow,InfoDialog,Temp7LiCalib,'7Li Number calibration','7Li Number calibration',0,100,1);
    h5:=Temp7LiCalibNr;
    AddR(yellow,InfoDialog,h5,'7Li Number Picture number','7Li Number Picture number',0,100,1);

    AddT(yellow,InfoDialog,'6Li Temperature Measurement Parameters');
    AddR(yellow,InfoDialog,Temp6t0,'6Li start expansion time','start expansion time',0.01,100,1);
    AddR(yellow,InfoDialog,Temp6dt,'6Li delta t expansion time','delta t expansion time',0,100,1);
    h3:=Temp6nt;
    h4:=Temp6nr;
    AddR(yellow,InfoDialog,h3,'6Li number of points','number of points',1,100,1);
    AddR(yellow,InfoDialog,h4,'6Li number of repetitions','number of repetitions',1,100,1);
    AddR(yellow,InfoDialog,Temp6rt,'6Li Reference time [ms]','Reference Time',0,1000000,1);
    AddR(yellow,InfoDialog,Temp6rd,'6Li Reference detuning [MHz]','Reference Detuning',-100,100,1);
    AddR(yellow,InfoDialog,Temp6LiCalib,'6Li Number calibration','6Li Number calibration',0,100,1);
    h6:=Temp7LiCalibNr;
    AddR(yellow,InfoDialog,h6,'6Li Number Picture number','6Li Number Picture number',0,100,1);

    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'Temperature Measurement Parameters',UpdateDialog);
    Temp7nt:=round(h1);
    Temp7nr:=round(h2);
    Temp6nt:=round(h3);
    Temp6nr:=round(h4);
    Temp7LiCalibNr:=round(h5);
    Temp6LiCalibNr:=round(h6);
  end;

var MenuInfo   : PMenuInfo;
    iMain,iTemp,iParam,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'Temperature Measurement          [1]',
    'Temperature Measurement','1',iTemp);
  AddChoice(yellow,MenuInfo,'Parameters                       [2]',
    'Temperature Measurement Parameters','2',iParam);
  AddChoice(yellow,MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Temperature Measurement Menu ',Choice);
    if Choice=iTemp then TemperatureMeasurement(false,true,true)
    else if Choice=iParam then TempParams;
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;

procedure MenuChargingTime;

  procedure ChargingTimeParams;
  var InfoDialog   : PDialogInfo;
      UpdateDialog : boolean;
      h1,h2:double;
  begin
    NewDialog(InfoDialog);
    AddT(yellow,InfoDialog,'Charging Time Measurement Parameters');
    AddR(yellow,InfoDialog,Chargingt0,'start (de)charging time','start charging time',0,10000,1);
    AddR(yellow,InfoDialog,Chargingdt,'delta t (de)charging time','delta t charging time',0,10000,1);
    h1:=Chargingnt;
    h2:=Chargingnr;
    AddR(yellow,InfoDialog,h1,'number of points','number of points',1,200,1);
    AddR(yellow,InfoDialog,h2,'number of repetitions','number of repetitions',1,100,1);
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'(De)Charging Time Measurement Parameters',UpdateDialog);
    Chargingnt:=round(h1);
    Chargingnr:=round(h2);
  end;

var MenuInfo   : PMenuInfo;
    iMain,iChargingTime,iDeChargingTime,iCMOTDeChargingTime,iMagTrapDeChargingTime,iParam,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'MOT Charging Time Measurement                  [1]',
    'Charging Time Measurement','1',iChargingTime);
  AddChoice(yellow,MenuInfo,'MOT Decharging Time Measurement                [2]',
    'Lifetime Measurement','2',iDeChargingTime);
  AddChoice(yellow,MenuInfo,'CMOT Decharging Time Measurement               [3]',
    'Lifetime Measurement','3',iCMOTDeChargingTime);
  AddChoice(yellow,MenuInfo,'Magnetic trap Decharging Time Measurement      [4]',
    'Lifetime Measurement','4',iMagTrapDeChargingTime);
  AddChoice(yellow,MenuInfo,'Parameters                                     [P]',
    'Charging Time Parameters','P',iParam);
  AddChoice(yellow,MenuInfo,'Main Menu                                      [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' De/Charging Time Measurement Menu ',Choice);
    if Choice=iChargingTime then ChargingTimeMeasurement
    else if Choice=iDeChargingTime then DeChargingTimeMeasurement
    else if Choice=iCMOTDeChargingTime then CMOTDeChargingTimeMeasurement
    else if Choice=iMagTrapDeChargingTime then MagTrapDeChargingTimeMeasurement
    else if Choice=iParam then ChargingTimeParams;
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;

procedure MenuNumber;

  procedure NumbParams;
  var InfoDialog   : PDialogInfo;
      UpdateDialog : boolean;
      h1,h2:double;
  begin
    NewDialog(InfoDialog);
    AddT(yellow,InfoDialog,'Atom Number Measurement Parameters');
    AddR(yellow,InfoDialog,NumbDet0,'start probe detuning','start Detuning',-50,50,1);
    AddR(yellow,InfoDialog,NumbdDet,'delta detuning','delta detunig',0.001,100,1);
    h1:=Numbnt;
    h2:=Numbnr;
    AddR(yellow,InfoDialog,h1,'number of points','number of points',1,100,1);
    AddR(yellow,InfoDialog,h2,'number of repetitions','number of repetitions',1,100,1);
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'Temperature Measurement Parameters',UpdateDialog);
    Numbnt:=round(h1);
    Numbnr:=round(h2);
  end;

var MenuInfo   : PMenuInfo;
    iMain,iNumb,iParam,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'Atom Number Measurement          [1]',
    'Atom Number Measurement','1',iNumb);
  AddChoice(yellow,MenuInfo,'Parameters                       [2]',
    'Atom Number Measurement Parameters','2',iParam);
  AddChoice(yellow,MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Atom Number Measurement Menu ',Choice);
    if Choice=iNumb then NumberMeasurement
    else if Choice=iParam then NumbParams;
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;

procedure Menu2DSweepMeasurement;

  procedure Sweep2DMeasureParams;
  var InfoDialog   : PDialogInfo;
      UpdateDialog : boolean;
      h1,h2,h3:double;
  begin
    NewDialog(InfoDialog);
    AddT(yellow,InfoDialog,'2D Sweep Measurement Parameters');
    AddR(yellow,InfoDialog,Sweep2DDet0T,'trap start  detuning','trap start Detuning',-50,50,1);
    AddR(yellow,InfoDialog,Sweep2DdDetT,'trap delta detuning','trap delta detunig',0.001,100,1);
    h1:=Sweep2DntT;
    AddR(yellow,InfoDialog,h1,'Trap Number of points','trap number of points',1,100,1);
    AddR(yellow,InfoDialog,Sweep2DDet0S,'slower start  detuning','slower start Detuning',-50,50,1);
    AddR(yellow,InfoDialog,Sweep2DdDetS,'slower delta detuning','slower delta detunig',0.001,100,1);
    h2:=Sweep2DntS;
    AddR(yellow,InfoDialog,h2,'slower Number of points','slower number of points',1,100,1);
    h3:=Sweep2Dnr;
    AddR(yellow,InfoDialog,h3,'number of repetitions','number of repetitions',1,100,1);
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'2D Sweep Measurement Parameters',UpdateDialog);
    Sweep2DntT:=round(h1);
    Sweep2DntS:=round(h2);
    Sweep2Dnr:=round(h3);
  end;

var MenuInfo   : PMenuInfo;
    iMain,iNumb,iParam,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'Sweep 2D Measurement             [1]',
    'Sweep 2D Measurement','1',iNumb);
  AddChoice(yellow,MenuInfo,'Parameters                       [2]',
    'Sweep 2D Measurement Parameters','2',iParam);
  AddChoice(yellow,MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Sweep 2D Measurement Menu ',Choice);
    if Choice=iNumb then Sweep2DMeasurement
    else if Choice=iParam then Sweep2DMeasureParams;
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;

procedure MenuTransferOptimisationMeasurement;

  procedure TransferOptimisationMeasureParams;
  var InfoDialog   : PDialogInfo;
      UpdateDialog : boolean;
      h1,h2,h3:double;
  begin
    NewDialog(InfoDialog);
    AddT(yellow,InfoDialog,'Transfer Optimisation Measurement Parameters');
    AddR(yellow,InfoDialog,T10,'mot start  Voltage','',0,20,1);
    AddR(yellow,InfoDialog,T1D,'mot delta Voltage','',0.001,20,1);
    h1:=Tnr1;
    AddR(yellow,InfoDialog,h1,'Number of points','',1,100,1);
    AddR(yellow,InfoDialog,T20,'Transfer2/MOT start ratio','',0,1,1);
    AddR(yellow,InfoDialog,T2D,'delta ratio','',0.001,1,1);
    h2:=Tnr2;
    AddR(yellow,InfoDialog,h2,'ratio Number of points','',1,100,1);
    h3:=Tnr3;
    AddR(yellow,InfoDialog,h3,'number of repetitions','number of repetitions',1,100,1);
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'2D Sweep Measurement Parameters',UpdateDialog);
    Tnr1:=round(h1);
    Tnr2:=round(h2);
    Tnr3:=round(h3);
  end;

var MenuInfo   : PMenuInfo;
    iMain,iNumb,iParam,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'Transfer Optimisation Measurement             [1]',
    'Sweep 2D Measurement','1',iNumb);
  AddChoice(yellow,MenuInfo,'Parameters                                    [2]',
    'Sweep 2D Measurement Parameters','2',iParam);
  AddChoice(yellow,MenuInfo,'Main Menu                                     [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Transfer Optimisation Measurement Menu ',Choice);
    if Choice=iNumb then TransferOptimisationMeasurement
    else if Choice=iParam then TransferOptimisationMeasureParams;
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;


procedure MenuCMOTSweep3DMeasurement;

  procedure CMOT3DMeasureParams;
  var InfoDialog   : PDialogInfo;
      UpdateDialog : boolean;
      h1,h2,h3,h4,h5,h6,h7:double;
  begin
    NewDialog(InfoDialog);
    AddT(yellow,InfoDialog,'CMOT 3D Sweep Measurement Parameters');
    AddR(yellow,InfoDialog,CMOT3DDet0P,'CMOT start principal detuning','CMOT start principal Detuning',-100,0,1);
    AddR(yellow,InfoDialog,CMOT3DdDetP,'CMOT delta principal detuning','CMOT delta principal detunig',0.001,100,1);
    h1:=CMOT3DntP;
    AddR(yellow,InfoDialog,h1,'CMOT principal detuning Number of points','CMOT principal detuning number of points',1,100,1);
    AddR(yellow,InfoDialog,CMOT3DDet0R,'CMOT start repump detuning','CMOT start repump Detuning',-100,0,1);
    AddR(yellow,InfoDialog,CMOT3DdDetR,'CMOT delta repump detuning','CMOT delta repump detunig',0.001,100,1);
    h2:=CMOT3DntR;
    AddR(yellow,InfoDialog,h2,'CMOT repump detuning Number of points','CMOT repump detuning number of points',1,100,1);
    AddR(yellow,InfoDialog,CMOT3Dt0,'CMOT Start time','CMOT start time',0,100000,1);
    AddR(yellow,InfoDialog,CMOT3Ddt,'CMOT delta time','CMOT time',0,10000,1);
    h5:=CMOT3Dnt;
    AddR(yellow,InfoDialog,h5,'CMOT time Number of points','CMOT time number of points',1,100,1);
    h3:=CMOT3DIntnt;
    AddR(yellow,InfoDialog,h3,'CMOT intensity Number of points','CMOT intensity number of points',1,100,1);
    h4:=CMOT3Dnr;
    AddR(yellow,InfoDialog,h4,'number of repetitions','number of repetitions',1,100,1);
    AddB(InfoDialog,CMOT3DTemp,'Measure temperature [Yes/No]','Temperature ?');
    AddB(InfoDialog,CMOT3DSigma,'Measure Sigma [Yes/No]','Sigma ?');
    AddB(InfoDialog,CMOT3DNumber,'Measure Number [Yes/No]','Number?');
    AddR(yellow,InfoDialog,CMOT3DNumberFlight,
    'Time of flight for Number measurement [ms]',
    'Time of flight for Number measurement [ms]',0.15,100,1);
    AddR(yellow,InfoDialog,CMOT3DSigmaDetuning,
    'Detuning for Sigma measurement [MHz]',
    'Detuning for Sigma measurement [MHz]',-100,100,1);
    h6:=CMOT3DStartPoint;
    AddR(yellow,InfoDialog,h6,'Start point','Start point',1,1000,1);
    h7:=CMOT3Drepetitions;
    AddR(yellow,InfoDialog,h7,'Number of repetitions','Number of repetitions',1,1000,1);
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'CMOT 3D Sweep Measurement Parameters',UpdateDialog);
    CMOT3DntP:=round(h1);
    CMOT3DntR:=round(h2);
    CMOT3DIntnt:=round(h3);
    CMOT3Dnr:=round(h4);
    CMOT3Dnt:=round(h5);
    CMOT3DStartPoint:=round(h6);
    CMOT3Drepetitions:=round(h7);
  end;

var MenuInfo   : PMenuInfo;
    iMain,iNumb,iParam,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'CMOT 3D Sweep Measurement        [1]',
    'CMOT 3D Sweep Measurement','1',iNumb);
  AddChoice(yellow,MenuInfo,'Parameters                       [2]',
    'CMOT 3D Sweep Measurement Parameters','2',iParam);
  AddChoice(yellow,MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' CMOT 3D Sweep Measurement Menu ',Choice);
    if Choice=iNumb then CMOTSweep3DMeasurement
    else if Choice=iParam then CMOT3DMeasureParams;
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;

procedure MenuSweepMeasurement;

  procedure SweepMeasureParams;
  var InfoDialog   : PDialogInfo;
      UpdateDialog : boolean;
      h1,h2:double;
  begin
    NewDialog(InfoDialog);
    AddT(yellow,InfoDialog,'Sweep Measurement Parameters');
    AddR(yellow,InfoDialog,SweepIsotop,'Lithium Isotop [6/7]','Lithium Isotop',6,7,1);
    AddR(yellow,InfoDialog,SweepDet0,'start Detuning','start Detuning',-500,500,1);
    AddR(yellow,InfoDialog,SweepdDet,'delta Detuning','delta Detuning',0,100,1);
    h1:=Sweepnt;
    h2:=Sweepnr;
    AddR(yellow,InfoDialog,h1,'number of points','number of points',1,500,1);
    AddR(yellow,InfoDialog,h2,'number of repetitions','number of repetitions',1,100,1);
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'Sweep Measurement Parameters',UpdateDialog);
    Sweepnt:=round(h1);
    Sweepnr:=round(h2);
  end;

var MenuInfo   : PMenuInfo;
    iMain,iTPD,iTRD,iSRD,iSPD,iTD,iSD,iParam,iTrapInt,iMOTIntens,
    iMOTField,iCMOTField,iMagTrapField,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'Trap Detuning                    [1]',
    'Sweep Trap Detuning','1',iTD);
  AddChoice(yellow,MenuInfo,'Trap Principal Detuning          [2]',
    'Sweep Trap Principal Detuning','2',iTPD);
  AddChoice(yellow,MenuInfo,'Trap Repump Detuning             [3]',
    'Sweep Trap Repump Detuning','3',iTRD);
  AddChoice(yellow,MenuInfo,'Slower Detuning                  [4]',
    'Sweep Slower Detuning','4',iSD);
  AddChoice(yellow,MenuInfo,'Slower Principal Detuning        [5]',
    'Sweep Slower Principal Detuning','5',iSPD);
  AddChoice(yellow,MenuInfo,'Slower Repump Detuning           [6]',
    'Sweep Slower Repump Detuning','6',iSRD);
  AddChoice(yellow,MenuInfo,'Trap Intensity                   [7]',
    'Trap Intensity','7',iTrapInt);
  AddChoice(yellow,MenuInfo,'MOT Field Gradient               [8]',
    'MOT Field Gradient','8',iMOTField);
  AddChoice(yellow,MenuInfo,'CMOT Field Gradient              [8]',
    'CMOT Field Gradient','9',iCMOTField);
  AddChoice(yellow,MenuInfo,'Magnetic Trap Field Gradient     [0]',
    'Magnetic Trap Field Gradient','0',iMagTrapField);
  AddChoice(yellow,MenuInfo,'MOT Intensity                    [I]',
    'MOT Intensity','I',iMOTIntens);
  AddChoice(yellow,MenuInfo,'Sweep Measurement Parameters     [P]',
    'Sweep Measurement Parameters','P',iParam);
  AddChoice(yellow,MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Sweep Measurement Menu ',Choice);
    case Choice of
      1:SweepMeasurement([1,2]);
      2:SweepMeasurement([1]);
      3:SweepMeasurement([2]);
      4:SweepMeasurement([3,4]);
      5:SweepMeasurement([3]);
      6:SweepMeasurement([4]);
      7:SweepMeasurement([5]);
      8:SweepMeasurement([6]);
      9:SweepMeasurement([7]);
      10:SweepMeasurement([8]);
    end;
    if Choice=iParam then SweepMeasureParams
    else if Choice=iMOTIntens then SweepMOTIntensity;
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;

procedure MenuMeasure;
var MenuInfo   : PMenuInfo;
    iMain,iTemp,iNumb,iCMOT3DSweep,iSweep,i2DSweep,iCharging,iFluo,iStab,
    iTOpt,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'Temperature measurement          [T]',
    'Measures the temperature','T',iTemp);
  AddChoice(yellow,MenuInfo,'Atom number measurement          [N]',
    'Measures the particle number','N',iNumb);
  AddChoice(yellow,MenuInfo,'Charging time measurement        [C]',
    'Charging time measurement','C',iCharging);
  AddChoice(yellow,MenuInfo,'Sweep measurement                [S]',
    'Frequency sweep measurement','S',iSweep);
  AddChoice(yellow,MenuInfo,'2D sweep measurement             [2]',
    '2D Frequency sweep measurement','2',i2DSweep);
  AddChoice(yellow,MenuInfo,'Transfer optimisation            [O]',
    '','O',iTOpt);
  AddChoice(yellow,MenuInfo,'CMOT 3D sweep Measurement        [B]',
    'CMOT 2D Sweep Measure','B',iCMOT3DSweep);
  AddChoice(yellow,MenuInfo,'Flourescence (de)charging time   [F]',
    'Flourescence (de)charging time','F',iFluo);
  AddChoice(yellow,MenuInfo,'Stability Measurement            [1]',
    'Repeats same measurement over and over again','1',iStab);
  AddChoice(yellow,MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Temperature Measurement Menu ',Choice);
    if Choice=iTemp then MenuTemperature
    else if Choice=iNumb then MenuNumber
    else if Choice=iCMOT3DSweep then MenuCMOTSweep3DMeasurement
    else if Choice=iFluo then FluoLifetime
    else if Choice=iCharging then MenuChargingTime
    else if Choice=iSweep then MenuSweepMeasurement
    else if Choice=i2DSweep then Menu2DSweepMeasurement
    else if Choice=iTOpt then MenuTransferOptimisationMeasurement
    else if Choice=iStab then StabilityMeasurement;
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;

procedure MenuSweep;
var MenuInfo   : PMenuInfo;
    iMain,i7TPD,i7TRD,i7SRD,i7SPD,i7TD,i7SD,
    i6TPD,i6TRD,i6SRD,i6SPD,i6TD,i6SD,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'7Li Trap Detuning                    [1]',
    '7Li Sweep Trap Detuning','1',i7TD);
  AddChoice(yellow,MenuInfo,'7Li Trap Principal Detuning          [2]',
    '7Li Sweep Trap Principal Detuning','2',i7TPD);
  AddChoice(yellow,MenuInfo,'7Li Trap Repump Detuning             [3]',
    '7Li Sweep Trap Repump Detuning','3',i7TRD);
  AddChoice(yellow,MenuInfo,'7Li Slower Detuning                  [4]',
    '7Li Sweep Slower Detuning','4',i7SD);
  AddChoice(yellow,MenuInfo,'7Li Slower Principal Detuning        [5]',
    '7Li Sweep Slower Principal Detuning','5',i7SPD);
  AddChoice(yellow,MenuInfo,'7Li Slower Repump Detuning           [6]',
    '7Li Sweep Slower Repump Detuning','6',i7SRD);
  AddChoice(yellow,MenuInfo,'6Li Trap Detuning                    [A]',
    '6Li Sweep Trap Detuning','1',i6TD);
  AddChoice(yellow,MenuInfo,'6Li Trap Principal Detuning          [B]',
    '6Li Sweep Trap Principal Detuning','2',i6TPD);
  AddChoice(yellow,MenuInfo,'6Li Trap Repump Detuning             [C]',
    '6Li Sweep Trap Repump Detuning','3',i6TRD);
  AddChoice(yellow,MenuInfo,'6Li Slower Detuning                  [D]',
    '6Li Sweep Slower Detuning','4',i6SD);
  AddChoice(yellow,MenuInfo,'6Li Slower Principal Detuning        [E]',
    '6Li Sweep Slower Principal Detuning','5',i6SPD);
  AddChoice(yellow,MenuInfo,'6Li Slower Repump Detuning           [F]',
    '6Li Sweep Slower Repump Detuning','6',i6SRD);
  AddChoice(yellow,MenuInfo,'Main Menu                            [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Sweep Menu ',Choice);
    if Choice=i7TD then SweepDetuning([1,2]) else
    if Choice=i7TPD then SweepDetuning([1]) else
    if Choice=i7TRD then SweepDetuning([2]) else
    if Choice=i7SD then  SweepDetuning([3,4]) else
    if Choice=i7SPD then SweepDetuning([3]) else
    if Choice=i7SRD then SweepDetuning([4]) else
    if Choice=i6TD then SweepDetuning([5,6]) else
    if Choice=i6TPD then SweepDetuning([5]) else
    if Choice=i6TRD then SweepDetuning([6]) else
    if Choice=i6SD then SweepDetuning([7,8]) else
    if Choice=i6SPD then SweepDetuning([7]) else
    if Choice=i6SRD then SweepDetuning([8]);
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;

procedure DisplayAOMFrequencies;
Var
  iFrequAOM0,iFrequAOM1,iFrequAOM2,iFrequAOM3,iFrequAOM4,iFrequAOM10,
  iFrequAOM11,iFrequAOM12,iFrequAOM13,iFrequAOM14,iFrequAOM15,
  iFrequAOM20,iFrequAOM21,iFrequAOM22,iQuit,Dummy:integer;
  MenuInfo:PMenuInfo;
  Choice:integer;
  Rep:char;
  buf:string;
begin
  repeat
    NewMenu(MenuInfo);
    AddChoice(yellow,MenuInfo,'Main Menu                      [M]',
      'Exit the program','M',iQuit);
    AddText(MenuInfo,
      '',Dummy);
    AddText(MenuInfo,'',iFrequAOM0);
    AddText(MenuInfo,'',iFrequAOM1);
    AddText(MenuInfo,'',iFrequAOM2);
    AddText(MenuInfo,'',iFrequAOM3);
    AddText(MenuInfo,'',iFrequAOM4);
    AddText(MenuInfo,'',iFrequAOM10);
    AddText(MenuInfo,'',iFrequAOM11);
    AddText(MenuInfo,'',iFrequAOM12);
    AddText(MenuInfo,'',iFrequAOM13);
    AddText(MenuInfo,'',iFrequAOM14);
    AddText(MenuInfo,'',iFrequAOM15);
    AddText(MenuInfo,'',iFrequAOM20);
    AddText(MenuInfo,'',iFrequAOM21);
    AddText(MenuInfo,'',iFrequAOM22);
    AddText(MenuInfo,
      '',Dummy);
    with MenuInfo^ do begin
      str(AOM0frequency:5:2,buf);
      Desc[iFrequAOM0]:='AOM0 Frequency : '+buf+' MHz';
      str(AOM1frequency:5:2,buf);
      Desc[iFrequAOM1]:='AOM1 Frequency : '+buf+' MHz';
      str(AOM2frequency:5:2,buf);
      Desc[iFrequAOM2]:='AOM2 Frequency : '+buf+' MHz';
      str(AOM3frequency:5:2,buf);
      Desc[iFrequAOM3]:='AOM3 Frequency : '+buf+' MHz';
      str(AOM4frequency:5:2,buf);
      Desc[iFrequAOM4]:='AOM4 Frequency : '+buf+' MHz';
      str(AOM10frequency:5:2,buf);
      Desc[iFrequAOM10]:='AOM10 Frequency : '+buf+' MHz';
      str(AOM11frequency:5:2,buf);
      Desc[iFrequAOM11]:='AOM11 Frequency : '+buf+' MHz';
      str(AOM12frequency:5:2,buf);
      Desc[iFrequAOM12]:='AOM12 Frequency : '+buf+' MHz';
      str(AOM13frequency:5:2,buf);
      Desc[iFrequAOM13]:='AOM13 Frequency : '+buf+' MHz';
      str(AOM14frequency:5:2,buf);
      Desc[iFrequAOM14]:='AOM14 Frequency : '+buf+' MHz';
      str(AOM15frequency:5:2,buf);
      Desc[iFrequAOM15]:='AOM15 Frequency : '+buf+' MHz';
      str(AOM20frequency:5:2,buf);
      Desc[iFrequAOM20]:='AOM20 Frequency : '+buf+' MHz';
      str(AOM21frequency:5:2,buf);
      Desc[iFrequAOM21]:='AOM21 Frequency : '+buf+' MHz';
      str(AOM22frequency:5:2,buf);
      Desc[iFrequAOM22]:='AOM22 Frequency : '+buf+' MHz';
    end;
    DoMenu(MenuInfo,' AOM Frequency Display for '+Detuning+' Detuning ',Choice);
  until (Choice=0) or (Choice=iQuit);
  dispose(MenuInfo);
end;

procedure DisplayLaserFrequencies;
Var
  iT7PD,iT7RD,iS7RD,iS7PD,iD7PD,iD7RD,
  iT6PD,iT6RD,iS6RD,iS6PD,iD6PD,iD6RD,
  iP6RD,iP7RD,
  iQuit,Dummy:integer;
  MenuInfo:PMenuInfo;
  Choice:integer;
  Rep:char;
  buf:string;
begin
  repeat
    NewMenu(MenuInfo);
    AddChoice(yellow,MenuInfo,'Main Menu                      [M]',
      'Exit the program','M',iQuit);
    AddText(MenuInfo,
      '',Dummy);
    AddText(MenuInfo,'',iT7PD);
    AddText(MenuInfo,'',iT7RD);
    AddText(MenuInfo,'',iD7PD);
    AddText(MenuInfo,'',iD7RD);
    AddText(MenuInfo,'',iS7PD);
    AddText(MenuInfo,'',iS7RD);
    AddText(MenuInfo,'',iT6PD);
    AddText(MenuInfo,'',iT6RD);
    AddText(MenuInfo,'',iD6PD);
    AddText(MenuInfo,'',iD6RD);
    AddText(MenuInfo,'',iS6PD);
    AddText(MenuInfo,'',iS6RD);
    AddText(MenuInfo,'',iP7RD);
    AddText(MenuInfo,'',iP6RD);
    AddText(MenuInfo,
      '',Dummy);
    with MenuInfo^ do begin
      str(MOT7PrincipalDetuning:6:2,buf);
      Desc[iT7PD]:='7Li MOT Principal Detuning  : '+buf+' MHz';
      str(MOT7RepumpDetuning:6:2,buf);
      Desc[iT7RD]:='7Li MOT Repump Detuning     : '+buf+' MHz';
      str(Probe7PrincipalDetuning:6:2,buf);
      Desc[iD7PD]:='7Li Probe Principal Detuning : '+buf+' MHz';
      str(Probe7RepumpDetuning:6:2,buf);
      Desc[iD7RD]:='7Li Probe Repump Detuning    : '+buf+' MHz';
      str(Slower7PrincipalDetuning:6:2,buf);
      Desc[iS7PD]:='7Li Slower Principal Detuning: '+buf+' MHz';
      str(Slower7RepumpDetuning:6:2,buf);
      Desc[iS7RD]:='7Li Slower Repump Detuning   : '+buf+' MHz';
      str(MOT6PrincipalDetuning:6:2,buf);
      Desc[iT6PD]:='6Li MOT Principal Detuning  : '+buf+' MHz';
      str(MOT6RepumpDetuning:6:2,buf);
      Desc[iT6RD]:='6Li MOT Repump Detuning     : '+buf+' MHz';
      str(Probe6PrincipalDetuning:6:2,buf);
      Desc[iD6PD]:='6Li Probe Principal Detuning : '+buf+' MHz';
      str(Probe6RepumpDetuning:6:2,buf);
      Desc[iD6RD]:='6Li Probe Repump Detuning    : '+buf+' MHz';
      str(Slower6PrincipalDetuning:6:2,buf);
      Desc[iS6PD]:='6Li Slower Principal Detuning: '+buf+' MHz';
      str(Slower6RepumpDetuning:6:2,buf);
      Desc[iS6RD]:='6Li Slower Repump Detuning   : '+buf+' MHz';
      str(OpticalPumping7RepumpDetuning:6:2,buf);
      Desc[iP7RD]:='7Li Optical Pumping Repump Detuning   : '+buf+' MHz';
      str(OpticalPumping6RepumpDetuning:6:2,buf);
      Desc[iP6RD]:='6Li Optical Pumping Repump Detuning   : '+buf+' MHz';
    end;
    DoMenu(MenuInfo,' Laser Frequency Display ',Choice);
  until (Choice=0) or (Choice=iQuit);
  dispose(MenuInfo);
end;

procedure MenuCalibrateProbe;

  procedure CalProbeParams;
  var InfoDialog   : PDialogInfo;
      UpdateDialog : boolean;
      h1,h2:double;
  begin
    NewDialog(InfoDialog);
    AddT(yellow,InfoDialog,'Temperature Measurement Parameters');
    AddR(yellow,InfoDialog,CalProbef0,'Probe Minimum Offset','Probe Minimum Offset',0.1,100,1);
    AddR(yellow,InfoDialog,CalProbedf,'Probe delta f','delta f',0,100,1);
    h1:=CalProbent;
    h2:=CalProbeIsotop;
    AddR(yellow,InfoDialog,h1,'number of points','number of points',1,100,1);
    AddR(yellow,InfoDialog,h2,'Isotop','Isotop',6,7,1);
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'Calibrate Probe Parameters',UpdateDialog);
    CalProbent:=round(h1);
    CalProbeIsotop:=round(h2);
  end;

var MenuInfo   : PMenuInfo;
    iMain,iCalProbe,iParam,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'Calibrate Probe                  [1]',
    'Calibrate Probe','1',iCalProbe);
  AddChoice(yellow,MenuInfo,'Parameters                       [2]',
    'Calibrate Probe Parameters','2',iParam);
  AddChoice(yellow,MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Temperature Measurement Menu ',Choice);
    if Choice=iCalProbe then CalibrateProbe
    else if Choice=iParam then CalProbeParams
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;


procedure MenuBlink;

  procedure BlinkParams;
  var InfoDialog   : PDialogInfo;
      UpdateDialog : boolean;
  begin
    NewDialog(InfoDialog);
    AddT(yellow,InfoDialog,'Blink Parameters');
    AddR(yellow,InfoDialog,Frequency,'Frequency [Hz]','Frequency',0,10000,1);
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'Blink Parameters',UpdateDialog);
  end;

var MenuInfo   : PMenuInfo;
    iMain,iBlink,iParam,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'Blink                            [1]',
    'Calibrate Probe','1',iBlink);
  AddChoice(yellow,MenuInfo,'Parameters                       [2]',
    'Calibrate Probe Parameters','2',iParam);
  AddChoice(yellow,MenuInfo,'Main Menu                        [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Blink Menu ',Choice);
    if Choice=iBlink then Blink
    else if Choice=iParam then BlinkParams
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;

procedure MenuRFsweep;
var MenuInfo   : pMenuInfo;
    iEQs,iEIS,iTQS,iTIS,iMain,Choice,dummy:integer;
begin
  NewMenu(MenuInfo);
  AddText(MenuInfo,'Quadrupol RF sweep',dummy);
  AddChoice(yellow,MenuInfo,'Edit RF sweep                                             [E]',
    'Edit RF sweep','E',iEQS);
  QuadrupolRegistry^.MakeMenuEntrys(menuInfo,0,0);
  AddChoice(yellow,MenuInfo,'Test RF sweep                                             [T]',
    'Test RF sweep','T',iTQS);
  AddText(MenuInfo,'Ioffe RF sweep',dummy);
  AddChoice(yellow,MenuInfo,'Edit RF sweep                                             [D]',
    'Edit RF sweep','D',iEIS);
  IoffeRegistry^.MakeMenuEntrys(menuInfo,2,0);
  AddChoice(yellow,MenuInfo,'Test RF sweep                                             [S]',
    'Test RF sweep','S',iTIS);
  AddChoice(yellow,MenuInfo,'Main Menu                                                 [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Experiment Utility Menu ',Choice);
    if Choice=iEQS then QuadrupolRFSweep^.Edit
    else if Choice=iTQS then begin
      StartCounter;
      QuadrupolRFSweep^.DoSweep;
    end else if Choice=iEIS then IoffeRFSweep^.Edit
    else if Choice=iTIS then begin
      StartCounter;
      IoffeRFSweep^.DoSweep;
    end else if (Choice<>0) and (Choice<>iMain)
    then begin
      QuadrupolRegistry^.ExecuteMenuDialog(choice,0);
      IoffeRegistry^.ExecuteMenuDialog(choice,0);
    end;
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;


procedure MenuUtils1;
var MenuInfo   : pMenuInfo;
    iMain,iAbs,iGen,iProbe,iCalProbeMenu,iCalibrateVCO,iTest7LiExpInjection,iTest6LiExpInjection,iTestInjection,
    iParams,iTestSerialLink,iTestShutters,iTrigger,iAnalogOut,iSweepAnalogOut,iDigitalOut,
    iDispAOMFrequ,iDispLaserFrequ,iRFSweep,iInit,iLoadUniMess,iFluoOszi,iCalOszi,iFastOszi,
    iIEEE,iSRQ,iFilm,iSweepDigitalOut,iSweep,iCalFluo,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'Initialise System              [I]',
    'Init System','I',iInit);
  AddChoice(yellow,MenuInfo,'Test 7Li Injection             [I]',
    'Test 7Li Injection','I',iTest7LiExpInjection);
  AddChoice(yellow,MenuInfo,'Test 6Li Injection             [J]',
    'Test 6Li Injection','J',iTest6LiExpInjection);
  AddChoice(yellow,MenuInfo,'Sweep frequencies              [S]',
    'Sweeps AOM frequencys','S',iSweep);
  AddChoice(yellow,MenuInfo,'Trigger Camera                 [T]',
    'Trigger Camera','T',iTrigger);
  AddChoice(yellow,MenuInfo,'Film Absorption Picture        [F]',
    'Films absorption pictures','F',iFilm);
  AddChoice(yellow,MenuInfo,'Display AOM frequencies        [A]',
    'Shows the calculated frequencies','A',iDispAOMfrequ);
  AddChoice(yellow,MenuInfo,'Display Laser frequencies      [L]',
    'Shows the calculated frequencies','L',iDispLaserfrequ);
  AddChoice(yellow,MenuInfo,'Calibrate Oszilloskop          [M]',
    'Calibrate Oscilloscope','M',iCalOszi);
  AddChoice(yellow,MenuInfo,'Fast Oszilloskop               [O]',
    'Fast Oszilloskop','O',iFastOszi);
  AddChoice(yellow,MenuInfo,'Fluorescence Oszilloskop       [F]',
    'FluoOszi','F',iFluoOszi);
  AddChoice(yellow,MenuInfo,'Calibrate Fluorescence         [C]',
    'Calibrate Fluorescence','C',iCalFluo);
  AddChoice(yellow,MenuInfo,'Load Universal measurements    [U]',
    'Load universal measurements','U',iLoadUniMess);
  AddChoice(yellow,MenuInfo,'Save Parameters                [P]',
    'Save Parameters','P',iParams);
  AddChoice(yellow,MenuInfo,'Main Menu                      [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Experiment Utility Menu ',Choice);
    if Choice=iProbe then TakeProbePicture
    else if Choice=iInit then InitExp
    else if Choice=iLoadUniMess then begin
      dispose(UniMeasure,done);
      Unimeasure:=LoadUniMess(MainDir+UniMessFileName,Registry);
    end else if Choice=iTest6LiExpInjection then TestExpInjection(6)
    else if Choice=iTest7LiExpInjection then TestExpInjection(7)
    else if Choice=iParams then SaveParameters(MainDir)
    else if Choice=iSweep then MenuSweep
    else if Choice=iFluoOszi then FluorescenceOszilloskop
    else if Choice=iCalFluo then CalibrateFluorescence
    else if Choice=iCalOszi then CalibrateOszilloskop
    else if Choice=iFastOszi then FastOszilloskop
    else if Choice=iTrigger then begin StartCounter;TriggerCameraAndExposure; end
    else if Choice=iDispAOMFrequ then DisplayAOMFrequencies
    else if Choice=iDispLaserFrequ then DisplayLaserFrequencies
    else if Choice=iFilm then FilmAbsorptionPicture
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;

procedure MenuUtils2;
var MenuInfo   : pMenuInfo;
    iMain,iAbs,iGen,iProbe,iCalProbeMenu,iCalibrateVCO,iTest7LiExpInjection,iTest6LiExpInjection,iTestInjection,
    iParams,iTestSerialLink,iTestShutters,iTrigger,iAnalogOut,iSweepAnalogOut,iDigitalOut,iDigitalIn,
    iDispAOMFrequ,iDispLaserFrequ,iTestAnalogIn,iDebugOn,iDebugOff,iTestSequence,
    iIEEE,iSRQ,iFilm,iSweepDigitalOut,iTestMultiOut,iDancingMOT,iMemory,Choice:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'Test Injection 2               [1]',
    'Test Injection','1',iTestInjection);
  AddChoice(yellow,MenuInfo,'Probe Picture                  [2]',
    'Takes probe pictures','2',iProbe);
  AddChoice(yellow,MenuInfo,'Frequency generator            [3]',
    'frequency generator','3',iGen);
  AddChoice(yellow,MenuInfo,'Calibrate Probe                [4]',
    'Calibrate Probe','4',iCalProbeMenu);
  AddChoice(yellow,MenuInfo,'Calibrate VCO                  [5]',
    'Utility to calibrate an VCO','5',iCalibrateVCO);
  AddChoice(yellow,MenuInfo,'Test serial link               [6]',
    'Test serial link','6',iTestSerialLink);
  AddChoice(yellow,MenuInfo,'Test Shutters                  [S]',
    'Test Shutters','S',iTestShutters);
  AddChoice(yellow,MenuInfo,'Sweep Analog Outputs           [S]',
    'Test Analog Outputs','S',iSweepAnalogOut);
  AddChoice(yellow,MenuInfo,'Test Analog Outputs            [A]',
    'Test Analog Outputs','A',iAnalogOut);
  AddChoice(yellow,MenuInfo,'Test Analog Inputs             [N]',
    'Test Analog Inputs','N',iTestAnalogIn);
  AddChoice(yellow,MenuInfo,'Test Digital Outputs           [D]',
    'Test Digital Outputs','D',iDigitalOut);
  AddChoice(yellow,MenuInfo,'Test Digital Inputs            [T]',
    'Test Digital Inputs','T',iDigitalIn);
  AddChoice(yellow,MenuInfo,'Sweep Digital Outputs          [G]',
    'Sweep Digital Outputs','G',iSweepDigitalOut);
  AddChoice(yellow,MenuInfo,'Test Multiout                  [O]',
    'Test MultiOut','O',iTestMultiOut);
  AddChoice(yellow,MenuInfo,'Send IEEE command              [I]',
    'Send IEEE command','I',iIEEE);
  AddChoice(yellow,MenuInfo,'Watch IEEE SRQ line            [S]',
    'Watch SRQ line','S',iSRQ);
  AddChoice(yellow,MenuInfo,'Debugging on                   [U]',
    'Debugging on','U',iDebugOn);
  AddChoice(yellow,MenuInfo,'Debugging off                  [Y]',
    'Debugging off','Y',iDebugoff);
  AddChoice(yellow,MenuInfo,'Dancing MOT                    [R]',
    'Dancing MOT','R',iDancingMOT);
  AddChoice(yellow,MenuInfo,'Test Sequence                  [T]',
    'Test Sequence','T',iTestSequence);
  AddChoice(yellow,MenuInfo,'Show Memory status             [H]',
    'Show Memory Status','H',iMemory);
  AddChoice(yellow,MenuInfo,'Main Menu                      [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Test Utility Menu ',Choice);
    if Choice=iProbe then TakeProbePicture
    else if Choice=iGen then MenuBlink
    else if Choice=iMemory then ShowMemory
    else if Choice=iIEEE then SendIEEE
    else if Choice=iSRQ then WatchSRQ
    else if Choice=iDebugOn then StartDebug(MainDir+DebugFilename,DebugAsOszilloskop,OriginOffset)
    else if Choice=iDebugOn then StopDebug
    else if Choice=iTestInjection then TestInjection(0)
    else if Choice=iCalibrateVCO then CalibrateVCO
    else if Choice=iTestSerialLink then TestSerialLink
    else if Choice=iTestShutters then TestShutters
    else if Choice=iTestAnalogIn then TestAnalogInputs
    else if Choice=iTestMultiOut then MultiOutTest
    else if Choice=iCalProbeMenu then MenuCalibrateProbe
    else if Choice=iAnalogOut then TestAnalogOutputs
    else if Choice=iSweepAnalogOut then SweepAnalogOutputs
    else if Choice=iDigitalOut then TestDigitalOutputs
    else if Choice=iDigitalIn then TestDigitalInputs
    else if Choice=iSweepDigitalOut then SweepDigitalOutputs
    else if Choice=iTestSequence then TestSequence
    else if Choice=iDancingMOT then DancingMOT;
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;

procedure MenuManualMOTProbe;
var MenuInfo   : PMenuInfo;
    iMain,Choice,
    i7LiMOTon,i7LiMOToff,i6LiMOTon,i6LiMOToff,iSlowerLighton,
    iSlowerLightoff,iSlowerFieldon,iSlowerFieldoff,
    iMOTLighton,iMOTLightoff,iMOTFieldon,iMOTFieldoff,
    i7Liprobeon,iprobeoff,i6Liprobeon,
    iOpticalPumpOn,iOpticalPumpOff,
    i7MasterRepOn,i7MasterRepOff,i6MasterRepOn,i6MasterRepOff,
    i7MasterPriOn,i7MasterPriOff,i6MasterPriOn,i6MasterPriOff:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'7Li MOT on                     [A]',
    '7Li MOT on','A',i7LiMOTon);
  AddChoice(yellow,MenuInfo,'7Li MOT off                    [B]',
    '7Li MOT off','B',i7LiMOToff);
  AddChoice(yellow,MenuInfo,'6Li MOT on                     [C]',
    '6Li MOT on','C',i6LiMOTon);
  AddChoice(yellow,MenuInfo,'6Li MOT off                    [D]',
    '6Li MOT off','D',i6LiMOToff);
  AddChoice(yellow,MenuInfo,'MOT Light on                   [E]',
    'MOT Light on','E',iMOTLighton);
  AddChoice(yellow,MenuInfo,'MOT Light off                  [F]',
    'MOT Light off','F',iMOTLightoff);
  AddChoice(yellow,MenuInfo,'MOT Field on                   [G]',
    'MOT Field on','G',iMOTFieldon);
  AddChoice(yellow,MenuInfo,'MOT Field off                  [H]',
    'MOT Field off','H',iMOTFieldoff);
  AddChoice(yellow,MenuInfo,'7Li probe on                   [M]',
    '7Li probe on','M',i7Liprobeon);
  AddChoice(yellow,MenuInfo,'6Li probe on                   [O]',
    '6Li probe on','O',i6Liprobeon);
  AddChoice(yellow,MenuInfo,'probe off                      [P]',
    '6Li probe off','P',iprobeoff);
  AddChoice(yellow,MenuInfo,'Optical Pumping beam on        [Q]',
    'Probe Repump on','Q',iopticalpumpon);
  AddChoice(yellow,MenuInfo,'Optical Pumping beam off       [R]',
    'Probe Repump off','R',iopticalpumpoff);
  AddChoice(yellow,MenuInfo,'7Li Master Repump on           [1]',
    '7Li Master Repump on','1',i7MasterRepOn);
  AddChoice(yellow,MenuInfo,'7Li Master Repump off          [2]',
    '7Li Master Repump off','2',i7MasterRepOff);
  AddChoice(yellow,MenuInfo,'7Li Master Principal on        [3]',
    '7Li Master Principal on','3',i7MasterPriOn);
  AddChoice(yellow,MenuInfo,'7Li Master Principal off       [4]',
    '7Li Master Principal off','4',i7MasterPriOff);
  AddChoice(yellow,MenuInfo,'6Li Master Repump on           [5]',
    '6Li Master Repump on','5',i6MasterRepOn);
  AddChoice(yellow,MenuInfo,'6Li Master Repump off          [6]',
    '6Li Master Repump off','6',i6MasterRepOff);
  AddChoice(yellow,MenuInfo,'6Li Master Principal on        [7]',
    '6Li Master Principal on','7',i6MasterPriOn);
  AddChoice(yellow,MenuInfo,'6Li Master Principal off       [8]',
    '6Li Master Principal off','8',i6MasterPriOff);
  AddChoice(yellow,MenuInfo,'Main Menu                      [T]',
    'Main Menu','T',iMain);
  repeat
    DoMenu(MenuInfo,' Manual Menu ',Choice);
    if Choice=i7LiMOTon then begin
      ShutterMOT7principal(open);
      ShutterMOT7repump(open);
      SwitchMOTLight(on);
      ShutterMOT(open);
    end else if Choice=i7LiMOToff then begin
      ShutterMOT7principal(close);
      ShutterMOT7repump(close);
    end else if Choice=i6LiMOTon then begin
      ShutterMOT6principal(open);
      ShutterMOT6repump(open);
      SwitchMOTLight(on);
      ShutterMOT(open);
    end else if Choice=i6LiMOToff then begin
      ShutterMOT6principal(close);
      ShutterMOT6repump(close);
    end else if Choice=iMOTLighton then begin
      ShutterMOT(open);
      SwitchMOTLight(on);
    end else if Choice=iMOTLightoff then begin
      ShutterMOT(close);
      SwitchMOTLight(off);
    end else if Choice=iMOTFieldon then begin
      SwitchIGBTsToMOT;
      SetMOTCurrent(MOTMOTCurrent);
      SetTransfer1Voltage(0);
      IOUpdate;
      SetTransfer1Current(MaxTransfer1Current);
      SetTransfer2Voltage(MOTTransfer2Voltage);
      SetMOTVoltage(MOTMOTVoltage);
    end else if Choice=iMOTFieldoff then begin
      SwitchIGBTsOff;
    end else if Choice=i7Liprobeon then begin
      ShutterProbe7principal(open);
      SwitchOpticalPumpingBeam(off);
      SwitchProbeBeam(on);
      ShutterProbe(open);
      ExposureTrigger(off);
    end else if Choice=i6Liprobeon then begin
      ShutterProbe6principal(open);
      SwitchOpticalPumpingBeam(off);
      SwitchProbeBeam(on);
      ShutterProbe(open);
      ExposureTrigger(off);
    end else if Choice=iprobeoff then begin
      ShutterProbe6principal(close);
      SwitchProbeBeam(off);
      ShutterProbe(close);
      ShutterProbe7principal(close);
      ExposureTrigger(off);
    end else if Choice=iopticalpumpon then begin
      SwitchProbeBeam(off);
      SwitchOpticalPumpingBeam(on);
      ShutterProbeRepumpAndOpticalPumpingBeamDirect(on);
    end else if Choice=iopticalpumpoff then begin
      SwitchOpticalPumpingBeam(off);
      ShutterProbeRepumpAndOpticalPumpingBeamDirect(off);
    end else if Choice=i7MasterRepOn then begin
      SwitchMaster7Repump(on);
    end else if Choice=i7MasterRepOff then begin
      SwitchMaster7Repump(off);
    end else if Choice=i6MasterRepOn then begin
      SwitchMaster6Repump(on);
    end else if Choice=i6MasterRepOff then begin
      SwitchMaster6Repump(off);
    end else if Choice=i6MasterPriOn then begin
      SwitchMaster6Principal(on);
    end else if Choice=i6MasterPriOff then begin
      SwitchMaster6Principal(off);
    end else if Choice=i7MasterPriOn then begin
      SwitchMaster7Principal(on);
    end else if Choice=i7MasterPriOff then begin
      SwitchMaster7Principal(off);
    end;
    IOUpdate;
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;

procedure MenuManualMagneticTrap;
var MenuInfo   : PMenuInfo;
    iMain,Choice,iSwitchIGBTsToMOT,iSwitchIGBTsOff,
    iBlink,iSwitchIGBTsToIoffe,iMenuCurrents,iSwitchOptPumpOff,
    iSwitchOptPumpOn,iSwitchTransferDechargingOff,
    iSwitchTransferDechargingOn,iSwitchMOTDechargingOff,
    iSwitchIoffeGuidingFieldOn,iSwitchIoffeGuidingFieldOff,
    iSwitchMOTDechargingOn,iDopplerCoolingon:integer;

  procedure MenuCurrents;
  var InfoDialog   : PDialogInfo;
      UpdateDialog : boolean;
      s:string;
      n:byte;
  begin
    NewDialog(InfoDialog);
    AddT(yellow,InfoDialog,'Magnetic Trap Parameters');
    AddR(yellow,InfoDialog,aktMOTCurrent,      'MOT Current               [0.. 500 A]','MOT Current',0,500,1);
    AddR(yellow,InfoDialog,aktMOTVoltage,      'MOT Voltage               [0..  30 V]','MOT Voltage',0,30,1);
    AddR(yellow,InfoDialog,aktTransfer1Current,'Transfer 1 Current        [0.. 500 A]','Transfer 1 Current',0,500,1);
    AddR(yellow,InfoDialog,aktTransfer1Voltage,'Transfer 1 Voltage        [0..  20 V]','Transfer 1 Voltage',0,20,1);
    AddR(yellow,InfoDialog,aktTransfer2Voltage,'Transfer 2 Voltage        [0..  20 V]','Transfer 2 Voltage',0,20,1);
    AddR(yellow,InfoDialog,aktBarCurrent,      'Ioffe Bar Current         [0..1000 A]','Ioffe Bar Current',0,1000,1);
    AddR(yellow,InfoDialog,aktBarVoltage,      'Ioffe Bar Voltage         [0..  10 V]','Ioffe Bar Current',0,10,1);
    For n:=1 to MaxIGBT do begin
      str(n,s);
      AddB(InfoDialog,aktIGBTStatus[n],'IGBT Nr. '+s+'                [on=Yes/off=No]','IGBT on/off');
    end;
    AddB(InfoDialog,SingleSwitchIGBTs,'Close IGBTs only for 0.5 seconds             [Yes/No]','SingleSwitch');
    BackupVars(InfoDialog);
    DoDialog(InfoDialog,'Magnetic Trap Parameters',UpdateDialog);
    For n:=1 to MaxIGBT do SwitchIGBT(n,aktIGBTStatus[n]);
    SetMOTCurrent(aktMOTCurrent);
    SetBarsCurrent(aktBarCurrent);
    SetBarsVoltage(aktBarVoltage);
    SetTransfer1Current(aktTransfer1Current);
    SetTransfer1Voltage(aktTransfer1Voltage);
    SetTransfer2Voltage(aktTransfer2Voltage);
    SetMOTVoltage(aktMOTVoltage);
    IOCompleteUpdate;
    if SingleSwitchIGBTs then begin
      StartCounter;
      SwitchOszilloskopTrigger(on);
      IOUpdate;
      Wait(500);
      SwitchOszilloskopTrigger(off);
      SwitchIGBTsOff;
      IOUpdate;
    end;
  end;

begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'Set Currents and Voltages           [0]',
    'Set Currents and Voltages','0',iMenuCurrents);
  AddChoice(yellow,MenuInfo,'Switch IGBTs to MOT                 [A]',
    'IGBT 1,3,6 on ; 2,4,5,7,8,9 off','A',iSwitchIGBTsToMOT);
  AddChoice(yellow,MenuInfo,'Switch IGBTs off                    [B]',
    'IGBT 1,2,3,4,5,6,7,8,9 off','B',iSwitchIGBTsOff);
  AddChoice(yellow,MenuInfo,'Switch IGBTs to Ioffe Trap          [C]',
    'IGBT 1,3,6,9 off ; 2,4,5,7,8 on','C',iSwitchIGBTsToIoffe);
  AddChoice(yellow,MenuInfo,'Switch Optical Pumping field on     [D]',
    'Switch Optical Pumping field on','D',iSwitchOptPumpOn);
  AddChoice(yellow,MenuInfo,'Switch Optical Pumping field off    [E]',
    'Switch Optical Pumping field off','E',iSwitchOptPumpOff);
  AddChoice(yellow,MenuInfo,'Switch Ioffe guiding field on       [F]',
    'Switch Ioffe guiding field on','F',iSwitchIoffeGuidingFieldOn);
  AddChoice(yellow,MenuInfo,'Switch Ioffe guiding field off      [G]',
    'Switch Ioffe guiding field off','G',iSwitchIoffeGuidingFieldOff);
  AddChoice(yellow,MenuInfo,'Switch Transfer Decharging on       [H]',
    'Switch Transfer Decharging on','H',iSwitchTransferDechargingOn);
  AddChoice(yellow,MenuInfo,'Switch Transfer Decharging off      [I]',
    'Switch Transfer Decharging off','I',iSwitchTransferDechargingOff);
  AddChoice(yellow,MenuInfo,'Switch MOT Decharging on            [J]',
    'Switch MOT Decharging on','J',iSwitchMOTDechargingOn);
  AddChoice(yellow,MenuInfo,'Switch MOT Decharging off           [K]',
    'Switch MOT Decharging off','K',iSwitchMOTDechargingOff);
  AddChoice(yellow,MenuInfo,'Doppler cooling beam on             [L]',
    'Doppler cooling beam on','L',iDopplerCoolingon);
  AddChoice(yellow,MenuInfo,'Main Menu                           [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Manual Menu ',Choice);
    if Choice=iSwitchIGBTsToMOT then SwitchIGBTsToMOT
    else if Choice=iSwitchOptPumpOn then SwitchOpticalPumpingField(on)
    else if Choice=iSwitchOptPumpOff then SwitchOpticalPumpingField(off)
    else if Choice=iDopplerCoolingon then begin
      ShutterMOT(open);
      SwitchMOTLight(off);
    end else if Choice=iSwitchIoffeGuidingFieldOn then begin
      SwitchIoffeGuidingField(on);
      SwitchOszilloskopTrigger(on);
    end else if Choice=iSwitchIoffeGuidingFieldOff then begin
      SwitchIoffeGuidingField(off);
      SwitchOszilloskopTrigger(off);
    end else if Choice=iSwitchTransferDechargingOff then SwitchTransferDecharging(off)
    else if Choice=iSwitchTransferDechargingOn then SwitchTransferDecharging(on)
    else if Choice=iSwitchMOTDechargingOff then SwitchMOTDecharging(off)
    else if Choice=iSwitchMOTDechargingOn then SwitchMOTDecharging(on)
    else if Choice=iSwitchIGBTsOff then begin
      SwitchIGBTsOff;
      SwitchIGBT(7,off);
    end else if Choice=iSwitchIGBTsToIoffe then SwitchIGBTsToIoffe
    else if Choice=iBlink then Blink
    else if Choice=iMenuCurrents then MenuCurrents;
    IOUpdate;
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
end;

procedure MenuManualSlower;
var MenuInfo   : PMenuInfo;
    iMain,Choice,
    i7LiMOTon,i7LiMOToff,i6LiMOTon,i6LiMOToff,iSlowerLighton,
    iSlowerLightoff,iSlowerJeton,iSlowerJetoff,iSlowerFieldon,iSlowerFieldoff,
    iMOTLighton,iMOTLightoff,iMOTFieldon,iMOTFieldoff,
    i7Liprobeon,i7Liprobeoff,i6Liprobeon,i6Liprobeoff,
    iSlower7principalon,iSlower6principalon,
    iSlower7principaloff,iSlower6principaloff,
    iprobeAOMsoff,iProbeRepumpon,iProbeRepumpoff,
    iSlowerCompensationon,iSlowerCompensationoff,
    iSlowerVoltageon,iSlowerVoltageoff:integer;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'Slower 7Li principal injection on  [A]',
    '7Li injection','A',iSlower7principalon);
  AddChoice(yellow,MenuInfo,'Slower 7Li principal injection off [B]',
    '7Li injection','B',iSlower7principaloff);
  AddChoice(yellow,MenuInfo,'Slower 6Li principal injection on  [C]',
    '6Li injection','C',iSlower6principalon);
  AddChoice(yellow,MenuInfo,'Slower 6Li principal injection off [D]',
    '6Li injection','D',iSlower6principaloff);
  AddChoice(yellow,MenuInfo,'Slower Light on                    [E]',
    'Slower Light on','E',iSlowerLighton);
  AddChoice(yellow,MenuInfo,'Slower Light off                   [F]',
    'Slower Light off','F',iSlowerLightoff);
  AddChoice(yellow,MenuInfo,'Slower Field on                    [G]',
    'Slower Field on','G',iSlowerFieldon);
  AddChoice(yellow,MenuInfo,'Slower Field off                   [H]',
    'Slower Field off','H',iSlowerFieldoff);
  AddChoice(yellow,MenuInfo,'Slower Jet on                      [I]',
    'Slower Jet on','I',iSlowerJeton);
  AddChoice(yellow,MenuInfo,'Slower Jet off                     [J]',
    'Slower Jet off','J',iSlowerJetoff);
  AddChoice(yellow,MenuInfo,'Slower Compensation on             [K]',
    'Slower Compensation on','K',iSlowerCompensationon);
  AddChoice(yellow,MenuInfo,'Slower Compensation off            [L]',
    'Slower Compensation off','L',iSlowerCompensationoff);
  AddChoice(yellow,MenuInfo,'Slower Voltage 20 V                [N]',
    'Slower Voltage 20 V','N',iSlowerVoltageon);
  AddChoice(yellow,MenuInfo,'Slower Voltrage 0 V                [O]',
    'Slower Voltage 20 V','O',iSlowerVoltageoff);
  AddChoice(yellow,MenuInfo,'Main Menu                          [M]',
    'Main Menu','M',iMain);
  repeat
    DoMenu(MenuInfo,' Manual Menu ',Choice);
    if Choice=iSlowerLighton then begin
      SwitchSlower6(on);
      SwitchSlower7(on);
    end else if Choice=iSlowerLightoff then begin
      SwitchSlower6(off);
      SwitchSlower7(off);
    end else if Choice=iSlowerJeton then begin
      ShutterSlowerJet(open);
    end else if Choice=iSlowerJetoff then begin
      ShutterSlowerJet(close);
    end else if Choice=iSlowerFieldon then begin
      SwitchSlowerField(on);
    end else if Choice=iSlowerFieldoff then begin
      SwitchSlowerField(off);
    end else if Choice=iSlower7principalon then begin
      SwitchSlower7(on);
    end else if Choice=iSlower7principaloff then begin
      SwitchSlower7(off);
    end else if Choice=iSlower6principalon then begin
      SwitchSlower6(on);
    end else if Choice=iSlower6principaloff then begin
      SwitchSlower6(off);
    end else if Choice=iSlowerCompensationon then begin
      SwitchSlowerCompensation(on);
    end else if Choice=iSlowerCompensationoff then begin
      SwitchSlowerCompensation(off);
    end else if Choice=iSlowerVoltageon then begin
      SwitchFinalSlowerVoltage(on);
    end else if Choice=iSlowerVoltageoff then begin
      SwitchFinalSlowerVoltage(off);
    end;
    IOUpdate;
  until (Choice=0) or (Choice=iMain);
  dispose(MenuInfo);
  SwitchSlowerCompensation(off);
  IOUpdate;
end;

procedure MainMenu;
Var
  iFrequ,iSetAOM,iManualSlower,iManualMotProbe,iManualMagneticTrap,
  iParam1,iParam2,iParam3,iParam4,iParam5,iParam6,iParam7,iParam8,
  iAOM,iAOM4,iAOM5,iUtils2,
  iQuit,iTemp,iSweep,iProbe,iUtils1,iCreateUniMess,iDoUniMess,
  iChargeDetectTrap,iCalibrateVCO,iRecapture,iAbs,iMess,iCalProbe,iClearQueue,
  iRFsweepmenu,iInit,iChooseSetup,iHeat,iExecuteQueue,iQueuePic,Dummy:integer;
  MenuInfo:PMenuInfo;
  Choice:integer;
  Rep:char;
  buf:string;
begin
  NewMenu(MenuInfo);
  AddChoice(yellow,MenuInfo,'Manual Operation of MOT and probe                         [M]',
    'Open/Close Click-Clack, AOMs etc.','M',iManualMotProbe);
  AddChoice(yellow,MenuInfo,'Manual Operation of slower                                [S]',
    'Open/Close Click-Clack, AOMs etc.','S',iManualSlower);
  AddChoice(yellow,MenuInfo,'Manual Operation of magnetic trap                         [T]',
    'Open/Close IGBTs, Voltage, Current of power supplies','T',iManualMagneticTrap);
  Registry^.MakeMenuEntrys(menuInfo,0,0);
  AddChoice(yellow,MenuInfo,'Setup RF sweeps                                           [R]',
    'RF sweep menu','R',iRFsweepmenu);
  AddChoice(yellow,MenuInfo,'Choose Setup                                              [O]',
    'Choose Setup','O',iChooseSetup);
  AddChoice(yellow,MenuInfo,'Take Absorption Picture                                   [*]',
    'Takes absorption pictures','*',iAbs);
  AddChoice(yellow,MenuInfo,'Heat bars                                                 [H]',
    'Heat bars','H',iHeat);
  AddChoice(yellow,MenuInfo,'Universal measurement menu                                [U]',
    'Measurements','U',iDoUniMess);
  AddChoice(yellow,MenuInfo,'Measurements                                              [A]',
    'Measurements','A',iMess);
  AddChoice(yellow,MenuInfo,'Queue Take Absorption Picture                             [P]',
    'Queue Takes absorption pictures','P',iQueuePic);
  AddChoice(yellow,MenuInfo,'Execute Measurement Queue                                 [E]',
    'Execute Measurement Queue','E',iExecuteQueue);
  AddChoice(yellow,MenuInfo,'Clear Measurement Queue                                   [C]',
    'Clear Measurement Queue','C',iClearQueue);
  AddChoice(yellow,MenuInfo,'Test Utilities                                            [U]',
    'Utilities 2','U',iUtils2);
  AddChoice(yellow,MenuInfo,'Experiment Utilities                                      [U]',
    'Utilities 1','U',iUtils1);
  AddChoice(yellow,MenuInfo,'Quit                                                      [Q]',
    'Exit the program','Q',iQuit);
  repeat
    DoMenu(MenuInfo,' Main Menu ',Choice);
       writeln(choice);
    repeat until keypressed;
    if Choice=iMess then MenuMeasure
    else if Choice=iChooseSetup then SelectSetup
    else if Choice=iRFsweepMenu then MenuRFSweep
    else if Choice=iUtils1 then MenuUtils1
    else if Choice=iUtils2 then MenuUtils2
    else if Choice=iManualMOTprobe then MenuManualMOTprobe
    else if Choice=iManualSlower then MenuManualSlower
    else if Choice=iManualMagneticTrap then MenuManualMagneticTrap
    else if Choice=iAbs then TakeAbsorptionPicture
    else if Choice=iQueuePic then QueueTakeAbsorptionPicture
    else if Choice=iClearQueue then ClearQueue
    else if Choice=iExecuteQueue then ExecuteQueue
    else if Choice=iHeat then begin
      SetBarsCurrent(650);
      SetBarsVoltage(MaxBarVoltage);
      SwitchIGBT(8,on);
      IOUpdate;
    end
   (* else if Choice=iInit then begin InitCards;InitExp; end *)
    else if Choice=iDoUniMess then begin
       if UniMeasure<>nil then UniMeasure^.SelectUniMessDialog(UniMeasure)
       else begin
         UniMeasure:=new(PUniMess,init(nil,Registry));
         UniMeasure^.SelectUniMessDialog(UniMeasure);
       end;
    end else if (Choice<>0) and (Choice<>iQuit)
    then Registry^.ExecuteMenuDialog(choice,0);
    if (Choice=0) or (Choice=iQuit) then begin
      WriteMessage('ATTENTION','Really quit?||(O,Y/N)');
      Rep:=UpCase(ReadKey);
      if (Rep <> 'Y') and (Rep<>'O') then Choice:=-1 else Choice:=0;
    end;

  until Choice=0;
  dispose(MenuInfo);
end;

end.