unit MixData;
interface

type Pdouble=^double;
type PPoint=^TPoint;
     TPoint=object
       P1,P2,P3,P4:double;
       next,last:PPoint;
       constructor init(aP1:double;aP2:double;aP3:double;aP4:double;anext:PPoint);
       destructor AllDone;
       destructor ThisDone(nr:byte;ap1:Pdouble;ap2:Pdouble;ap3:Pdouble;ap4:Pdouble);
     end;

type PMix=^TMix;
     TMix=object
       points:PPoint;
       nr:byte;
       p1,p2,p3,p4:Pdouble;
       nrpoints:word;
       constructor init(anr:byte;ap1:Pdouble;ap2:Pdouble;ap3:Pdouble;ap4:Pdouble;initrandomgenerator:boolean);
       destructor done;
       procedure AddPoint1(aP1:double);
       procedure AddPoint2(aP1:double;aP2:double);
       procedure AddPoint3(aP1:double;aP2:double;aP3:double);
       procedure AddPoint4(aP1:double;aP2:double;aP3:double;aP4:double);
       procedure GetPoint;
       function EOF:boolean;
     end;

implementation

constructor TPoint.init(aP1:double;aP2:double;aP3:double;aP4:double;anext:PPoint);
begin
  P1:=aP1;
  P2:=aP2;
  P3:=aP3;
  P4:=aP4;
  if anext=nil then begin
    next:=@self;
    last:=@self;
  end else begin
    next:=anext^.next;
    last:=anext;
    anext^.next:=@self;
    next^.last:=@self;
  end;
end;

destructor TPoint.AllDone;
begin
  last^.next:=nil;
  if next<>nil then dispose(next,AllDone);
end;

destructor TPoint.ThisDone(nr:byte;ap1:Pdouble;ap2:Pdouble;ap3:Pdouble;ap4:Pdouble);
begin
  last^.next:=next;
  next^.last:=last;
  ap1^:=P1;
  if nr>=2 then ap2^:=P2;
  if nr>=3 then ap3^:=P3;
  if nr>=4 then ap4^:=P4;
end;

constructor TMix.init(anr:byte;ap1:Pdouble;ap2:Pdouble;ap3:Pdouble;ap4:Pdouble;initrandomgenerator:boolean);
begin
  if (anr<1) or (anr>4) then begin
    writeln('MixData: TMix.init : nr Range error',^G);
    halt(1);
  end;
  nr:=anr;
  p1:=ap1;
  p2:=ap2;
  p3:=ap3;
  p4:=ap4;
  points:=nil;
  nrpoints:=0;
  if initrandomgenerator then randseed:=7;
end;

destructor TMix.done;
begin
  if points<>nil then dispose(points,AllDone);
end;

procedure TMix.AddPoint1(aP1:double);
begin
  points:=new(PPoint,init(aP1,0,0,0,points));
  nrpoints:=nrpoints+1;
end;

procedure TMix.AddPoint2(aP1:double;aP2:double);
begin
  points:=new(PPoint,init(aP1,aP2,0,0,points));
  nrpoints:=nrpoints+1;
end;

procedure TMix.AddPoint3(aP1:double;aP2:double;aP3:double);
begin
  points:=new(PPoint,init(aP1,aP2,aP3,0,points));
  nrpoints:=nrpoints+1;
end;

procedure TMix.AddPoint4(aP1:double;aP2:double;aP3:double;aP4:double);
begin
  points:=new(PPoint,init(aP1,aP2,aP3,aP4,points));
  nrpoints:=nrpoints+1;
end;

procedure TMix.GetPoint;
var n:word;
    hpoint:PPoint;
    ende:boolean;
begin
  if nrpoints>0 then begin
    for n:=0 to random(nrpoints) do points:=points^.next;
    hpoint:=points^.next;
    ende:=hpoint=points;
    dispose(points,ThisDone(nr,p1,p2,p3,p4));
    if ende then points:=nil
    else points:=hpoint;
    nrpoints:=nrpoints-1;
  end;
end;

function TMix.EOF:boolean;
begin
  EOF:=nrpoints=0;
end;

end.