procedure PrepareSinglePulsBurst(time:double);far;
var status:integer;
    buf:string;
begin
  if SequenceOut then begin
    IEEE.Send(SRS,'ATTL',status);
    IEEE.Send(SRS,'FUNC 1',status);
    Str(500/time:10:8,buf);
    buf:='FREQ '+buf;
    IEEE.Send(SRS,buf,status);
    IEEE.Send(SRS,'BCNT 1',status);
    IEEE.Send(SRS,'MTYP 5',status);
    IEEE.Send(SRS,'TSRC 2',status);
    IEEE.Send(SRS,'MDWF 0',status);
    {IEEE.Send(SRS,'PHSE 359',status);}
    IEEE.Send(SRS,'PHSE -162',status);
    IEEE.Send(SRS,'INVT 1',status);
  end else SequenceDoubleArg(PrepareSinglePulsBurst,time,0);
end;


{
Gate(time,rate)     Configures the SRS Synthesizer to produce TTL pulses
                    with the width "time" and the repetition rate "rate".
                    time [ms]
                    rate [Hz]
}
procedure Gate(time:double;rate:double);
var status:integer;
    buf:string;
begin
  if SequenceOut then begin
    IEEE.Send(SRS,'ATTL',status);
    IEEE.Send(SRS,'FUNC 1',status);
    Str(500/time:10:8,buf);
    buf:='FREQ '+buf;
    IEEE.Send(SRS,buf,status);
    IEEE.Send(SRS,'MDWF 0',status);
    IEEE.Send(SRS,'TSRC 1',status);
    Str(rate:10:8,buf);
    buf:='TRAT '+buf;
    IEEE.Send(SRS,buf,status);
  end else SequenceDoubleDoubleArg(Gate,time,rate,0);
end;


procedure SineWave(frequ:double);
var status:integer;
    buf:string;
begin
  if SequenceOut then begin
    IEEE.Send(SRS,'FUNC 0',status);
    Str(frequ:10:3,buf);
    buf:='FREQ '+buf;
    IEEE.Send(SRS,buf,status);
  end else SequenceDoubleArg(SineWave,frequ,0);
end;
