unit MultiOut;
{
  Software interface to our homebrewn digital analog output system
}
interface

procedure MultiOutInit;
procedure MultiOutanalogOut(Channel: byte; Value:word );
Procedure MultiOutdigitalOut(channel:byte; Value:word );
procedure WritePortDirect(channel:byte;value:word);
procedure MultiOutTest;

implementation
uses PortList,Debug,crt;

Const NumbDig=4;
Const NumbAna=28;
      NumbChannel=32;
      BUS1=128;
      BUS2=64;
      BA=BUS1+BUS2;
      BB=BUS1+BUS2;

                                          {0, 1, 2, 3}
Const DigAdr:array[0..NumbDig-1] of byte=(29,30,31,28);
      AnaAdr:array[0..NumbAna-1] of byte=(20,21,22,23,24,25,26,27,12,13,14,15, 8, 9,10,11, 0, 1, 2, 3, 4, 5, 6, 7,16,17,18,19);
                                          {0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27}
      BUS:array[0..NumbChannel-1] of byte=(BB,BB,BB,BB,BA,BA,BA,BA,BB,BB,BB,BB,BB,BB,BB,BB,BA,BA,BA,BA,BB,BB,BB,BB,BA,BA,BA,BA,
        BA,BB,BA,BA);
                                          { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,
        24,25,26,27,28,29,30,31}
const DebugDigBuffer:array[0..NumbDig-1] of word=(0,0,0,0);
      DebugAnaBuffer:array[0..NumbAna-1] of word=( 0,0,0,0,0,0,0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,0,0,0,0);
CONST
  {DAS-1601 registers:}
  adr=$310;
  ad0=adr+$0;
  ad1=adr+$1;
  mux=adr+$2;
  dio=adr+$3;
  da0lb=adr+$4;
  da0hb=adr+$5;
  da1lb=adr+$6;
  da1hb=adr+$7;
  statusa=adr+$8;
  ctrl=adr+$9;
  cnten=adr+$A;
  gain=adr+$B;
  timer0=adr+$C;
  timer1=adr+$D;
  timer2=adr+$E;
  timerctl=adr+$F;

  piopa=adr+$400;
  piopb=adr+$401;
  piopc=adr+$402;

  {BaseAddrDDA06 = 768;
  piopa=BaseAddrDDA06+$C+0;
  piopb=BaseAddrDDA06+$C+1;
  piopc=BaseAddrDDA06+$C+2;}


  pioctl=adr+$403;
  disarm=adr+$404;
  bmden=adr+$405;
  mden1600=adr+$406;
  statusb=adr+$407;
  RW=32;
  bufa:byte=0;
  bufb:byte=0;
  bufc:byte=0;


procedure Store(channel:byte;value:word);
var Digital:boolean;
    n:byte;

  procedure Save;
  var n,m:word;
  begin
    DebugTimeStamp;
    for m:=0 to NumbAna-1 do begin
      if DebugOriginOffset then write(DebugFile,DebugAnaBuffer[m]*2.0/$FFFF*0.8+m:1:4,' ')
      else write(DebugFile,DebugAnaBuffer[m],' ');
    end;
    for m:=0 to NumbDig-1 do begin
      for n:=15 downto 0 do if (DebugDigBuffer[m] and (1 shl n))>0
      then begin
        if DebugOriginOffset then write(DebugFile,(NumbAna+m*16+15-n+1)+0.8:1:1,' ')
        else write(DebugFile,'1 ')
      end else begin
        if DebugOriginOffset then write(DebugFile,(NumbAna+m*16+15-n+1):1,' ')
        else write(DebugFile,'0 ');
      end;
    end;
    writeln(DebugFile);
  end;

begin
  n:=0;
  while (n<NumbDig) and (DigAdr[n]<>channel) do inc(n);
  if n<NumbDig then begin
    Save;
    DebugDigBuffer[n]:=value;
    Save;
  end else begin
    n:=0;
    while (n<NumbAna) and (AnaAdr[n]<>channel) do inc(n);
    if n>=NumbAna then begin
      writeln('MultiOut : Store : Strange Error');
      exit;
    end;
    Save;
    DebugAnaBuffer[n]:=value;
    save;
  end;
end;

procedure WritePortDirect(channel:byte;value:word);
var n:byte;
begin
  if Debuging then begin
    write(DebugFile,'MultiOutDirect(',channel:2,'):=',value:5,' = ');
    for n:=15 downto 0 do if (value and (1 shl n))>0
    then write(DebugFile,'1') else write(DebugFile,'0');
    writeln(DebugFile);
  end;
  if DebugingAsOszilloskop then Store(channel,value);
  {if (bufa<>Lo(value)) then }
  port[piopa]:=Lo(value);
  {if (bufb<>Hi(value)) then }
  port[piopb]:=Hi(value);
  {if (bufc<>channel+BUS[channel]+RW) then }
  port[piopc]:=channel+BUS[channel]+RW;
  port[piopc]:=channel+BUS[channel];
  port[piopc]:=channel+BUS[channel]+RW;
  bufa:=Lo(value);
  bufb:=Hi(value);
  bufc:=channel+BUS[channel]+RW;
end;

procedure WritePort(channel:byte;value:word);
var n:byte;
begin
  if PortListRegister then begin
    PortListMultiOut(channel,value);
  end else begin
    if Debuging then begin
      write(DebugFile,'MultiOut(',channel:2,'):=',value:5,' = ');
      for n:=15 downto 0 do if (value and (1 shl n))>0
      then write(DebugFile,'1') else write(DebugFile,'0');
      writeln(DebugFile);
    end;
    if DebugingAsOszilloskop then Store(channel,value);
    {if (bufa<>Lo(value)) then}
    port[piopa]:=Lo(value);
    {if (bufb<>Hi(value)) then }
    port[piopb]:=Hi(value);
    {if (bufc<>channel+BUS[channel]+RW) then }
    port[piopc]:=channel+BUS[channel]+RW;
    port[piopc]:=channel+BUS[channel];
    port[piopc]:=channel+BUS[channel]+RW;
    bufa:=Lo(value);
    bufb:=Hi(value);
    bufc:=channel+BUS[channel]+RW;
  end;
end;

procedure MultiOutdigitalOut(channel:byte;value:word);
begin
  if (channel<NumbDig) then WritePort(DigAdr[channel],value)
  else writeln('MultiOut : digitalOut : wrong channel ',channel);
end;

procedure MultiOutanalogOut(channel:byte;value:word);
begin
  if (channel<NumbAna) then WritePort(AnaAdr[channel],value shr 1)
  else writeln('MultiOut : analogOut : wrong channel ',channel);
end;

procedure MultiOutInit;
var n:byte;
begin
  port[pioctl]:=128;
  for n:=0 to NumbDig-1 do MultiOutdigitalOut(n,0);
  for n:=0 to NumbAna-1 do MultiOutanalogOut(n,0);
end;

procedure MultiOutTest;
var which,bit:byte;
    Addr:word;
begin
  clrscr;
  writeln('Testing all bits');
  repeat
    port[piopa]:=0;
    port[piopb]:=0;
    port[piopc]:=0;
    port[piopa]:=$FF;
    port[piopb]:=$FF;
    port[piopc]:=$FF;
  until keypressed;
  while keypressed do readkey;
  write('Test which port (0=Lo data 1=Hi data 2=Addr) ');
  readln(which);
  if which>2 then which:=2;
  write('Test which bit (0..7) ');
  readln(bit);
  if bit>7 then bit:=7;
  case which of
    0:Addr:=piopa;
    1:Addr:=piopb;
    2:Addr:=piopc;
  end;
  repeat
    port[Addr]:=0;
    port[Addr]:=1 shl bit;
  until keypressed;
  bufa:=$FF;
  bufb:=$FF;
  bufc:=$FF;
end;

begin
  MultiOutInit;
end.