unit MagTrap;
interface
uses IO,Params,Sequence,ExpIO,Exp,crt;

procedure PrepareOpticalPumping;
procedure OpticalPumping;
procedure MagneticTrap;
procedure InitMagTrap;
procedure SwitchIGBTsToMOT;
procedure SwitchIGBTsOff;
procedure SwitchIGBTsToIoffe;
procedure SwitchIGBTsToMagTrap;
procedure SwitchTrapOff;
procedure SwitchMagTrapCompletelyOff;

implementation
uses RFSweep,Marconi;

const commandtime=0.2;

procedure SwitchIGBTsToMOT;
begin
  SwitchIGBT(1,on);
  SwitchIGBT(2,off);
  SwitchIGBT(3,on);
  SwitchIGBT(4,off);
  SwitchIGBT(5,off);
  SwitchIGBT(6,on);
  SwitchIGBT(7,off);
  SwitchIGBT(8,off);
  SwitchIGBT(9,off);
  SwitchIGBT(10,off);
end;

procedure SwitchIGBTsToMagTrap;
begin
  SwitchIGBT(1,off);
  SwitchIGBT(2,off);
  SwitchIGBT(3,off);
  SwitchIGBT(4,off);
  SwitchIGBT(5,off);
  SwitchIGBT(6,on);
  SwitchIGBT(7,off);
  SwitchIGBT(8,off);
  SwitchIGBT(9,off);
  SwitchIGBT(10,off);
end;

procedure SwitchIGBTsToTransfer;

begin
  SwitchIGBT(1,on);
  SwitchIGBT(2,off);
  SwitchIGBT(3,on);
  SwitchIGBT(4,off);
  SwitchIGBT(5,off);
  SwitchIGBT(6,on);
  SwitchIGBT(7,off);
  SwitchIGBT(8,off);
  SwitchIGBT(9,off);
  SwitchIGBT(10,off);
end;

procedure SwitchIGBTsToPumping;
begin
  SwitchIGBT(1,off);
  SwitchIGBT(2,off);
  SwitchIGBT(3,off);
  SwitchIGBT(4,off);
  SwitchIGBT(5,off);
  SwitchIGBT(6,off);
  SwitchIGBT(7,off);
  SwitchIGBT(8,off);
  SwitchIGBT(9,off);
  SwitchIGBT(10,off);
end;

procedure SwitchIGBTsOff;
begin
  SwitchIGBT(1,off);
  SwitchIGBT(2,off);
  SwitchIGBT(3,off);
  SwitchIGBT(4,off);
  SwitchIGBT(5,off);
  SwitchIGBT(6,off);
  SwitchIGBT(7,off);
  SwitchIGBT(8,off);
  SwitchIGBT(9,off);
  SwitchIGBT(10,off);
end;

procedure SwitchIGBTsToIoffe;
begin
  SwitchIGBT(1,off);
  SwitchIGBT(2,on);
  SwitchIGBT(3,off);
  SwitchIGBT(4,on);
  SwitchIGBT(5,on);
  SwitchIGBT(6,off);
  SwitchIGBT(7,on);
  SwitchIGBT(8,on);
  SwitchIGBT(9,off);
  SwitchIGBT(10,off);
end;

Type TTrapOffMode=(Normal,Ioffe,CompensatedIoffe);
const TrapOffMode:TTrapOffMode=Normal;

procedure SwitchTrapOff;
begin
  case TrapOffMode of
    Normal:begin
      if not PictureWithAxialConfinementOn then SwitchIGBT(4,off);
      if not PictureWithAxialConfinementOn then begin
        SwitchIGBT(5,off);
        SwitchIGBT(10,off);
      end;
    end;
    Ioffe:begin
      if not PictureWithAxialConfinementOn then SwitchIGBT(4,off);
      if not PictureWithAxialConfinementOn then begin
        SwitchIGBT(5,off);
        SwitchIGBT(10,off);
      end;
    end;
    CompensatedIoffe:begin
      if not PictureWithAxialConfinementOn then begin
        SwitchIGBT(5,off);
        SwitchIGBT(10,off);
      end;
      {if not PictureWithAxialConfinementOn then SwitchIGBT(4,off);}
    end;
  end;
  if not PictureWithAxialConfinementOn then SwitchIGBT(2,off);
  SwitchIGBT(1,off);
  SwitchIGBT(3,off);
  SwitchIGBT(6,off);
  SwitchIGBT(7,off);
  if not PictureWithRadialConfinementOn then SwitchIGBT(8,off);
  SwitchIGBT(9,off);
end;

procedure InitMagTrap;
begin
  TrapOffMode:=Normal;
  SwitchIGBTsToMOT;
  SwitchOpticalPumpingField(off);
  SwitchOpticalPumpingBeam(off);
  SwitchTransferDecharging(off);
  SwitchMOTDecharging(off);
  IOUpdate;
  SetMOTCurrent(MOTMOTCurrent);
  SetMOTVoltage(MOTMOTVoltage);
  SetTransfer1Current(MaxTransfer1Current);
  SetTransfer2Voltage(MOTTransfer2Voltage);
  SetTransfer1Voltage(0);
  SetBarsCurrent(MaxBarCurrent);
  SetBarsVoltage(0);
  IOUpdate;
end;

type TDoubleArgProc=procedure(y:double);

procedure Ramp(proc:TDoubleArgProc;start:double;stop:double;time:double;AktCommandTime:double);
var n,maxn:longint;
    resttime:double;
begin
  maxn:=trunc(time/Aktcommandtime);
  resttime:=time-(maxn*Aktcommandtime);
  if (resttime<0.1) then begin
    maxn:=maxn-1;
    resttime:=Time-(maxn*Aktcommandtime);
  end;
  if maxn<1 then writeln('Error : MagTrap : ramp : time too short ',time:2:3);
  for n:=1 to maxn do begin
    proc(n/maxn*(stop-start)+start);
    wait(Aktcommandtime);
  end;
  Wait(resttime);
end;

procedure CleanMagTrap;far;
var initMOTVoltage:double;
begin
  FinalTrap:='Cleaned MagTrap';
  AtomPath:=AtomPath+'Cl';
  SequenceStartBlockNoArg(CleanMagTrap);
  initMOTVoltage:=aktMOTVoltage;
  Ramp(SetMOTVoltage,initMOTVoltage,CleaningVoltage1,CleaningSweepTime,0.2);
  Wait(CleaningTime1);
  if CleaningTime2=0 then begin
    Ramp(SetMOTVoltage,CleaningVoltage1,initMOTVoltage,CleaningSweepTime,0.2);
  end else begin
    Ramp(SetMOTVoltage,CleaningVoltage1,CleaningVoltage2,CleaningSweepTime,0.2);
    Wait(CleaningTime2);
    Ramp(SetMOTVoltage,CleaningVoltage2,initMOTVoltage,CleaningSweepTime,0.2);
  end;
  SequenceEndBlock;
end;

  procedure CompressMagTrap;far;
  var n,maxn:longint;
      resttime:double;
  begin
    if CompressMagTrapTime>0 then begin
      FinalTrap:='Compressed MagTrap';
      AtomPath:=AtomPath+'Co';
      Wait(1);
      SequenceStartBlockNoArg(CompressMagTrap);
        maxn:=trunc(CompressMagTrapTime/commandtime);
        resttime:=CompressMagTrapTime-(maxn*commandtime);
        if (resttime<0.1) then begin
          maxn:=maxn-1;
          resttime:=CompressMagTrapTime-(maxn*commandtime);
        end;
        if maxn<1 then writeln('Error : MagTrap : MagneticTrap : Magnetic trap compression time too short');
        for n:=1 to maxn do begin
          SetMOTVoltage(n/maxn*(MagTrapMOTVoltageCompressed-MagTrapMOTVoltage)+MagTrapMOTVoltage);
          wait(commandtime);
        end;
        Wait(resttime);
      SequenceEndBlock;
    end;
  end;

  procedure DeCompressMagTrap;far;
  var n,maxn:longint;
      resttime:double;
  begin
    FinalTrap:='decompressed MagTrap';
    AtomPath:=AtomPath+'D';
    SequenceStartBlockNoArg(DeCompressMagTrap);
      Wait(1);
      if CompressMagTrapTime>0 then begin
        maxn:=trunc(DeCompressMagTrapTime/commandtime);
        resttime:=DeCompressMagTrapTime-(maxn*commandtime);
        if (resttime<0.1) then begin
          maxn:=maxn-1;
          resttime:=DeCompressMagTrapTime-(maxn*commandtime);
        end;
        if maxn<1 then writeln('Error : MagTrap : MagneticTrap : Magnetic trap compression time too short');
        for n:=1 to maxn do begin
          SetMOTVoltage(n/maxn*(MagTrapMOTVoltageDeCompressed-MagTrapMOTVoltageCompressed)+MagTrapMOTVoltageCompressed);
          wait(commandtime);
        end;
        Wait(resttime);
      end;
    SequenceEndBlock;
  end;

  procedure ReCompressMagTrap;far;
  var n,maxn:longint;
      resttime:double;
  begin
    SequenceStartBlockNoArg(ReCompressMagTrap);
      Wait(1);
      if CompressMagTrapTime>0 then begin
        maxn:=trunc(DeCompressMagTrapTime/commandtime);
        resttime:=DeCompressMagTrapTime-(maxn*commandtime);
        if (resttime<0.1) then begin
          maxn:=maxn-1;
          resttime:=DeCompressMagTrapTime-(maxn*commandtime);
        end;
        if maxn<1 then writeln('Error : MagTrap : MagneticTrap : Magnetic trap compression time too short');
        for n:=1 to maxn do begin
          SetMOTVoltage(n/maxn*(MagTrapMOTVoltageCompressed-MagTrapMOTVoltageDeCompressed)+MagTrapMOTVoltageDeCompressed);
          wait(commandtime);
        end;
        Wait(resttime);
      end;
    SequenceEndBlock;
  end;

  procedure TranslateMagTrap;far;
  begin
    FinalTrap:='translated MagTrap';
    AtomPath:=AtomPath+'T';
    SequenceStartBlockNoArg(TranslateMagTrap);
      SwitchSlowerCompensation(on);
      Wait(10);
      SwitchFinalSlowerVoltage(on);
      Wait(1);
      Ramp(SetFinalSlowerCurrent,3,SlowerCompensationCurrent[0],SlowerCompensationRampTime,0.2);
    SequenceEndBlock;
  end;

  procedure DeTranslateMagTrap;far;
  begin
    FinalTrap:='Detranslated MagTrap';
    AtomPath:=AtomPath+'Dt';
    SequenceStartBlockNoArg(DeTranslateMagTrap);
      Ramp(SetFinalSlowerCurrent,SlowerCompensationCurrent[0],0,SlowerCompensationRampTime,0.2);
      SwitchSlowerCompensation(off);
      Wait(1);
    SequenceEndBlock;
  end;

  procedure AddCurrent;far;
  begin
    if DoAddCurrent then begin
      FinalTrap:='Added current MagTrap';
      AtomPath:=AtomPath+'A';
    end;
    SequenceStartBlockNoArg(AddCurrent);
    if DoAddCurrent then begin
      SetTransfer2Voltage(0);
      SwitchTransferDecharging(off);
      IOUpdate;
      {SetTransfer1Voltage(AddCurrentStartVoltage);
      Wait(10);}
      SetTransfer1Current(0);
      Wait(1);
      SetMOTCurrent(MaxMOTCurrent);
      Ramp(SetMOTVoltage,MagTrapMOTVoltageCompressed,AddCurrentMOTVoltageRamp1MOTEndVoltage,
        LowerMagTrapMOTVoltageRampTime1,0.2);
      Ramp(SetMOTVoltage,AddCurrentMOTVoltageRamp1MOTEndVoltage,MaxMOTVoltage,LowerMagTrapMOTVoltageRampTime2,0.2);
      SwitchIGBT(7,on);
      SwitchIGBT(9,on);
      Wait(1);
      Ramp(SetTransfer1Voltage,0{AddCurrentStartVoltage},MaxTransfer1Voltage,LowerMagTrapTransferVoltageRampTime,0.2);
      if (MaxTotalLowerMagTrapCurrent-MaxMotCurrent)<0 then MaxTotalLowerMagTrapCurrent:=MaxMotCurrent;
      if (MaxTotalLowerMagTrapCurrent-MaxMotCurrent)>300 then MaxTotalLowerMagTrapCurrent:=300+MaxMotCurrent;
      LockIGBTs;
      Ramp(SetTransfer1Current,0,MaxTotalLowerMagTrapCurrent-MaxMotCurrent,LowerMagTrapCurrentRampTime1,0.2);
    end else begin
      SetTransfer1Voltage(0);
      SetTransfer2Voltage(0);
      SetTransfer1Current(MaxTransfer1Current);
      SwitchTransferDecharging(on);
    end;
    SequenceEndBlock;
  end;

  procedure DeAddCurrent;far;
  begin
    SequenceStartBlockNoArg(DeAddCurrent);
      if DoAddCurrent then begin
        Ramp(SetTransfer1Current,MaxTotalLowerMagTrapCurrent-MaxMotCurrent,0,LowerMagTrapCurrentRampTime2,0.2);
        UnlockIGBTs;
        Wait(10);
        SwitchIGBT(7,off);
        SwitchIGBT(9,off);
        IOUpdate;
        SetTransfer1Voltage(0);
        SetTransfer2Voltage(0);
        SetTransfer1Current(MaxTransfer1Current);
        SwitchTransferDecharging(on);
        Wait(1);
        Ramp(SetMOTVoltage,MaxMOTVoltage,AddCurrentMOTVoltageRamp1MOTEndVoltage,LowerMagTrapMOTVoltageRampTime2,0.2);
        Ramp(SetMOTVoltage,AddCurrentMOTVoltageRamp1MOTEndVoltage,
          MagTrapMOTVoltageCompressed,LowerMagTrapMOTVoltageRampTime1,0.2);
        SwitchTransferDecharging(off);
      end;{ else SwitchTransferDecharging(off);}
    SequenceEndBlock;
  end;

  procedure SetTranslateCurrent(y:double);{y is position scaled from 0 to 1}
  var n:byte;
      hy,Current:double;
  begin
    n:=trunc(y*MaxSlowerCompCurrent);
    hy:=y*MaxSlowerCompCurrent-n;
    if n<MaxSlowerCompCurrent then begin
      current:=hy*(SlowerCompensationCurrent[n+1]-SlowerCompensationCurrent[n])+
        SlowerCompensationCurrent[n];
    end else Current:=SlowerCompensationCurrent[MaxSlowerCompCurrent];
    SetFinalSlowerCurrent(Current);
  end;

  procedure Transfer;far;
  var n,maxn,startn:longint;
      y,x,helpTransfer1Current,helpTransfer2Voltage,helpMOTCurrent,resttime:double;
      TransferFraction,TransferEndCurrentMOT,
      aktRampTransferCoilsTime,aktRampMOTCoilsTime,aktTransfer2EndVoltage,
      aktTransferCurrentMiddle:double;
      MagTrapTransfer1CurrentCC:double;
      aktTransferPercent:double;
      WaitTime:double;
  begin
    FinalTrap:='transfered MagTrap';
    AtomPath:=AtomPath+'Tr';
    SequenceStartBlockNoArg(Transfer);
      {SwitchOszilloskopTrigger(off);
      IOUpdate;}
      SwitchTransferDecharging(off);
      SwitchIGBTsToTransfer;
      Wait(1);
      {if DoIoffeTrap then TransferFraction:=1 else}
      TransferFraction:=TransferPercent/100;
      if StartBarsTransferPercent<=TransferFraction*100 then begin
        SetBarsCurrent(MaxBarCurrent);
        SetBarsVoltage(0);
        SwitchIGBT(8,on);
      end;
      if TransferFraction<0.5 then begin
        x:=TransferFraction/0.5;
        aktTransferCurrentMiddle:=TransferCurrentMiddle*x;
        if DoTransferParabolic
        then aktRampTransferCoilsTime:=(TransferTime/(2*TransferTimeRatio))*sqrt(x)
        else aktRampTransferCoilsTime:=(TransferTime/(2*TransferTimeRatio))*x;
      end else begin
        x:=(TransferFraction-0.5)/0.5;
        aktTransferCurrentMiddle:=TransferCurrentMiddle;
        aktRampTransferCoilsTime:=(TransferTime/(2*TransferTimeRatio));
        if DoTransferParabolic
        then aktRampMOTCoilsTime:=(TransferTime*(1-1/(2*TransferTimeRatio)))*(1-sqrt(1-x))
        else aktRampMOTCoilsTime:=(TransferTime*(1-1/(2*TransferTimeRatio)))*(1-(1-x));
      end;
      MagTrapTransfer1CurrentCC:=0;
      maxn:=trunc(aktRampTransferCoilsTime/(2*commandtime));
      resttime:=aktRampTransferCoilsTime-(maxn*2*commandtime);
      if (resttime<0.03) then begin
        maxn:=maxn-1;
        resttime:=aktRampTransferCoilsTime-(maxn*2*commandtime);
      end;
      if maxn<1 then writeln('Error : MagTrap : MagneticTrap : Transfer Coils time too short or Transfer percent too low');
      for n:=1 to maxn do begin
        if DoTransferParabolic
        then helpTransfer1Current:=n*n/(maxn*maxn)*
          (aktTransferCurrentMiddle-MagTrapTransfer1CurrentCC)+MagTrapTransfer1CurrentCC
        else helpTransfer1Current:=n/maxn*(aktTransferCurrentMiddle-MagTrapTransfer1CurrentCC)+MagTrapTransfer1CurrentCC;
        SetTransferCurrentControlVoltage(helpTransfer1Current);
        if DoTranslateMagTrap then begin
          y:=helpTransfer1Current/TransferCurrentMiddle;
          SetTranslateCurrent(y*0.5);
        end;
        wait(2*commandtime);
      end;
      Wait(resttime);
      Wait(TransferHalfWayWait);
      if TransferFraction>0.5 then begin
        WaitTime:=2*commandtime;
        maxn:=trunc(aktRampMOTCoilsTime/WaitTime);
        resttime:=aktRampMOTCoilsTime-(maxn*WaitTime);
        if (resttime<0.1) then begin
          maxn:=maxn-1;
          resttime:=aktRampMOTCoilsTime-(maxn*WaitTime);
        end;
        if maxn<1 then writeln('Error : MagTrap : MagneticTrap : MOT Coils time too short or Transfer percent too low');
        for n:=1 to maxn do begin
          if DoTransferParabolic
          then helpMOTCurrent:=(sqr((TransferTime*(1-1/(2*TransferTimeRatio)))
            -n*aktRampMOTCoilsTime/maxn)
            /sqr((TransferTime*(1-1/(2*TransferTimeRatio)))))
            *(MOTTransferStartCurrent-MOTTransferEndCurrent)+MOTTransferEndCurrent
          else helpMOTCurrent:=(((TransferTime*(1-1/(2*TransferTimeRatio)))-
            n*aktRampMOTCoilsTime/maxn)/((TransferTime*(1-1/(2*TransferTimeRatio)))))
            *(MOTTransferStartCurrent-MOTTransferEndCurrent)+MOTTransferEndCurrent;
          SetMOTCurrentControlVoltage(helpMOTCurrent);
          aktTransferPercent:=50+(1-helpMOTCurrent/MOTTransferStartCurrent)*50;
          if aktTransferPercent>StartBarsTransferPercent
          then SetBarsCurrentControlVoltage(BarsTransferEndCurrent*
            (aktTransferPercent-StartBarsTransferPercent)/(100-StartBarsTransferPercent));
          SetTransferCurrentControlVoltage((n/maxn)*(TransferCurrentEnd-TransferCurrentMiddle)+TransferCurrentMiddle);
          if DoTranslateMagTrap then begin
            y:=1-helpMOTCurrent/MOTTransferStartCurrent;
            SetTranslateCurrent(0.5+y*0.5);
          end;
          wait(WaitTime);
        end;
        Wait(resttime);
      end;
      {SwitchOszilloskopTrigger(off);
      IOUpdate;}
      if (TransferFraction>=1) and (MOTTransferEndCurrent=0) then begin
        SwitchIGBT(6,off);
        IOUpdate;
        If DoIoffeTrap then begin
          SetMOTVoltage(0);
          SetMOTCurrent(0);
          SwitchMOTDecharging(on);
          {Wait(50);
          SwitchMOTDecharging(off);
          SetMOTCurrent(MaxMOTCurrent);}
          {SetMOTVoltage(PinchCapacitorVoltageStart);}
        end;
      end;
      Wait(2*commandtime);
    SequenceEndBlock;
  end;

  const OldMOTVoltage:double=0;

  procedure RampMOTCoilsOff;far;
  begin
    FinalTrap:='transfered MagTrap';
    AtomPath:=AtomPath+'M-';
    SequenceStartBlockNoArg(RampMOTCoilsOff);
      if ((TransferPercent/100)<1) or (MOTTransferEndCurrent<>0) then begin
        OldMOTVoltage:=AktMOTVoltage;
        Ramp(SetMOTVoltage,AktMOTVoltage,0,RampMOTCoilsOffTime,0.3);
        SwitchIGBT(6,off);
        IOUpdate;
        If DoIoffeTrap then begin
          SetMOTVoltage(0);
          SetMOTCurrent(0);
          SwitchMOTDecharging(on);
          {Wait(50);
          SwitchMOTDecharging(off);
          SetMOTCurrent(MaxMOTCurrent);}
          {SetMOTVoltage(PinchCapacitorVoltageStart);}
        end;
      end;
      Wait(2*commandtime);
    SequenceEndBlock;
  end;

  procedure RampMOTCoilsOn;far;
  begin
    FinalTrap:='transfered MagTrap';
    AtomPath:=AtomPath+'M+';
    SequenceStartBlockNoArg(RampMOTCoilsOn);
      SwitchMOTDecharging(off);
      IOUpdate;
      SetMOTVoltage(0);
      SetMOTCurrent(500);
      IOUpdate;
      if (TransferPercent<100) or (MOTTransferEndCurrent<>0) then begin
        SwitchIGBT(6,on);
        Wait(1);
        Ramp(SetMOTVoltage,0,OldMOTVoltage,RampMOTCoilsOffTime,0.3);
      end;
      Wait(2*commandtime);
    SequenceEndBlock;
  end;

  procedure DeTransfer;far;
  var n,maxn,endn:longint;
      y,x,helpTransfer1Current,helpTransfer2Voltage,helpMOTCurrent,resttime:double;
      TransferFraction,TransferEndCurrentMOT,aktTransfer2EndVoltage,
      aktRampTransferCoilsTime,aktRampMOTCoilsTime,
      aktTransferCurrentMiddle:double;
      MagTrapTransfer1CurrentCC:double;
      aktTransferPercent:double;
      WaitTime:double;
  begin
    FinalTrap:='QP Magtrap Up/down';
    AtomPath:=AtomPath+'Td';
    SequenceStartBlockNoArg(DeTransfer);
      if DoIoffeTrap then TransferFraction:=1 else TransferFraction:=TransferPercent/100;
      if TransferFraction<0.5 then begin
        x:=TransferFraction/0.5;
        aktTransferCurrentMiddle:=TransferCurrentMiddle*x;
        if DoTransferParabolic
        then aktRampTransferCoilsTime:=(TransferTime/(2*TransferTimeRatio))*sqrt(x)
        else aktRampTransferCoilsTime:=(TransferTime/(2*TransferTimeRatio))*(x);
      end else begin
        x:=(TransferFraction-0.5)/0.5;
        aktTransferCurrentMiddle:=TransferCurrentMiddle;
        aktRampTransferCoilsTime:=(TransferTime/(2*TransferTimeRatio));
        if DoTransferParabolic
        then aktRampMOTCoilsTime:=(TransferTime*(1-1/(2*TransferTimeRatio)))*(1-sqrt(1-x))
        else aktRampMOTCoilsTime:=(TransferTime*(1-1/(2*TransferTimeRatio)))*(1-(1-x));
      end;
      MagTrapTransfer1CurrentCC:=0;
      SwitchMOTDecharging(off);
      IOUpdate;
      if (TransferFraction>=1) and (MOTTransferEndCurrent=0) then begin
        {SetMOTCurrent(MaxMOTCurrent);
        IOUpdate;
        SetMOTVoltage(MOTVoltageOffset);}
        SwitchIGBT(6,on);
      end;
      Wait(2*commandtime);
      if TransferFraction>0.5 then begin
        WaitTime:=2*commandtime;
        maxn:=trunc(aktRampMOTCoilsTime/WaitTime);
        resttime:=aktRampMOTCoilsTime-(maxn*WaitTime);
        if (resttime<0.1) then begin
          maxn:=maxn-1;
          resttime:=aktRampMOTCoilsTime-(maxn*WaitTime);
        end;
        if maxn<1 then writeln('Error : MagTrap : MagneticTrap : MOT Coils time too short or Transfer percent too low');
        for n:=maxn-1 downto 0 do begin
          if DoTransferParabolic
          then helpMOTCurrent:=(sqr((TransferTime*(1-1/(2*TransferTimeRatio)))-
            n*aktRampMOTCoilsTime/maxn)/sqr((TransferTime*(1-1/(2*TransferTimeRatio)))))
             *(MOTTransferStartCurrent-MOTTransferEndCurrent)+MOTTransferEndCurrent
          else helpMOTCurrent:=(((TransferTime*(1-1/(2*TransferTimeRatio)))-
            n*aktRampMOTCoilsTime/maxn)/((TransferTime*(1-1/(2*TransferTimeRatio)))))
            *(MOTTransferStartCurrent-MOTTransferEndCurrent)+MOTTransferEndCurrent;
          SetMOTCurrentControlVoltage(helpMOTCurrent);
          aktTransferPercent:=50+(1-helpMOTCurrent/MOTTransferStartCurrent)*50;
          if aktTransferPercent>StartBarsTransferPercent
          then SetBarsCurrentControlVoltage(BarsTransferEndCurrent*
            (aktTransferPercent-StartBarsTransferPercent)/(100-StartBarsTransferPercent));
          SetTransferCurrentControlVoltage((n/maxn)*(TransferCurrentEnd-TransferCurrentMiddle)+TransferCurrentMiddle);
          if DoTranslateMagTrap then begin
            y:=1-helpMOTCurrent/MOTTransferStartCurrent;
            SetTranslateCurrent(0.5+y*0.5);
          end;
          wait(WaitTime);
        end;
        Wait(resttime);
      end;
      Wait(TransferHalfWayWait);
      maxn:=trunc(aktRampTransferCoilsTime/(2*commandtime));
      resttime:=aktRampTransferCoilsTime-(maxn*2*commandtime);
      if (resttime<0.03) then begin
        maxn:=maxn-1;
        resttime:=aktRampTransferCoilsTime-(maxn*2*commandtime);
      end;
      if maxn<1 then writeln('Error : MagTrap : MagneticTrap : Transfer Coils time too short or Transfer percent too low');
      if (DeTransferPercent>50) and (DeTransferPercent<100) then endn:=round(maxn-maxn*(DeTransferPercent-50)/50)
      else endn:=0;
      for n:=maxn-1 downto endn do begin
        if DoTransferParabolic
        then helpTransfer1Current:=n*n/(maxn*maxn)*
          (aktTransferCurrentMiddle-MagTrapTransfer1CurrentCC)+MagTrapTransfer1CurrentCC
        else helpTransfer1Current:=n/(maxn)*(aktTransferCurrentMiddle-MagTrapTransfer1CurrentCC)+MagTrapTransfer1CurrentCC;
        SetTransferCurrentControlVoltage(helpTransfer1Current);
        {SetTransfer1Current(helpTransfer1Current);
        helpTransfer2Voltage:=(helpTransfer1Current-Transfer2CurrentOffset)/
          (MaxTransfer1Current-Transfer2CurrentOffset)*Transfer2EndVoltage;
        if helpTransfer2Voltage>0 then SetTransfer2Voltage(helpTransfer2Voltage);}
        if DoTranslateMagTrap then begin
          y:=helpTransfer1Current/TransferCurrentMiddle;
          SetTranslateCurrent(y*0.5);
        end;
        wait(2*commandtime);
      end;
      Wait(resttime);
    SequenceEndBlock;
  end;

  procedure SetFinalSlowerAndMOTCurrent(f:double);far;
  begin
    if DoTranslateMagTrap then SetFinalSlowerCurrent(f*SlowerCompensationCurrent[MaxSlowerCompCurrent]);
    if (MOTTransferEndCurrent<>0) then SetMOTCurrent(f*MOTTransferEndCurrent);
  end;

  procedure DeTranslateUpperMagTrap;far;
  var TransferCurrentAtHop,TransferGradiantZAtHop:double;
      FirstRampTime,TransferEndCurrentFirstRamp:double;
      SecondRampTime,TransferEndCurrentSecondRamp:double;
  begin
    FinalTrap:='detranslated MagTrap';
    AtomPath:=AtomPath+'dT';
    SequenceStartBlockNoArg(DeTranslateUpperMagTrap);
      if DoTranslateMagTrap or (MOTTransferEndCurrent<>0)
      then Ramp(SetFinalSlowerCurrent,1,0,FinalSlowerEndRampTime,0.2);
      SwitchSlowerCompensation(off);
      SwitchIGBT(6,off);
    SequenceEndBlock;
  end;

  var DefTransStart,DefTransEnd,DefBarStart,DefBarEnd:double;

  procedure SetDeformationCurrent(f:double);far;
  begin
    SetTransferCurrentControlVoltage(f*(DefTransEnd-DefTransStart)+DefTransStart);
    SetBarsCurrentControlVoltage(f*(DefBarEnd-DefBarStart)+DefBarStart);
  end;

  procedure TransferQuadrupolDeformation;far;
  var TransferCurrentAtHop,TransferGradiantZAtHop:double;
      FirstRampTime,TransferEndCurrentFirstRamp:double;
      SecondRampTime,TransferEndCurrentSecondRamp:double;
  begin
    FinalTrap:='transfered MagTrap with Quadrupol Deformation';
    AtomPath:=AtomPath+'Qd';
    SequenceStartBlockNoArg(TransferQuadrupolDeformation);
      SetBarsCurrent(MaxBarCurrent);
      IOUpdate;
      SetBarsCurrentControlVoltage(BarCurrentAfterHop);
      SwitchIGBT(8,on);
      DefBarStart:=BarCurrentAfterHop;
      DefBarEnd:=EndDeformationBarCurrent;
      DefTransStart:=TransferCurrentEnd;
      DefTransEnd:=EndDeformationBarCurrent;
      Wait(0.5);
      if ((DeformationPercent>0) and (DeformationTime>0)) then
        Ramp(SetDeformationCurrent,0,DeformationPercent/100.0,
             DeformationTime*DeformationPercent/100,0.3);
    SequenceEndBlock;
  end;

  procedure DeTransferQuadrupolDeformation;far;
  var TransferCurrentAtHop,TransferGradiantZAtHop:double;
      FirstRampTime,TransferEndCurrentFirstRamp:double;
      SecondRampTime,TransferEndCurrentSecondRamp:double;
  begin
    SequenceStartBlockNoArg(DeTransferQuadrupolDeformation);
      if DoTranslateMagTrap then SwitchSlowerCompensation(on);
      if (MOTTransferEndCurrent<>0) then SwitchIGBT(6,on);
      Ramp(SetFinalSlowerCurrent,0,1,FinalSlowerEndRampTime,0.2);
      DefBarStart:=BarCurrentAfterHop;
      DefBarEnd:=EndDeformationBarCurrent;
      DefTransStart:=TransferCurrentEnd;
      DefTransEnd:=EndDeformationBarCurrent;
      Wait(0.5);
      if ((DeformationPercent>0) and (DeformationTime>0)) then
        Ramp(SetDeformationCurrent,DeformationPercent/100.0,0,
             DeformationTime*DeformationPercent/100,0.3);
      if StartBarsTransferPercent>100 then begin
        SwitchIGBT(8,off);
        Wait(0.5);
      end else begin
        SetBarsCurrentControlVoltage(BarsTransferEndCurrent);
        Wait(0.5);
      end;
    SequenceEndBlock;
  end;

  {function EndGradianty:double;
  begin
    if DoHopAtOnce then begin
      EndGradianty:=TransferCurrentEnd*TransferGradiantZ_Ampere*0.5+
        BarCurrentAfterHop*IoffeGradiant_Ampere;
    end else begin
      EndGradianty:=TransferCurrentEnd*TransferGradiantZ_Ampere*0.5+
        BarsTransferEndCurrent*IoffeGradiant_Ampere;
    end;
  end;

  procedure SetDeformationCurrent(TransferCurrent:double);far;
  var TransferGradiantz,IoffeGradiant,
      IoffeCurrent,IoffeVoltage:double;
  begin
    SetTransferCurrentControlVoltage(TransferCurrent);
    TransferGradiantz:=TransferCurrent*TransferGradiantZ_Ampere;
    IoffeGradiant:=EndGradianty-TransferGradiantz*0.5;
    IoffeCurrent:=IoffeGradiant/IoffeGradiant_Ampere;
    SetBarsCurrentControlVoltage(IoffeCurrent);
  end;

  procedure SetDeformationCurrentAfterHop(TransferCurrent:double);far;
  var TransferGradiantz,IoffeGradiant,GradiantYAfterHop,
      IoffeCurrent,IoffeVoltage:double;
  begin
    SetTransferCurrentControlVoltage(TransferCurrent);
    TransferGradiantz:=TransferCurrent*TransferGradiantZ_Ampere;
    GradiantYAfterHop:=EndGradianty+2*MinimumVerticalGradiant;
    IoffeGradiant:=GradiantYAfterHop-TransferGradiantz*0.5;
    IoffeCurrent:=IoffeGradiant/IoffeGradiant_Ampere;
    SetBarsCurrentControlVoltage(IoffeCurrent);
  end;

  procedure TransferQuadrupolDeformation;far;
  var TransferCurrentAtHop,TransferGradiantZAtHop:double;
      FirstRampTime,TransferEndCurrentFirstRamp:double;
      SecondRampTime,TransferEndCurrentSecondRamp:double;
  begin
    FinalTrap:='transfered MagTrap with Quadrupol Deformation';
    AtomPath:=AtomPath+'Qd';
    SequenceStartBlockNoArg(TransferQuadrupolDeformation);
      If DoHopAtOnce then begin
        SetBarsCurrent(MaxBarCurrent);
        IOUpdate;
        SetBarsCurrentControlVoltage(BarCurrentAfterHop);
        SwitchIGBT(8,on);
        Wait(0.5);
        if (DeformationPercent>0) then
          Ramp(SetDeformationCurrent,TransferCurrentEnd,
            (DeformationPercent/100)*(EndDeformationCurrent-TransferCurrentEnd)
            +TransferCurrentEnd,DeformationTime*DeformationPercent/100,0.3);
      end else begin
        if StartBarsTransferPercent>100 then begin
          SetBarsCurrent(MaxBarCurrent);
          SetBarsVoltage(0);
          IOUpdate;
          SwitchIGBT(8,on);
          Wait(0.5);
        end;
        TransferGradiantZAtHop:=MinimumVerticalGradiant+EndGradianty;
        TransferCurrentAtHop:=TransferGradiantZAtHop/TransferGradiantZ_Ampere;
        if DeformationPercent<50 then TransferEndCurrentFirstRamp:=TransferCurrentAtHop*DeformationPercent/50
        else TransferEndCurrentFirstRamp:=TransferCurrentAtHop;
        FirstRampTime:=(TransferCurrentEnd-TransferEndCurrentFirstRamp)/
          (TransferCurrentEnd-EndDeformationCurrent)*DeformationTime;
        Ramp(SetDeformationCurrent,TransferCurrentEnd,TransferEndCurrentFirstRamp,FirstRampTime,0.3);
        if DeformationPercent>=50 then begin
          TransferEndCurrentSecondRamp:=TransferCurrentAtHop-
          (TransferCurrentAtHop-EndDeformationCurrent)*(DeformationPercent-50)/50;
          SecondRampTime:=(TransferCurrentEnd-TransferEndCurrentSecondRamp)/
            (TransferCurrentEnd-EndDeformationCurrent)*DeformationTime
            -FirstRampTime;
          Ramp(SetDeformationCurrentAfterHop,TransferCurrentAtHop,
            TransferEndCurrentSecondRamp,SecondRampTime,0.3);
        end;
      end;
    SequenceEndBlock;
  end;

  procedure DeTransferQuadrupolDeformation;far;
  var TransferCurrentAtHop,TransferGradiantZAtHop:double;
      FirstRampTime,TransferEndCurrentFirstRamp:double;
      SecondRampTime,TransferEndCurrentSecondRamp:double;
  begin
    SequenceStartBlockNoArg(DeTransferQuadrupolDeformation);
      if DoTranslateMagTrap then SwitchSlowerCompensation(on);
      if (MOTTransferEndCurrent<>0) then SwitchIGBT(6,on);
      Ramp(SetFinalSlowerCurrent,0,1,FinalSlowerEndRampTime,0.2);
      If DoHopAtOnce then begin
        Ramp(SetDeformationCurrentAfterHop,
            (DeformationPercent/100)*(EndDeformationCurrent-TransferCurrentEnd)
            +TransferCurrentEnd,TransferCurrentEnd,DeformationTime*DeformationPercent/100,0.3);
        if StartBarsTransferPercent>100 then begin
          SwitchIGBT(8,off);
          Wait(0.5);
        end else begin
          SetBarsCurrentControlVoltage(BarsTransferEndCurrent);
          Wait(0.5);
        end;
      end else begin
        TransferGradiantZAtHop:=MinimumVerticalGradiant+EndGradianty;
        TransferCurrentAtHop:=TransferGradiantZAtHop/TransferGradiantZ_Ampere;
        if DeformationPercent<50 then TransferEndCurrentFirstRamp:=TransferCurrentAtHop*DeformationPercent/50
        else TransferEndCurrentFirstRamp:=TransferCurrentAtHop;
        FirstRampTime:=(TransferCurrentEnd-TransferEndCurrentFirstRamp)/
          (TransferCurrentEnd-EndDeformationCurrent)*DeformationTime;
        if DeformationPercent>=50 then begin
          TransferEndCurrentSecondRamp:=TransferCurrentAtHop-
          (TransferCurrentAtHop-EndDeformationCurrent)*(DeformationPercent-50)/50;
          SecondRampTime:=(TransferCurrentEnd-TransferEndCurrentSecondRamp)/
            (TransferCurrentEnd-EndDeformationCurrent)*DeformationTime
            -FirstRampTime;
          Ramp(SetDeformationCurrentAfterHop,TransferEndCurrentSecondRamp,
            TransferCurrentAtHop,SecondRampTime,0.3);
        end;
        Ramp(SetDeformationCurrent,TransferEndCurrentFirstRamp,
          TransferCurrentEnd,FirstRampTime,0.3);
        if StartBarsTransferPercent>100 then begin
          SwitchIGBT(8,off);
          Wait(0.5);
        end;
      end;
    SequenceEndBlock;
  end;}

  procedure ReTranslateUpperMagTrap;far;
  var TransferCurrentAtHop,TransferGradiantZAtHop:double;
      FirstRampTime,TransferEndCurrentFirstRamp:double;
      SecondRampTime,TransferEndCurrentSecondRamp:double;
  begin
    SequenceStartBlockNoArg(ReTranslateUpperMagTrap);
      if DoTranslateMagTrap then SwitchSlowerCompensation(on);
      if (MOTTransferEndCurrent<>0) then SwitchIGBT(6,on);
      Ramp(SetFinalSlowerCurrent,0,1,FinalSlowerEndRampTime,0.2);
    SequenceEndBlock;
  end;

  procedure IoffeBarRamp;far;
  begin
    FinalTrap:='transfered MagTrap with Ioffe Bars';
    AtomPath:=AtomPath+'Ib';
    SequenceStartBlockNoArg(IoffeBarRamp);
      Ramp(SetBarsCurrentControlVoltage,BarsTransferEndCurrent,
      IoffeBarRampEndCurrent,IoffeBarRampTime,commandTime);
    SequenceEndBlock;
  end;

  procedure DeIoffeBarRamp;far;
  begin
    FinalTrap:='transfered MagTrap';
    AtomPath:=AtomPath+'Di';
    SequenceStartBlockNoArg(DeIoffeBarRamp);
      Ramp(SetBarsCurrentControlVoltage,IoffeBarRampEndCurrent,
        BarsTransferEndCurrent,IoffeBarRampTime,commandTime);
    SequenceEndBlock;
  end;

  procedure TransferQuadrupolExpansion;far;
  begin
    FinalTrap:='transfered MagTrap with Quadrupol Expansion';
    AtomPath:=AtomPath+'Qe';
    SequenceStartBlockNoArg(TransferQuadrupolExpansion);
      Ramp(SetTransferCurrentControlVoltage,TransferCurrentEnd,
        TransferQuadrupolEndCurrent,TransferQuadrupolExpansionTime,2);
    SequenceEndBlock;
  end;

  procedure DeTransferQuadrupolExpansion;far;
  begin
    FinalTrap:='transfered MagTrap';
    AtomPath:=AtomPath+'De';
    SequenceStartBlockNoArg(TransferQuadrupolExpansion);
      Ramp(SetTransferCurrentControlVoltage,TransferQuadrupolEndCurrent,
        TransferCurrentEnd,TransferQuadrupolExpansionTime,2);
    SequenceEndBlock;
  end;

  procedure IoffeTrapF2;far;
  var n,maxn:longint;
      resttime:double;
  begin
    FinalTrap:='F2 in Ioffe trap';
    AtomPath:=AtomPath+'I2';
    FinalTrapType:=IoffePritchard;
    SequenceStartBlockNoArg(IoffeTrapF2);
      {SwitchOszilloskopTrigger(off);
      IOUpdate;}
      SequenceStartPortListDuringWait(2);
      SwitchMOTDecharging(off);
      IOUpdate;
      SetMOTVoltage(PinchCapacitorVoltageStart);
      SetMOTCurrent(MaxMOTCurrent);
      Wait(PinchCapacitorChargingTime);
      SwitchIGBT(1,off);
      SwitchIGBT(2,off);
      SwitchIGBT(3,off);
      SwitchIGBT(4,on);
      SwitchIGBT(5,on);
      SwitchIGBT(10,off);
      {Wait(0.2);}
      SwitchIGBT(8,on);
      TrapOffMode:=Ioffe;
      IOUpdate;
      SetBarsCurrentControlVoltage(F2IoffeTrapBarStartCurrent);
      IOUpdate;
      Wait(PinchStartTime);
      SetMOTVoltage(PinchVoltageStart);
      IOUpdate;
      SetTransfer1Voltage(0);
      SetTransfer2Voltage(0);
      IOUpdate;
      SetTransfer1Current(0);
      IOUpdate;
      SwitchTransferDecharging(on);
      Wait(IoffeTrapStartTime);
      SequenceStopPortList;
    SequenceEndBlock;
  end;

  procedure SetCompressIoffeTrapCV(f:double);far;
  begin
    SetBarsCurrentControlVoltage(f*(BarCompCVCurrent-F2IoffeTrapBarStartCurrent)+F2IoffeTrapBarStartCurrent);
    SetMOTVoltage(f*(PinchCompCVVoltage-PinchVoltageStart)+PinchVoltageStart);
  end;

  procedure CompressIoffeTrapCV;far;
  begin
    FinalTrap:='CV compressed Ioffe trap';
    AtomPath:=AtomPath+'Cv';
    SequenceStartBlockNoArg(CompressIoffeTrapCV);
      Wait(1);
      Ramp(SetCompressIoffeTrapCV,0,1,IoffeCVCompressionTime,0.3);
      Wait(1);
    SequenceEndBlock;
  end;

  var BarVoltageAfterCVCCTransition:double;

  procedure CVCCTransitionF2;far;
  begin
    SequenceStartBlockNoArg(CVCCTransitionF2);
      Ramp(SetMOTCurrent,MaxMOTCurrent,PinchCurrentAfterCVCCTransition,PinchCVCCCurrentRampTime,CommandTime);
      {Ramp(SetMOTVoltage,aktMOTVoltage,MaxMOTVoltage,PinchCVCCVoltageRampTime,CommandTime);}
      Ramp(SetBarsCurrent,MaxBarCurrent,BarCurrentAfterCVCCTransition,BarCVCCCurrentRampTime,CommandTime);
      BarVoltageAfterCVCCTransition:=aktBarVoltage;
      {Ramp(SetBarsVoltage,aktBarVoltage,MaxBarVoltage,BarCVCCVoltageRampTime,CommandTime);}

      SwitchIGBT(2,on);
      Wait(1.0000001);
      TrapOffMode:=CompensatedIoffe;
      Ramp(SetTransfer1Voltage,0,MaxTransfer1Voltage,TransferRaiseVoltageTime,0.3);
      SetTransfer1Voltage(MaxTransfer1Voltage);
      Wait(0.5);
      SwitchTransferDecharging(off);
      Wait(1.0000002);

    SequenceEndBlock;
  end;

  {procedure SetCompressIoffeTrapCurrent(f:double);far;
  begin
    SetBarsCurrent(f*(BarCurrentInCompIoffeTrap-BarCurrentAfterCVCCTransition)+BarCurrentAfterCVCCTransition);
    SetTransfer1Current(f*(BiasCompPinchCurrent-PinchCurrentAfterCVCCTransition));
  end;

  procedure SetTransferVoltages(voltage:double);far;
  begin
    SetTransfer1Voltage(Voltage);
    SetTransfer2Voltage(Voltage);
  end;

  procedure CompressIoffeTrapF2;far;
  begin
    FinalTrap:='compressed Ioffe trap';
    AtomPath:=AtomPath+'Ci';
    SequenceStartBlockNoArg(CompressIoffeTrapF2);
      Ramp(SetCompressIoffeTrapCurrent,0,1,CompressIoffeTrapTime,0.3);
    SequenceEndBlock;
  end;}

  procedure SetTransferCurrent(current:double);far;
  begin
    SetTransfer1Current(Current);
    if current>Transfer2AddVoltageCurrent
    then SetTransfer2Voltage((current-Transfer2AddVoltageCurrent)*CompPinchResistance/1000);
  end;

  var ChangeIoffeStartMOTVoltage:double;
      ChangeIoffeStartPinchCurrent:double;
      ChangeIoffeStartBarCurrent:double;
      ChangeIoffeStartBarVoltage:double;
      ChangeIoffeStartCompCurrent:double;
      ChangeIoffeStartPinchOffsetCurrent:double;
      ChangeIoffeEndPinchCurrent:double;
      ChangeIoffeEndBarCurrent:double;
      ChangeIoffeEndCompCurrent:double;
      ChangeIoffeEndPinchOffsetCurrent:double;

  procedure ChangeIoffeSetPinchCompAndBarCurrents(f:double);far;
  var compCurrent,AktPinchCurrent:double;
  begin
    if (ChangeIoffeStartBarVoltage<>MaxBarVoltage) then
      SetBarsVoltage(f*(MaxBarVoltage-ChangeIoffeStartBarVoltage)+ChangeIoffeStartBarVoltage);
    if (ChangeIoffeStartMOTVoltage<>MaxMOTVoltage) then
      SetMOTVoltage(f*(MaxMOTVoltage-ChangeIoffeStartMOTVoltage)+ChangeIoffeStartMOTVoltage);
    compCurrent:=f*(ChangeIoffeEndCompCurrent-ChangeIoffeStartCompCurrent)+ChangeIoffeStartCompCurrent;
    AktPinchCurrent:=f*(ChangeIoffeEndPinchCurrent-ChangeIoffeStartPinchCurrent)+ChangeIoffeStartPinchCurrent;
    SetTransferCurrent(CompCurrent);
    SetMOTCurrent(AktPinchCurrent-CompCurrent);
    SetBarsCurrent(f*(ChangeIoffeEndBarCurrent-ChangeIoffeStartBarCurrent)+ChangeIoffeStartBarCurrent);
    if (ChangeIoffeEndPinchOffsetCurrent<>ChangeIoffeStartPinchOffsetCurrent)
    then SetPinchOffsetCurrent(f*(ChangeIoffeEndPinchOffsetCurrent-
      ChangeIoffeStartPinchOffsetCurrent)+ChangeIoffeStartPinchOffsetCurrent);
  end;

  procedure ChangeIoffeTrap(aBarCurrent:double;aPinchCurrent:double;
    aCompCurrent:double;aPinchOffsetCurrent:double;RampTime:double);
  var RampDeltaTime:double;
  begin
    ChangeIoffeStartMOTVoltage:=aktMOTVoltage;
    ChangeIoffeStartPinchCurrent:=aktMOTCurrent+aktTransfer1Current;
    ChangeIoffeStartBarCurrent:=aktBarCurrent;
    ChangeIoffeStartBarVoltage:=aktBarVoltage;
    ChangeIoffeStartCompCurrent:=aktTransfer1Current;
    ChangeIoffeStartPinchOffsetCurrent:=aktPinchOffsetCurrent;
    ChangeIoffeEndPinchCurrent:=aPinchCurrent;
    ChangeIoffeEndBarCurrent:=aBarCurrent;
    ChangeIoffeEndCompCurrent:=aCompCurrent;
    ChangeIoffeEndPinchOffsetCurrent:=aPinchOffsetCurrent;
    if (aktMOTVoltage<>MaxMOTVoltage) or (aktBarVoltage<>MaxBarVoltage) then RampDeltaTime:=0.4
    else RampDeltaTime:=0.3;
    Wait(1);
    Ramp(ChangeIoffeSetPinchCompAndBarCurrents,0,1,RampTime,RampDeltaTime);
    Wait(1);
  end;

  procedure CompressIoffeTrap;far;
  begin
    FinalTrap:='compressed Ioffe Trap';
    AtomPath:=AtomPath+'Ci';
    SequenceStartBlockNoArg(CompressIoffeTrap);
      ChangeIoffeTrap(BarCurrentInCompIoffeTrap1,
        BiasCurrentInCompIoffeTrap1+CompensationCurrentInCompIoffeTrap1,
        CompensationCurrentInCompIoffeTrap1,0,
        CompressIoffeTrapTime1);
      if BiasCurrentInCompIoffeTrap1=0 then SwitchIGBT(5,off);
    SequenceEndBlock;
  end;

  procedure PrepareDopplerCooling;
  begin
    SetAOM20Intensity(DopplerCoolIntensity);
    ShutterAOM20(open);
    ShutterMOT(close);
    if DopplerCoolBeamIsPrincipal then begin
      ShutterMOT7principal(open);
      ShutterMOT7repump(close);
      SwitchMaster7Repump(off);
      SwitchMaster7Principal(on);
      SetDopplerCoolPrincipalFrequency(DopplerCoolStartFrequency);
    end else begin
      ShutterMOT7principal(close);
      ShutterMOT7repump(open);
      SwitchMaster7Repump(on);
      SwitchMaster7Principal(off);
      SetDopplerCoolRepumpFrequency(DopplerCoolStartFrequency);
    end;
    Wait(1);
  end;

  procedure PrepareDopplerCooling2;
  begin
    SetAOM20Intensity(DopplerCoolIntensity2);
    ShutterAOM20(open);
    ShutterMOT(close);
    if DopplerCoolBeamIsPrincipal2 then begin
      ShutterMOT7principal(open);
      ShutterMOT7repump(close);
      SwitchMaster7Repump(off);
      SwitchMaster7Principal(on);
      SetDopplerCoolPrincipalFrequency(DopplerCoolStartFrequency2);
    end else begin
      ShutterMOT7principal(close);
      ShutterMOT7repump(open);
      SwitchMaster7Repump(on);
      SwitchMaster7Principal(off);
      SetDopplerCoolRepumpFrequency(DopplerCoolStartFrequency2);
    end;
    Wait(1);
  end;

  procedure PrepareDopplerCooling3;
  begin
    SetAOM20Intensity(DopplerCoolIntensity3);
    ShutterAOM20(open);
    ShutterMOT(close);
    if DopplerCoolBeamIsPrincipal3 then begin
      ShutterMOT7principal(open);
      ShutterMOT7repump(close);
      SwitchMaster7Repump(off);
      SwitchMaster7Principal(on);
      SetDopplerCoolPrincipalFrequency(DopplerCoolStartFrequency3);
    end else begin
      ShutterMOT7principal(close);
      ShutterMOT7repump(open);
      SwitchMaster7Repump(on);
      SwitchMaster7Principal(off);
      SetDopplerCoolRepumpFrequency(DopplerCoolStartFrequency3);
    end;
    Wait(1);
  end;

  procedure PrepareDopplerCooling4;
  begin
    SetAOM20Intensity(DopplerCoolIntensity4);
    ShutterAOM20(open);
    ShutterMOT(close);
    if DopplerCoolBeamIsPrincipal4 then begin
      ShutterMOT7principal(open);
      ShutterMOT7repump(close);
      SwitchMaster7Repump(off);
      SwitchMaster7Principal(on);
      SetDopplerCoolPrincipalFrequency(DopplerCoolStartFrequency4);
    end else begin
      ShutterMOT7principal(close);
      ShutterMOT7repump(open);
      SwitchMaster7Repump(on);
      SwitchMaster7Principal(off);
      SetDopplerCoolRepumpFrequency(DopplerCoolStartFrequency4);
    end;
    Wait(1);
  end;

  procedure FinishDopplerCooling;
  begin
    ShutterAOM20(close);
    if KeepInjection then begin
      SwitchMaster7Repump(on);
      SwitchMaster7Principal(on);
      ShutterMOT7principal(open);
      ShutterMOT7repump(open);
    end else begin
      SwitchMaster7Repump(KeepMasterAOMsOn);
      SwitchMaster7Principal(KeepMasterAOMsOn);
      ShutterMOT7repump(close);
      ShutterMOT7principal(close);
      ShutterMaster7AndMOT7LiPrincipal(off);
    end;
    SetProbeDetuning;
    if DoSwitchMaster7PrincipalOff then SwitchMaster7Principal(off);
    if KeepMOTAOMOn then SwitchAOM20Delayed(on);
  end;

  procedure DopplerCoolIoffeTrap;far;
  var n:integer;
  begin
    FinalTrap:='cooled Ioffe trap';
    AtomPath:=AtomPath+'DC';
    SequenceStartBlockNoArg(DopplerCoolIoffeTrap);
      Wait(1);
      if DopplerCoolBeamIsPrincipal then SetDopplerCoolPrincipalFrequency(DopplerCoolStartFrequency)
      else SetDopplerCoolRepumpFrequency(DopplerCoolStartFrequency);
      SwitchAOM20Frequency(on);
      Wait(1);
      for n:=1 to DopplerCoolCycles do begin
        if (DopplerCoolTime>0) then begin
          SwitchAOM20(on);
          if DopplerCoolBeamIsPrincipal
          then Ramp(SetDopplerCoolPrincipalFrequency,DopplerCoolStartFrequency,DopplerCoolStopFrequency,DopplerCoolTime,0.5)
          else Ramp(SetDopplerCoolRepumpFrequency,DopplerCoolStartFrequency,DopplerCoolStopFrequency,DopplerCoolTime,0.5);
        end;
        if not ((n=DopplerCoolCycles) and LeaveDopplerCoolingBeamOn) then SwitchAOM20(off);
        if n<>DopplerCoolCycles then Wait(DopplerCoolPause);
      end;
      if (not DoDopplerCoolIoffeTrap2) and (not DoDopplerCoolIoffeTrap3) and DoProtectMagTrap
      then FinishDopplerCooling;
      if DoDopplerCoolIoffeTrap2 then PrepareDopplerCooling2
      else if DoDopplerCoolIoffeTrap3 then PrepareDopplerCooling3;
      Wait(1);
    SequenceEndBlock;
  end;

  procedure DopplerCoolIoffeTrap2;far;
  var n:integer;
  begin
    FinalTrap:='cooled Ioffe trap2';
    AtomPath:=AtomPath+'D2';
    SequenceStartBlockNoArg(DopplerCoolIoffeTrap2);
      Wait(1);
      if DopplerCoolBeamIsPrincipal2 then SetDopplerCoolPrincipalFrequency(DopplerCoolStartFrequency2)
      else SetDopplerCoolRepumpFrequency(DopplerCoolStartFrequency2);
      Wait(1);
      for n:=1 to DopplerCoolCycles2 do begin
        if (DopplerCoolTime2>0) then begin
          SwitchAOM20(on);
          if DopplerCoolBeamIsPrincipal2 then Ramp(SetDopplerCoolPrincipalFrequency,
            DopplerCoolStartFrequency2,DopplerCoolStopFrequency2,DopplerCoolTime2,0.5)
          else Ramp(SetDopplerCoolRepumpFrequency,DopplerCoolStartFrequency2,DopplerCoolStopFrequency2,DopplerCoolTime2,0.5);
        end;
        SwitchAOM20(off);
        if n<>DopplerCoolCycles2 then Wait(DopplerCoolPause2);
      end;
      if (not DoDopplerCoolIoffeTrap3 or DoDopplerCoolIoffeTrap4) and DoProtectMagTrap
      then FinishDopplerCooling;
      if DoDopplerCoolIoffeTrap3 then PrepareDopplerCooling3
      else if DoDopplerCoolIoffeTrap4 then PrepareDopplerCooling4;
      Wait(1);
    SequenceEndBlock;
  end;

  procedure DopplerCoolIoffeTrap3;far;
  var n:integer;
  begin
    FinalTrap:='cooled Ioffe trap3';
    AtomPath:=AtomPath+'D3';
    SequenceStartBlockNoArg(DopplerCoolIoffeTrap3);
      Wait(1);
      if DopplerCoolBeamIsPrincipal3 then SetDopplerCoolPrincipalFrequency(DopplerCoolStartFrequency3)
      else SetDopplerCoolRepumpFrequency(DopplerCoolStartFrequency3);
      Wait(1);
      for n:=1 to DopplerCoolCycles3 do begin
        if (DopplerCoolTime3>0) then begin
          SwitchAOM20(on);
          if DopplerCoolBeamIsPrincipal3 then Ramp(SetDopplerCoolPrincipalFrequency,
            DopplerCoolStartFrequency3,DopplerCoolStopFrequency3,DopplerCoolTime3,0.5)
          else Ramp(SetDopplerCoolRepumpFrequency,DopplerCoolStartFrequency3,DopplerCoolStopFrequency3,DopplerCoolTime3,0.5);
        end;
        SwitchAOM20(off);
        if n<>DopplerCoolCycles3 then Wait(DopplerCoolPause3);
      end;
      if (not DoDopplerCoolIoffeTrap4) and DoProtectMagTrap
      then FinishDopplerCooling;
      if DoDopplerCoolIoffeTrap4 then PrepareDopplerCooling4;
      {if DoProtectMagTrap and (DopplerCoolErgodicMixCycles=1)
      then FinishDopplerCooling;}
      Wait(1);
    SequenceEndBlock;
  end;

  procedure DopplerCoolIoffeTrap4;far;
  var n:integer;
  begin
    FinalTrap:='cooled Ioffe trap4';
    AtomPath:=AtomPath+'D4';
    SequenceStartBlockNoArg(DopplerCoolIoffeTrap4);
      Wait(1);
      if DopplerCoolBeamIsPrincipal4 then SetDopplerCoolPrincipalFrequency(DopplerCoolStartFrequency4)
      else SetDopplerCoolRepumpFrequency(DopplerCoolStartFrequency4);
      Wait(1);
      for n:=1 to DopplerCoolCycles4 do begin
        if (DopplerCoolTime4>0) then begin
          SwitchAOM20(on);
          if DopplerCoolBeamIsPrincipal4 then Ramp(SetDopplerCoolPrincipalFrequency,
            DopplerCoolStartFrequency4,DopplerCoolStopFrequency4,DopplerCoolTime4,0.5)
          else Ramp(SetDopplerCoolRepumpFrequency,DopplerCoolStartFrequency4,DopplerCoolStopFrequency4,DopplerCoolTime4,0.5);
        end;
        SwitchAOM20(off);
        if n<>DopplerCoolCycles4 then Wait(DopplerCoolPause4);
      end;
      if DoProtectMagTrap and (DopplerCoolErgodicMixCycles=1)
      then FinishDopplerCooling;
      Wait(1);
    SequenceEndBlock;
  end;

  procedure CompressIoffeTrap2;far;
  begin
    FinalTrap:='compressed Ioffe Trap';
    AtomPath:=AtomPath+'C2';
    SequenceStartBlockNoArg(CompressIoffeTrap2);
      if (CompressIoffeTrapTime2>0) then ChangeIoffeTrap(BarCurrentInCompIoffeTrap2,
        BiasCurrentInCompIoffeTrap2+CompensationCurrentInCompIoffeTrap2,
        CompensationCurrentInCompIoffeTrap2,0,
        CompressIoffeTrapTime2);
      if BiasCurrentInCompIoffeTrap2=0 then SwitchIGBT(5,off);
    SequenceEndBlock;
  end;

  procedure CompressIoffeTrap3;far;
  begin
    FinalTrap:='compressed Ioffe Trap';
    AtomPath:=AtomPath+'C3';
    SequenceStartBlockNoArg(CompressIoffeTrap3);
      if (CompressIoffeTrapTime3>0) then ChangeIoffeTrap(BarCurrentInCompIoffeTrap3,
        BiasCurrentInCompIoffeTrap3+CompensationCurrentInCompIoffeTrap3,
        CompensationCurrentInCompIoffeTrap3,0,
        CompressIoffeTrapTime3);
      if BiasCurrentInCompIoffeTrap3=0 then SwitchIGBT(5,off);
    SequenceEndBlock;
  end;

  procedure CompressIoffeTrap4;far;
  begin
    FinalTrap:='compressed Ioffe Trap';
    AtomPath:=AtomPath+'C4';
    SequenceStartBlockNoArg(CompressIoffeTrap4);
      if (CompressIoffeTrapTime4>0) then ChangeIoffeTrap(BarCurrentInCompIoffeTrap4,
        BiasCurrentInCompIoffeTrap4+CompensationCurrentInCompIoffeTrap4,
        CompensationCurrentInCompIoffeTrap4,0,
        CompressIoffeTrapTime4);
      if BiasCurrentInCompIoffeTrap4=0 then SwitchIGBT(5,off);
    SequenceEndBlock;
  end;

  procedure CompressIoffeTrap9;far;
  begin
    FinalTrap:='compressed Ioffe Trap';
    AtomPath:=AtomPath+'C9';
    SequenceStartBlockNoArg(CompressIoffeTrap9);
      if (CompressIoffeTrapTime9>0) then ChangeIoffeTrap(BarCurrentInCompIoffeTrap9,
        BiasCurrentInCompIoffeTrap9+CompensationCurrentInCompIoffeTrap9,
        CompensationCurrentInCompIoffeTrap9,
        PinchOffsetCurrentInCompIoffeTrap9,
        CompressIoffeTrapTime9);
      if BiasCurrentInCompIoffeTrap9=0 then SwitchIGBT(5,off);
    SequenceEndBlock;
  end;

  procedure CompressIoffeTrap10;far;
  begin
    FinalTrap:='compressed Ioffe Trap';
    AtomPath:=AtomPath+'CA';
    SequenceStartBlockNoArg(CompressIoffeTrap10);
      if (CompressIoffeTrapTime10>0) then ChangeIoffeTrap(BarCurrentInCompIoffeTrap10,
        BiasCurrentInCompIoffeTrap10+CompensationCurrentInCompIoffeTrap10,
        CompensationCurrentInCompIoffeTrap10,
        PinchOffsetCurrentInCompIoffeTrap10,
        CompressIoffeTrapTime10);
      if BiasCurrentInCompIoffeTrap10=0 then SwitchIGBT(5,off);
    SequenceEndBlock;
  end;

  procedure CompressIoffeTrap5;far;
  begin
    FinalTrap:='compressed Ioffe Trap';
    AtomPath:=AtomPath+'C5';
    SequenceStartBlockNoArg(CompressIoffeTrap5);
      if (CompressIoffeTrapTime5>0) then ChangeIoffeTrap(BarCurrentInCompIoffeTrap5,
        BiasCurrentInCompIoffeTrap5+CompensationCurrentInCompIoffeTrap5,
        CompensationCurrentInCompIoffeTrap5,0,
        CompressIoffeTrapTime5);
      if BiasCurrentInCompIoffeTrap5=0 then SwitchIGBT(5,off);
    SequenceEndBlock;
  end;

  procedure CompressIoffeTrap6;far;
  begin
    FinalTrap:='compressed Ioffe Trap';
    AtomPath:=AtomPath+'C6';
    SequenceStartBlockNoArg(CompressIoffeTrap6);
      if (CompressIoffeTrapTime6>0) then ChangeIoffeTrap(BarCurrentInCompIoffeTrap6,
        BiasCurrentInCompIoffeTrap6+CompensationCurrentInCompIoffeTrap6,
        CompensationCurrentInCompIoffeTrap6,
        PinchOffsetCurrentInCompIoffeTrap6,
        CompressIoffeTrapTime6);
      if BiasCurrentInCompIoffeTrap6=0 then SwitchIGBT(5,off);
    SequenceEndBlock;
  end;

  procedure AddPinchOffset;far;
  begin
    FinalTrap:='Add Pinch Offset Ioffe Trap';
    AtomPath:=AtomPath+'PO';
    SequenceStartBlockNoArg(AddPinchOffset);
      Wait(0.2);
      SwitchIGBT(10,on);
      Wait(0.2);
      if (PinchOffsetCurrentRampTime>0) then Ramp(SetPinchOffsetCurrent,0,PinchOffsetCurrent,PinchOffsetCurrentRampTime,0.3)
      else SetPinchOffsetCurrent(PinchOffsetCurrent);
      Wait(0.2);
    SequenceEndBlock;
  end;

  procedure BiasCompensateIoffeTrapF2;far;
  begin
    FinalTrap:='bias compensated Ioffe Trap';
    AtomPath:=AtomPath+'Bi';
    SequenceStartBlockNoArg(BiasCompensateIoffeTrapF2);
      ChangeIoffeTrap(BiasCompBarCurrent,
        BiasCompPinchCurrent,
        BiasCompPinchCurrent-BiasCurrent,0,
        BiasCompensationRampTime);
      if BiasCurrent=0 then SwitchMOTDecharging(on);
      Wait(BiasCompensationEquilibrationTime);
      if BiasCurrent=0 then SwitchIGBT(5,off);
    SequenceEndBlock;
  end;

  procedure IoffeTrapF1;far;
  var n,maxn:longint;
      resttime:double;
  begin
    FinalTrap:='F1 in Ioffe trap';
    AtomPath:=AtomPath+'I1';
    FinalTrapType:=IoffePritchard;
    SequenceStartBlockNoArg(IoffeTrapF1);
      {SwitchOszilloskopTrigger(off);
      IOUpdate;}
      SequenceStartPortListDuringWait(1);
      {SwitchIGBT(4,on);
      IOUpdate;}
      SwitchIGBT(1,off);
      SwitchIGBT(2,off);
      SwitchIGBT(3,off);
      SwitchIGBT(4,off);
      SwitchIGBT(5,off);
      SwitchIGBT(6,off);
      SwitchIGBT(7,off);
      SwitchIGBT(9,off);
      SwitchIGBT(10,off);
      TrapOffMode:=Ioffe;
      SwitchMOTDecharging(off);
      IOUpdate;
      SetTransfer1Voltage(MaxTransfer1Voltage);
      SetTransfer2Voltage(MaxTransfer2Voltage);
      SetTransfer1Current(MaxTransfer1Current);
      if (F1QuadrupolDecayTime<0.05) then F1QuadrupolDecayTime:=0.05;
      Wait(F1QuadrupolDecayTime);
      SwitchIGBT(2,on);
      SwitchIGBT(4,on);
      SwitchIGBT(8,on);
      IOUpdate;
      {SwitchIGBT(1,off);
      SwitchIGBT(3,off);
      IOUpdate;}
      SetBarsCurrentControlVoltage(F1IoffeTrapBarStartCurrent);
      Wait(F1PinchStartTime);
      if (F1PinchStartVoltage>15) then begin
        SetTransfer1Voltage(F1PinchStartVoltage-15);
        SetTransfer2Voltage(15);
      end else begin
        SetTransfer1Voltage(F1PinchStartVoltage);
        SetTransfer2Voltage(0);
      end;
      SequenceStopPortList;
    SequenceEndBlock;
  end;

  procedure CVCCTransitionF1;far;
  begin
    {SequenceStartBlockNoArg(CVCCTransitionF1);
      Ramp(SetMOTCurrent,MaxMOTCurrent,PinchCurrentAfterCVCCTransition,PinchCVCCCurrentRampTime,CommandTime);
      Ramp(SetBarsCurrent,MaxBarCurrent,BarCurrentAfterCVCCTransition,BarCVCCCurrentRampTime,CommandTime);
      BarVoltageAfterCVCCTransition:=aktBarVoltage;
    SequenceEndBlock;}
  end;

  var HelpDecompIoffeBarCurrent:double;

  procedure SetDecompressIoffeCurrent(f:double);far;
  begin
    SetTransferCurrent(f*(DecompressIoffeTransferEndCurrent-
      (BiasCompPinchCurrent-BiasCurrent))+(BiasCompPinchCurrent-BiasCurrent));
    SetBarsCurrent(f*(DecompressIoffeBarsEndCurrent-HelpDecompIoffeBarCurrent)+
      HelpDecompIoffeBarCurrent);
  end;

  procedure DecompressIoffeTrap;far;
  begin
    FinalTrap:='decompressed Ioffe trap';
    AtomPath:=AtomPath+'De';
    SequenceStartBlockNoArg(DecompressIoffeTrap);
      HelpDecompIoffeBarCurrent:=aktBarCurrent;
      {SwitchOszilloskopTrigger(off);
      Wait(1);}
      Ramp(SetDecompressIoffeCurrent,0,1,DecompressIoffeTime,0.3);
      if DecompressIoffeTransferEndCurrent=0 then SwitchIGBT(2,off);
      if DecompressIoffeBarsEndCurrent=0 then SwitchIGBT(8,off);
    SequenceEndBlock;
  end;

  procedure RecompressIoffeTrap;far;
  begin
    FinalTrap:='recompressed Ioffe trap';
    AtomPath:=AtomPath+'Re';
    SequenceStartBlockNoArg(RecompressIoffeTrap);
      {SwitchOszilloskopTrigger(off);
      Wait(1);}
      if DecompressIoffeTransferEndCurrent=0 then SwitchIGBT(2,on);
      if DecompressIoffeBarsEndCurrent=0 then SwitchIGBT(8,on);
      Ramp(SetDecompressIoffeCurrent,1,0,DecompressIoffeTime,0.3);
    SequenceEndBlock;
  end;

  procedure CleanIoffeTrap;far;
  var StartBarsCurrent:double;
  begin
    FinalTrap:='cleaned Ioffe trap';
    AtomPath:=AtomPath+'Cl';
    SequenceStartBlockNoArg(CleanIoffeTrap);
      {SwitchOszilloskopTrigger(off);
      Wait(1);}
      StartBarsCurrent:=aktBarCurrent;
      Ramp(SetBarsCurrent,StartBarsCurrent,CleanIoffeBarsEndCurrent,CleanIoffeRampTime,0.2);
      Wait(CleanIoffeTime);
      Ramp(SetBarsCurrent,CleanIoffeBarsEndCurrent,StartBarsCurrent,CleanIoffeRampTime,0.2);
    SequenceEndBlock;
  end;

  procedure MicroWaveSweep;far;
  begin
    FinalTrap:='Evaporated Ioffe trap';
    AtomPath:=AtomPath+'E0';
    SequenceStartBlockNoArg(MicroWaveSweep);
      SwitchRFTo(MicroWaveAntenna);
      IOUpdate;
      SetFrequency(IoffeMicroWaveStartFrequency);
      Wait(GPIBCommandTime);
      SwitchRF(MaxRFLevel,on);
      Wait(GPIBCommandTime);
      Ramp(SetFrequency,IoffeMicroWaveStartFrequency,
        IoffeMicroWaveStopFrequency,IoffeMicroWaveSweepTime*1000,GPIBCommandTime);
      SwitchRF(MinRFLevel,off);
      Wait(GPIBCommandTime);
    SequenceEndBlock;
  end;

  procedure MicroWaveSweep2;far;
  begin
    FinalTrap:='Evaporated Ioffe trap';
    AtomPath:=AtomPath+'E1';
    SequenceStartBlockNoArg(MicroWaveSweep2);
      SwitchRFTo(MicroWaveAntenna);
      IOUpdate;
      SetFrequency(IoffeMicroWaveStartFrequency2);
      Wait(GPIBCommandTime);
      SwitchRF(MaxRFLevel,on);
      Wait(GPIBCommandTime);
      Ramp(SetFrequency,IoffeMicroWaveStartFrequency2,
        IoffeMicroWaveStopFrequency2,IoffeMicroWaveSweepTime2*1000,GPIBCommandTime);
      SwitchRF(MinRFLevel,off);
      Wait(GPIBCommandTime);
    SequenceEndBlock;
  end;

  procedure ConstantMicroWaveEvaporation1;far;
  begin
    FinalTrap:='Evaporated Ioffe trap';
    AtomPath:=AtomPath+'E2';
    SequenceStartBlockNoArg(ConstantMicroWaveEvaporation1);
      SwitchRFTo(MicroWaveAntenna);
      IOUpdate;
      SetFrequency(IoffeMicroWaveFrequence1);
      Wait(GPIBCommandTime);
      SwitchRF(MaxRFLevel,on);
      Wait(GPIBCommandTime);
      {Ramp(SetBarsCurrent,aktBarCurrent,EvaporationEndBarCurrent,System.Exp(IoffeEvaporationTime*ln(2))*1000,0.2);}
      {Ramp(SetBarsCurrent,aktBarCurrent,EvaporationEndBarCurrent,IoffeEvaporationTime*1000,0.2);}
      if (IoffeEvaporationTime1>0) then ChangeIoffeTrap(
        EvaporationEndBarCurrent1,
        EvaporationEndBiasCurrent1+EvaporationEndCompCurrent1,
        EvaporationEndCompCurrent1,EvaporationEndPinchOffsetCurrent1,
        IoffeEvaporationTime1*1000);
      if EvaporationEndBiasCurrent1=0 then SwitchIGBT(5,off);
      SwitchRF(MinRFLevel,off);
      Wait(GPIBCommandTime);
    SequenceEndBlock;
  end;

  procedure ConstantMicroWaveEvaporation2;far;
  begin
    FinalTrap:='Evaporated Ioffe trap';
    AtomPath:=AtomPath+'E3';
    SequenceStartBlockNoArg(ConstantMicroWaveEvaporation2);
      SwitchRFTo(MicroWaveAntenna);
      IOUpdate;
      SetFrequency(IoffeMicroWaveFrequence2);
      Wait(GPIBCommandTime);
      SwitchRF(MaxRFLevel,on);
      Wait(GPIBCommandTime);
      {Ramp(SetBarsCurrent,aktBarCurrent,EvaporationEndBarCurrent2,System.exp(IoffeEvaporationTime2*ln(2))*1000,0.2);}
      {Ramp(SetBarsCurrent,aktBarCurrent,EvaporationEndBarCurrent2,IoffeEvaporationTime2*1000,0.2);}
      if (IoffeEvaporationTime2>0) then ChangeIoffeTrap(
        EvaporationEndBarCurrent2,
        EvaporationEndBiasCurrent2+EvaporationEndCompCurrent2,
        EvaporationEndCompCurrent2,EvaporationEndPinchOffsetCurrent2,
        IoffeEvaporationTime2*1000);
      if EvaporationEndBiasCurrent2=0 then SwitchIGBT(5,off);
      SwitchRF(MinRFLevel,off);
      Wait(GPIBCommandTime);
    SequenceEndBlock;
  end;

  procedure ShakeTrap;far;
  var n,maxn:word;
      ShakeStopFrequency:double;
  begin
    FinalTrap:='Shaked trap';
    AtomPath:=AtomPath+'S+';
    SequenceStartBlockNoArg(ShakeTrap);
      ShakeStopFrequency:=ShakeStartFrequency+ShakeDeltaFrequency;
      maxn:=round(ShakeTime/SRSGPIBCommandTime);
      for n:=1 to maxn do begin
        SRS2Sinus((n/maxn)*(ShakeStopFrequency-ShakeStartFrequency)+ShakeStartFrequency,ShakeAmplitude);
        Wait(SRSGPIBCommandTime);
      end;
      SRS2Sinus(ShakeStopFrequency,0);
      Wait(SRSGPIBCommandTime);
    SequenceEndBlock;
  end;

  procedure CompressIoffeForPicture;far;
  begin
    FinalTrap:='Compressed Ioffe trap';
    AtomPath:=AtomPath+'Co';
    SequenceStartBlockNoArg(CompressIoffeForPicture);
      Wait(1);
      Ramp(SetBarsCurrent,aktBarCurrent,CompressionForPictureBarEndCurrent,CompressionForPictureTime,0.2);
      Wait(CompressedIoffeWaitTime+1);
    SequenceEndBlock;
  end;

  procedure OpticalPumping;
  var HelpMagTrapStartTime:double;
      n:byte;
      FirstTime:boolean;
      AktPump6Repump:boolean;
      mf:integer;
  begin
    FinalTrap:='optical pumping';
    if PumpToF_2 then AtomPath:=AtomPath+'O2'
    else AtomPath:=AtomPath+'O1';
    SwitchIGBTsOff;
    SwitchAOM20(off);
    SwitchOpticalPumpingField(on);
    IOUpdate;
    if (MOT7LiPrincipalFlashTime>0) then SwitchMaster7Principal(on);
    SetMOTVoltage(MagTrapStartMOTVoltage);
    if Use7RepumpForOpticalPumping then SetOpticalPumpingDetuning7Li(OpticalPumping7repumpDetuning);
    if Use6RepumpForOpticalPumping then SetOpticalPumpingDetuning6Li(OpticalPumping6repumpDetuning);
    SwitchMaster7Repump(Use7RepumpForOpticalPumping);
    SwitchMaster6Repump(Use6RepumpForOpticalPumping);
    {SwitchOszilloskopTrigger3(on);}
    SetAOM20Intensity(MOTIntensity);
    Set7PrincipalDetuning(Flash7PrincipalDetuning);
    Wait(OpticalPumpingToggleFieldTime);
    if DoToggleOpticalPumpingBeams then begin
      SwitchMaster6Repump(off);
      SwitchMaster7Repump(off);
      if PumpToF_2 then begin
        if DoF1OpticalPumpingFrequencySweep then SetOpticalPumpingDetuning(1,-1);
        if DoF2OpticalPumpingFrequencySweep then SetOpticalPumpingDetuning(2,-1);{-2);}
      end else begin
        if DoF1OpticalPumpingFrequencySweep then SetOpticalPumpingDetuning(1,1);
        if DoF2OpticalPumpingFrequencySweep then SetOpticalPumpingDetuning(2,1);{2);}
      end;
      IOUpdate;
      SwitchOpticalPumpingBeam(on);
      FirstTime:=True;
      if StopToggelingWith6Repumpon then begin
        AktPump6Repump:=(OpticalPumpingFlashes mod 2)=1;
      end else begin
        AktPump6Repump:=(OpticalPumpingFlashes mod 2)=0;
      end;
      for n:=1 to OpticalPumpingFlashes do begin
        if AktPump6Repump then begin
          if Replace6LiRepumpbyFlash then begin
            SwitchOpticalPumpingBeam(off);
            SwitchMaster7Principal(on);
            IOUpdate;
            SwitchAOM20(on);
          end else begin
            SwitchMaster6Repump(on);
            SwitchMaster7Repump(off);
            if DoF1OpticalPumpingFrequencySweep then begin
              IOUpdate;
              if PumpToF_2 then begin
                for mf:=0 to 1 do begin
                  SetOpticalPumpingDetuning(1,mf);
                  IOUpdate;
                end;
              end else begin
                for mf:=1 downto 0 do begin
                  SetOpticalPumpingDetuning(1,mf);
                  IOUpdate;
                end;
              end;
            end;
          end;
        end else begin
          SwitchMaster6Repump(off);
          SwitchMaster7Repump(on);
          if DoF2OpticalPumpingFrequencySweep then begin
            IOUpdate;
            if PumpToF_2 then begin
              for mf:=0 to 1 do begin
                SetOpticalPumpingDetuning(2,mf);
                IOUpdate;
              end;
            end else begin
              for mf:=1 downto 0 do begin
                SetOpticalPumpingDetuning(2,mf);
                IOUpdate;
              end;
            end;
          end;
        end;
        AktPump6Repump:=not AktPump6Repump;
        if (OpticalPumpingFlashTime>=0.05) then begin
          if FirstTime then Wait(OpticalPumpingFlashTime+0.04)
          else Wait(OpticalPumpingFlashTime);
          FirstTime:=false;
        end else IOUpdate;
        if n<>OpticalPumpingFlashes then begin
          if Replace6LiRepumpbyFlash then begin
            SwitchAOM20(off);
            SwitchMaster6Repump(off);
            SwitchMaster7Repump(off);
            IOUpdate;
            SwitchOpticalPumpingBeam(on);
            IOUpdate;
          end else begin
            SwitchMaster6Repump(off);
            SwitchMaster7Repump(off);
            IOUpdate;
            if PumpToF_2 then begin
              if DoF1OpticalPumpingFrequencySweep then SetOpticalPumpingDetuning(1,-1);
              if DoF2OpticalPumpingFrequencySweep then SetOpticalPumpingDetuning(2,-2);
            end else begin
              if DoF1OpticalPumpingFrequencySweep then SetOpticalPumpingDetuning(1,1);
              if DoF2OpticalPumpingFrequencySweep then SetOpticalPumpingDetuning(2,2);
            end;
          end;
        end;
      end;
      if (OpticalPumpingFlashTime<0.05) then begin
        if (OpticalPumpingTime<0.05*OpticalPumpingFlashes)
        then OpticalPumpingTime:=0.05*OpticalPumpingFlashes;
        if (OpticalPumpingFlashes=1) and (OpticalPumpingTime<0.1)
        then OpticalPumpingTime:=0.1;
      end;
    end;
    {SwitchOszilloskopTrigger3(off);}
    if OpticalPumpingTime>0 then begin
      SwitchOpticalPumpingBeam(on);
      IOUpdate;
      if (OpticalPumpingTime>0.025) then Wait(OpticalPumpingTime);
      if OpticalPumping7LiRepumpAloneTime>0 then begin
        SwitchMaster6Repump(off);
        SwitchMaster7Repump(on);
        Wait(OpticalPumping7LiRepumpAloneTime);
      end else if OpticalPumping7LiRepumpAloneTime<0 then begin
        SwitchMaster7Repump(off);
        SwitchMaster6Repump(on);
        Wait(-OpticalPumping7LiRepumpAloneTime);
      end;
      SwitchOpticalPumpingBeam(off);
      IOUpdate;
      {SwitchMaster6Repump(on);
      SwitchMaster7Repump(on);
      IOUpdate;}
    end;
    if (MOT7LiPrincipalFlashTime>0) then begin
      SwitchMaster7Principal(on);
      SwitchMaster7Repump(off);
      Set7PrincipalDetuning(Flash7PrincipalDetuning);
      IOUpdate;
      SwitchAOM20(on);
      SetAOM20Intensity(MOTIntensity);
      Wait(MOT7LiPrincipalFlashTime);
      SwitchAOM20(off);
      IOUpdate;
    end;
    if (MOT7LiPrincipalFlashTime<0) then begin
      SwitchMaster7Principal(off);
      SwitchMaster7Repump(on);
      Set7RepumpDetuning(Flash7RepumpDetuning);
      SetAOM20Intensity(FlashIntensity);
      IOUpdate;
      SwitchAOM20(on);
      Wait(-MOT7LiPrincipalFlashTime);
      SwitchAOM20(off);
      IOUpdate;
    end;
    SwitchMaster7Repump(off);
    SwitchMaster6Repump(off);
    SwitchMaster7Principal(off);
    SwitchMaster6Principal(off);
    IOUpdate;
  end;

  procedure StartMagTrapWithOpticalPumping;
  begin
    OpticalPumping;
    FinalTrap:='QP MagTrap';
    AtomPath:=AtomPath+'Qp';
    FinalTrapType:=QP;
    SetMOTVoltage(MagTrapStartMOTVoltage);
    IOUpdate;
    SwitchIGBTsToMagTrap;
    if (MagTrapStartTime>OpticalPumpingFieldOverlapTime) then begin
      Wait(OpticalPumpingFieldOverlapTime);
      SwitchOpticalPumpingField(off);
      Wait(MagTrapStartTime-OpticalPumpingFieldOverlapTime);
      SetMOTVoltage(MagTrapMOTVoltage);
    end else begin
      Wait(MagTrapStartTime);
      SetMOTVoltage(MagTrapMOTVoltage);
      Wait(OpticalPumpingFieldOverlapTime-MagTrapStartTime);
      SwitchOpticalPumpingField(off);
    end;
    IOUpdate;
    {ShutterProbe6principal(DetectLithium6);
    ShutterProbe7principal(DetectLithium7);}
  end;

procedure PrepareOpticalPumping;
begin
  if ProbeAOMsDefaultOn then begin
    SwitchProbeBeamDirect(off);
    Wait(ProbeAOMOffTimeBeforeShutterOpen);
    ShutterProbeRepumpAndOpticalPumpingBeamDirect(open);
  end;
  ShutterMOT6repump(on);
  SwitchMaster6Repump(on);
  if not TrapLithium6 then SetOpticalPumpingDetuning6Li(OpticalPumping6repumpDetuning);
  if ProbeAOMsDefaultOn then Wait(ShutterProbeOnDelay);
end;

procedure FinishOpticalPumping;
begin
  if ProbeAOMsDefaultOn then begin
    ShutterProbeDirect(close);
    ShutterProbeRepumpAndOpticalPumpingBeamDirect(close);
    Wait(ShutterProbeOffDelay);
    SwitchProbeBeamDirect(on);
  end;
end;

procedure StartMagTrap;
begin
  {SwitchOszilloskopTrigger(off);
  Wait(0.1);}
  FinalTrap:='QP MagTrap';
  AtomPath:=AtomPath+'Qp';
  FinalTrapType:=QP;
  SwitchIGBTsToMagTrap;
  SwitchAOM20(off);
  IOUpdate;
  SetMOTVoltage(MagTrapStartMOTVoltage);
  Wait(MagTrapStartTime);
  SetMOTVoltage(MagTrapMOTVoltage);
end;

procedure ProtectMagTrap;
begin
  FinalTrap:='protected MagTrap';
  AtomPath:=AtomPath+'P+';
  if KeepInjection then begin
    SwitchMaster7Repump(on);
    SwitchMaster7Principal(on);
  end else begin
    if KeepMasterAOMsOn then begin
      SwitchMaster7Repump(on);
      SwitchMaster7Principal(on);
      SwitchMaster6Repump(on);
      SwitchMaster6Principal(on);
    end else begin
      SwitchMaster7Repump(DoDopplerCoolIoffeTrap and DopplerCoolBeamIsPrincipal);
      SwitchMaster7Principal(DoDopplerCoolIoffeTrap and (not DopplerCoolBeamIsPrincipal));
      SwitchMaster6Repump(off);
      SwitchMaster6Principal(off);
    end;
  end;
  ShutterMOT(close);
  SwitchAOM20(off);
  if KeepMOTAOMOn and (not DoDopplerCoolIoffeTrap) then begin
    ShutterAOM20(off);
    SwitchAOM20Delayed(on);
  end;
  if KeepInjection then begin
    ShutterMOT7principal(open);
    ShutterMOT7repump(open);
  end else begin
    if not DoDopplerCoolIoffeTrap then begin
      ShutterMOT7repump(close);
      ShutterMOT7principal(close);
    end;
  end;
  ShutterMOT6principal(close);
  ShutterMOT6repump(close);
  ShutterProbe6principal(close);
  ShutterProbe7principal(close);
  if (not DoDopplerCoolIoffeTrap) and (not KeepInjection)
  then ShutterMaster7AndMOT7LiPrincipal(off);
  ShutterProbeDirect(off);
  ShutterProbeRepumpAndOpticalPumpingBeamDirect(off);
  IOUpdate;
  if DoSwitchMaster7PrincipalOff then SwitchMaster7Principal(off);
  if not DoDopplerCoolIoffeTrap then SetProbeDetuning
  else PrepareDopplerCooling;
  IOUpdate;
end;

procedure UnProtectMagTrap;
begin
  FinalTrap:='unprotected MagTrap';
  AtomPath:=AtomPath+'P-';
  ShutterProbeDirect(not ProbeAOMsDefaultOn);
  if ProbeWithRepump then ShutterProbeRepumpAndOpticalPumpingBeamDirect(not ProbeAOMsDefaultOn);
  if DetectLithium7 then begin
    {SwitchMaster7Principal(on);
    SwitchMaster7Repump(ProbeWithRepump);}
    {SwitchMaster7Principal(off);
    SwitchMaster7Repump(off);
    IOUpdate;}
    {ShutterMOT7principal(open);
    Wait(10);}
    ShutterMaster7AndMOT7LiPrincipal(on);
    {Wait(10);}
    ShutterProbe7principal(open);
    {Wait(10);}
    ShutterMOT7repump(ProbeWithRepump);
    {Wait(10);}
  end;
  if DetectLithium6 then begin
    SwitchMaster6Repump(ProbeWithRepump);
    ShutterMOT6repump(ProbeWithRepump);
    SwitchMaster6Principal(on);
    ShutterMOT6principal(open);
    ShutterProbe6principal(open);
  end;
  {EnableAOMs;}
  Wait(UnProtectMagTrapStabilizationTime);
end;

procedure QPDopplerCooling;
begin
  FinalTrap:='Cooled QP';
  AtomPath:=AtomPath+'DC';
  if (QPDCPrincipalDetuning>-100) then Set7PrincipalDetuning(QPDCPrincipalDetuning)
  else SwitchMaster7Principal(off);
  if (QPDCRepumpDetuning>-100) then Set7RepumpDetuning(QPDCRepumpDetuning)
  else SwitchMaster7Repump(off);
  SetAOM20Intensity(QPDCIntensity);
  IOUpdate;
  SwitchAOM20(on);
  wait(QPDCTime);
  SwitchAOM20(off);
  if not DoDopplerCoolIoffeTrap then SetProbeDetuning
  else PrepareDopplerCooling;
end;

procedure Recapture;
var n:word;
    Waittime:double;
begin
  {if DoCompressedMagTrap then CCCVTransition;}
  FinalTrap:='Recaptured';
  AtomPath:=AtomPath+'Re';
  SwitchMaster7Repump(off);
  SwitchMaster7Principal(off);
  IOUpdate;
  if TrapLithium7 then begin
    ShutterMOT7principal(open);
    ShutterMOT7repump(open);
    ShutterMaster7AndMOT7LiPrincipal(on);
  end else begin
    ShutterMOT7principal(close);
    ShutterMOT7repump(close);
  end;
  if TrapLithium6 then begin
    ShutterMOT6principal(open);
    ShutterMOT6repump(open);
  end else begin
    ShutterMOT6principal(close);
    ShutterMOT6repump(close);
  end;
  ShutterProbe6principal(DetectLithium6);
  ShutterProbe7principal(DetectLithium7);
  ShutterProbeDirect(not ProbeAOMsDefaultOn);
  if ProbeWithRepump then ShutterProbeRepumpAndOpticalPumpingBeamDirect(not ProbeAOMsDefaultOn);
  {ShutterProbeDirect(close);}
  ShutterMOT(open);
  ShutterAOM20(open);
  SetMOTDetuning;
  SetAOM20Intensity(MOTIntensity);
  SwitchMaster7Repump(on);
  SwitchMaster7Principal(on);
  SwitchMaster6Repump(on);
  SwitchMaster6Principal(on);
  EnableAOMs;
  SwitchAOM20Frequency(off);
  IOUpdate;
  SwitchIGBTsOff;
  SetMOTVoltage(MOTMOTVoltage);
  SwitchAOM20(on);
  IOUpdate;
  for n:=0 to 35 do begin
    SwitchIGBTsToMOT;
    WaitTime:=0.3+0.02*n;
    if n=0 then Waittime:=Waittime+0.1;
    Wait(WaitTime);
    SwitchIGBTsOff;
    IOUpdate;
  end;
  SwitchTransferDecharging(off);
  IOUpdate;
  SwitchIGBTsToMOT;
  IOUpdate;
  SetTransfer2Voltage(MOTTransfer2Voltage);
  IOUpdate;
  if MeasureRecaptureFluo then begin
    SequenceStopPortList;
    MeasureFluorescence(1);
    for n:=1 to round(RecaptureTime) do begin
      MeasureIntegratedFluorescence(1);
      wait(1);
    end;
    NormalizeIntegratedFluorescence(1,round(RecaptureTime)+1);
    SequenceStartPortListDuringWait(10);
  end else Wait(RecaptureTime);
end;

procedure StartRFShield;
begin
  AtomPath:=AtomPath+'Rf';
  SwitchRFTo(RFShieldAntenna);
  IOUpdate;
  SetFrequency(RFShieldFrequency);
  SwitchRF(MaxRFLevel,on);
end;

procedure MagneticTrap;
var n:byte;
    helpMagTrapTime:double;
begin
  if DoProtectMagTrap then begin
    helpMagTrapTime:=MagTrapTime-UnProtectMagTrapStabilizationTime;
  end else helpMagTrapTime:=MagTrapTime;
  if helpMagTrapTime<=0 then begin
    helpMagTrapTime:=1;
    writeln('MagTrap : MagneticTrap : MagTrapTime too short');
  end;
  {SwitchOszilloskopTrigger(off);
  Wait(1);}
  if DoOpticalPumping then StartMagTrapWithOpticalPumping
  else StartMagTrap;
  if RFShieldDuringMagTrap then StartRFShield;
  SetProbeDetuning;
  if DoProtectMagTrap then ProtectMagTrap
  else if DoDopplerCoolIoffeTrap then PrepareDopplerCooling;
  if DoOpticalPumping then FinishOpticalPumping;
  {if not DoCompressedMagTrap then DoTransfer:=false;}
  if DoTransfer then RecaptureTime:=0;
  if (not DoTransfer) or (TransferPercent<>100) then DoIoffeBarRamp:=false;
  if not DoTransfer then begin
    DoIoffeTrap:=false;
    if TransferPercent>20 then DoDeCompressMagTrapBeforeTransfer:=false;
  end;
  if DoIoffeTrap then begin
    DoDeCompressMagTrapBeforeTransfer:=false;
    DoDeCompressedMagTrap:=false;
  end;
  if not (DoDeCompressMagTrapBeforeTransfer or DoDeCompressedMagTrap)
  then DoReCompressedMagtrap:=false;
  if not DoIoffeTrap then begin
    DoIoffeCVCCTransition:=false;
    DoDecompressIoffe:=false;
  end;
  if not DoIoffeCVCCTransition then DoBiasCompensation:=false;

  SequenceStopPortList;
  Wait(0.5);
  {if DoAddCurrent then MagTrapMOTVoltageCompressed:=MaxMOTVoltage;}
  if DoCleaning then CleanMagTrap;
  if DoQuadrupolEvaporation and DoQPEvaporationbeforecompression then begin
    DoSweep(QuadrupolRFSweep);
    FinalTrap:='QP Magtrap after evaporation';
    AtomPath:=AtomPath+'Ev';
  end;
  if DoCompressedMagTrap then CompressMagTrap;
  Wait(InitialMagTrapWaitTime);
  AddCurrent;
  if DoQPDopplerCooling then QPDopplerCooling;
  if DoQuadrupolEvaporation and (not DoQPEvaporationbeforecompression) then begin
    DoSweep(QuadrupolRFSweep);
    FinalTrap:='QP Magtrap after evaporation';
    AtomPath:=AtomPath+'Ev';
  end;
  if DoAddCurrent then Wait(AddedCurrentWaitTime);
  DeAddCurrent;
  if DoDeCompressMagTrapBeforeTransfer then DeCompressMagTrap;
  if DoTranslateMagTrap then TranslateMagTrap;
  if DoTransfer then begin
    Transfer;
    if DoIoffeBarRamp then IoffeBarRamp;
    if DoTransferQuadrupolExpansion then TransferQuadrupolExpansion;
    if DoTransferQuadrupolDeformation then TransferQuadrupolDeformation;
    if DoRampMOTCoilsOff then RampMOTCoilsOff;
    if DoIoffeTrap then begin
      DeTranslateUpperMagTrap;
      if PumpToF_2 then begin
        IoffeTrapF2;
        if DoCompressIoffeTrapCV then CompressIoffeTrapCV;
        if DoIoffeCVCCTransition then begin
          CVCCTransitionF2;
          if DoCompressIoffeTrap1 then CompressIoffeTrap;
          if DoDopplerCoolIoffeTrap then DopplerCoolIoffeTrap;
          if DoCompressIoffeTrap2 then CompressIoffeTrap2;
          Wait(CompressedIoffeTrapWait0);
          if DoDopplerCoolIoffeTrap2 then DopplerCoolIoffeTrap2;
          Wait(CompressedIoffeTrapWait);
            if DoCompressIoffeTrap3 then CompressIoffeTrap3;
            Wait(CompressedIoffeTrapWait2);
            if DoDopplerCoolIoffeTrap3 then DopplerCoolIoffeTrap3;
            {if (DopplerCoolErgodicMixCycles=1) or (n<DopplerCoolErgodicMixCycles) then begin}
          for n:=1 to DopplerCoolErgodicMixCycles do begin
            if DoCompressIoffeTrap4 then CompressIoffeTrap4;
            Wait(CompressedIoffeTrapWait3);
            if DoCompressIoffeTrap5 then CompressIoffeTrap5;
            if DoDopplerCoolIoffeTrap4 then DopplerCoolIoffeTrap4;
          end;

          if DoProtectMagTrap then FinishDopplerCooling;
          if DoAddPinchOffset then AddPinchOffset;
          if DoCompressIoffeTrap6 then CompressIoffeTrap6;
          Wait(CompressedIoffeTrapWait4);
          if DoBiasCompensation then BiasCompensateIoffeTrapF2;
          {else if helpMagTrapTime>2000 then helpMagTrapTime:=500;}
        end; {else if helpMagTrapTime>2000 then helpMagTrapTime:=500;}
      end else begin
        IoffeTrapF1;
        if DoIoffeCVCCTransition then CVCCTransitionF1;
      end;
      if DoDecompressIoffe then DecompressIoffeTrap;
      if DoCleanIoffeTrap then CleanIoffeTrap;
      if DoMicrowaveSweep then MicroWaveSweep;
      if DoConstantmicrowaveEvaporation1 then ConstantMicroWaveEvaporation1;
      if DoConstantmicrowaveEvaporation2 then ConstantMicroWaveEvaporation2;
      if DoMicrowaveSweep2 then MicroWaveSweep2;
      if DoCompressIoffeTrap9 then CompressIoffeTrap9;
      if DoIoffeEvaporation then begin
        DoSweep(IoffeRFSweep);
        FinalTrap:='Ioffe trap after evaporation';
        AtomPath:=AtomPath+'e1';
      end;
      if DoCompressIoffeTrap10 then CompressIoffeTrap10;
      Wait(IoffeTrapWait1);
      if DoIoffeEvaporation2 then begin
        DoSweep(QuadrupolRFSweep);
        FinalTrap:='Ioffe trap after evaporation';
        AtomPath:=AtomPath+'e2';
      end;
    end;
  end;
  {SwitchOszilloskopTrigger(off);
  IOUpdate;}
  SaveAktCurrents;
  if KeepMOTAOMOn then SwitchAOM20Delayed(on);
  if DoShakeTrap then ShakeTrap;
  if DoCompressionForPicture or DoRecompressIoffe or
     DoDeCompressedMagTrap or DoReCompressedMagTrap then begin
    Wait(helpMagTrapTime);
    if DoCompressionForPicture then CompressIoffeForPicture;
    if DoRecompressIoffe then RecompressIoffeTrap;
    if DoDeCompressedMagTrap then DeCompressMagTrap;
    if DoReCompressedMagTrap then ReCompressMagTrap;
    SaveAktCurrents;
    SequenceStartPortListDuringWait(50);
  end else SequenceStartPortListDuringWait(helpMagTrapTime);
 { end;}
  if (RecaptureTime>0) and DoCompressedMagTrap then ReverseMagTrap:=true;
  if ReverseMagTrap and not DoIoffeTrap then begin
    SequenceStopPortList;
    {ReTranslateUpperMagTrap;}
    if DoRampMOTCoilsOff then RampMOTCoilsOn;
    if DoTransferQuadrupolDeformation then DeTransferQuadrupolDeformation;
    if DoTransferQuadrupolExpansion then DeTransferQuadrupolExpansion;
    if DoIoffeBarRamp then DeIoffeBarRamp;
    if DoTransfer then DeTransfer;
    if DoTranslateMagTrap then DeTranslateMagTrap;
    Wait(FinalMagTrapTime);
    SequenceStartPortListDuringWait(50);
  end;
  if RFOn then begin
    SequenceStopPortList;
    SwitchRFOff;
    SequenceStartPortListDuringWait(GPIBCommandTime);
  end;
  if (RecaptureTime>0) then Recapture
  else if DoProtectMagTrap then UnProtectMagTrap;
end;

procedure SwitchMagTrapCompletelyOff;
begin
  SetMOTVoltage(0);
  SetMOTCurrent(0);
  SetTransfer1Current(0);
  SetTransfer1Voltage(0);
  SetTransfer2Voltage(0);
  SetBarsCurrent(0);
  SetBarsVoltage(0);
  IOUpdate;
  SwitchTransferDecharging(on);
  SwitchMOTDecharging(on);
  SwitchSlowerCompensation(off);
  Wait(50);
  SwitchIGBTsOff;
  IOUpdate;
end;

end.