procedure MenuParams1;
var InfoDialog   : pDialogInfo;
    UpdateDialog : boolean;
    ratio:double;
    text:string;
begin
  NewDialog(InfoDialog);
  AddT(InfoDialog,'MOT and CMOT Parameters');
  AddR(InfoDialog,MOT7PrincipalDetuning,'7Li MOT Principal Detuning [MHz]','MOT7PrincipalDetuning ? MHz',-100,0,1);
  AddR(InfoDialog,MOT7RepumpDetuning,'7Li MOT Repump Detuning [MHz]','MOT7RepumpDetuning? MHz',-100,0,1);
  AddR(InfoDialog,MOT6PrincipalDetuning,'6Li MOT Principal Detuning [MHz]','MOT6PrincipalDetuning ? MHz',-100,0,1);
  AddR(InfoDialog,MOT6RepumpDetuning,'6Li MOT Repump Detuning [MHz]','MOT6RepumpDetuning? MHz',-100,0,1);
  AddR(InfoDialog,MOTIntensity,'MOT Intensity [0..1]','MOTIntensity',0,1,1);
  AddR(InfoDialog,MOTMOTCurrent,'MOT current in MOT coils [0..500 A]','MOTMOTCurrent',0,500,1);
  AddR(InfoDialog,MOTMOTVoltage,'MOT Voltage [0..20 V]','MOTVoltage',0,20,1);
  AddR(InfoDialog,MOTTransfer1Current,'MOT Transfer 1 Current [0..50 A]','MOTTransfer1Current',0,50,1);
  AddR(InfoDialog,MOTTransfer2Voltage,'MOT voltage in transfer2 power supply [0..30 A]','MOTTransfer2Voltage',0,30,1);
  AddR(InfoDialog,MOTTransferOffTime,'Time to switch off transfer coils [ms]','MOTTransferOffTime',0,1000,1);

  AddR(InfoDialog,CMOT7PrincipalDetuning,'7Li CMOT Principal Detuning [MHz]','CMOT7PrincipalDetuning ? MHz',-100,0,1);
  AddR(InfoDialog,CMOT7RepumpDetuning,'7Li CMOT Repump Detuning [MHz]','CMOT7RepumpDetuning? MHz',-100,0,1);
  AddR(InfoDialog,CMOT6PrincipalDetuning,'6Li CMOT Principal Detuning [MHz]','CMOT6PrincipalDetuning ? MHz',-100,0,1);
  AddR(InfoDialog,CMOT6RepumpDetuning,'6Li CMOT Repump Detuning [MHz]','CMOT6RepumpDetuning? MHz',-100,0,1);
  AddR(InfoDialog,CMOTIntensity,'CMOT Intensity [0..1]','CMOTIntensity',0,1,1);
  AddR(InfoDialog,CMOTMOTVoltage,'CMOT Voltage [0..20 V]','CMOTVoltage',0,20,1);
  AddR(InfoDialog,CMOTTime,'CMOT Time [ms]','CMOT Time [ms]',0,10000,1);
  AddR(InfoDialog,CMOTSweepTime,'CMOT Sweep Time [ms]','CMOT Sweep Time [ms]',0,10000,1);

  AddB(InfoDialog,DechargeMOT,'Decharge MOT before loading [Yes/No]','DechargeMOT? ');

  BackupVars(InfoDialog);
  DoDialog(InfoDialog,'Parameters 1',UpdateDialog);
  SetTrapIntensity(MOTIntensity);
  SetMOTCurrent(MOTMOTCurrent);
  SetTransfer1Current(MOTTransfer1Current);
  SetTransfer2Voltage(MOTTransfer2Voltage);
  SetMOTVoltage(MOTMOTVoltage);
  SetAOMfrequencies;
end;

procedure MenuParams2;
var InfoDialog   : PDialogInfo;
    UpdateDialog : boolean;
begin
  NewDialog(InfoDialog);
  AddT(InfoDialog,'Magnetic Trap Parameters');
  AddR(InfoDialog,OpticalPumpingTime,
    'Time to switch repumpers off before switching off MOT light [ms]',
    'OpticalPumpingTime: <0: principal off first >0: repump off first',-100,100,1);
{  AddR(InfoDialog,MOTTransferOffTime,'time for switch off of transfer coil current [ms]','MOTTransferOffTime',0,100000,1);}
  AddB(InfoDialog,DoMagTrap,'Do magnetic trapping ? [Yes/No]','DoMagTrap');
  AddR(InfoDialog,MagTrapTime,'Magnetic trap time [ms]','MagTrapTime',0,100000,1);
  AddB(InfoDialog,ReverseMagTrap,'Reverse magnetic trapping ? [Yes/No]','ReverseMagTrap');
  AddR(InfoDialog,RecaptureTime,'Time of recapture in MOT ? [ms]','RecaptureTime',0,10000,1);
  AddR(InfoDialog,MagTrapMOTVoltage,'Magnetic Trap MOT coils Voltage [0..20 V]','MagTrapMOTVoltage',0,20,1);
  AddR(InfoDialog,MagTrapTransfer2Voltage,'Magnetic Trap Transfer 2 Voltage [0..30 V]','MagTrapTransfer2Voltage',0,30,1);
  AddR(InfoDialog,MagTrapTransfer1CurrentCV,'Transfer 1 (start) current in CV mode [0..500 A]',
    'MagTrapTransfer1CurrentCV',0,500,1);
  AddR(InfoDialog,MagTrapTransfer1CurrentCC,'Transfer 1 (end) current in CC mode [0..500 A]',
    'MagTrapTransfer1CurrentCC',0,500,1);
  AddR(InfoDialog,MagTrapMOTCurrentCV,'Magnetic Trap MOT Current in CV mode [0..500 A]','MagTrapMOTCurrentCV',0,500,1);
  AddR(InfoDialog,MagTrapMOTCurrentCC,'Magnetic Trap MOT Current in CC mode [0..500 A]','MagTrapMOTCurrentCV',0,500,1);
  AddR(InfoDialog,CV_CCTime1,'CV mode CC mode transition time [ms]','CV_CCTime1',0,1000,1);
  AddR(InfoDialog,CV_CCTime2,'Transfer 2 voltage drop time [ms]','CV_CCTime2',0,1000,1);
  AddB(InfoDialog,DoCompressedMagTrap,'compress magnetic trap ? [Yes/No]','DoCompressedMagTrap');
  AddR(InfoDialog,MagTrapCurrentCompressed,'Magnetic Trap Current after compression [0..500 A]',
    'MagTrapCurrentCompressed',0,500,1);
  AddR(InfoDialog,CompressMagTrapTime,'Magnetic trap compression time [ms]','CompressMagTrapTime',0,5000,1);
  BackupVars(InfoDialog);
  DoDialog(InfoDialog,'Magnetic Trap Parameters',UpdateDialog);
end;

procedure MenuParams3;
var InfoDialog   : PDialogInfo;
    UpdateDialog : boolean;
begin
  NewDialog(InfoDialog);
  AddT(InfoDialog,'Transfer Parameters');
  AddB(InfoDialog,DoTransfer,'Move magnetic trap ? [Yes/No]','DoTransfer');
  AddR(InfoDialog,TransferPercent,'Do x % of transfer [x=0..100]','TransferPercent',0,100,1);
  AddR(InfoDialog,Tranfer2VoltageRampDelayFraction,'Delay x % of transfer to start Transfer2 voltage ramp [x=0..100]',
    'Tranfer2VoltageRampDelayFraction',0,100,1);
  AddR(InfoDialog,Transfer2EndVoltage,'Transfer 2 end Voltage [0..30]','Transfer2EndVoltage',0,30,1);
  AddR(InfoDialog,RampTransferCoilsTime,'Transfer coils ramp time [ms]','RampTransferCoilsTime',0,10000,1);
  AddR(InfoDialog,RampMOTCoilsTime,'Mot coils ramp time [ms]','RampMOTCoilsTime',0,10000,1);
  AddR(InfoDialog,TransferCurrentEnd,'End current in transfer coils [0..500 A]','TransferCurrentEnd',0,500,1);
  BackupVars(InfoDialog);
  DoDialog(InfoDialog,'Transfer Parameters',UpdateDialog);
end;

procedure MenuParams4;
var InfoDialog   : PDialogInfo;
    UpdateDialog : boolean;
begin
  NewDialog(InfoDialog);
  AddT(InfoDialog,'Ioffe Trap Parameters');
  AddB(InfoDialog,DoIoffeTrap,'Use Ioffe trap ? [Yes/No]','DoIoffeTrap');
  AddR(InfoDialog,PinchCurrentStart,'Start current in pinch coils [0..500 A]','PinchCurrentStart',0,500,1);
  AddR(InfoDialog,PinchVoltageStart,'Start voltage for pinch coil power supply [0..20 V]','PinchVoltageStart',0,20,1);
  AddR(InfoDialog,CompCurrentStart,'Start current in compensation power supply [0..500 A]','CompCurrentStart',0,500,1);
  AddR(InfoDialog,BarCurrentStart,'Start current in Bars [0..1000 A]','BarCurrentStart',0,1000,1);
  AddR(InfoDialog,BarCurrentStartTime,'Bar current ramp time [ms]','BarCurrentStartTime',0,10000,1);
  AddB(InfoDialog,DoCompressedIoffeTrap,'Compress Ioffe trap ? [Yes/No]','DoCompressedIoffeTrap');
  AddR(InfoDialog,PinchCurrentEnd,'End current in pinch coils [0..500 A]','PinchCurrentEnd',0,500,1);
  AddR(InfoDialog,CompCurrentEnd,'End current in compensation power supply [0..500 A]','CompCurrentEnd',0,500,1);
  AddR(InfoDialog,BarCurrentEnd,'End current in Bars [0..1000 A]','BarCurrentEnd',0,1000,1);
  AddR(InfoDialog,CompressIoffeTrapTime,'Ioffe trap compression time [ms]','CompressIoffeTrapTime',0,5000,1);
  AddB(InfoDialog,DoBiasCompensation,'Bias compensate Ioffe trap ? [Yes/No]','DoBiasCompensation');
  AddR(InfoDialog,CompCurrentEnd2,'End current in compensation power supply for bias compensation [0..500 A]',
    'CompCurrentEnd2',0,500,1);
  AddR(InfoDialog,BiasCompTime,'Ioffe trap bias compensation time [ms]','BiasCompTime',0,5000,1);
  BackupVars(InfoDialog);
  DoDialog(InfoDialog,'Ioffe Trap Parameters',UpdateDialog);
end;


procedure MenuParams5;
var InfoDialog   : PDialogInfo;
    UpdateDialog : boolean;
begin
  NewDialog(InfoDialog);
  AddT(InfoDialog,'Slower Parameters');

  AddR(InfoDialog,Slower7PrincipalDetuning,'7Li Slower Principal Detuning [MHz]','Slower7PrincipalDetuning? MHz',-2000,0,1);
  AddR(InfoDialog,Slower7RepumpDetuning,'7Li Slower Repump Detuning [MHz]','Slower7RepumpDetuning? MHz',-2000,0,1);
  AddR(InfoDialog,Slower6PrincipalDetuning,'6Li Slower Principal Detuning [MHz]','Slower6PrincipalDetuning? MHz',-2000,0,1);
  AddR(InfoDialog,Slower6RepumpDetuning,'6Li Slower Repump Detuning [MHz]','Slower6RepumpDetuning? MHz',-2000,0,1);
  AddR(InfoDialog,SlowerOffTime,'Delay between shutting Slower off and using MOT [ms]','SlowerOffTime',0,10000,1);

  AddR(InfoDialog,Melasse7PrincipalDetuning,'7Li Melasse Principal Detuning [MHz]','Melasse7PrincipalDetuning ? MHz',-100,0,1);
  AddR(InfoDialog,Melasse7RepumpDetuning,'7Li Melasse Repump Detuning [MHz]','Melasse7RepumpDetuning? MHz',-100,0,1);
  AddR(InfoDialog,Melasse6PrincipalDetuning,'6Li Melasse Principal Detuning [MHz]','Melasse6PrincipalDetuning ? MHz',-100,0,1);
  AddR(InfoDialog,Melasse6RepumpDetuning,'6Li Melasse Repump Detuning [MHz]','Melasse6RepumpDetuning? MHz',-100,0,1);
  AddR(InfoDialog,MelasseIntensity,'Melasse Intensity [0..1]','MelasseIntensity',0,1,1);
  AddR(InfoDialog,MelasseTime,'Melasse Time [ms]','Melasse Time [ms]',0,100,1);

  AddT(InfoDialog,'AOM Parameters');
  AddR(InfoDialog,AOM0Frequency,'AOM0 Frequency [MHz]','pump probe 7Li = 80 MHz',60,120,1);
  AddR(InfoDialog,AOM10Frequency,'AOM10 Frequency [MHz]','pump probe 6Li = -90 MHz',-120,-60,1);
  AddR(InfoDialog,AOM12Frequency,'AOM12 Frequency [MHz]','helper AOM for 6Li repump = -80 MHz',-120,-60,1);
  AddR(InfoDialog,AOM20Frequency,'AOM20 Frequency [MHz]','MOT on/off = 80 MHz',50,120,1);
  AddR(InfoDialog,AOM21Frequency,'AOM21 Frequency [MHz]','exposure principal = 80 MHz',50,120,1);
  AddR(InfoDialog,AOM22Frequency,'AOM22 Frequency [MHz]','exposure repump = 80 MHz',50,120,1);
  AddI(InfoDialog,IdleTime,'Close Shutter after x seconds.','IdleTime',1,6000);

  BackupVars(InfoDialog);
  DoDialog(InfoDialog,'Slower and AOM Parameters',UpdateDialog);
  SetTrapIntensity(MOTIntensity);
  SetMOTCurrent(MOTMOTCurrent);
  SetTransfer1Current(MOTTransfer1Current);
  SetTransfer2Voltage(MOTTransfer2Voltage);
  SetMOTVoltage(MOTMOTVoltage);
  SetAOMfrequencies;
end;

procedure MenuParams6;
var InfoDialog   : PDialogInfo;
    UpdateDialog : boolean;
    h1:double;
begin
  NewDialog(InfoDialog);
  AddT(InfoDialog,'Detection Parameters');

  AddB(InfoDialog,DetectLithium6,'Detect 6Li [Yes/No]','DetectLithium6 ?');
  AddB(InfoDialog,DetectLithium7,'Detect 7Li [Yes/No]','DetectLithium7 ?');
  AddB(InfoDialog,TrapLithium6,'Trap 6Li [Yes/No]','TrapLithium6 ?');
  AddB(InfoDialog,TrapLithium7,'Trap 7Li [Yes/No]','TrapLithium7 ?');
  AddB(InfoDialog,SlowLithium6,'Slow 6Li [Yes/No]','SlowLithium6 ?');
  AddB(InfoDialog,SlowLithium7,'Slow 7Li [Yes/No]','SlowLithium7 ?');
  AddB(InfoDialog,TwoPictures,'Pictures of 6Li and 7Li [Yes/No]','TwoPictures ?');

  h1:=CameraPosition;
  AddR(InfoDialog,h1,'Camera: 0=MOT / 1=Ioffe Pritchard','Which Camera to use?',0,2,1);

  AddR(InfoDialog,Probe7Offset,'7Li Probe Offset [MHz]','Probe7Offset? MHz',-100,100,1);
  AddR(InfoDialog,Probe6Offset,'6Li Probe Offset [MHz]','Probe6Offset? MHz',-100,100,1);
  AddR(InfoDialog,Probe7PrincipalDetuning,'7Li Detecion Principal Detuning [MHz]','ProbePrincipalDetuning? MHz',-100,100,1);
  AddR(InfoDialog,Probe7RepumpDetuning,'7Li Detecion Repump Detuning [MHz]','ProbeRepumpDetuning? MHz',-100,100,1);
  AddR(InfoDialog,Probe6PrincipalDetuning,'6Li Detecion Principal Detuning [MHz]','ProbePrincipalDetuning? MHz',-100,100,1);
  AddR(InfoDialog,Probe6RepumpDetuning,'6Li Detecion Repump Detuning [MHz]','ProbeRepumpDetuning? MHz',-100,100,1);
  AddR(InfoDialog,ChargingTime,'Charging time of trap [ms]','Charging time ? [ms]',500,100000,1);
  AddR(InfoDialog,DeChargingTime,'DeCharging time of trap [ms]','DeCharging time ? [ms]',0,100000,1);
  AddR(InfoDialog,ExpansionTime6,'Expansion time of 6Li trap [ms]','Expansion time 6Li ? [ms]',0.1,100000,1);
  AddR(InfoDialog,ExpansionTime7,'Expansion time of 7Li trap [ms]','Expansion time 7Li ? [ms]',0.1,100000,1);
  AddR(InfoDialog,VisionCalculationTime,'VisionCalculationTime [s]','VisionCalculationTime',0,100,1);
  AddR(InfoDialog,VisionSecurityTime,'VisionSecurityTime [ms]','VisionSecurityTime',0,10000,1);

  BackupVars(InfoDialog);
  DoDialog(InfoDialog,'Detection Parameters',UpdateDialog);
{  if not (TrapLithium6 or TrapLithium7) then TrapLithium7:=True;}
{  if not (DetectLithium6 or DetectLithium7) then DetectLithium7:=True;}
  if DetectLithium6 and (not TrapLithium6 or not SlowLithium6) then begin
    clrscr;
    writeln('Warning: You told me to detect 6Li, while not trapping it!',^G);
    delay(1000);
  end;
  if DetectLithium7 and (not TrapLithium7 and not SlowLithium7) then begin
    clrscr;
    writeln('Warning: You told me to detect 7Li, while not trapping it!',^G);
    delay(1000);
  end;
  SetAOMfrequencies;
  CameraPosition:=round(h1);
end;

procedure MenuParams7;
var InfoDialog   : PDialogInfo;
    UpdateDialog : boolean;
    asx,asy,awx,awy,abx,aby,ahs:double;
begin
  NewDialog(InfoDialog);
  asx:=AndorStartX;
  asy:=AndorStartY;
  awx:=AndorWidth;
  awy:=AndorHeight;
  abx:=AndorBiningX;
  aby:=AndorBiningY;
  ahs:=AndorHorizontalSpeed;

  AddR(InfoDialog,AndorEichX,'X Calibration [m/Pixel]','X Calibration [m/Pixel]',0,1,1000);
  AddR(InfoDialog,AndorEichY,'Y Calibration [m/Pixel]','Y Calibration [m/Pixel]',0,1,1000);
  AddR(InfoDialog,AsX,'Start Pixel in X direction [0..511]','Start Pixel X [0..511]',0,511,1);
  AddR(InfoDialog,ASY,'Start Pixel in Y direction [0..511]','Start Pixel Y [0..511]',0,511,1);
  AddR(InfoDialog,AWx,'Witdh [1..512]','Width [1..512]',1,512,1);
  AddR(InfoDialog,Awy,'Height [1..512]','Height [1..512]',1,512,1);
  AddR(InfoDialog,ABX,'Bining in X direction [1,2,4,8,16]','Bining X [1,2,4,8,16]',1,16,1);
  AddR(InfoDialog,ABY,'Bining in Y direction [1,2,4,8,16]','Bining Y [1,2,4,8,16]',1,16,1);
  AddR(InfoDialog,AndorTemperature,'Temperature in deg Celsius [-50..30]','Temperature in deg Celsius [-50..30]',-50,30,1);
  AddR(InfoDialog,AHS,'Speed [0= 62.5 kHz / 1= 31.25 kHz]',
    'Horizontal Shift Speed [0= 16 s = 62.5 kHz / 1= 32 s = 31.25 kHz]',0,1,1);
  AddR(InfoDialog,AndorTriggerDelay,'Trigger Delay [ms]','Waiting time for trigger puls',1,500,1);
  AddR(InfoDialog,AndorExposureTime,'Exposure time [ms]','Exposure time ? [ms]',0,100000,1);

  BackupVars(InfoDialog);
  DoDialog(InfoDialog,'Andor Camera Parameters',UpdateDialog);

  AndorStartX:=round(asx);
  AndorStartY:=round(asy);
  AndorWidth:=round(awx);
  AndorHeight:=round(awy);
  AndorBiningX:=1 shl round(ln(abx)/ln(2));
  AndorBiningY:=1 shl round(ln(aby)/ln(2));
  AndorHorizontalSpeed:=round(ahs);

  SetAndorCameraParameters;
end;

procedure MenuParams8;
var InfoDialog   : PDialogInfo;
    UpdateDialog : boolean;
    msx,msy,mwx,mwy,mbx,mby:double;
begin
  NewDialog(InfoDialog);
  msx:=MatroxStartX;
  msy:=MatroxStartY;
  mwx:=MatroxWidth;
  mwy:=MatroxHeight;
  mbx:=MatroxBiningX;
  mby:=MatroxBiningY;

  AddR(InfoDialog,MatroxEichX,'X Calibration [m/Pixel]','X Calibration [m/Pixel]',0,1,1000);
  AddR(InfoDialog,MatroxEichY,'Y Calibration [m/Pixel]','Y Calibration [m/Pixel]',0,1,1000);
  AddR(InfoDialog,MsX,'Start Pixel in X direction [0..511]','Start Pixel X [0..511]',0,511,1);
  AddR(InfoDialog,MSY,'Start Pixel in Y direction [0..511]','Start Pixel Y [0..511]',0,511,1);
  AddR(InfoDialog,MWx,'Witdh [1..512]','Width [1..512]',1,512,1);
  AddR(InfoDialog,Mwy,'Height [1..512]','Height [1..512]',1,512,1);
  AddR(InfoDialog,MBX,'Step width in X direction [1..512]','Step width X [1..512]',1,512,1);
  AddR(InfoDialog,MBY,'Step width in Y direction [1..512]','Step width Y [1..512]',1,512,1);
  AddB(InfoDialog,MatroxOnlyOddLines,'Only odd lines [Y/N]','Only odd lines [Y/N]');
  AddR(InfoDialog,MatroxGain,'Gain [0..255]','Gain [0..255]',0,255,1);
  AddR(InfoDialog,MatroxOffset,'Offset [0..255]','Offset [0..255]',0,255,1);
  AddR(InfoDialog,MatroxExposureTime,'Exposure time [ms]','Exposure time ? [ms]',0,100000,1);

  BackupVars(InfoDialog);
  DoDialog(InfoDialog,'Matrox Camera Parameters',UpdateDialog);

  MatroxStartX:=round(msx);
  MatroxStartY:=round(msy);
  MatroxWidth:=round(mwx);
  MatroxHeight:=round(mwy);
  MatroxBiningX:=round(mbx);
  MatroxBiningY:=round(mby);

  SetMatroxCameraParameters;
end;
