unit Params;

{
  This unit contains all Parameters used by the experiment and
  registers them, so that they can easily be stored, loaded, ...
}

interface
uses Register,UniMess,RFSweep,crt,strings,timing,params2;

Procedure RegisterDouble(acolor:byte;ap:DoublePtr;ainit:double;amin:double;amax:double;aname:string;aquestion:string);
Procedure RegisterInteger(acolor:byte;ap:IntPtr;ainit:integer;amin:integer;amax:integer;aname:string;aquestion:string);
Procedure RegisterBoolean(acolor:byte;ap:boolPtr;ainit:boolean;aname:string;aquestion:string);
Procedure RegisterString(acolor:byte;ap:StringPtr;ainit:string;aname:string;aquestion:string);
Procedure SRegisterDouble (acolor:byte;ap:DoublePtr;ainit:double;aname:string;aquestion:string);
Procedure SRegisterInteger(acolor:byte;ap:IntPtr;ainit:integer;aname:string;aquestion:string);

const MaxRFSweep=3;
var UniMeasure:PUniMess;
    RFSweepData: array [1..MaxRFSweep] of PRFSweep;
    RFSweepRegistry: array [1..MaxRFSweep] of PRegistry;
    RFSweepFileName: array [1..MaxRFSweep] of string;
    Registry:PRegistry;

const RohdeGPIBCommandTime=15+ID*0.1;             {Minimum time delay between two commands to the same Marconi Synthesizer}
const HPGPIBCommandTime=50+ID*0.2;
const MarconiGPIBCommandTime=70+ID*0.3;
const GPIBCommandTime=70+ID*0.4;
const MinGPIBCommandTime=2+ID*0.5;           {Time consumed by writing to one Marconi}
const MinSubsequentGPIBCommandTime=5+ID*0.6;
  {Time consumed by writing to one Marconi + Time for GPIB system to get ready for next command}
const SRSGPIBCommandTime=100+ID*0.7;         {Minimum time delay between two commands to the same SRS Synthesizer}
const Gamma=5.88; {MHz}
const MaxIGBT5Current=350;
const MaxMOTCurrent=500;
const MaxMOTVoltage=30;
const MaxBarCurrent=1000;
const MaxBarVoltage=10;
const MaxTransfer2Voltage=20;
const MaxTransfer1Voltage=20;
const MaxTransfer1Current=500;
const MaxFinalSlowerVoltage=20;
const MaxFinalSlowerCurrent=50;
const MaxPinchOffsetCurrent=30;
const MaxIGBT=10;
const SlowerState:boolean=false;
const aktIGBTStatus:array[1..MaxIGBT] of boolean=(false,false,false,false,false,false,false,false,false,false);
const aktBarCurrent:double=0;
const aktBarVoltage:double=0;
const aktTransfer1Current:double=0;
const aktTransfer2Voltage:double=0;
const aktTransfer1Voltage:double=0;
const aktFinalSlowerVoltage:double=0;
const aktFinalSlowerCurrent:double=0;
const aktMOTCurrent:double=0;
const aktMOTVoltage:double=0;
const aktPinchOffsetCurrent:double=0;
const aktStateRelais1:boolean=false;
const MaxOptTrapBeams=1;
const aktOptTrapIntensity:array[0..MaxOptTrapBeams] of double=(0,0);
const SRSWaitTimeBeforePulse:double=0;
const AktExposureTime:double=0.1;
const MatroxCamera=0;
const AndorCamera=1;
const MaxCameraPos=1;
const CameraTyp:array[0..MaxCameraPos] of byte=(MatroxCamera,AndorCamera);
const CameraCode:array[0..MaxCameraPos] of char=('M','I');
const StdtColor=yellow;
var End7LiFluorescence:double;
    End6LiFluorescence:double;

var Frequency:Double;
    AOM0Frequency:Double;
    AOM1Frequency:Double;
    AOM2Frequency:Double;
    AOM3Frequency:Double;
    AOM4Frequency:Double;
    AOM10Frequency:Double;
    AOM11Frequency:Double;
    AOM12Frequency:Double;
    AOM13Frequency:Double;
    AOM14Frequency:Double;
    AOM15Frequency:Double;
    AOM20MOTFrequency:Double;
    AOM20DopplerCoolFrequency:Double;
    AOM21Frequency:Double;
    AOM22Frequency:Double;
    MOT7PrincipalDetuning:Double;
    MOT7RepumpDetuning:Double;
    MOT6PrincipalDetuning:Double;
    MOT6RepumpDetuning:Double;
    MOTIntensity:Double;
    MOTMOTCurrent:Double;
    MOTMOTVoltage:Double;
    MOTTransfer2Voltage:Double;
    MOTTransferOffTime:Double;
    CMOT7PrincipalDetuning:Double;
    CMOT7RepumpDetuning:Double;
    CMOT6PrincipalDetuning:Double;
    CMOT6RepumpDetuning:Double;
    CMOTIntensity:Double;
    CMOTMOTVoltage:Double;
    DoCMOT:boolean;
    CMOTTime:Double;
    DoShiftMOThorizontal:boolean;
    ShiftMOThorizontalcurrent:double;
    DoMolasses:boolean;
    Molasses7PrincipalDetuning:Double;
    Molasses7RepumpDetuning:Double;
    Molasses6PrincipalDetuning:Double;
    Molasses6RepumpDetuning:Double;
    MolassesIntensity:Double;
    MolassesCurrent:Double;
    MolassesVoltage:Double;
    MolassesTime:Double;
    MolassesFieldOffTime:Double;
    MolassesWithGuidingField:boolean;
    MolassesWithMOTField:boolean;

    DoHyperfinePumping:boolean;
    DoOnly6LiHyperfinePumping:boolean;
    Repump6LiOffTime:double;
    Repump7LiOffTime:double;
    HyperfinePumping7LiPrincipalDetuning:double;
    HyperfinePumping7LiRepumpDetuning:double;
    HyperfinePumping6LiPrincipalDetuning:double;
    HyperfinePumping6LiRepumpDetuning:double;
    HyperfinePumpingIntensity:Double;
    HyperfinePumpingWithMOTField:boolean;
    MOTShiftTime:double;
    DoOpticalPumping:boolean;
    PumpToF_2:boolean;
    Use7RepumpForOpticalPumping:boolean;
    Use6RepumpForOpticalPumping:boolean;
    DoShiftMOT:boolean;
    OpticalPumpingToggleFieldTime:double;
    OpticalPumpingTime:double;
    OpticalPumping7repumpDetuning:double;
    OpticalPumping6repumpDetuning:double;
    OpticalPumping7LiRepumpAloneTime:double;
    MOT7LiPrincipalFlashTime:double;
    Do6LiRepumpFlash:boolean;
    Flash7PrincipalDetuning:double;
    Flash7RepumpDetuning:double;
    FlashIntensity:double;
    DoMagTrap:Boolean;
    RFShieldDuringMagTrap:boolean;
    RFShieldFrequency0:double;
    RFShieldFrequency1:double;
    RFShieldAntenna:boolean;
    RecaptureTime:double;
    MeasureRecaptureFluo:boolean;
    ReverseMagTrap:Boolean;
    MagTrapMOTVoltage:Double;
    MagTrapStartTime:double;
    MagTrapStartMOTVoltage:double;
    
    OpticalPumpingFieldOverlapTime:double;
    MagTrapTransfer2Voltage:Double;
    DoTranslateMagTrap:boolean;
    SlowerCompensationRampTime:double;

const MaxSlowerCompCurrent=2;
var SlowerCompensationCurrent:array[0..MaxSlowerCompCurrent] of double;
    FinalSlowerEndRampTime:double;
    DoCleaning:boolean;
    CleaningSweepTime:double;
    CleaningVoltage1:double;
    CleaningTime1:double;
    CleaningVoltage2:double;
    CleaningTime2:double;

    DoProtectMagTrap:boolean;
    UnProtectMagTrapStabilizationTimeInjection:double;
    UnProtectMagTrapStabilizationTime:double;
    DoCompressedMagTrap:Boolean;
    DoDeCompressMagTrapBeforeTransfer:boolean;
    MagTrapMOTVoltageCompressed:Double;
    MagTrapMOTVoltageDeCompressed:Double;
    CompressMagTrapTime:Double;
    DeCompressMagTrapTime:Double;
    InitialMagTrapWaitTime:double;

    DoAddCurrent:Boolean;
    AddedCurrentWaitTime:double;
    AddCurrentMOTVoltageRamp1MOTEndVoltage:double;
    LowerMagTrapMOTVoltageRampTime1:double;
    LowerMagTrapMOTVoltageRampTime2:double;
    {AddCurrentStartVoltage:double;}
    LowerMagTrapTransferVoltageRampTime:double;
    MaxTotalLowerMagTrapCurrent:double;
    LowerMagTrapCurrentRampTime1:double;
    LowerMagTrapCurrentRampTime2:double;

    DoTransfer:Boolean;
    DoTransferParabolic:Boolean;
    TransferPercent:Double;
    StartBarsTransferPercent:Double;
    BarsTransferEndCurrent:Double;
    DeTransferPercent:Double;
    Transfer2CurrentOffset:double;

    TransferTime:Double;
    TransferHalfWayWait:Double;
    TransferTimeRatio:double;
    FinalMagTrapTime:double;
    MOTTransferStartCurrent:double;
    MOTTransferEndCurrent:double;
    TransferCurrentEnd:Double;
    TransferCurrentMiddle:Double;
    DoIoffeTrap:Boolean;
    PinchVoltageStart:Double;
    PinchStartTime:double;
    IoffeTrapStartTime:Double;
    PinchCapacitorChargingTime:Double;

    PinchCapacitorVoltageStart:Double;
    F2IoffeTrapBarStartCurrent:Double;

    F1IoffeTrapBarStartCurrent:Double;
    F1QuadrupolDecayTime:Double;
    F1PinchStartTime:Double;
    F1PinchStartVoltage:Double;

    DoCompressIoffeTrapCV:boolean;
    BarCompCVCurrent:double;
    PinchCompCVVoltage:double;
    IoffeCVCompressionTime:double;

    DoShakeTrap:boolean;
    ShakeStartFrequency:double;
    ShakeDeltaFrequency:double;
    ShakeTime:double;
    ShakeAmplitude:double;
{const NdYAGFeedbackMode:integer=1;
var NdYAGPower:double;}
    MaxNdYAGIntensity:double;
    DoOpticalTrap:boolean;
    StartHorizontalNdYAGIntensity:double;
    StartVerticalNdYAGIntensity:double;
    OpticalTrapStartTime:double;
    CloseVerticalNdYagShutter:boolean;
    VerticalNdYagShutterDelay:double;

    DoModeMatchTransferRadial:boolean;
    ModeMatchHorizontalNdYAGIntensity:double;
    ModeMatchVerticalNdYAGIntensity:double;

    DoExciteOpticalTrap:boolean;
    ExciteOptTrapHorizontalNdYAGIntensity:double;
    ExciteOptTrapVerticalNdYAGIntensity:double;
    ExciteOptTrapWait:double;

    UseOrthogonalField:boolean;
    OrthogonalFieldRampTime:double;
    OrthogonalFieldCurrent:double;
    DoAxialGradient:boolean;

    DoSwitchOffMagTrap1:boolean;
    DoSwitchOffMagtrap2:boolean;

    DoSeparationGradient:boolean;
    SeparationGradientCurrent:double;
    SeparationGradientRampTime:double;
    SeparationGradientTime:double;

    DoAddFeshbachField:boolean;
Type TUsedFeshbachField=(Pinch,Comp,NotInitialised);
var UsedFeshbachField:TUsedFeshbachField;
    UsePinchForFeshbachField:boolean;
{    DoSuddenFeshbachField:boolean;}
    DoSpinMix:boolean;
    StartFeshbachCurrent:double;
    EtaFeshbachStartRamp:double;
    FeshbachCurrentStartTime:double;
{    StartFeshbachFieldPrepareVoltage:double;
    StartFeshbachFieldPrepareTime:double; }



    DoVCORFSweepHere1:boolean;
    DoVCORFSweepHere2:boolean;
    TimeVCORFSweep:double;
    LevelVCORFSweep1:double;
    StartVCORFSweep1:double;
    StopVCORFSweep1:double;
    LevelVCORFSweep2:double;
    StartVCORFSweep2:double;
    StopVCORFSweep2:double;

const MaxRampOpticalTrap=8;
var DoRampOpticalTrap:array[1..MaxRampOpticalTrap] of boolean;
    FinalHorizontalNdYAGIntensity:array[1..MaxRampOpticalTrap] of double;
    FinalVerticalNdYAGIntensity:array[1..MaxRampOpticalTrap] of double;
    OpticalTrapRampTime:array[1..MaxRampOpticalTrap] of double;


const MaxOpticalTrapWait=8;
var OpticalTrapWait:array [1..MaxOpticalTrapWait] of double;

const MaxRampFeshbachField=5;
var DoRampFeshbachField:array [1..MaxRampFeshbachField] of boolean;
    FeshbachCurrent:array [1..MaxRampFeshbachField] of double;
    EtaFeshbachRamp:array [1..MaxRampFeshbachField] of double;
    FeshbachCurrentRampTime:array [1..MaxRampFeshbachField] of double;

    DoIoffeCVCCTransition:boolean;
    PinchCurrentAfterCVCCTransition:Double;
    PinchCVCCCurrentRampTime:Double;
    PinchCVCCVoltageRampTime:Double;
    BarCurrentAfterCVCCTransition:Double;
    BarCVCCCurrentRampTime:Double;
    BarCVCCVoltageRampTime:Double;

    TransferRaiseVoltageTime:double;

const MaxCompressIoffeTrap=17;
var DoCompressIoffeTrap:array [1..MaxCompressIoffeTrap] of boolean;
    CompressIoffeTrapTime:array [1..MaxCompressIoffeTrap] of double;
    BarCurrentInCompIoffeTrap:array [1..MaxCompressIoffeTrap] of double;
    BiasCurrentInCompIoffeTrap:array [1..MaxCompressIoffeTrap] of double;
    PinchOffsetCurrentInCompIoffeTrap:array [1..MaxCompressIoffeTrap] of double;
    CompensationCurrentInCompIoffeTrap:array [1..MaxCompressIoffeTrap] of double;
const MaxIoffeTrapWait=9;
var IoffeTrapWait:array [1..MaxIoffeTrapWait] of double;
    DoSwitchRFShieldOff:boolean;
    DoSwitchRFShieldOff2:boolean;
    DoProbeFlash:boolean;

const MaxDopplerCoolings=2;
var DoDopplerCoolIoffeTrap: array [1..MaxDopplerCoolings] of boolean;
    DopplerCoolBeamIsPrincipal: array [1..MaxDopplerCoolings] of boolean;
    DopplerCoolStartFrequency: array [1..MaxDopplerCoolings] of double;
    DopplerCoolStopFrequency: array [1..MaxDopplerCoolings] of double;
    DopplerCoolIntensity: array [1..MaxDopplerCoolings] of double;
    DopplerCoolTime: array [1..MaxDopplerCoolings] of double;
    DopplerCoolRamp: array [1..MaxDopplerCoolings] of double;

    DoStartOpticalTrapHere1:boolean;
    DoStartOpticalTrapHere2:boolean;
    DoStartOpticalTrapHere3:boolean;
    DoStartOpticalTrapHere4:boolean;

    DoAddPinchOffset:boolean;
    PinchOffsetCurrent:double;
    PinchOffsetCurrentRampTime:double;

    CompressedIoffeTrapWait0:double;
    CompressedIoffeTrapWait:double;
    CompressedIoffeTrapWait4:double;

    BiasCompPinchCurrent:double;
    Transfer2AddVoltageCurrent:double;
    CompPinchResistance:double;

const MaxMicroWaveSweeps=2;
var DoMicrowaveSweep:array [1..MaxMicroWaveSweeps] of boolean;
    DoMicrowaveSweepSynth0:array [1..MaxMicroWaveSweeps] of boolean;
    IoffeMicroWaveStartFrequency0:array [1..MaxMicroWaveSweeps] of double;
    IoffeMicroWaveStopFrequency0:array [1..MaxMicroWaveSweeps] of double;
    IoffeMicroWavePower0:array [1..MaxMicroWaveSweeps] of double;
    DoMicrowaveSweepSynth1:array [1..MaxMicroWaveSweeps] of boolean;
    IoffeMicroWaveStartFrequency1:array [1..MaxMicroWaveSweeps] of double;
    IoffeMicroWaveStopFrequency1:array [1..MaxMicroWaveSweeps] of double;
    IoffeMicroWavePower1:array [1..MaxMicroWaveSweeps] of double;
    IoffeMicroWaveSweepTime:array [1..MaxMicroWaveSweeps] of double;

const MaxSmoothSweeps=1;
var DoSmoothSweep:array [1..MaxSmoothSweeps] of boolean;
    SmoothStartFrequency:array [1..MaxSmoothSweeps] of double;
    SmoothStopFrequency:array [1..MaxSmoothSweeps] of double;
    SmoothSweepStepTime:array [1..MaxSmoothSweeps] of double;
    SmoothSweepSteps:array [1..MaxSmoothSweeps] of double;
    SmoothSweepTime:array [1..MaxSmoothSweeps] of double;
    SmoothSweepRFLevel:array [1..MaxSmoothSweeps] of double;

const MaxRFPulsSequenceValues=2;
var PSValue:array[1..MaxRFPulsSequenceValues,0..3] of record
      time,frequency,level:double;
    end;

const MaxRFPulsSequences=3;
var DoRFPulsSequence:array [1..MaxRFPulsSequences-1] of boolean;
    RFPulsSequence:array [1..MaxRFPulsSequences] of string;
    PSTriggerTable:array[1..MaxRFPulsSequences,0..3] of record
      Trigger:byte;
      Delay:double;
    end;
    DoRepumpFlash:boolean;
    DoFinalRFPulsSequence:boolean;

    DoPushBeam:boolean;
    UsePushBeamWithRepump:boolean;
    AndorProbeOffDelay:double;
    AndorProbeOnDelay:double;
    AndorProbeOnRiseTime:double;
    PushBeamTime:double;
    FinalWait:double;

const MaxRFPuls=1;
var DoRFPuls:array [1..MaxRFPuls] of boolean;
    RFPulsSynth:array [1..MaxRFPuls] of byte;
    RFPulsFrequency:array [1..MaxRFPuls] of double;
    RFPulsTime:array [1..MaxRFPuls] of double;
    RFThermalisationTime:array [1..MaxRFPuls] of double;
    RFPulsRFLevel:array [1..MaxRFPuls] of double;


const MaxTrapDeformMicroWaveEvaporation=2;
var DoTrapDeformmicrowaveEvaporation:array [1..MaxTrapDeformMicroWaveEvaporation] of boolean;
    IoffeMicroWaveStartFrequence0:array [1..MaxTrapDeformMicroWaveEvaporation] of double;
    IoffeMicroWaveStopFrequence0:array [1..MaxTrapDeformMicroWaveEvaporation] of double;
    IoffeMicroWaveUseSynth1:array[1..MaxTrapDeformMicroWaveEvaporation] of boolean;
    IoffeMicroWaveStartFrequence1:array [1..MaxTrapDeformMicroWaveEvaporation] of double;
    IoffeMicroWaveStopFrequence1:array [1..MaxTrapDeformMicroWaveEvaporation] of double;
    EvaporationEndBarCurrent:array [1..MaxTrapDeformMicroWaveEvaporation] of double;
    EvaporationEndCompCurrent:array [1..MaxTrapDeformMicroWaveEvaporation] of double;
    EvaporationEndBiasCurrent:array [1..MaxTrapDeformMicroWaveEvaporation] of double;
    EvaporationEndPinchOffsetCurrent:array [1..MaxTrapDeformMicroWaveEvaporation] of double;
    IoffeEvaporationTime:array [1..MaxTrapDeformMicroWaveEvaporation] of double;

    {CompressedIoffeWaitTime:double;}

    DoIoffeEvaporation1:Boolean;
    DoIoffeEvaporation2:Boolean;
    DoIoffeEvaporation3:boolean;
    DoIoffeEvaporation4:boolean;
    DoQuadrupolEvaporation:Boolean;
    DoQPEvaporationbeforecompression:Boolean;

    DoQPDopplerCooling:boolean;
    QPDCRepumpDetuning:double;
    QPDCPrincipalDetuning:double;
    QPDCIntensity:double;
    QPDCTime:double;


    MagTrapTime:Double;
    DoShortMagTrapTime:Boolean;
    DoTransferQuadrupolExpansion:Boolean;
    TransferQuadrupolExpansionTime:double;
    TransferQuadrupolEndCurrent:double;
    DoIoffeBarRamp:Boolean;
    IoffeBarRampEndCurrent:double;
    IoffeBarRampTime:double;
    DoTransferQuadrupolDeformation:Boolean;
    DoHopAtOnce:Boolean;
    BarCurrentAfterHop:Double;
    DeformationPercent:double;
    DoRampMOTCoilsOff:boolean;
    RampMOTCoilsOffTime:double;

    MinimumVerticalGradiant:double;
    EndDeformationTransferCurrent:double;
    EndDeformationBarCurrent:double;
    {TransferGradiantZ_Ampere:double;
    IoffeGradiant_Ampere:double;}
    DeformationTime:double;

    Slower6PrincipalDetuning:Double;
    Slower6RepumpDetuning:Double;
    Slower7PrincipalDetuning:Double;
    Slower7RepumpDetuning:Double;
    SlowerOffTime:Double;
    SlowerCurrent:Double;
    Probe6Offset:Double;
    Probe7Offset:Double;
    Probe6PrincipalDetuning:Double;
    Probe6RepumpDetuning:Double;
    Probe7PrincipalDetuning:Double;
    Probe7RepumpDetuning:Double;


    ChargingTime:Double;
    FluoStoppedCharging:boolean;
    FluoEndLevel:double;
    FluoStopped6LiCharging:boolean;
    DeltaFluoStopped6LiCharging:boolean;
    Fluo7LiEndLevel:double;
    Fluo6LiEndLevel:double;
    Added6LiChargingTime:double;
    DeChargingTime:Double;
    ExpansionTime6:Double;
    ExpansionTime7:Double;

    TrapLithium6:Boolean;
    TrapLithium7:Boolean;
    DetectIsotop:Integer;
    CameraPosition:Integer;
    SlowLithium6:Boolean;
    SlowLithium7:Boolean;
    TwoPictures:Boolean;
    TwoPicturesOfSameIsotop:Boolean;
    PictureFirstWithoutThenWithRepump:Boolean;
    DisinjectUnusedRepumper:Boolean;
    AtomCleaningTime:double;
    NoisePictureMode:Integer;

    Probe6MOTIntensity:double;
    Probe7MOTIntensity:double;
    Probe6IoffeIntensity:double;
    Probe7IoffeIntensity:double;

    Li6ProbeToIoffe:double;
    Li6ProbeToMOT:double;
    ProbeMixed:double;

    DechargeMOT:Boolean;
    ProbeWithRepump:Boolean;
    DoRepumpBeforeProbe:boolean;
    InjectProbeRepumpLast:boolean;
    PictureWithTrapOn:Boolean;
    DelayOpticalTrapOffTime:double;
    PictureWithOpticalTrapOn:Boolean;
    SwitchOpticalTrapOffFirst:boolean;
    SwitchOffOnlyVerticalBeam:boolean;
    PictureWithRadialConfinementOn:boolean;
    AxialConfinementOffTime:double;
    PictureWithAxialConfinementOn:boolean;
    SternGerlachTime:double;
    FreeFlightTime:double;
    MOTGuidingFieldOn:Boolean;
    IoffeGuidingFieldOn:Boolean;
    MOTGuidingFieldRaiseTime:double;
    IoffeGuidingFieldRaiseTime:double;
    NumberOfPictures:integer;
    VisionCalculationTime:Double;
    SecurityTime:Double;
    DoHeatupCycle:boolean;
    HeatupTime:double;
    HeatupBarCurrent:double;
    HeatupPinchCurrent:double;
    DoHideDetuning:boolean;
    HideProbe7PrincipalDetuning:double;
    HideProbe6PrincipalDetuning:double;
    DoHideMagField:boolean;
    HideMagFieldAfterPictureNr:integer;
    HideFieldPinchCurrent:double;
    HideFieldPinchVoltage:double;

    AndorEichX:double;
    AndorEichY:Double;
    AndorStartX:integer;
    AndorStartY:integer;
    AndorWidth:integer;
    AndorHeight:integer;
    AndorBiningX:integer;
    AndorBiningY:integer;
    AndorTemperature:double;
    AndorHorizontalSpeed:integer;
    AndorTriggerDelay:double;
    Andor7LiExposureTime:Double;
    Andor6LiExposureTime:Double;
    AndorFastKineticSeries:boolean;
    AndorFKSShiftSpeed:integer;
    AndorFKSExposedRows:integer;
    AndorFKSImages:integer;
    AndorFKSExposureTime:double;
    PictureSplitting:boolean;
    PictureSplittingDelay:double;
    AndorFKSPictureDistance:integer;
    AndorFKSPictureOffset:integer;
    AndorFKSPictureHeight:integer;
    AndorFKSSoftBining:integer;
    AndorFKSTriggerMode:boolean;

    AndorTriggerCalibrationAbsorption:double;
    AndorTriggerCalibrationProbeNoise:double;
    AndorPreTriggerDelay:double;
    AndorStartExposureSecurityTime:double;

    MatroxEichX:double;
    MatroxEichY:Double;
    MatroxStartX:integer;
    MatroxStartY:integer;
    MatroxWidth:integer;
    MatroxHeight:integer;
    MatroxBiningX:integer;
    MatroxBiningY:integer;
    MatroxMode:integer;
    MatroxGain:double;
    MatroxOffset:Double;
    Matrox7LiExposureTime:Double;
    Matrox6LiExposureTime:Double;
    MatroxWait:double;


{    T2D,T20,T1D,T10:double;
    Tnr1,Tnr2,Tnr3:integer;}

    IdleTime:integer;

    BigMeasurementTemp:boolean;
    BigMeasurementSigma:boolean;
    BigMeasurementNumber:boolean;
    BigMeasurementNumberFlight:double;
    BigMeasurementSigmaDetuning:double;
    MeasurementStartPoint:integer;
    FluorescenceMax:double;
    FluorescenceMin:double;

    UniMessFileName:string;
    SetupsFileName:string;
    DebugFileName:string;
    DoDebug:boolean;
    DebugAsOszilloskop:boolean;
    OriginOffset:boolean;
    ShutterProbeAndRepumpDelay:double;
    ProbeAOMOffTimeBeforeShutterOpen:double;
    ProbeAOMsDefaultOn:boolean;
    KeepInjection:boolean;
    KeepMasterAOMsOn:boolean;
    KeepMOTAOMOn:boolean;
    DoSwitchMaster7PrincipalOff:boolean;
    MOTShutterDelay:double;

    MOTCoilGradiant:double;
    TransferCoilGradiant:double;
    BarGradiant:double;
    PinchCurbature:double;
    PinchOffset:double;
    BiasFieldCurrentOffset:double;
    CompensationOffset:double;
    MeasuredOffset:double;
    Measured7LiOffsetFrequency:double;

    Remote:boolean;
    MeasureQueueDirectory:string;
    MeasureQueueRemoteDirectory:string;
    ConfigurationsDirectory:string;
    AkkusticFluorescence:boolean;
    Fluo6Delay:double;

type TFinalTrap=(MOT,QP,IoffePritchard);
     TFinalPosition=(LowerTrap,HigherTrap);
const ConfigFileName='Lithium.cfg';
      MainDir='c:\Lithium\';
      singleswitchIGBTS:boolean=false;
      FinalTrap:string='MOT';
      FinalTrapBarCurrent:double=0;
      FinalTrapMOTCurrent:double=0;
      FinalTrapTransferCurrent:double=0;
      FinalTrapPinchOffsetCurrent:double=0;
      FinalTrapType:TFinalTrap=MOT;
      FinalPosition:TFinalPosition=LowerTrap;
      FinalTrapIsOpticalTrap:boolean=FALSE;
      LoadingTime:double=0;
      AtomPath:string='';

procedure SaveParameters(Dir:string);
procedure LoadParameters(Dir:string);
var DummyReg:PRegistry;

implementation
uses exp,ShutDown;

procedure SaveParameters(Dir:string);
var n:byte;
begin
  if Registry<>nil then Registry^.SaveVariables(Dir+ConfigFileName);
  for n:=1 to MaxRFSweep do
   if RFSweepData[n]<>nil then RFSweepData[n]^.Save(Dir+RFSweepFileName[n]);
  if UniMeasure<>Nil then UniMeasure^.Save(Dir+UniMessFileName);
end;

procedure LoadParameters(Dir:string);
var n:byte;
begin
  Registry^.LoadVariables(Dir+ConfigFileName);
  if Unimeasure<>nil then dispose(unimeasure,done);
  Unimeasure:=LoadUniMess(Dir+UniMessFileName,Registry);
  for n:=1 to MaxRFSweep do
   RFSweepData[n]^.Load(Dir+RFSweepFileName[n]);
end;

var oldexitproc:pointer;

procedure myExitProc;far;
var n:byte;
begin
  exitproc:=oldexitproc;
  SaveParameters(MainDir);
  ShutDownSuccessFull;
  for n:=1 to MaxRFSweep do
   if RFSweepData[n]<>NIL then dispose(RFSweepData[n],done);
  if UniMeasure<>Nil then dispose(unimeasure,done);
  if Registry<>NIL then dispose(Registry,done(true));
end;

Procedure RegisterDouble(acolor:byte;ap:DoublePtr;ainit:double;
  amin:double;amax:double;aname:string;aquestion:string);
begin
  Registry^.Insert(new(PRegDouble,init(ap,aname,ainit,amin,amax,aquestion,acolor)));
end;

Procedure RegisterInteger(acolor:byte;ap:IntPtr;ainit:integer;
  amin:integer;amax:integer;aname:string;aquestion:string);
begin
  Registry^.Insert(new(PRegInt,init(ap,aname,ainit,amin,amax,aquestion,acolor)));
end;

Procedure RegisterBoolean(acolor:byte;ap:boolPtr;ainit:boolean;aname:string;aquestion:string);
begin
  Registry^.Insert(new(PRegBoolean,init(ap,aname,ainit,aquestion,acolor)));
end;

Procedure RegisterString(acolor:byte;ap:StringPtr;ainit:string;aname:string;aquestion:string);
begin
  Registry^.Insert(new(PRegString,init(ap,aname,ainit,aquestion,acolor)));
end;

Procedure SRegisterDouble (acolor:byte;ap:DoublePtr;ainit:double;aname:string;aquestion:string);
begin
  Registry^.Insert(new(PRegDouble,init(ap,aname,ainit,0,0,aquestion,acolor)));
end;

Procedure SRegisterInteger(acolor:byte;ap:IntPtr;ainit:integer;aname:string;aquestion:string);
begin
  Registry^.Insert(new(PRegInt,init(ap,aname,ainit,0,0,aquestion,acolor)));
end;

procedure Dummy;far;
begin
end;

var n:byte;
    buf:string[3];
const DummyDouble:double=0;
procedure RegisterParameters1;
begin
  DummyReg:=new(PRegistry,init(@Registry,nil,true,'Slower and AOM Parameters',SlowerUpdate));

  RegisterDouble (StdtColor,@Slower7PrincipalDetuning, -460 ,-2000,0 ,
    'Slower7PrincipalDetuning','7Li Slower Principal Detuning [MHz]');
  RegisterDouble (StdtColor,@Slower7RepumpDetuning, -460  ,-1000,0,'Slower7RepumpDetuning','7Li Slower Repump Detuning [MHz]');
  RegisterDouble (StdtColor,@Slower6PrincipalDetuning, -460  ,-1000,0,
    'Slower6PrincipalDetuning','6Li Slower Principal Detuning [MHz]');
  RegisterDouble (StdtColor,@Slower6RepumpDetuning, -460 ,-1000,0 ,'Slower6RepumpDetuning','6Li Slower Repump Detuning [MHz]');

  RegisterDouble (StdtColor,@SlowerOffTime, 50  ,0,10000,
    'SlowerOffTime','Delay between shutting Slower off and using MOT [ms]');
  RegisterDouble (StdtColor,@SlowerCurrent, 20  ,0,50,'SlowerCurrent','Slower Current [A]');
  RegisterInteger(StdtColor,@IdleTime, 1,0,10000  ,'IdleTime','Close Shutter after x seconds.');
  RegisterDouble (StdtColor,@AOM0Frequency,   80 ,60,260,'AOM0Frequency','AOM0 Frequency [MHz]');
  RegisterDouble (StdtColor,@AOM10Frequency, -90 ,60,260,'AOM10Frequency','AOM10 Frequency [MHz]');
  RegisterDouble (StdtColor,@AOM12Frequency, -80 ,-150,-60,'AOM12Frequency','AOM12 Frequency [MHz]');
  RegisterDouble (StdtColor,@AOM20MOTFrequency,  80 ,60,150,'AOM20MOTFrequency','AOM20 MOT Frequency [MHz]');
  RegisterDouble (StdtColor,@AOM20DopplerCoolFrequency,  100 ,60,150,
    'AOM20DopplerCoolFrequency','AOM20 doppler cool frequency [MHz]');
  RegisterDouble (StdtColor,@AOM21Frequency, 120 ,60,150,'AOM21Frequency','AOM21 Frequency [MHz]');
  RegisterDouble (StdtColor,@AOM22Frequency, 120 ,60,150,'AOM22Frequency','AOM22 Frequency [MHz]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'MOT and CMOT Parameters',MOTUpdate));

  RegisterDouble (StdtColor,@MOT7PrincipalDetuning,-42,-100,0,'MOT7PrincipalDetuning',
    '7Li MOT Principal Detuning [MHz]');
  RegisterDouble (StdtColor,@MOT7RepumpDetuning,-35,-100,0,'MOT7RepumpDetuning','7Li MOT Repump Detuning [MHz]');
  RegisterDouble (StdtColor,@MOT6PrincipalDetuning,-37,-100,100,'MOT6PrincipalDetuning','6Li MOT Principal Detuning [MHz]');
  RegisterDouble (StdtColor,@MOT6RepumpDetuning, -30  ,-100,100,'MOT6RepumpDetuning','6Li MOT Repump Detuning [MHz]');
  RegisterDouble (StdtColor,@MOTIntensity, 0.6,0,1  ,'MOTIntensity','MOT Intensity [0..1]');
  RegisterDouble (StdtColor,@MOTMOTCurrent, 500,0,500 ,'MOTMOTCurrent','MOT current in MOT coils [0..500 A]');
  RegisterDouble (StdtColor,@MOTMOTVoltage, 1.5,0,30  ,'MOTVoltage','MOT Voltage [0..20 V]');
  RegisterDouble (StdtColor,@MOTTransfer2Voltage, 2.3,0,20  ,
    'MOTTransfer2Voltage','MOT voltage in transfer2 power supply [0..20 V]');
  RegisterDouble (StdtColor,@MOTTransferOffTime, 0,0,1000  ,'MOTTransferOffTime','Time to switch off transfer coils [ms]');
  RegisterBoolean(MarkColor,@DoShiftMOT,         False ,'DoShiftMOT'   ,'Shift the MOT ? [Yes/No]');
  RegisterDouble (StdtColor,@MOTShiftTime, 0 ,0,1000 ,'MOTShiftTime',
    'Time to wait for MOT to shift [ms]');
  RegisterBoolean(MarkColor,@DoCMOT,         True ,'DoCMOT'   ,'Do CMOT ? [Yes/No]');
  RegisterDouble (StdtColor,@CMOT7PrincipalDetuning, -17.53,-100,100  ,
    'CMOT7PrincipalDetuning','7Li CMOT Principal Detuning [MHz]');
  RegisterDouble (StdtColor,@CMOT7RepumpDetuning, -18 , -100,100 ,'CMOT7RepumpDetuning','7Li CMOT Repump Detuning [MHz]');
  RegisterDouble (StdtColor,@CMOT6PrincipalDetuning, -18 , -100,100,
    'CMOT6PrincipalDetuning','6Li CMOT Principal Detuning [MHz]');
  RegisterDouble (StdtColor,@CMOT6RepumpDetuning, -18 , -100,100,'CMOT6RepumpDetuning','6Li CMOT Repump Detuning [MHz]');
  RegisterDouble (StdtColor,@CMOTIntensity, 1 ,0,1 ,'CMOTIntensity','CMOT Intensity [0..1]');
  RegisterDouble (StdtColor,@CMOTMOTVoltage, 3  ,0,30,'CMOTMOTVoltage','CMOT Voltage [0..20 V]');
  RegisterDouble (StdtColor,@CMOTTime, 0  ,0,10000,'CMOTTime','CMOT Time [ms]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Molasses & HF pumping Parameters',Dummy));

  RegisterBoolean(MarkColor,@DoShiftMOThorizontal,         False ,'DoShiftMOThorizontal'   ,
    'Shift the MOT horizontaly ? [Yes/No]');
  RegisterDouble (StdtColor,@ShiftMOThorizontalCurrent, 0 ,0,50 ,
    'ShiftMOThorizontalCurrent','Shift MOT horizontal Current [A]');
  RegisterBoolean(MarkColor,@DoMolasses,         True ,'DoMolasses'   ,'Do Molasses ? [Yes/No]');
  RegisterDouble (StdtColor,@Molasses7PrincipalDetuning, -18,-100,0  ,
    'Molasses7PrincipalDetuning','7Li Molasses Principal Detuning [MHz]');
  RegisterDouble (StdtColor,@Molasses7RepumpDetuning, -18  ,-100,0,
    'Molasses7RepumpDetuning','7Li Molasses Repump Detuning [MHz]');

  RegisterDouble (StdtColor,@Molasses6PrincipalDetuning, -18 ,-100,0 ,
     'Molasses6PrincipalDetuning','6Li Molasses Principal Detuning [MHz]');
  RegisterDouble (StdtColor,@Molasses6RepumpDetuning, -18 ,-100,0 ,
    'Molasses6RepumpDetuning','6Li Molasses Repump Detuning [MHz]');
  RegisterDouble (StdtColor,@MolassesIntensity, 1  ,0,1,'MolassesIntensity','MolassesIntensity');
  RegisterDouble (StdtColor,@MolassesTime, 0  ,0,1000,'MolassesTime','Molasses Time [ms]');
  RegisterBoolean(StdtColor,@MolassesWithGuidingField, False,
    'MolassesWithGuidingField','Molasses With Guiding Field [Yes/No]');
  RegisterBoolean(StdtColor,@MolassesWithMOTField, False,'MolassesWithMOTField','Molasses With MOT Field [Yes/No]');
  RegisterDouble (StdtColor,@MolassesFieldOffTime, 0  ,0,1000,'MolassesFieldOffTime','Time to wait to switch off fields [ms]');
  RegisterBoolean(MarkColor,@DoHyperfinePumping, False,'DoHyperfinePumping','Do Hyperfine Pumping ? [Yes/No]');
  RegisterDouble (StdtColor,@Repump6LiOffTime, -0.2 ,-1000,1000 ,'Repump6LiOffTime',
    'Time to switch 6Li repumpers off before switching off MOT [ms]');
  RegisterDouble (StdtColor,@Repump7LiOffTime, -0.2 ,-1000,1000 ,'Repump7LiOffTime',
    'Time to switch 7Li repumpers off before switching off MOT [ms]');
  RegisterDouble (StdtColor,@HyperfinePumping7LiPrincipalDetuning, -17.53,-100,100  ,
    'HyperfinePumping7PrincipalDetuning','7Li Principal Detuning [MHz]');
  RegisterDouble (StdtColor,@HyperfinePumping7LiRepumpDetuning, -18 , -100,100 ,
    'HyperfinePumping7LiRepumpDetuning','7Li Repump Detuning [MHz]');
  RegisterDouble (StdtColor,@HyperfinePumping6LiPrincipalDetuning, -18 , -100,100,
    'HyperfinePumping6LiPrincipalDetuning','6Li Principal Detuning [MHz]');
  RegisterDouble (StdtColor,@HyperfinePumping6LiRepumpDetuning, -18 , -100,100,
    'HyperfinePumping6LiRepumpDetuning','6Li Repump Detuning [MHz]');
  RegisterDouble (StdtColor,@HyperfinePumpingIntensity, 0.6 , 0,1,
    'HyperfinePumpingIntensity','Hyperfine Pumping Intensity [0..1]');
  RegisterBoolean(StdtColor,@HyperfinePumpingWithMOTField, False ,
    'HyperfinePumpingWithMOTField'   ,'MOT field on during Hyperfine Pumping ? [Yes/No]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Optical pumping Parameters',Dummy));

  RegisterBoolean(MarkColor,@DoOpticalPumping,         False ,'DoOpticalPumping'   ,'Do optical pumping ? [Yes/No]');
  RegisterBoolean(StdtColor,@PumpToF_2,         False ,'PumpToF_2'   ,'Pump To F=2 ? [Yes/No]');
  RegisterBoolean(StdtColor,@Use7RepumpForOpticalPumping,         True ,'Use7RepumpForOpticalPumping'   ,
    'Use 7Li repump for optical pumping ? [Yes/No]');
  RegisterBoolean(StdtColor,@Use6RepumpForOpticalPumping,         True ,'Use6RepumpForOpticalPumping'   ,
    'Use 6Li repump for optical pumping ? [Yes/No]');
  RegisterDouble (StdtColor,@OpticalPumpingToggleFieldTime, 0 ,0,1000 ,'OpticalPumpingToggleFieldTime',
    'Time to wait for magnetic field to stabilize [ms]');
  RegisterDouble (StdtColor,@OpticalPumpingTime, 0 ,0,1000 ,'OpticalPumpingTime',
    'Time to repump [ms]');
  RegisterDouble (StdtColor,@OpticalPumping7repumpDetuning, 0 ,-100,100 ,'OpticalPumping7repumpDetuning',
    'Optical Pumping 7Li repump detuning [MHz]');
  RegisterDouble (StdtColor,@OpticalPumping6repumpDetuning, 0 ,-100,100 ,'OpticalPumping6repumpDetuning',
    'Optical Pumping 6Li repump detuning [MHz]');
  RegisterDouble (StdtColor,@OpticalPumping7LiRepumpAloneTime, 0 ,-100,100 ,'OpticalPumping7LiRepumpAloneTime',
    'Time to pump only with 7Li repump (may be negative) [ms]');
  RegisterDouble (StdtColor,@MOT7LiPrincipalFlashTime, 0 ,-1000,1000 ,'MOT7LiPrincipalFlashTime',
    'MOT 7Li Principal Flash Time (may be negative) [ms]');
  RegisterBoolean(StdtColor,@Do6LiRepumpFlash,         True ,
    'Do6LiRepumpFlash'   ,'Do 6Li Repump Flash ? [Yes/No]');
  RegisterDouble (StdtColor,@Flash7PrincipalDetuning, 0 ,-100,100 ,'Flash7PrincipalDetuning',
    'Flash 7Principal Detuning [ms]');
  RegisterDouble (StdtColor,@Flash7RepumpDetuning, 0 ,-100,100 ,'Flash7RepumpDetuning',
    'Flash 7Repump Detuning [ms]');
  RegisterDouble (StdtColor,@FlashIntensity, 0 ,0,1 ,'FlashIntensity',
    'Flash Intensity [0..1]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Magnetic Trap Parameters 1',Dummy));

  RegisterBoolean(MarkColor,@DoMagTrap,         True ,'DoMagTrap'   ,'Do magnetic trapping ? [Yes/No]');
  RegisterBoolean(StdtColor,@RFShieldDuringMagTrap,         True ,'RFShieldDuringMagTrap'   ,
    'RF Shield During Mag Trap ? [Yes/No]');
  RegisterBoolean(StdtColor,@RFShieldAntenna,         True ,'RFShieldAntenna'   ,'RF Shield Antenna ? [Yes=RF/No=wave]');
  RegisterDouble (StdtColor,@RFShieldFrequency0, 0 ,0,1000 ,'RFShieldFrequency0',
    'RF Shield Frequency for Synthesizer 0 [MHz]');
  RegisterDouble (StdtColor,@RFShieldFrequency1, 0 ,0,1000 ,'RFShieldFrequency1',
    'RF Shield Frequency for Synthesizer 1 [MHz,0=OFF]');

  RegisterBoolean(MarkColor,@DoProtectMagTrap,         True ,'DoProtectMagTrap'   ,'Protect magnetic trap ? [Yes/No]');
  RegisterDouble (StdtColor,@UnProtectMagTrapStabilizationTimeInjection, 100 ,
    0,100000 ,'InjectionUnProtectMagTrapStabilizationTime',
    'Un Protect MagTrap Stabilization Time for Injection [ms]');
  RegisterDouble (StdtColor,@UnProtectMagTrapStabilizationTime, 100 ,0,100000 ,'UnProtectMagTrapStabilizationTime',
    'Un Protect MagTrap Stabilization Time [ms]');
  RegisterDouble (StdtColor,@MagTrapTime, 2000 ,0,900000 ,'MagTrapTime','Magnetic trap time [ms]');
  RegisterBoolean(MarkColor,@DoShortMagTrapTime,         True ,'DoShortMagTrapTime'   ,'Short Mag Trap Time? [Yes/No]');
  RegisterDouble (MarkColor,@RecaptureTime,    0 ,0,10000,'RecaptureTime'   ,'Time of recapture in MOT ? [ms]');
  RegisterBoolean(StdtColor,@MeasureRecaptureFluo,         True ,
    'MeasureRecaptureFluo'   ,'Measure Recapture Fluo ? [Yes/No]');

  RegisterDouble (StdtColor,@MagTrapStartMOTVoltage, 0 ,0,30 ,'MagTrapStartMOTVoltage',
    'Magnetic Trap Start MOT coils Voltage [0..30 V]');
  RegisterDouble (StdtColor,@MagTrapMOTVoltage, 0 ,0,30 ,'MagTrapMOTVoltage','Magnetic Trap MOT coils Voltage [0..30 V]');
  RegisterDouble (StdtColor,@MagTrapStartTime, 0 ,0,20 ,'MagTrapStartTime','Magnetic Trap start time [ms]');
  RegisterDouble (StdtColor,@OpticalPumpingFieldOverlapTime, 0 ,0,20 ,'OpticalPumpingFieldOverlapTime',
    'Optical pumping field overlap time [ms]');

  RegisterDouble (StdtColor,@MagTrapTransfer2Voltage, 0,0,30  ,
    'MagTrapTransfer2Voltage','Magnetic Trap Transfer 2 Voltage [0..30 V]');
  RegisterBoolean(MarkColor,@DoCleaning,         False ,'DoCleaning'   ,'Do cleaning ? [Yes/No]');
  RegisterDouble (StdtColor,@CleaningSweepTime, 100  ,0,5000,'CleaningSweepTime','Cleaning sweep time [ms]');
  RegisterDouble (StdtColor,@CleaningVoltage1, 8  ,0,30,'CleaningVoltage1',
    'Magnetic Trap MOT voltage 1 for cleaning [0..30 V]');
  RegisterDouble (StdtColor,@CleaningTime1, 100  ,0,500000,'CleaningTime1','Cleaning time at voltage 1 [ms]');
  RegisterDouble (StdtColor,@CleaningVoltage2, 8  ,0,30,'CleaningVoltage2',
    'Magnetic Trap MOT voltage 2 for cleaning [0..30 V]');
  RegisterDouble (StdtColor,@CleaningTime2, 100  ,0,500000,'CleaningTime2','Cleaning time at voltage 2 [ms]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Magnetic Trap Parameters 2',Dummy));

  RegisterBoolean(MarkColor,@DoCompressedMagTrap,         True ,'DoCompressedMagTrap'   ,'compress magnetic trap ? [Yes/No]');

  RegisterBoolean(MarkColor,@DoDeCompressMagTrapBeforeTransfer,         True ,'DoDeCompressMagTrapBeforeTransfer'   ,
    'decompress magnetic trap before transfer ? [Yes/No]');

  RegisterDouble (StdtColor,@MagTrapMOTVoltageCompressed, 0,0,30  ,
    'MagTrapMOTVoltageCompressed','Magnetic Trap MOT Voltage after compression [0..30 V]');
  RegisterDouble (StdtColor,@CompressMagTrapTime, 2000 ,0,100000 ,'CompressMagTrapTime','Magnetic trap compression time [ms]');
  RegisterDouble (StdtColor,@MagTrapMOTVoltageDeCompressed, 0,0,30  ,
    'MagTrapMOTVoltageDeCompressed','Magnetic Trap MOT Voltage after decompression [0..30 V]');
  RegisterDouble (StdtColor,@DeCompressMagTrapTime, 2000 ,0,10000 ,
    'DeCompressMagTrapTime','Magnetic trap decompression time [ms]');
  RegisterDouble (StdtColor,@InitialMagTrapWaitTime, 0 ,0,10000 ,'InitialMagTrapWaitTime','Initial MagTrap Wait Time [ms]');

  RegisterBoolean(MarkColor,@DoAddCurrent,         True ,'DoAddCurrent'   ,
    'Add current with transfer power supplies ? [Yes/No]');
  RegisterDouble (StdtColor,@LowerMagTrapMOTVoltageRampTime1, 20 ,0,1000 ,'LowerMagTrapMOTVoltageRampTime1',
    'Lower MagTrap MOT Voltage Ramp Time 1 [ms]');
  RegisterDouble (StdtColor,@AddCurrentMOTVoltageRamp1MOTEndVoltage, 0,0,30  ,
    'AddCurrentMOTVoltageRamp1MOTEndVoltage','Add Current MOT Voltage Ramp1 MOT End Voltage [0..30 V]');
  RegisterDouble (StdtColor,@LowerMagTrapMOTVoltageRampTime2, 20 ,0,1000 ,'LowerMagTrapMOTVoltageRampTime2',
    'Lower MagTrap MOT Voltage Ramp Time 2 [ms]');
  {RegisterDouble (StdtColor,@AddCurrentStartVoltage, 0,0,20  ,
    'AddCurrentStartVoltage','Start Voltage for transfer power supply [0..20 V]');}
  RegisterDouble (StdtColor,@LowerMagTrapTransferVoltageRampTime, 20 ,0,1000 ,'LowerMagTrapTransferVoltageRampTime' ,
    'Lower MagTrap Transfer Voltage Ramp Time [ms]');
  RegisterDouble (StdtColor,@MaxTotalLowerMagTrapCurrent, 0 ,0,1000 ,
    'MaxTotalLowerMagTrapCurrent','Final mag trap current [0..1000 A]');
  RegisterDouble (StdtColor,@LowerMagTrapCurrentRampTime1, 100 ,0,100000 ,'LowerMagTrapCurrentRampTime1' ,
    'Lower MagTrap current ramp time 1 [ms]');
  RegisterDouble (StdtColor,@LowerMagTrapCurrentRampTime2, 100 ,0,100000 ,'LowerMagTrapCurrentRampTime2' ,
    'Lower MagTrap current ramp time 2 [ms]');
  RegisterDouble (StdtColor,@AddedCurrentWaitTime, 0 ,0,100000 ,'AddedCurrentWaitTime','Added Current Wait Time [ms]');
  RegisterBoolean(MarkColor,@DoQuadrupolEvaporation,True ,'DoQuadrupolEvaporation'   ,
    'Do evaporation in quadrupol potential ? [Yes/No]');
  RegisterBoolean(MarkColor,@DoQPEvaporationbeforecompression,True ,'DoQPEvaporationbeforecompression'   ,
    'Do QP Evaporation before compression ? [Yes/No]');
  RegisterBoolean(MarkColor,@DoQPDopplerCooling,True ,'DoQPDopplerCooling'   ,
    'Do Doppler Cooling in QP ? [Yes/No]');
  RegisterDouble (StdtColor,@QPDCRepumpDetuning, 0 ,-100,100 ,
    'QPDCRepumpDetuning','QP DC Repump Detuning [MHz]');
  RegisterDouble (StdtColor,@QPDCPrincipalDetuning, 0 ,-100,100 ,
    'QPDCPrincipalDetuning','QP DC Principal Detuning [MHz]');
  RegisterDouble (StdtColor,@QPDCIntensity, 0 ,0,1 ,
    'QPDCIntensity','QP DC Intensity [0..1]');
  RegisterDouble (StdtColor,@QPDCTime, 0 ,0,1000 ,
    'QPDCTime','QP DC Time [ms]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Transfer Parameters',Dummy));

  RegisterBoolean(MarkColor,@DoTranslateMagTrap,         True ,'DoTranslateMagTrap'   ,'Do Translate MagTrap? [Yes/No]');
  RegisterDouble (StdtColor,@SlowerCompensationRampTime, 0,0,3000  ,
    'SlowerCompensationRampTime','SlowerCompensationRampTime [ms]');
  for n:=0 to MaxSlowerCompCurrent do begin
    str(n,buf);
    RegisterDouble (StdtColor,@SlowerCompensationCurrent[n], 0,0,50  ,'SlowerCompensationCurrent'+buf,
      'SlowerCompensationCurrent '+buf+' [0..50 A]');
  end;
  RegisterDouble (StdtColor,@FinalSlowerEndRampTime, 0,0,3000  ,'FinalSlowerEndRampTime','Final Slower End Ramp Time [ms]');
  RegisterBoolean(MarkColor,@DoTransfer,         True ,'DoTransfer'   ,'Move magnetic trap ? [Yes/No]');
  RegisterBoolean(StdtColor,@DoTransferParabolic,         True ,'DoTransferParabolic'   ,'Do Transfer Parabolic ? [Yes/No]');
  RegisterDouble (StdtColor,@TransferPercent, 100,0,100  ,'TransferPercent','Do x % of transfer [x=0..100]');
  RegisterDouble (StdtColor,@StartBarsTransferPercent, 100,0,200  ,
    'StartBarsTransferPercent','Start Ioffe bars at x % of transfer [x=0..100]');
  RegisterDouble (StdtColor,@BarsTransferEndCurrent, 0,0,1000  ,
    'BarsTransferEndCurrent','Transfer end current in bars [0..1000 A]');
  RegisterBoolean(MarkColor,@ReverseMagTrap,    False ,'ReverseMagTrap'   ,'Reverse magnetic trapping ? [Yes/No]');
  RegisterDouble (StdtColor,@DeTransferPercent, 100,0,100  ,'DeTransferPercent','Do x % of detransfer [x=0..100]');
  RegisterDouble (StdtColor,@TransferTime, 2000 ,0,10000 ,'TransferTime','Transfer time [ms]');
  RegisterDouble (StdtColor,@TransferTimeRatio, 2 ,0,10 ,'TransferTimeRatio','Transfer time ratio');
  RegisterDouble (StdtColor,@TransferHalfWayWait, 0 ,0,10000 ,'TransferHalfWayWait','Transfer Half Way Wait time [ms]');
  RegisterDouble (MarkColor,@FinalMagTrapTime, 2000 ,0,100000 ,'FinalMagTrapTime','Final MagTrap Time [ms]');
  RegisterDouble (StdtColor,@MOTTransferStartCurrent, 0 ,0,500 ,
    'MOTTransferStartCurrent','Current in MOT coils at begin of transfer [0..500 A]');
  RegisterDouble (StdtColor,@MOTTransferEndCurrent, 0 ,0,500 ,
    'MOTTransferEndCurrent','Current in MOT coils at end of transfer [0..500 A]');
  RegisterDouble (StdtColor,@TransferCurrentMiddle, 0 ,0,500 ,
    'TransferCurrentMiddle','Current in transfer coils after parabolic ramp [0..500 A]');
  RegisterDouble (StdtColor,@TransferCurrentEnd, 0 ,0,500 ,'TransferCurrentEnd','Final current in transfer coils [0..500 A]');
  RegisterBoolean(MarkColor,@DoTransferQuadrupolExpansion,False ,'DoTransferQuadrupolExpansion'   ,
    'Do Transfer Quadrupol Expansion? [Yes/No]');
  RegisterDouble (StdtColor,@TransferQuadrupolExpansionTime, 2 ,0,30000 ,'TransferQuadrupolExpansionTime',
    'Transfer Quadrupol Expansion Time [ms]');
  RegisterDouble (StdtColor,@TransferQuadrupolEndCurrent, 0 ,0,500 ,'TransferQuadrupolEndCurrent',
    'Transfer Quadrupol expansion end current [0..500 A]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Deformation and Ioffe trap Parameters',Dummy));

  RegisterBoolean(MarkColor,@DoIoffeBarRamp,False ,'DoIoffeBarRamp'   ,
    'Do Ioffe Bar Ramp? [Yes/No]');
  RegisterDouble (StdtColor,@IoffeBarRampEndCurrent, 0 ,0,1000 ,'IoffeBarRampEndCurrent',
    'Ioffe Bar Ramp End Current [0..1000 A]');
  RegisterDouble (StdtColor,@IoffeBarRampTime, 2 ,0,30000 ,'IoffeBarRampTime',
    'Ioffe Bar Ramp Time [ms]');
  RegisterBoolean(MarkColor,@DoTransferQuadrupolDeformation,False ,'DoTransferQuadrupolDeformation'   ,
    'Do Transfer Quadrupol Deformation? [Yes/No]');
  RegisterDouble (StdtColor,@BarCurrentAfterHop, 0 ,0,1000 ,'BarCurrentAfterHop',
    'Bar Current After Hop [0..1000 A]');
  RegisterDouble (StdtColor,@EndDeformationTransferCurrent, 0 ,0,500 ,'EndDeformationTransferCurrent',
    'End deformation current in Transfer Coils [0..500 A]');
  RegisterDouble (StdtColor,@EndDeformationBarCurrent, 0 ,0,750 ,'EndDeformationBarCurrent',
    'End deformation current in Bars [0..750 A]');
  RegisterDouble (StdtColor,@DeformationTime, 2 ,0,30000 ,'DeformationTime',
    'Deformation Time [ms]');
  RegisterDouble (StdtColor,@DeformationPercent, 0 ,0,100 ,'DeformationPercent',
    'Deformation Percent [0..100%]');

  RegisterBoolean(MarkColor,@DoRampMOTCoilsOff,False ,'DoRampMOTCoilsOff'   ,
    'Do Ramp MOT Coils Off? [Yes/No]');
  RegisterDouble (StdtColor,@RampMOTCoilsOffTime, 2 ,0,30000 ,'RampMOTCoilsOffTime',
    'Ramp MOT Coils Off Time [ms]');

  {RegisterBoolean(MarkColor,@DoHopAtOnce,False ,'DoHopAtOnce'   ,
    'Do Hop At Once ? [Yes/No]');
  RegisterDouble (StdtColor,@BarCurrentAfterHop, 0 ,0,1000 ,'BarCurrentAfterHop',
    'Bar Current After Hop [0..1000 A]');
  RegisterDouble (StdtColor,@DeformationPercent, 0 ,0,100 ,'DeformationPercent',
    'Deformation Percent [0..100%]');
  RegisterDouble (StdtColor,@MinimumVerticalGradiant, 0 ,0,1000 ,'MinimumVerticalGradiant',
    'Minimum Vertical Gradiant [G/cm]');
  RegisterDouble (StdtColor,@EndDeformationCurrent, 0 ,0,500 ,'EndDeformationCurrent',
    'End deformation current in Transfer Coils [0..500 A]');
  RegisterDouble (StdtColor,@DeformationTime, 2 ,0,30000 ,'DeformationTime',
    'Deformation Time [ms]');
  RegisterDouble (StdtColor,@TransferGradiantZ_Ampere, 2 ,0,30000 ,'TransferGradiantZ_Ampere',
    'Transfer Gradiant Z par Ampere [G/cmA]');
  RegisterDouble (StdtColor,@IoffeGradiant_Ampere, 2 ,0,30000 ,'IoffeGradiant_Ampere',
    'Ioffe Gradiant par Ampere [G/cmA]');}

  RegisterBoolean(MarkColor,@DoIoffeTrap,         True ,'DoIoffeTrap'   ,'Use Ioffe trap ? [Yes/No]');
  RegisterDouble (StdtColor,@PinchCapacitorVoltageStart, 0 ,0,30 ,
    'PinchCapacitorVoltageStart','Start voltage for pinch capacitors [0..30 V]');
  RegisterDouble (StdtColor,@PinchStartTime, 0 ,0,2000 ,'PinchStartTime','Pinch Start time [ms]');
  RegisterDouble (StdtColor,@PinchCapacitorChargingTime, 0 ,0,20 ,
    'PinchCapacitorChargingTime','Pinch Capacitor Charging Time [ms]');
  RegisterDouble (StdtColor,@PinchVoltageStart, 0 ,0,30 ,'PinchVoltageStart','Start voltage for pinch coils [0..30 V]');
  RegisterDouble (StdtColor,@IoffeTrapStartTime, 0 ,0,2000 ,'IoffeTrapStartTime','Ioffe Trap Start time [ms]');
  RegisterDouble (StdtColor,@F2IoffeTrapBarStartCurrent, 0 ,0,1000 ,
    'F2IoffeTrapBarStartCurrent','Start current in Bars for F=2 [0..1000 A]');
  RegisterDouble (StdtColor,@F1QuadrupolDecayTime, 0 ,0,100 ,'F1QuadrupolDecayTime','Quadrupol Decay Time for F=1 [ms]');
  RegisterDouble (StdtColor,@F1IoffeTrapBarStartCurrent, 0 ,0,1000 ,
    'F1IoffeTrapBarStartCurrent','Start current in Bars for F=1 [0..1000 A]');
  RegisterDouble (StdtColor,@F1PinchStartTime, 0 ,0,100 ,'F1PinchStartTime','Pinch Start Time for F=1 [ms]');
  RegisterDouble (StdtColor,@F1PinchStartVoltage, 0 ,0,40 ,'F1PinchStartVoltage','Pinch Start Voltage for F=1 [0..40 V]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'CVCC Transition Parameters',Dummy));

  RegisterBoolean(MarkColor,@DoCompressIoffeTrapCV,         True ,'DoCompressIoffeTrapCV'   ,
    'Compress Ioffe Trap in CV mode ? [Yes/No]');
  RegisterDouble (StdtColor,@BarCompCVCurrent, 0 ,0,1000 ,
    'BarCompCVCurrent','Current in Bars after compression [0..1000 A]');
  RegisterDouble (StdtColor,@PinchCompCVVoltage, 0 ,0,15 ,
    'PinchCompCVVoltage','Voltage in Pinch after compression [0..15 V]');
  RegisterDouble (StdtColor,@IoffeCVCompressionTime, 0 ,0,100000 ,
    'IoffeCVCompressionTime','Ioffe CV Compression Time [ms]');
  RegisterBoolean(MarkColor,@DoIoffeCVCCTransition,         True ,
    'DoIoffeCVCCTransition'   ,'Do Ioffe CVCC transition ? [Yes/No]');
  RegisterDouble (StdtColor,@PinchCurrentAfterCVCCTransition, 0 ,0,500 ,
    'PinchCurrentEnd','Current in pinch coils after CVCC transition [0..500 A]');
  RegisterDouble (StdtColor,@PinchCVCCCurrentRampTime, 0 ,0,2000 ,
    'PinchCVCCCurrentRampTime','Pinch CVCC transition current ramp time [ms]');
  RegisterDouble (StdtColor,@PinchCVCCVoltageRampTime, 0 ,0,2000 ,
    'PinchCVCCVoltageRampTime','Pinch CVCC transition voltage ramp time [ms]');
  RegisterDouble (StdtColor,@BarCurrentAfterCVCCTransition, 0 ,0,1000 ,
    'BarCurrentAfterCVCCTransition','Bar current after CVCC transition [0..1000 A]');
  RegisterDouble (StdtColor,@BarCVCCCurrentRampTime, 0 ,0,100 ,
    'BarCVCCCurrentRampTime','Bar CVCC transition current ramp time [ms]');
  RegisterDouble (StdtColor,@BarCVCCVoltageRampTime, 0 ,0,100 ,
    'BarCVCCVoltageRampTime','Bar CVCC transition voltage ramp time [ms]');
  RegisterDouble (StdtColor,@TransferRaiseVoltageTime, 0 ,0,100 ,
    'TransferRaiseVoltageTime','Transfer Raise Voltage Time [ms]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Doppler cooling Parameters',Dummy));

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[1],         True ,
    'C1DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 1 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[1], 0 ,0,50000 ,
    'C1CompressIoffeTrapTime','Compress Ioffe Trap Time 1 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[1], 0 ,0,1000 ,'C1BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 1 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[1], 0 ,0,280 ,'C1BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 1 [0..280 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[1], 0 ,0,500 ,'C1CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 1 [0..500 A]');



  RegisterBoolean(MarkColor,@DoStartOpticalTrapHere1,         True ,
    'Nd1DoStartOpticalTrapHere'   ,'Start optical trap here (Params below) ? [Yes/No]');

  RegisterBoolean(MarkColor,@DoDopplerCoolIoffeTrap[1],         True ,
    'D1DoDopplerCoolIoffeTrap'   ,'Doppler cool Ioffe trap 1 ? [Yes/No]');
  RegisterBoolean(StdtColor,@DopplerCoolBeamIsPrincipal[1],         True ,
    'D1DopplerCoolBeamIsPrincipal'   ,'Doppler Cool Beam ? [Yes=Princ/No=Rep]');
  RegisterDouble (StdtColor,@DopplerCoolStartFrequency[1], 0 ,10,1000 ,
    'D1DopplerCoolStartFrequency','Doppler Cool Start Frequency [MHz]');
  RegisterDouble (StdtColor,@DopplerCoolStopFrequency[1], 0 ,0,1000 ,
    'D1DopplerCoolStopFrequency','Doppler Cool Stop Frequency [MHz]');
  RegisterDouble (StdtColor,@DopplerCoolIntensity[1], 0.6 ,0,1 ,
    'D1DopplerCoolIntensity','Doppler Cool Intensity [0..1]');
  RegisterDouble (StdtColor,@DopplerCoolTime[1], 0 ,0,50000 ,
    'D1DopplerCoolTime','Doppler cool time [ms]');
  RegisterDouble (StdtColor,@DopplerCoolRamp[1], 0 ,0,5000 ,
    'D1DopplerCoolRamp','Doppler cool ramp [ms]');

  RegisterDouble (MarkColor,@CompressedIoffeTrapWait0, 0 ,0,500000 ,
    'C0CompressedIoffeTrapWait','Compressed Ioffe Trap Wait 0 [ms]');

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[2],         True ,
    'C2DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 2 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[2], 0 ,0,500000 ,
    'C2CompressIoffeTrapTime','Compress Ioffe Trap Time 2 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[2], 0 ,0,1000 ,'C2BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 2 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[2], 0 ,0,280 ,'C2BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 2 [0..280 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[2], 0 ,0,500 ,'C2CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 2 [0..500 A]');

  RegisterBoolean(MarkColor,@DoStartOpticalTrapHere2,         True ,
    'Nd2DoStartOpticalTrapHere'   ,'Start optical trap here (Params below) ? [Yes/No]');

  RegisterBoolean(MarkColor,@DoDopplerCoolIoffeTrap[2],         True ,'D2DoDopplerCoolIoffeTrap'   ,
    'Doppler cool Ioffe trap 2 ? [Yes/No]');
  RegisterBoolean(StdtColor,@DopplerCoolBeamIsPrincipal[2],         True ,
    'D2DopplerCoolBeamIsPrincipal'   ,'Doppler Cool Beam 2 ? [Yes=Princ/No=Rep]');
  RegisterDouble (StdtColor,@DopplerCoolStartFrequency[2], 0 ,10,1000 ,'D2DopplerCoolStartFrequency',
    'Doppler Cool Start Frequency 2 [MHz]');
  RegisterDouble (StdtColor,@DopplerCoolStopFrequency[2], 0 ,0,1000 ,
    'D2DopplerCoolStopFrequency','Doppler Cool Stop Frequency 2 [MHz]');
  RegisterDouble (StdtColor,@DopplerCoolIntensity[2], 0.6 ,0,1 ,
    'D2DopplerCoolIntensity','Doppler Cool Intensity 2 [0..1]');
  RegisterDouble (StdtColor,@DopplerCoolTime[2], 0 ,0,50000 ,'D2DopplerCoolTime','Doppler cool time 2 [ms]');
  RegisterDouble (StdtColor,@DopplerCoolRamp[2], 0 ,0,5000 ,'D2DopplerCoolRamp','Doppler cool Ramp 2 [ms]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Doppler cooling Parameters 2',Dummy));

  RegisterDouble (MarkColor,@CompressedIoffeTrapWait, 0 ,0,500000 ,
    'CompressedIoffeTrapWait','Compressed Ioffe Trap Wait [ms]');

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[3],         True ,
    'C3DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 3 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[3], 0 ,0,50000 ,
    'C3CompressIoffeTrapTime','Compress Ioffe Trap Time 3 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[3], 0 ,0,1000 ,'C3BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 3 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[3], 0 ,0,250 ,'C3BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 3 [0..250 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[3], 0 ,0,500 ,'C3CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 3 [0..500 A]');

  RegisterBoolean(MarkColor,@DoStartOpticalTrapHere3,         True ,
    'Nd3DoStartOpticalTrapHere'   ,'Start optical trap here (Params below) ? [Yes/No]');

  RegisterBoolean(MarkColor,@DoAddPinchOffset,         True ,
    'DoAddPinchOffset'   ,'Add Pinch Offset ? [Yes/No]');
  RegisterDouble (StdtColor,@PinchOffsetCurrent, 0 ,0,30 ,
    'PinchOffsetCurrent','Pinch Offset Current [A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentRampTime, 0 ,0,5000 ,
    'PinchOffsetCurrentRampTime','Pinch Offset Current Ramp Time [ms]');

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[4],         True ,
    'C4DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 4 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[4], 0 ,0,50000 ,
    'C4CompressIoffeTrapTime','Compress Ioffe Trap Time 4 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[4], 0 ,0,1000 ,'C4BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 4 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[4], 0 ,0,250 ,'C4BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 4 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[4], 0 ,0,30 ,'C4PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 4 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[4], 0 ,0,500 ,'C4CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 4 [0..500 A]');
end;

procedure RegisterParameters2;
begin
  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Manipulate Ioffe Trap Parameters 1',Dummy));

  RegisterBoolean(MarkColor,@DoTrapDeformmicrowaveEvaporation[1],         False ,'E1DoTrapDeformmicrowaveEvaporation'   ,
    'Do trap deform micro wave Evaporation 1? [Yes/No]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStartFrequence0[1], 0 ,0,1000 ,'E1IoffeMicroWaveStartFrequency0',
    'Micro Wave Start Frequency Synthesizer 0 [0..1000 MHz]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStopFrequence0[1], 0 ,0,1000 ,'E1IoffeMicroWaveStopFrequency0',
    'Micro Wave Stop Frequency Synthesizer 0 [0..1000 MHz]');
  RegisterBoolean(StdtColor,@IoffeMicroWaveUseSynth1[1],         False ,'E1IoffeMicroWaveUseSynth1'   ,
    'Use Synthesizer 1 ? [Yes/No]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStartFrequence1[1], 0 ,0,1000 ,'E1IoffeMicroWaveStartFrequency1',
    'Micro Wave Start Frequency Synthesizer 1 [0..1000 MHz]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStopFrequence1[1], 0 ,0,1000 ,'E1IoffeMicroWaveStopFrequency1',
    'Micro Wave Stop Frequency Synthesizer 1 [0..1000 MHz]');
  RegisterDouble (StdtColor,@EvaporationEndBarCurrent[1], 0 ,0,1000 ,'E1EvaporationEndBarCurrent',
    'Evaporation Bar end Current 1 [0..1000 A]');
  RegisterDouble (StdtColor,@EvaporationEndBiasCurrent[1], 0 ,0,250 ,'E1EvaporationEndBiasCurrent',
    'Evaporation Bias end current [0..250 A]');
  RegisterDouble (StdtColor,@EvaporationEndPinchOffsetCurrent[1], 0 ,0,30 ,'E1EvaporationEndPinchOffsetCurrent',
    'Evaporation End Pinch Offset Current 1 [0..30 A]');
  RegisterDouble (StdtColor,@EvaporationEndCompCurrent[1], 0 ,0,500 ,'E1EvaporationEndCompCurrent',
    'Evaporation Compensation end Current [0..500 A]');
  RegisterDouble (StdtColor,@IoffeEvaporationTime[1], 0 ,0,1000 ,'E1IoffeEvaporationTime','Evaporation Time 1 [sec]');

  RegisterBoolean(MarkColor,@DoMicrowaveSweep[1],         False ,'E1DoMicrowaveSweep'   ,
    'Do micro wave sweep ? [Yes/No]');
  RegisterBoolean(StdtColor,@DoMicrowaveSweepSynth0[1],         False ,'E1S0DoMicrowaveSweepSynth0'   ,
    'Do micro wave sweep with synthesizer 0 ? [Yes/No]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStartFrequency0[1], 0 ,0,1000 ,'E1IoffeMicroWaveStartFrequency0',
    'Micro Wave Start Frequency Synthesizer 0 [0..1000 MHz]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStopFrequency0[1], 0 ,0,1000 ,'E1IoffeMicroWaveStopFrequency0',
    'Micro Wave Stop Frequency Synthesizer 0 [0..1000 MHz]');
  RegisterDouble (StdtColor,@IoffeMicroWavePower0[1], 0 ,-144,19 ,'E1IoffeMicroWavePower0',
    'Micro Wave Power 1 [dBm]');
  RegisterBoolean(StdtColor,@DoMicrowaveSweepSynth1[1],         False ,'E1DoMicrowaveSweepSynth1'   ,
    'Do micro wave sweep with synthesizer 1 ? [Yes/No]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStartFrequency1[1], 0 ,0,1000 ,'E1IoffeMicroWaveStartFrequency1',
    'Micro Wave Start Frequency Synthesizer 1 [0..1000 MHz]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStopFrequency1[1], 0 ,0,1000 ,'E1IoffeMicroWaveStopFrequency1',
    'Micro Wave Stop Frequency Synthesizer 1 [0..1000 MHz]');
  RegisterDouble (StdtColor,@IoffeMicroWavePower1[1], 0 ,-144,19 ,'E1IoffeMicroWavePower1',
    'Micro Wave Power 1 [dBm]');
  RegisterDouble (StdtColor,@IoffeMicroWaveSweepTime[1], 0 ,0,100000 ,'E1IoffeMicroWaveSweepTime','Sweep Time [ms]');


  RegisterBoolean(MarkColor,@DoIoffeEvaporation1,True ,'E1S1DoIoffeEvaporation1','Do RF Sweep 1 ? [Yes/No]');

  RegisterBoolean(MarkColor,@DoTrapDeformmicrowaveEvaporation[2],         False ,'E2DoTrapDeformmicrowaveEvaporation'   ,
    'Do trap deform micro wave Evaporation 2? [Yes/No]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStartFrequence0[2], 0 ,0,1000 ,'E2IoffeMicroWaveStartFrequency0',
    'Micro Wave Start Frequency Synthesizer 0 [0..1000 MHz]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStopFrequence0[2], 0 ,0,1000 ,'E2IoffeMicroWaveStopFrequency0',
    'Micro Wave Stop Frequency Synthesizer 0 [0..1000 MHz]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStartFrequence1[2], 0 ,0,1000 ,'E2IoffeMicroWaveStartFrequency1',
    'Micro Wave Start Frequency Synthesizer 1 [0..1000 MHz]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStopFrequence1[2], 0 ,0,1000 ,'E2IoffeMicroWaveStopFrequency1',
    'Micro Wave Stop Frequency Synthesizer 1 [0..1000 MHz]');
  RegisterDouble (StdtColor,@EvaporationEndBarCurrent[2], 0 ,0,1000 ,'E2EvaporationEndBarCurrent',
    'Evaporation Bar end Current 2 [0..1000 A]');
  RegisterDouble (StdtColor,@EvaporationEndBiasCurrent[2], 0 ,0,250 ,'E2EvaporationEndBiasCurrent',
    'Evaporation Bias end current [0..250 A]');
  RegisterDouble (StdtColor,@EvaporationEndPinchOffsetCurrent[2], 0 ,0,30 ,'E2EvaporationEndPinchOffsetCurrent',
    'Evaporation End Pinch Offset Current 2 [0..30 A]');
  RegisterDouble (StdtColor,@EvaporationEndCompCurrent[2], 0 ,0,500 ,'E2EvaporationEndCompCurrent',
    'Evaporation Compensation end Current [0..500 A]');
  RegisterDouble (StdtColor,@IoffeEvaporationTime[2], 0 ,0,100 ,'E2IoffeEvaporationTime','Evaporation Time 2 [sec]');

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[5],         True ,
    'C5DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 5 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[5], 0 ,0,90000 ,
    'C5CompressIoffeTrapTime','Compress Ioffe Trap Time 5 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[5], 0 ,0,1000 ,'C5BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 5 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[5], 0 ,0,250 ,'C5BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 5 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[5], 0 ,0,30 ,'C5PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 5 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[5], 0 ,0,500 ,'C5CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 5 [0..500 A]');

  RegisterDouble (MarkColor,@CompressedIoffeTrapWait4, 0 ,0,500000 ,
    'C4CompressedIoffeTrapWait','Compressed Ioffe Trap Wait 4 [ms]');

  RegisterBoolean(MarkColor,@DoIoffeEvaporation2,True ,
    'E2S2DoIoffeEvaporation','Do RF Sweep 2 ? [Yes/No]');

  Registerboolean(MarkColor,@DoSmoothSweep[1],         False ,'F1DoSmoothSweep'   ,
    'Do smooth sweep 1 ? [Yes/No]');
  RegisterDouble (StdtColor,@SmoothStartFrequency[1], 0 ,0,1000 ,'F1SmoothStartFrequency',
    'Micro Wave Start Frequency [0..1000 MHz]');
  RegisterDouble (StdtColor,@SmoothStopFrequency[1], 0 ,0,1000 ,'F1SmoothStopFrequency',
    'Micro Wave Stop Frequency [0..1000 MHz]');
  RegisterDouble (StdtColor,@SmoothSweepStepTime[1], 1 ,1,100 ,'F1SmoothSweepStepTime',
    'Smooth Sweep Step Time [1..100 ms]');
  RegisterDouble (StdtColor,@SmoothSweepSteps[1], 100 ,1,401 ,'F1SmoothSweepSteps',
    'Smooth Sweep Steps [1..1000]');
  RegisterDouble (StdtColor,@SmoothSweepTime[1], 1000 ,1,100000 ,'F1SmoothSweepTime',
    'Smooth Sweep Time [ms]');
  RegisterDouble (StdtColor,@SmoothSweepRFLevel[1], -136 ,-136,19 ,'F1SmoothSweepRFLevel',
    'Smooth Sweep RF Level [dBm]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Manipulate Ioffe Trap Parameters 2',Dummy));

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[6],         True ,
    'C6DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 6 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[6], 0 ,0,90000 ,
    'C6CompressIoffeTrapTime','Compress Ioffe Trap Time 6 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[6], 0 ,0,1000 ,'C6BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 6 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[6], 0 ,0,250 ,'C6BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 6 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[6], 0 ,0,30 ,'C6PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 6 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[6], 0 ,0,500 ,'C6CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 6 [0..500 A]');

  RegisterDouble (MarkColor,@IoffeTrapWait[1], 0 ,0,500000 ,
    'I1IoffeTrapWait','Ioffe Trap Wait 1 [ms]');

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[7],         True ,
    'C7DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 7 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[7], 0 ,0,90000 ,
    'C7CompressIoffeTrapTime','Compress Ioffe Trap Time 7 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[7], 0 ,0,1000 ,'C7BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 7 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[7], 0 ,0,250 ,'C7BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 7 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[7], 0 ,0,30 ,'C7PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 7 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[7], 0 ,0,500 ,'C7CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 7 [0..500 A]');

  RegisterDouble (MarkColor,@IoffeTrapWait[2], 0 ,0,500000 ,
    'I2IoffeTrapWait','Ioffe Trap Wait 2 [ms]');

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[8],         True ,
    'C8DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 8 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[8], 0 ,0,90000 ,
    'C8CompressIoffeTrapTime','Compress Ioffe Trap Time 8 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[8], 0 ,0,1000 ,'C8BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 8 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[8], 0 ,0,250 ,'C8BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 8 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[8], 0 ,0,30 ,'C8PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 8 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[8], 0 ,0,500 ,'C8CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 8 [0..500 A]');

  RegisterDouble (MarkColor,@IoffeTrapWait[3], 0 ,0,500000 ,
    'I3IoffeTrapWait','Ioffe Trap Wait 3 [ms]');

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[9],         True ,
    'C9DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 9 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[9], 0 ,0,90000 ,
    'C9CompressIoffeTrapTime','Compress Ioffe Trap Time 9 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[9], 0 ,0,1000 ,'C9BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 9 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[9], 0 ,0,250 ,'C9BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 9 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[9], 0 ,0,30 ,'C9PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 9 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[9], 0 ,0,500 ,'C9CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 9 [0..500 A]');

  RegisterDouble (MarkColor,@IoffeTrapWait[4], 0 ,0,500000 ,
    'I4IoffeTrapWait','Ioffe Trap Wait 4 [ms]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Transfer Puls Parameters',Dummy));

  RegisterDouble (StdtColor,@PSValue[1,0].Frequency, 0 ,0,1000 ,'S1S0RFPulsSequenceFrequency0',
    'A Micro Wave Frequency Synth 0 [0..1000 MHz]');
  RegisterDouble (StdtColor,@PSValue[1,0].Time, 1000 ,0,100000 ,'S1S0RFPulsSequenceTime0',
    'A RF Puls Time Synth 0 [ms]');
  RegisterDouble (StdtColor,@PSValue[1,0].Level, -136 ,-136,19 ,'S1S0RFPulsSequenceLevel0',
    'A RF Puls RF Level Synth 0 [dBm]');
  RegisterDouble (lightgreen,@PSValue[1,2].Frequency, 0 ,0,1000 ,'S1S2RFPulsSequenceFrequency2',
    'A Micro Wave Frequency Synth 2 [0..1000 MHz]');
  RegisterDouble (lightgreen,@PSValue[1,2].Time, 1000 ,0,100000 ,'S1S2RFPulsSequenceTime2',
    'A RF Puls Burst Count 2 [ms]');
  RegisterDouble (lightgreen,@PSValue[1,2].Level, -136 ,-136,19 ,'S1S2RFPulsSequenceLevel2',
    'A RF Puls RF Level Synth 2 [dBm]');
  RegisterDouble (StdtColor,@PSValue[1,1].Frequency, 0 ,0,1000 ,'S1S1RFPulsSequenceFrequency1',
    'A Micro Wave Frequency Synth 1 [0..1000 MHz]');
  RegisterDouble (StdtColor,@PSValue[1,1].Time, 1000 ,0,100000 ,'S1S1RFPulsSequenceTime1',
    'A RF Puls Time Synth 1 [ms]');
  RegisterDouble (StdtColor,@PSValue[1,1].Level, -136 ,-136,19 ,'S1S1RFPulsSequenceLevel1',
    'A RF Puls RF Level Synth 1 [dBm]');
  RegisterDouble (lightgreen,@PSValue[1,3].Frequency, 0 ,0,1000 ,'S1S3RFPulsSequenceFrequency3',
    'A Micro Wave Frequency Synth 3 [0..1000 MHz]');
  RegisterDouble (lightgreen,@PSValue[1,3].Time, 1000 ,0,100000 ,'S1S3RFPulsSequenceTime3',
    'A RF Puls Burst Count Synth 3 [ms]');
  RegisterDouble (lightgreen,@PSValue[1,3].Level, -136 ,-136,19 ,'S1S3RFPulsSequenceLevel3',
    'A RF Puls RF Level Synth 3 [dBm]');
  RegisterDouble (StdtColor,@DummyDouble, 0 ,0,0 ,'Dummy',
    '');
  RegisterDouble (StdtColor,@PSValue[2,0].Frequency, 0 ,0,1000 ,'S2S0RFPulsSequenceFrequency0',
    'B Micro Wave Frequency Synth 0 [0..1000 MHz]');
  RegisterDouble (StdtColor,@PSValue[2,0].Time, 1000 ,0,100000 ,'S2S0RFPulsSequenceTime0',
    'B RF Puls Time Synth 0 [ms]');
  RegisterDouble (StdtColor,@PSValue[2,0].Level, -136 ,-136,19 ,'S2S0RFPulsSequenceLevel0',
    'B RF Puls RF Level Synth 0 [dBm]');
  RegisterDouble (lightgreen,@PSValue[2,2].Frequency, 0 ,0,1000 ,'S2S2RFPulsSequenceFrequency2',
    'B Micro Wave Frequency Synth 2 [0..1000 MHz]');
  RegisterDouble (lightgreen,@PSValue[2,2].Time, 1000 ,0,100000 ,'S2S2RFPulsSequenceTime2',
    'B RF Puls Burst Count 2 [ms]');
  RegisterDouble (lightgreen,@PSValue[2,2].Level, -136 ,-136,19 ,'S2S2RFPulsSequenceLevel2',
    'B RF Puls RF Level Synth 2 [dBm]');
  RegisterDouble (StdtColor,@PSValue[2,1].Frequency, 0 ,0,1000 ,'S2S1RFPulsSequenceFrequency1',
    'B Micro Wave Frequency Synth 1 [0..1000 MHz]');
  RegisterDouble (StdtColor,@PSValue[2,1].Time, 1000 ,0,100000 ,'S2S1RFPulsSequenceTime1',
    'B RF Puls Time Synth 1 [ms]');
  RegisterDouble (StdtColor,@PSValue[2,1].Level, -136 ,-136,19 ,'S2S1RFPulsSequenceLevel1',
    'B RF Puls RF Level Synth 1 [dBm]');
  RegisterDouble (lightgreen,@PSValue[2,3].Frequency, 0 ,0,1000 ,'S2S3RFPulsSequenceFrequency3',
    'B Micro Wave Frequency Synth 3 [0..1000 MHz]');
  RegisterDouble (lightgreen,@PSValue[2,3].Time, 1000 ,0,100000 ,'S2S3RFPulsSequenceTime3',
    'B RF Puls Burst Count Synth 3 [ms]');
  RegisterDouble (lightgreen,@PSValue[2,3].Level, -136 ,-136,19 ,'S2S3RFPulsSequenceLevel3',
    'B RF Puls RF Level Synth 3 [dBm]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Manipulate Ioffe Trap Parameters 3',Dummy));

  Registerboolean(MarkColor,@DoRFPulsSequence[1],         False ,'S1DoRFPulsSequence'   ,
    'Do RF Puls Sequence 1 ? [Yes/No]');
  RegisterString(StdtColor,@RFPulsSequence[1],'A 7HfPi 7ZePi 6HfPi 6ZePi','P1RFPulsSequence','Desciption of puls sequence');

  RegisterBoolean(MarkColor,@DoSwitchRFShieldOff,         True ,
    'S1DoSwitchRFShieldOff'   ,'Switch RF Shield Off ? [Yes/No]');
  RegisterBoolean(MarkColor,@DoProbeFlash,         False,
    'DoProbeFlash'   ,'Do Probe Flash ? [Yes/No]');

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[10],         True ,
    'C10DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 10 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[10], 0 ,0,90000 ,
    'C10CompressIoffeTrapTime','Compress Ioffe Trap Time 10 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[10], 0 ,0,1000 ,'C10BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 10 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[10], 0 ,0,250 ,'C10BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 10 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[10], 0 ,0,30 ,'C10PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 10 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[10], 0 ,0,500 ,'C10CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 10 [0..500 A]');


  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[11],         True ,
    'C11DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 11 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[11], 0 ,0,90000 ,
    'C11CompressIoffeTrapTime','Compress Ioffe Trap Time 11 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[11], 0 ,0,1000 ,'C11BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 11 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[11], 0 ,0,250 ,'C11BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 11 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[11], 0 ,0,30 ,'C11PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 11 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[11], 0 ,0,500 ,'C11CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 11 [0..500 A]');

  RegisterDouble (MarkColor,@IoffeTrapWait[5], 0 ,0,500000 ,
    'I5IoffeTrapWait','Ioffe Trap Wait 5 [ms]');

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[12],         True ,
    'C12DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 12 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[12], 0 ,0,90000 ,
    'C12CompressIoffeTrapTime','Compress Ioffe Trap Time 12 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[12], 0 ,0,1000 ,'C12BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 12 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[12], 0 ,0,250 ,'C12BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 12 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[12], 0 ,0,30 ,'C12PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 12 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[12], 0 ,0,500 ,'C12CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 12 [0..500 A]');

  RegisterDouble (MarkColor,@IoffeTrapWait[6], 0 ,0,500000 ,
    'I6IoffeTrapWait','Ioffe Trap Wait 6 [ms]');

  RegisterBoolean(MarkColor,@DoIoffeEvaporation3,True ,
    'E3S2DoIoffeEvaporation','Do RF Sweep 2 ? [Yes/No]');
  RegisterBoolean(MarkColor,@DoIoffeEvaporation4,True ,
    'E4S3DoIoffeEvaporation','Do RF Sweep 3 ? [Yes/No]');


  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Manipulate Ioffe trap Parameters 4',Dummy));

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[13],         True ,
    'C13DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 13 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[13], 0 ,0,90000 ,
    'C13CompressIoffeTrapTime','Compress Ioffe Trap Time 13 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[13], 0 ,0,1000 ,'C13BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 13 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[13], 0 ,0,250 ,'C13BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 13 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[13], 0 ,0,30 ,'C13PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 13 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[13], 0 ,0,500 ,'C13CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 13 [0..500 A]');

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[14],         True ,
    'C14DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 14 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[14], 0 ,0,90000 ,
    'C14CompressIoffeTrapTime','Compress Ioffe Trap Time 14 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[14], 0 ,0,1000 ,'C14BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 14 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[14], 0 ,0,250 ,'C14BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 14 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[14], 0 ,0,30 ,'C14PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 14 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[14], 0 ,0,500 ,'C14CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 14 [0..500 A]');

  RegisterDouble (MarkColor,@IoffeTrapWait[7], 0 ,0,500000 ,
    'I7IoffeTrapWait','Ioffe Trap Wait 7 [ms]');

  RegisterBoolean(MarkColor,@DoSwitchRFShieldOff2,         True ,
    'S2DoSwitchRFShieldOff'   ,'Switch RF Shield Off ? [Yes/No]');
  Registerboolean(MarkColor,@DoRepumpFlash,         False ,'DoRepumpFlash'   ,
    'Do Repump Flash ? [Yes/No]');

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[15],         True ,
    'C15DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 15 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[15], 0 ,0,90000 ,
    'C15CompressIoffeTrapTime','Compress Ioffe Trap Time 15 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[15], 0 ,0,1000 ,'C15BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 15 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[15], 0 ,0,250 ,'C15BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 15 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[15], 0 ,0,30 ,'C15PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 15 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[15], 0 ,0,500 ,'C15CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 15 [0..500 A]');

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[16],         True ,
    'C16DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 16 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[16], 0 ,0,90000 ,
    'C16CompressIoffeTrapTime','Compress Ioffe Trap Time 16 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[16], 0 ,0,1000 ,'C16BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 16 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[16], 0 ,0,250 ,'C16BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 16 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[16], 0 ,0,30 ,'C16PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 16 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[16], 0 ,0,500 ,'C16CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 16 [0..500 A]');

  RegisterDouble (MarkColor,@IoffeTrapWait[8], 0 ,0,500000 ,
    'I8IoffeTrapWait','Ioffe Trap Wait 8 [ms]');

  Registerboolean(MarkColor,@DoMicrowaveSweep[2],         False ,'E2DoMicrowaveSweep'   ,
    'Do micro wave sweep 2 ? [Yes/No]');
  RegisterBoolean(StdtColor,@DoMicrowaveSweepSynth0[2],         False ,'E2S0DoMicrowaveSweepSynth0'   ,
    'Do micro wave sweep with synthesizer 0 ? [Yes/No]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStartFrequency0[2], 0 ,0,1000 ,'E2IoffeMicroWaveStartFrequency0',
    'Micro Wave Start Frequency Syntesizer 0  [0..1000 MHz]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStopFrequency0[2], 0 ,0,1000 ,'E2IoffeMicroWaveStopFrequency0',
    'Micro Wave Stop Frequency Syntesizer 0 [0..1000 MHz]');
  RegisterDouble (StdtColor,@IoffeMicroWavePower0[2], 0 ,-144,19,'E2IoffeMicroWavePower0',
    'Micro Wave Power 0 [dBm]');
  RegisterBoolean(StdtColor,@DoMicrowaveSweepSynth1[2],         False ,'E2DoMicrowaveSweepSynth1'   ,
    'Do micro wave sweep with synthesizer 1 ? [Yes/No]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStartFrequency1[2], 0 ,0,1000 ,'E2IoffeMicroWaveStartFrequency1',
    'Micro Wave Start Frequency Syntesizer 1  [0..1000 MHz]');
  RegisterDouble (StdtColor,@IoffeMicroWaveStopFrequency1[2], 0 ,0,1000 ,'E2IoffeMicroWaveStopFrequency1',
    'Micro Wave Stop Frequency Syntesizer 1 [0..1000 MHz]');
  RegisterDouble (StdtColor,@IoffeMicroWavePower1[2], 0 ,-144,19,'E2IoffeMicroWavePower1',
    'Micro Wave Power 1 [dBm]');
  RegisterDouble (StdtColor,@IoffeMicroWaveSweepTime[2], 0 ,0,100000 ,
    'E2IoffeMicroWaveSweepTime','Sweep Time 2 [ms]');


  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Optical trap experiments',Dummy));

  RegisterBoolean(MarkColor,@DoOpticalTrap, False ,'DoOpticalTrap','Do optical trap ? [Yes/No]');
  RegisterDouble (StdtColor,@StartHorizontalNdYAGIntensity, 0 ,0,1 ,'StartHorizontalNdYAGIntensity',
                  'Nd YAG Horizontal Intensity [0..1]');
  RegisterDouble (StdtColor,@StartVerticalNdYAGIntensity, 0 ,0,1 ,'StartVerticalNdYAGIntensity',
                  'Nd YAG Vertical Intensity [0..1]');
  RegisterDouble (StdtColor,@OpticalTrapStartTime, 0 ,0,20000 ,'OpticalTrapStartTime','Optical Trap Start Time [ms]');

  RegisterBoolean(MarkColor,@DoCompressIoffeTrap[17],         True ,
    'C17DoCompressIoffeTrap'   ,'Do Compress Ioffe Trap 17 ? [Yes/No]');
  RegisterDouble (StdtColor,@CompressIoffeTrapTime[17], 0 ,0,90000 ,
    'C17CompressIoffeTrapTime','Compress Ioffe Trap Time 17 [ms]');
  RegisterDouble (StdtColor,@BarCurrentInCompIoffeTrap[17], 0 ,0,1000 ,'C17BarCurrentInCompIoffeTrap',
    'Bar current in compressed Ioffe Trap 17 [0..1000 A]');
  RegisterDouble (StdtColor,@BiasCurrentInCompIoffeTrap[17], 0 ,0,250 ,'C17BiasCurrentInCompIoffeTrap',
    'Bias current in compressed Ioffe Trap 17 [0..250 A]');
  RegisterDouble (StdtColor,@PinchOffsetCurrentInCompIoffeTrap[17], 0 ,0,30 ,'C17PinchOffsetCurrentInCompIoffeTrap',
    'Pinch Offset current in compressed Ioffe Trap 17 [0..30 A]');
  RegisterDouble (StdtColor,@CompensationCurrentInCompIoffeTrap[17], 0 ,0,500 ,'C17CompensationCurrentInCompIoffeTrap',
    'Compensation current in compressed Ioffe Trap 17 [0..500 A]');

{  RegisterBoolean(MarkColor,@DoModeMatchTransferRadial, False ,
    'DoModeMatchTransferRadial','Do Mode Match Transfer Radial ? [Yes/No]');
  RegisterDouble (StdtColor,@ModeMatchHorizontalNdYAGIntensity, 0 ,0,1 ,'ModeMatchHorizontalNdYAGIntensity',
                  'Nd YAG Horizontal Intensity [0..1]');
  RegisterDouble (StdtColor,@ModeMatchVerticalNdYAGIntensity, 0 ,0,1 ,'ModeMatchVerticalNdYAGIntensity',
                  'Nd YAG Vertical Intensity [0..1]');
}
  Registerboolean(MarkColor,@DoRFPulsSequence[2],         False ,'S2DoRFPulsSequence'   ,
    'Do RF Puls Sequence 2 ? [Yes/No]');
  RegisterString(StdtColor,@RFPulsSequence[2],'A 6ZePi/2','P2RFPulsSequence','Desciption of puls sequence');



  RegisterBoolean(MarkColor,@DoSwitchOffMagTrap1, False ,'O1DoSwitchOffMagTrap','Do Switch Off Mag Trap ? [Yes/No]');

  RegisterDouble (MarkColor,@IoffeTrapWait[9], 0 ,0,500000 ,
    'I9IoffeTrapWait','Ioffe Trap Wait 9 [ms]');


  RegisterBoolean(MarkColor,@DoVCORFSweepHere1,False ,'VCORFSweep1','Do VCO RF Sweep here? [Yes/No]');
  RegisterDouble (StdtColor,@TimeVCORFSweep, 0 ,0,2000 ,'TimeVCORFSweep','Sweep time [ms]');
  RegisterDouble (StdtColor,@LevelVCORFSweep1, 0 ,-144,15 ,'LevelVCORFSweep1','Synth1: Sweep Level [dBm]');
  RegisterDouble (StdtColor,@StartVCORFSweep1, 0 ,0,1100 ,'StartVCORFSweep1','Synth1: Start Frequency [MHz]');
  RegisterDouble (StdtColor,@StopVCORFSweep1, 0 ,0,1100 ,'StopVCORFSweep1','Synth1: Stop Frequency [MHz]');
  RegisterDouble (StdtColor,@LevelVCORFSweep2, 0 ,-144,15 ,'LevelVCORFSweep2','Synth2: Sweep Level [dBm]');
  RegisterDouble (StdtColor,@StartVCORFSweep2, 0 ,0,1100 ,'StartVCORFSweep2','Synth2: Start Frequency (same order) [MHz]');
  RegisterDouble (StdtColor,@StopVCORFSweep2, 0 ,0,1100 ,'StopVCORFSweep2','Synth2: Stop Frequency [MHz]');

  RegisterBoolean(MarkColor,@DoRampOpticalTrap[7], False ,'O7DoRampDownOpticalTrap','Do ramp optical trap 7? [Yes/No]');
  RegisterDouble (StdtColor,@FinalHorizontalNdYAGIntensity[7], 0 ,0,1 ,
                  'O7FinalHorizontalNdYAGIntensity','Final Horizontal Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@FinalVerticalNdYAGIntensity[7], 0 ,0,1 ,'O7FinalVerticalNdYAGIntensity',
                  'Final Vertical Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@OpticalTrapRampTime[7], 0 ,0,5000 ,'O7OpticalTrapRampTime','Optical Trap Ramp Time [ms]');

  RegisterBoolean(MarkColor,@DoSeparationGradient, False ,'DoSeparationGradient','Do Separation Gradient ? [Yes/No]');
  RegisterDouble (StdtColor,@SeparationGradientCurrent, 0 ,0,500 ,'SeparationGradientCurrent','Separation Current [0..500 A]');
  RegisterDouble (StdtColor,@SeparationGradientRampTime, 0 ,0,5000 ,'SeparationGradientRampTime',
    'Separation Gradient Ramp Time [ms]');
  RegisterDouble (StdtColor,@SeparationGradientTime, 0 ,0,5000 ,'SeparationGradientTime',
    'Separation Gradient Time [ms]');

  RegisterBoolean(MarkColor,@DoRampOpticalTrap[8], False ,'O8DoRampDownOpticalTrap','Do ramp optical trap 8? [Yes/No]');
  RegisterDouble (StdtColor,@FinalHorizontalNdYAGIntensity[8], 0 ,0,1 ,
                  'O8FinalHorizontalNdYAGIntensity','Final Horizontal Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@FinalVerticalNdYAGIntensity[8], 0 ,0,1 ,'O8FinalVerticalNdYAGIntensity',
                  'Final Vertical Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@OpticalTrapRampTime[8], 0 ,0,5000 ,'O8OpticalTrapRampTime','Optical Trap Ramp Time [ms]');

  RegisterBoolean(MarkColor,@DoAddFeshbachField, False ,'DoAddFeshbachField','Do add Feshbach field ? [Yes/No]');
  RegisterBoolean(StdtColor,@UsePinchForFeshbachField, False ,'UsePinchForFeshbachField',
    'Use Pinch For Feshbach Field ? [Yes/No]');
  RegisterDouble (StdtColor,@StartFeshbachCurrent, 0 ,0,500 ,'StartFeshbachCurrent','Start Feshbach Field Current [0..500 A]');
  RegisterDouble (StdtColor,@EtaFeshbachStartRamp, 0 ,0,10 ,'EtaFeshbachStartRamp','Eta Feshbach Start Ramp [0..10 units]');
  RegisterDouble (StdtColor,@FeshbachCurrentStartTime, 0 ,0,5000 ,'FeshbachCurrentStartTime',
    'Feshbach Current Start Time [ms]');

  RegisterBoolean(StdtColor,@DoSpinMix, False ,'DoSpinMix','Do Spin Mix ? [Yes/No]');
  RegisterBoolean(StdtColor,@UseOrthogonalField, False ,'UseOrthogonalField','Use orthogonal field ? [Yes/No]');
  RegisterDouble (StdtColor,@OrthogonalFieldRampTime, 0 ,0,500 ,'OrthogonalFieldCurrent','Orthogonal Field Ramp Time [ms]');
  RegisterDouble (StdtColor,@OrthogonalFieldCurrent, 0 ,0,50 ,'OrthogonalFieldCurrent','Orthogonal Field Current [0..50 A]');

  RegisterDouble (MarkColor,@OpticalTrapWait[1], 0 ,0,500000 ,
    'I1OpticalTrapWait','Optical Trap Wait 1 [ms]');
  RegisterBoolean(MarkColor,@DoVCORFSweepHere2,False ,'VCORFSweep2','Do VCO RF Sweep here (params above)? [Yes/No]');


  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Optical Trap 2',Dummy));


  RegisterBoolean(MarkColor,@DoRampOpticalTrap[1], False ,'O1DoRampDownOpticalTrap','Do ramp optical trap 1? [Yes/No]');
  RegisterDouble (StdtColor,@FinalHorizontalNdYAGIntensity[1], 0 ,0,1 ,
                  'O1FinalHorizontalNdYAGIntensity','Final Horizontal Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@FinalVerticalNdYAGIntensity[1], 0 ,0,1 ,'O1FinalVerticalNdYAGIntensity',
                  'Final Vertical Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@OpticalTrapRampTime[1], 0 ,0,5000 ,'O1OpticalTrapRampTime','Optical Trap Ramp Time [ms]');

  RegisterBoolean(MarkColor,@DoRampOpticalTrap[2], False ,'O2DoRampDownOpticalTrap','Do ramp optical trap 2? [Yes/No]');
  RegisterDouble (StdtColor,@FinalHorizontalNdYAGIntensity[2], 0 ,0,1 ,
                  'O2FinalHorizontalNdYAGIntensity','Final Horizontal Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@FinalVerticalNdYAGIntensity[2], 0 ,0,1 ,'O2FinalVerticalNdYAGIntensity',
                  'Final Vertical Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@OpticalTrapRampTime[2], 0 ,0,5000 ,'O2OpticalTrapRampTime','Optical Trap Ramp Time [ms]');
  RegisterDouble (MarkColor,@OpticalTrapWait[2], 0 ,0,500000 ,
    'I2OpticalTrapWait','Optical Trap Wait 2 [ms]');

  RegisterBoolean(MarkColor,@DoRampFeshbachField[1], False ,'R1DoRampFeshbachField','Do ramp Feshbach field 1 ? [Yes/No]');
  RegisterDouble (StdtColor,@FeshbachCurrent[1], 0 ,0,500 ,'R1FeshbachCurrent','Feshbach Field 1 [0..500 A]');
  RegisterDouble (StdtColor,@EtaFeshbachRamp[1], 0 ,0,10 ,'Eta1FeshbachRamp','Eta Feshbach Ramp 1 [0..10 units]');
  RegisterDouble (StdtColor,@FeshbachCurrentRampTime[1], 0 ,0,5000 ,'R1FeshbachRampTime','Feshbach Current Ramp Time 1 [ms]');

  RegisterBoolean(MarkColor,@DoRampOpticalTrap[3], False ,'O3DoRampDownOpticalTrap','Do ramp optical trap 3? [Yes/No]');
  RegisterDouble (StdtColor,@FinalHorizontalNdYAGIntensity[3], 0 ,0,1 ,
                  'O3FinalHorizontalNdYAGIntensity','Final Horizontal Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@FinalVerticalNdYAGIntensity[3], 0 ,0,1 ,'O3FinalVerticalNdYAGIntensity',
                  'Final Vertical Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@OpticalTrapRampTime[3], 0 ,0,5000 ,'O3OpticalTrapRampTime','Optical Trap Ramp Time [ms]');
  RegisterDouble (MarkColor,@OpticalTrapWait[3], 0 ,0,500000 ,
    'I3OpticalTrapWait','Optical Trap Wait 3 [ms]');

  RegisterBoolean(MarkColor,@DoRampOpticalTrap[4], False ,'O4DoRampDownOpticalTrap','Do ramp optical trap 4? [Yes/No]');
  RegisterDouble (StdtColor,@FinalHorizontalNdYAGIntensity[4], 0 ,0,1 ,
                  'O4FinalHorizontalNdYAGIntensity','Final Horizontal Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@FinalVerticalNdYAGIntensity[4], 0 ,0,1 ,'O4FinalVerticalNdYAGIntensity',
                  'Final Vertical Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@OpticalTrapRampTime[4], 0 ,0,5000 ,'O4OpticalTrapRampTime','Optical Trap Ramp Time [ms]');

  RegisterBoolean(MarkColor,@DoAxialGradient, False ,'DoAxialGradient','Do Axial Gradient ? [Yes/No]');

  RegisterDouble (MarkColor,@OpticalTrapWait[4], 0 ,0,500000 ,
    'I4OpticalTrapWait','Optical Trap Wait 4 [ms]');

  RegisterBoolean(MarkColor,@DoRampFeshbachField[2], False ,'R2DoRampFeshbachField','Do ramp Feshbach field 2 ? [Yes/No]');
  RegisterDouble (StdtColor,@FeshbachCurrent[2], 0 ,0,500 ,'R2FeshbachCurrent','Feshbach Field 2 [0..500 A]');
  RegisterDouble (StdtColor,@EtaFeshbachRamp[2], 0 ,0,10 ,'Eta2FeshbachRamp','Eta Feshbach Ramp 2 [0..10 units]');
  RegisterDouble (StdtColor,@FeshbachCurrentRampTime[2], 0 ,0,5000 ,'R2FeshbachRampTime','Feshbach Current Ramp Time 2 [ms]');

  RegisterDouble (MarkColor,@OpticalTrapWait[5], 0 ,0,500000 ,
    'I5OpticalTrapWait','Optical Trap Wait 5 [ms]');

  RegisterBoolean(MarkColor,@DoRampOpticalTrap[5], False ,'O5DoRampDownOpticalTrap','Do ramp optical trap 5? [Yes/No]');
  RegisterDouble (StdtColor,@FinalHorizontalNdYAGIntensity[5], 0 ,0,1 ,
                  'O5FinalHorizontalNdYAGIntensity','Final Horizontal Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@FinalVerticalNdYAGIntensity[5], 0 ,0,1 ,'O5FinalVerticalNdYAGIntensity',
                  'Final Vertical Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@OpticalTrapRampTime[5], 0 ,0,5000 ,'O5OpticalTrapRampTime','Optical Trap Ramp Time [ms]');
  RegisterDouble (MarkColor,@OpticalTrapWait[6], 0 ,0,500000 ,
    'I6OpticalTrapWait','Optical Trap Wait 6 [ms]');

  RegisterBoolean(MarkColor,@DoRampFeshbachField[3], False ,'R3DoRampFeshbachField','Do ramp Feshbach field 3 ? [Yes/No]');
  RegisterDouble (StdtColor,@FeshbachCurrent[3], 0 ,0,500 ,'R3FeshbachCurrent','Feshbach Field 3 [0..500 A]');
  RegisterDouble (StdtColor,@EtaFeshbachRamp[3], 0 ,0,10 ,'Eta3FeshbachRamp','Eta Feshbach Ramp 3 [0..10 units]');
  RegisterDouble (StdtColor,@FeshbachCurrentRampTime[3], 0 ,0,5000 ,'R3FeshbachRampTime','Feshbach Current Ramp Time 3 [ms]');


  RegisterBoolean(MarkColor,@DoSwitchOffMagtrap2, False ,'O2DoSwitchOffMagtrap2',
    'Switch off magtrap (keep offset) ? [Yes/No]');

  RegisterBoolean(MarkColor,@DoShakeTrap, False ,'DoShakeTrap','Shake Trap ? [Yes/No]');
  RegisterDouble (StdtColor,@ShakeStartFrequency, 0 ,0,50000 ,'ShakeStartFrequency','Shake Start Frequency [Hz]');
  RegisterDouble (StdtColor,@ShakeDeltaFrequency, 0 ,0,50000 ,'ShakeDeltaFrequency','Shake Frequency Span [Hz]');
  RegisterDouble (StdtColor,@ShakeTime, 0 ,0,500000 ,'ShakeTime','Shake Time [ms]');
  RegisterDouble (StdtColor,@ShakeAmplitude, 0 ,0,1,'ShakeAmplitude','Shake Amplitude [Vpp]');

  RegisterDouble (MarkColor,@OpticalTrapWait[7], 0 ,0,500000 ,
    'I7OpticalTrapWait','Optical Trap Wait 7 [ms]');

  DummyReg:=new(PRegistry,init(@Registry,Registry,true,'Last Millisecond Manipulations',Dummy));

  Registerboolean(MarkColor,@DoFinalRFPulsSequence,         False ,'DoFinalRFPulsSequence'   ,
    'Do Final RF Puls Sequence (uses PulsSequence parameters) ? [Yes/No]');
  RegisterString(StdtColor,@RFPulsSequence[3],'A 7HfPi','P3RFPulsSequence','Desciption of puls sequence');

  Registerboolean(MarkColor,@DoRFPuls[1],         False ,'R1DoRFPuls'   ,
    'Do RF Puls 1 ? [Yes/No]');
  RegisterInteger(StdtColor,@RFPulsSynth[1], 0 ,0,1 ,'R1RFPulsSynth',
    'Synthesizer [0,1]');
  RegisterDouble (StdtColor,@RFPulsFrequency[1], 0 ,0,1000 ,'R1RFPulsFrequency',
    'Micro Wave Frequency [0..1000 MHz]');
  RegisterDouble (StdtColor,@RFPulsTime[1], 1000 ,1,100000 ,'R1RFPulsTime',
    'RF Puls Time [ms]');
  RegisterDouble (StdtColor,@RFThermalisationTime[1], 1000 ,1,100000 ,'R1RFThermalisationTime',
    'RF Thermalisation Time [ms]');
  RegisterDouble (StdtColor,@RFPulsRFLevel[1], -136 ,-136,19 ,'R1RFPulsRFLevel',
    'RF Puls RF Level [dBm]');

  Registerboolean(MarkColor,@DoPushBeam,         False ,'DoPushBeam'   ,
    'Do Push Beam ? [Yes/No]');
  RegisterDouble (StdtColor,@AndorProbeOffDelay, 10 ,0,1000 ,'AndorProbeOffDelay',
    'Andor Probe Off delay [ms]');
  RegisterDouble (StdtColor,@AndorProbeOnDelay, 10 ,0,1000 ,'AndorProbeOnDelay',
    'Andor Probe On delay [ms]');
  RegisterDouble (StdtColor,@AndorProbeOnRiseTime, 10 ,0,1000 ,'AndorProbeOnRiseTime',
    'Andor Probe On Rise Time [ms]');
  RegisterDouble (StdtColor,@PushBeamTime, 0.10 ,0,1000 ,'PushBeamTime',
    'Push Beam Time [ms]');
  Registerboolean(StdtColor,@UsePushBeamWithRepump,         False ,'DoPushBeamWithRepump'   ,
    'Do Push Beam With Repump ? [Yes/No]');


  RegisterBoolean(MarkColor,@DoStartOpticalTrapHere4, False ,
  'Nd4DoStartOpticalTrapHere','Start optical trap here (Params above) ? [Yes/No]');

  RegisterBoolean(MarkColor,@DoExciteOpticalTrap, False ,
    'DoExciteOpticalTrap','Do Excite Optical Trap ? [Yes/No]');
  RegisterDouble (StdtColor,@ExciteOptTrapHorizontalNdYAGIntensity, 0 ,0,1 ,'ExciteOptTrapHorizontalNdYAGIntensity',
                  'Nd YAG Horizontal Intensity [0..1]');
  RegisterDouble (StdtColor,@ExciteOptTrapVerticalNdYAGIntensity, 0 ,0,1 ,'ExciteOptTrapVerticalNdYAGIntensity',
                  'Nd YAG Vertical Intensity [0..1]');
  RegisterDouble (StdtColor,@ExciteOptTrapWait, 0 ,0,5000 ,'ExciteOptTrapWait','Excite Optical Trap Time [ms]');

  RegisterBoolean(MarkColor,@DoRampFeshbachField[4], False ,'R4DoRampFeshbachField','Do ramp Feshbach field 4 ? [Yes/No]');
  RegisterDouble (StdtColor,@FeshbachCurrent[4], 0 ,0,500 ,'R4FeshbachCurrent','Feshbach Field 4 [0..500 A]');
  RegisterDouble (StdtColor,@EtaFeshbachRamp[4], 0 ,0,10 ,'Eta4FeshbachRamp','Eta Feshbach Ramp 4 [0..10 units]');
  RegisterDouble (StdtColor,@FeshbachCurrentRampTime[4], 0 ,0,5000 ,'R4FeshbachRampTime','Feshbach Current Ramp Time 4 [ms]');

  RegisterBoolean(MarkColor,@DoRampOpticalTrap[6], False ,'O6DoRampDownOpticalTrap','Do ramp optical trap 6? [Yes/No]');
  RegisterDouble (StdtColor,@FinalHorizontalNdYAGIntensity[6], 0 ,0,1 ,
                  'O6FinalHorizontalNdYAGIntensity','Final Horizontal Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@FinalVerticalNdYAGIntensity[6], 0 ,0,1 ,'O6FinalVerticalNdYAGIntensity',
                  'Final Vertical Nd YAG Intensity [0..1]');
  RegisterDouble (StdtColor,@OpticalTrapRampTime[6], 0 ,0,5000 ,'O6OpticalTrapRampTime','Optical Trap Ramp Time [ms]');

  RegisterBoolean(StdtColor,@CloseVerticalNdYagShutter, False ,'CloseVerticalNdYagShutter',
                 'Close Vertical NdYag Shutter? [Yes/No]');
  RegisterDouble (StdtColor,@VerticalNdYagShutterDelay, 10 ,0,1000 ,'VerticalNdYagShutterDelay',
    'Vertical NdYag Shutter Delay Time [ms]');

  RegisterDouble (MarkColor,@OpticalTrapWait[8], 0 ,0,500000 ,
    'I8OpticalTrapWait','Optical Trap Wait 8 [ms]');


  RegisterBoolean(MarkColor,@DoRampFeshbachField[5], False ,'R5DoRampFeshbachField','Do ramp Feshbach field 5 ? [Yes/No]');
  RegisterDouble (StdtColor,@FeshbachCurrent[5], 0 ,0,500 ,'R5FeshbachCurrent','Feshbach Field 5 [0..500 A]');
  RegisterDouble (StdtColor,@EtaFeshbachRamp[5], 0 ,0,10 ,'Eta5FeshbachRamp','Eta Feshbach Ramp 5 [0..10 units]');
  RegisterDouble (StdtColor,@FeshbachCurrentRampTime[5], 0 ,0,5000 ,'R5FeshbachRampTime','Feshbach Current Ramp Time 5 [ms]');

  RegisterDouble (MarkColor,@FinalWait, 0 ,0,1000 ,'FinalWait',
    'Final Wait [ms]');
end;

begin
  {
   This table has to be modified if a Variable is added or removed
   The format is

   RegisterType(@Name,DefaultValue,Min,Max,'Name','Question');
  }
  Registry:=nil;
  RegisterParameters1;
  RegisterParameters2;
  RegisterParameters3;
  for n:=1 to MaxRFSweep do
   RFSweepData[n]:=new(PRFSweep,init(RFSweepRegistry[n],'S'+char(n+byte('0'))));
  LoadParameters(MainDir);

  for n:=1 to MaxRFSweep do RegisterRegistry(@RFSweepRegistry[n]);
  RegisterRegistry(@Registry);

  oldexitproc:=exitproc;
  exitproc:=@myExitProc;
end.
