unit Pulsgen;
interface

procedure PulsgenSetMode(Adr:integer;mode:byte);
procedure PulsgenSetGateMode(Adr:integer;mode:byte);
procedure PulsgenSetToPeriode(Adr:integer;periode:double);
procedure PulsgenSetDutyCycleOnTime(Adr:integer;OnTime:double);
procedure PulsgenSetDutyCycleOffTime(Adr:integer;OffTime:double);
procedure PulsgenSetTriggerPolarity(Adr:integer;Polarity:byte);
procedure PulsgenSetNrPulses(Adr:integer;Pulses:word);
procedure PulsgenSetDutyCycleCycles(Adr:integer;Cycles:word);
procedure PulsgenSetPulsesInBurst(Adr:integer;Number:word);
procedure PulsgenSetPulsWidth(Adr:integer;Channel:byte;width:double);
procedure PulsgenSetPulsDelay(Adr:integer;Channel:byte;delay:double);
procedure PulsgenSetPulsPolarity(Adr:integer;Channel:byte;Polarity:byte);
procedure PulsgenSetChannel2Output(Adr:integer;Output:byte);
procedure PulsgenSetChannel2Gate(Adr:integer;State:byte);
procedure PulsgenSetChannel2Wait(Adr:integer;delay:double);
procedure PulsgenSetChannel2Period(Adr:integer;n:word);
procedure PulsgenBeep(Adr:integer;n:word);
procedure PulsgenRun(Adr:integer;onoff:byte);
procedure PulsgenRecall(Adr:integer;n:byte);
procedure PulsgenStore(Adr:integer;n:byte);
procedure PulsgenResetShots(Adr:integer);
procedure PulsgenEcho(Adr:integer;onoff:byte);
procedure PulsgenMark(Adr:integer;MarkType:byte);
procedure PulsgenVolume(Adr:integer;Volume:byte);

implementation
uses IEEE,crt;

var buf:string;
    buf2:string;

procedure SendAndCheck(Adr:integer;buf:string);
var s:string;
    len:word;
    st:integer;
    status:integer;
begin
  IEEE.Send(Adr,'$'+buf+char(13),status);
  enter(s,20,len,Adr,st);
  if (len<2) or (st<>0) or (status<>0) or (s<>'ok') then begin
    writeln('PulsGen : Error writing command : '+buf);
    delay(1000);
  end;
end;

procedure PulsgenSetMode(Adr:integer;mode:byte);
begin
  str(mode,buf);
  SendAndCheck(Adr,'MODE '+buf);
end;

procedure PulsgenSetGateMode(Adr:integer;mode:byte);
begin
  str(mode,buf);
  SendAndCheck(Adr,'GATE '+buf);
end;

procedure PulsgenSetToPeriode(Adr:integer;periode:double);
begin
  str(periode,buf);
  SendAndCheck(Adr,'ToPer '+buf);
end;

procedure PulsgenSetDutyCycleOnTime(Adr:integer;OnTime:double);
begin
  str(OnTime,buf);
  SendAndCheck(Adr,'DC:On '+buf);
end;

procedure PulsgenSetDutyCycleOffTime(Adr:integer;OffTime:double);
begin
  str(OffTime,buf);
  SendAndCheck(Adr,'DC:Off '+buf);
end;

procedure PulsgenSetTriggerPolarity(Adr:integer;Polarity:byte);
begin
  str(Polarity,buf);
  SendAndCheck(Adr,'TRIG '+buf);
end;

procedure PulsgenSetNrPulses(Adr:integer;Pulses:word);
begin
  str(Pulses,buf);
  SendAndCheck(Adr,'PULSES '+buf);
end;

procedure PulsgenSetDutyCycleCycles(Adr:integer;Cycles:word);
begin
  str(Cycles,buf);
  SendAndCheck(Adr,'Cycles '+buf);
end;

procedure PulsgenSetPulsesInBurst(Adr:integer;Number:word);
begin
  str(Number,buf);
  SendAndCheck(Adr,'#/BURST '+buf);
end;

procedure PulsgenSetPulsWidth(Adr:integer;Channel:byte;width:double);
begin
  str(width:0:0,buf);
  str(channel,buf2);
  SendAndCheck(Adr,'T'+buf2+':Wid '+buf);
end;

procedure PulsgenSetPulsDelay(Adr:integer;Channel:byte;delay:double);
begin
  str(delay:0:0,buf);
  str(channel,buf2);
  SendAndCheck(Adr,'T'+buf2+':Dly '+buf);
end;

procedure PulsgenSetPulsPolarity(Adr:integer;Channel:byte;Polarity:byte);
begin
  str(Polarity,buf);
  str(channel,buf2);
  SendAndCheck(Adr,'T'+buf2+':Pol '+buf);
end;

procedure PulsgenSetChannel2Output(Adr:integer;Output:byte);
begin
  str(Output,buf);
  SendAndCheck(Adr,'T2:Enable '+buf);
end;

procedure PulsgenSetChannel2Gate(Adr:integer;State:byte);
begin
  str(State,buf);
  SendAndCheck(Adr,'T2:Gate '+buf);
end;

procedure PulsgenSetChannel2Wait(Adr:integer;delay:double);
begin
  str(delay,buf);
  SendAndCheck(Adr,'T2:Wait '+buf);
end;

procedure PulsgenSetChannel2Period(Adr:integer;n:word);
begin
  str(n,buf);
  SendAndCheck(Adr,'T2*n '+buf);
end;

procedure PulsgenBeep(Adr:integer;n:word);
begin
  str(n,buf);
  SendAndCheck(Adr,'BEEP '+buf);
end;

procedure PulsgenRun(Adr:integer;onoff:byte);
begin
  str(onoff,buf);
  SendAndCheck(Adr,'RUN '+buf);
end;

procedure PulsgenRecall(Adr:integer;n:byte);
begin
  str(n,buf);
  SendAndCheck(Adr,'RECALL '+buf);
end;

procedure PulsgenStore(Adr:integer;n:byte);
begin
  str(n,buf);
  SendAndCheck(Adr,'STORE '+buf);
end;

procedure PulsgenResetShots(Adr:integer);
begin
  SendAndCheck(Adr,'SHOTS 0');
end;

procedure PulsgenEcho(Adr:integer;onoff:byte);
begin
  str(onoff,buf);
  SendAndCheck(Adr,'ECHO '+buf);
end;

procedure PulsgenMark(Adr:integer;MarkType:byte);
begin
  str(MarkType,buf);
  SendAndCheck(Adr,'Fmark '+buf);
end;

procedure PulsgenVolume(Adr:integer;Volume:byte);
begin
  str(Volume,buf);
  SendAndCheck(Adr,'VOLUME '+buf);
end;

end.
