unit RFSweep;
interface
uses Register;

const MaxRFPoints=10;
      MaxSynth=1;
type codestring=string[2];
     PRFSweep=^TRFSweep;
     TRFSweep=object
       MyRegistry:PRegistry;
       name:string;
       aktend:integer;
       aktedit:integer;
       akteditend:integer;
       DoSynth:array[0..MaxSynth] of boolean;
       RFLevel:array[0..MaxSynth] of double;
       Antenna:boolean;
       ConstantSweep:boolean;
       GPIBSingleStep:boolean;
       DoPowerCorrection:boolean;
       RFShieldFrequency:array [0..MaxSynth] of double;
       SwitchOffAfterSweep:boolean;
       SweepTime:double;
       SecondSynthStartTime:double;
       ThermalisationTime:double;
       sweep:array[1..MaxRFPoints] of record
         f:array[0..MaxSynth] of double;
         t:double;
       end;
       code:codestring;
       constructor init(var Registry:PRegistry;acode:codestring);
       destructor done;
       procedure Load(aname:string);
       procedure Save(aname:string);
       procedure DoSweep;
       procedure Edit;
       {function GetTotalSweepTime:double;}
     end;

procedure DoSweep(Sweep:Pointer);

implementation
uses crt,graph,Sequence,ExpIO,SigGen,params,strings;

procedure Dummy;far;
begin
end;

constructor TRFSweep.init(var Registry:PRegistry;acode:codestring);
var s,n,m:byte;
    buf,buf2:string;

  Procedure RegisterDouble(acolor:byte;ap:DoublePtr;ainit:double;amin:double;amax:double;aname:string;aquestion:string);
  begin
    Registry^.Insert(new(PRegDouble,init(ap,code+aname,ainit,amin,amax,aquestion,acolor)));
  end;

  Procedure RegisterInteger(acolor:byte;ap:IntPtr;ainit:integer;amin:integer;amax:integer;aname:string;aquestion:string);
  begin
    Registry^.Insert(new(PRegInt,init(ap,code+aname,ainit,amin,amax,aquestion,acolor)));
  end;

  Procedure RegisterBoolean(acolor:byte;ap:boolPtr;ainit:boolean;aname:string;aquestion:string);
  begin
    Registry^.Insert(new(PRegBoolean,init(ap,code+aname,ainit,aquestion,acolor)));
  end;

  Procedure RegisterString(acolor:byte;ap:StringPtr;ainit:string;aname:string;aquestion:string);
  begin
    Registry^.Insert(new(PRegString,init(ap,code+aname,ainit,aquestion,acolor)));
  end;

begin
  code:=acode;
  name:='RF Sweep';
  aktend:=2;
  akteditend:=2;
  aktedit:=1;
  for s:=0 to MaxSynth do RFLevel[s]:=1;
  Antenna:=true;
  ConstantSweep:=false;
  GPIBSingleStep:=false;
  DoPowerCorrection:=true;
  for n:=1 to MaxRFPoints do begin
    for m:=0 to MaxSynth do sweep[n].f[m]:=n;
    sweep[n].t:=n;
  end;
  for s:=0 to MaxSynth do RFShieldFrequency[s]:=1350;
  SwitchOffAfterSweep:=true;
  SweepTime:=0;
  SecondSynthStartTime:=0;
  ThermalisationTime:=0;
  Registry:=nil;

  myRegistry:=new(PRegistry,init(@Registry,Registry,true,'RF Sweep Parameters 1',Dummy));
  RegisterInteger(yellow,@AktEnd, 2  ,1,MaxRFPoints,'AktEnd','EndPoint [1..10]');

  for s:=0 to MaxSynth do begin
    str(s,buf);
    RegisterBoolean(markcolor,@DoSynth[s], false,'DoSynth'+buf,'Use Synthesizer '+buf+' [YES/NO]');
    RegisterDouble (yellow,@RFShieldFrequency[s], 1350  ,0,1350,
      'RFShieldFrequency'+buf,'RF Shield frequency Synthesizer '+buf+' [0..1350 MHz]');
    RegisterDouble (yellow,@RFLevel[s], -144  ,-144,19,'RFLevel'+buf,'RF Level Synthesizer '+buf+' [-144..19 dBm]');
  end;

  RegisterBoolean(yellow,@Antenna, true,'Antenna','Antenna obsolet [YES=RF/NO=-wave]');
  RegisterBoolean(yellow,@ConstantSweep, False,'ConstantSweep','Constant Frequency [YES/NO]');
  RegisterBoolean(yellow,@GPIBSingleStep, False,'GPIBSingleStep','GPIB Single Step [YES/NO]');
  RegisterBoolean(yellow,@DoPowerCorrection, True,'DoPowerCorrection','Do Power Correction [YES/NO]');
  RegisterBoolean(yellow,@SwitchOffAfterSweep, true,'SwitchOffAfterSweep','Switch RF off after sweep [Yes/no]');
  RegisterDouble (yellow,@SweepTime, 0  ,0,100000,'SweepTime','Total Sweep Time [ms] (0=fixed by sweep)');
  RegisterDouble (yellow,@SecondSynthStartTime, 0  ,0,100000,
    'SecondSynthStartTime','Second Synth Start Time [ms] (0=start at once)');
  RegisterDouble (yellow,@ThermalisationTime, 0  ,0,100000,'ThermalisationTime','Thermalisation Time [ms]');
  for n:=1 to 10 do begin
    str(n,buf);
    RegisterDouble (yellow,@(sweep[n].t), n  ,0,1000000,'Time'+buf,'Time of point '+buf+' [ms]');
    for s:=0 to MaxSynth do begin
      str(s,buf2);
      RegisterDouble (yellow,@(sweep[n].f[s]), n  ,0,1400,
        'Frequency'+buf+buf2,'Frequency at point '+buf+' for Synthesizer '+buf2+' [Mhz]');
    end;
  end;
  {myRegistry:=new(PRegistry,init(@Registry,Registry,true,'RF Sweep Parameters 2',Dummy));
  for n:=5 to 11 do begin
    str(n,buf);
    RegisterDouble (yellow,@(sweep[n].t), n  ,0,1000000,'Time'+buf,'Time of point '+buf+' [ms]');
    for s:=0 to MaxSynth do begin
      str(s,buf2);
      RegisterDouble (yellow,@(sweep[n].f[s]), n  ,0,1400,
        'Frequency'+buf+buf2,'Frequency at point '+buf+' for Synthesizer '+buf2+' [Mhz]');
    end;
  end;}
end;

destructor TRFSweep.done;
begin
  dispose(MyRegistry,done(false));
end;

procedure eatWhite(var buf:string);
begin
  while (buf[length(buf)]=' ') and (length(buf)>1) do buf:=copy(buf,1,length(buf)-1);
  while (buf[1]=' ') and (length(buf)>1) do buf:=copy(buf,2,length(buf)-1);
end;

procedure TRFSweep.Save(aname:string);
var out:text;
    n,s:byte;
begin
  assign(out,aname);
  rewrite(out);
  writeln(out,name);
  writeln(out,akteditend);
  writeln(out,aktend);
  writeln(out,aktedit);
  for s:=0 to MaxSynth do writeln(out,DoSynth[s]);
  for s:=0 to MaxSynth do writeln(out,RFShieldFrequency[s]);
  for s:=0 to MaxSynth do writeln(out,RFLevel[s]);
  writeln(out,Antenna);
  writeln(out,ConstantSweep);
  writeln(out,GPIBSingleStep);
  writeln(out,DoPowerCorrection);
  writeln(out,SwitchOffAfterSweep);
  writeln(out,SweepTime);
  writeln(out,SecondSynthStartTime);
  writeln(out,ThermalisationTime);
  for n:=1 to akteditend do begin
    write(out,sweep[n].t:7:4);
    for s:=0 to MaxSynth do write(out,' ',sweep[n].f[s]:7:4);
    writeln(out);
  end;
  system.close(out);
end;

procedure TRFSweep.Load(aname:string);
var inp:text;
    buf,buf2:string;
    err:integer;
    n,s:byte;
begin
  assign(inp,aname);
  {$I-}
  reset(inp);
  {$I+}
  if ioresult=0 then begin
    Readln(inp,name);
    Readln(inp,akteditend);
    Readln(inp,aktend);
    Readln(inp,aktedit);
    for s:=0 to MaxSynth do begin
      readln(inp,buf);
      DoSynth[s]:=buf='TRUE';
    end;
    for s:=0 to MaxSynth do readln(inp,RFShieldFrequency[s]);
    for s:=0 to MaxSynth do readln(inp,RFLevel[s]);
    readln(inp,buf);
    Antenna:=buf='TRUE';
    readln(inp,buf);
    ConstantSweep:=buf='TRUE';
    readln(inp,buf);
    GPIBSingleStep:=buf='TRUE';
    readln(inp,buf);
    DoPowerCorrection:=buf='TRUE';
    readln(inp,buf);
    SwitchOffAfterSweep:=buf='TRUE';
    readln(inp,SweepTime);
    readln(inp,SecondSynthStartTime);
    readln(inp,ThermalisationTime);
    for n:=1 to akteditend do begin
      Readln(inp,buf);
      eatWhite(buf);
      buf2:=copy(buf,1,pos(' ',buf)-1);
      eatWhite(buf2);
      val(buf2,sweep[n].t,err);
      for s:=0 to MaxSynth do begin
        buf:=copy(buf,pos(' ',buf)+1,255);
        eatWhite(buf);
        if s<>MaxSynth then buf2:=copy(buf,1,pos(' ',buf)-1)
        else buf2:=buf;
        eatWhite(buf2);
        val(buf2,sweep[n].f[s],err);
      end;
    end;
    system.close(inp);
  end;
end;

procedure TRFSweep.DoSweep;
var s,n:byte;
    dt,f,h:double;
    m,Maxm:integer;
    TotalTime,ElapsedTime,LocalUsedTime,hdt,RestTime,EndTime:double;
    PowerCorrection,NewPowerCorrection:double;
    SecondSynthOn,Sweepende:boolean;
    StartF:array[0..MaxSynth] of double;
    StopF:array[0..MaxSynth] of double;
    Slope:array[0..MaxSynth] of double;
    nrsmallSweeps,LastPowerCorrection:integer;
    WaitForCommand:boolean;
    HelpWait:double;
Label TimeOver;

const RS:array[0..MaxSynth] of byte=(0,1);

  function CalcPowerCorrection(s:byte;f:double):double;
    const PC:array[0..MaxSynth,0..15] of double =((
      2.07399,
      0.07087,
      -0.0013,
      1.72837E-5,
      -1.36417E-7,
      6.55667E-10,
      -1.9398E-12,
      3.449E-15,
      -3.3799E-18,
      1.40285E-21,
      2.07399,
      0.07087,
      -0.0013,
      1.72837E-5,
      -1.36417E-7,
      6.55667E-10)
    ,(
      2.07399,
      0.07087,
      -0.0013,
      1.72837E-5,
      -1.36417E-7,
      6.55667E-10,
      -1.9398E-12,
      3.449E-15,
      -3.3799E-18,
      1.40285E-21,
      2.07399,
      0.07087,
      -0.0013,
      1.72837E-5,
      -1.36417E-7,
      6.55667E-10
    ));
    const Offset:array[0..MaxSynth] of double = (-850,-850);
  begin
    f:=f+Offset[s];
    CalcPowerCorrection:=PC[s,0]+PC[s,1]*(f+PC[s,2]*(f+PC[s,3]*(f+PC[s,4]*(f+PC[s,5]*
                         PC[s,6]+PC[s,7]*(f+PC[s,8]*(f+PC[s,9]*(f+PC[s,10]*(f+PC[s,11]*
                         PC[s,12]+PC[s,13]*(f+PC[s,14]*(f+PC[s,15]))))))))));
  end;

  procedure MakeSweep(StartF:array of double;
                  StopF:array of double;
                  Time:double);
  var Slope:array[0..MaxSynth] of double;
      LocalUsedTime:double;
      s:byte;
      n:integer;

  begin
    {nrSynths:=0;
    for s:=0 to MaxSynth do if DoSynth[s] then inc(nrSynths);}
    LocalUsedTime:=0;
    if Time<GPIBCommandTime then begin
      Wait(time);
      ElapsedTime:=ElapsedTime+time;
      exit;
    end;
    for s:=0 to MaxSynth do if DoSynth[s] then begin
      SigGen.PrepareSweep(RS[s],StartF[s],StopF[s],1,Time-GPIBCommandTime);
      Wait(MinGPIBCommandTime);
      ElapsedTime:=ElapsedTime+MinGPIBCommandTime;
      LocalUsedTime:=LocalUsedTime+MinGPIBCommandTime;
      Slope[s]:=(StopF[s]-StartF[s])/(Time-MinGPIBCommandTime);
    end;
    dt:=Time-LocalUsedTime;
    for n:=0 to round(dt) do begin
      for s:=0 to MaxSynth do begin
        if DoSynth[s] then SetRFSweepCopyFrequency(RS[s],StartF[s]+slope[s]*n);
        Wait(1/(MaxSynth+1));
      end;
    end;
    Wait(dt-round(dt));
  end;

begin
  PowerCorrection:=0;
  ElapsedTime:=0;
  SecondSynthOn:=false;
  For s:=0 to MaxSynth do if DoSynth[s] then begin
    SetFrequency(RS[s],sweep[1].f[s]);
    wait(SynthGPIBCommandTime[RS[s]]);
    ElapsedTime:=ElapsedTime+SynthGPIBCommandTime[RS[s]];
    if ((s=0) or (SecondSynthStartTime=0)) then begin
      if DoPowerCorrection then PowerCorrection:=CalcPowerCorrection(s,sweep[1].f[s]);
      ModulationOff(RS[s]);
      SwitchRFGPIB(RS[s],RFLevel[s]+PowerCorrection,on);
      SwitchRF(RS[s],on);
      LastPowerCorrection:=0;
      wait(SynthGPIBCommandTime[RS[s]]);
      if s>0 then SecondSynthOn:=true;
      ElapsedTime:=ElapsedTime+SynthGPIBCommandTime[RS[s]];
    end;
  end;
  if ConstantSweep then begin
    Wait(sweep[2].t);
    ElapsedTime:=ElapsedTime+sweep[2].t;
  end else begin
    if not GPIBSingleStep then begin
      if (SweepTime<sweep[aktend].t) and (SweepTime>0) then TotalTime:=SweepTime
      else TotalTime:=sweep[aktend].t;
      n:=1;
      Sweepende:=false;
      while not Sweepende do begin
        dt:=sweep[n+1].t-sweep[n].t;
        For s:=0 to MaxSynth do begin
          StartF[s]:=sweep[n].f[s];
          slope[s]:=(sweep[n+1].f[s]-sweep[n].f[s])/dt;
        end;
        if ElapsedTime+dt>TotalTime then hdt:=TotalTime-ElapsedTime
        else hdt:=dt;
        nrsmallSweeps:=round(hdt/1000);
        RestTime:=hdt-1000*nrsmallSweeps;
        for m:=0 to nrsmallSweeps do begin
          EndTime:=RestTime+m*1000;
          For s:=0 to MaxSynth do StopF[s]:=sweep[n].f[s]+slope[s]*EndTime;
          if m=0 then SweepTime:=RestTime else SweepTime:=1000;
          MakeSweep(StartF,StopF,SweepTime);
          for s:=0 to MaxSynth do StartF[s]:=StopF[s];
        end;
        n:=n+1;
        Sweepende:=(ElapsedTime>=TotalTime) or (n>=aktend);
      end;
    end else begin
      for n:=1 to aktend-1 do begin
        dt:=sweep[n+1].t-sweep[n].t;
        if dt<(2+MaxSynth)*SynthGPIBCommandTime[RS[s]] then begin
          LocalUsedTime:=0;
          For s:=0 to MaxSynth do if DoSynth[s] then begin
            SetFrequency(RS[s],sweep[n+1].f[s]);
            wait(MinSubsequentGPIBCommandTime);
            LocalUsedTime:=LocalUsedTime+MinSubsequentGPIBCommandTime;
          end;
          if dt>LocalUsedTime then begin
            Wait(dt-LocalUsedTime);
            ElapsedTime:=ElapsedTime+dt;
          end else ElapsedTime:=ElapsedTime+LocalUsedTime;
          if ((ElapsedTime>SweepTime) and (SweepTime<>0)) then goto TimeOver;
        end else begin
          Maxm:=trunc(dt/SynthGPIBCommandTime[RS[s]]);
          for m:=1 to maxm do begin
            LocalUsedTime:=0;
            For s:=0 to MaxSynth do if DoSynth[s] then begin
              f:=(sweep[n+1].f[s]-sweep[n].f[s])*m/maxm+sweep[n].f[s];
              NewPowerCorrection:=CalcPowerCorrection(s,f);
              if (LastPowerCorrection>10) and DoPowerCorrection and
                 (abs(NewPowerCorrection-PowerCorrection)>1) then begin
                LastPowerCorrection:=0;
                NewPowerCorrection:=PowerCorrection;
                ModulationOff(RS[s]);
                SwitchRFGPIB(RS[s],RFLevel[s]+PowerCorrection,on);
                SwitchRF(RS[s],on);
              end else begin
                SetFrequency(RS[s],f);
                inc(LastPowerCorrection);
              end;
              wait(MinSubsequentGPIBCommandTime);
              LocalUsedTime:=LocalUsedTime+MinSubsequentGPIBCommandTime;
            end;
            if (MaxSynth=1) and DoSynth[1] then begin
              HelpWait:=SynthGPIBCommandTime[RS[s]]-LocalUsedTime;
              SetRFSweepCopyFrequency(RS[0],LastFrequency[0]);
              wait(HelpWait/2);
              SetRFSweepCopyFrequency(RS[1],LastFrequency[1]);
              wait(HelpWait/2);
            end else wait(SynthGPIBCommandTime[RS[s]]-LocalUsedTime);
            ElapsedTime:=ElapsedTime+SynthGPIBCommandTime[RS[s]];
            if ((ElapsedTime>SweepTime) and (SweepTime<>0)) then goto TimeOver;
            if (ElapsedTime>SecondSynthStartTime) and (SecondSynthStartTime>0) and (not SecondSynthOn) then
             For s:=1 to MaxSynth do if DoSynth[s] then begin
              ModulationOff(RS[s]);
              SwitchRFGPIB(RS[s],RFLevel[s],on);
              SwitchRF(RS[s],on);
              wait(SynthGPIBCommandTime[RS[s]]);
              ElapsedTime:=ElapsedTime+2*SynthGPIBCommandTime[RS[s]];
              SecondSynthOn:=true;
            end;
          end;
        end;
      end;
    end;
    TimeOver:
  end;
  Wait(ThermalisationTime);
  ElapsedTime:=ElapsedTime+ThermalisationTime;
  WaitForCommand:=false;
  if SwitchOffAfterSweep then begin
    For s:=0 to MaxSynth do if DoSynth[s] then begin
      if WaitForCommand then begin
        wait(2*MinSubsequentGPIBCommandTime);
        ElapsedTime:=ElapsedTime+2*MinSubsequentGPIBCommandTime;
      end;
      SwitchRFOff(RS[s]);
      SwitchRF(RS[s],off);
      WaitForCommand:=true;
    end;
  end else begin
    For s:=0 to MaxSynth do if DoSynth[s] then begin
      if WaitForCommand then begin
        wait(MinSubsequentGPIBCommandTime);
        ElapsedTime:=ElapsedTime+MinSubsequentGPIBCommandTime;
      end;
      SetFrequency(RS[s],RFShieldFrequency[s]);
      WaitForCommand:=true;
    end;
  end;
  {if ElapsedTime<SweepTime then Wait(sweepTime-ElapsedTime);}
end;

procedure DoSweep(Sweep:Pointer);
begin
  SequenceStartBlockPointerArg(DoSweep,Sweep);
    if sweep<>nil then PRFSweep(Sweep)^.DoSweep;
  SequenceEndBlock;
end;

{$L EGAVGA}
procedure EGAVGAdriver;external;

procedure TRFSweep.Edit;
var Maxx,Maxy,Maxh,Maxw,minw:integer;
    Shiftmode:boolean;
    AktSweep:byte;
    ein:char;
    actscreen:integer;

  const AxeHeight=20;
        AxeWidth=45;

  function GraphOn:boolean;
  var
   grDriver: Integer;
   grMode: Integer;
   ErrCode: Integer;
  begin
   grDriver:=VGA;
   grMode:=VGAMed;
   InitGraph(grDriver, grMode,'');
   ErrCode := GraphResult;
   if ErrCode<>grOk then begin
     writeln('Graphic Error ',ErrCode,^G);
     delay(1000);
     exit;
   end else begin
     Maxx:=GetMaxx;
     Maxy:=GetMaxy;
     Maxh:=Maxy-AxeHeight;
     Maxw:=Maxx-AxeWidth;
     Minw:=AxeWidth;
   end;
   GraphOn:=ErrCode = grOk;
   actscreen:=0;
   SetVisualPage(0);
   SetActivePage(1);
  end;

  procedure InitScreen;
  begin
    SetVisualPage(actscreen);
    if actscreen=1 then actscreen:=0 else actscreen:=1;
    SetActivePage(actscreen);
    SetLineStyle(SolidLn,0,ThickWidth);
    SetBKColor(black);
    ClearDevice;
  end;

  procedure DrawMe;
  var mint,maxt,minf,maxf,startt,startf:double;
      hx,hy,tw:integer;
      n:byte;
      buft,buff:string;
      buf:string;

    function X(t:double):integer;
    var hx:integer;
    begin
      hx:=round((t-mint)/(maxt-mint)*maxw)+AxeWidth;
      if hx<minw then hx:=minw;
      if hx>maxx then hx:=maxx;
      x:=hx;
    end;

    function Y(f:double):integer;
    var hy:integer;
    begin
      hy:=maxy-AxeHeight-round((f-minf)/(maxf-minf)*maxh);
      if hy<0 then hy:=0;
      if hy>maxy then hy:=maxy;
      y:=hy;
    end;

    procedure DrawAxes;
    var n,m,xh,yh:integer;
        startf,aktf,aktt:double;

    begin
      SetLineStyle(SolidLn,0,NormWidth);
      SetColor(green);
      Line(AxeWidth,0,AxeWidth,Maxy);
      Line(0,maxy-AxeHeight,maxx,maxy-AxeHeight);
      n:=trunc((maxf-minf)/100);
      startf:=trunc(minf/100+1)*100;
      for m:=1 to n do begin
        SetLineStyle(SolidLn,0,NormWidth);
        SetColor(green);
        aktf:=(m-1)*100+startf;
        yh:=Y(aktf);
        Line(AxeWidth-5,yh,AxeWidth,yh);
        SetColor(blue);
        SetLineStyle(DashedLn,0,NormWidth);
        Line(AxeWidth+1,yh,Maxx,yh);
        SetColor(yellow);
        str(aktf:4:0,buf);
        OuttextXY(0,yh-4,buf);
      end;
      n:=trunc((maxt-mint)/1000);
      startt:=trunc(mint/1000+1)*1000;
      for m:=1 to n do begin
        SetLineStyle(SolidLn,0,NormWidth);
        SetColor(green);
        aktt:=(m-1)*1000+startt;
        xh:=x(aktt);
        Line(xh,Maxy-AxeHeight,xh,MAxy-AxeHeight+5);
        if (trunc(aktt/1000) mod 5)=0 then begin
          SetColor(blue);
          SetLineStyle(DashedLn,0,NormWidth);
          Line(xh,0,xh,Maxy-AxeHeight-1);
          SetColor(yellow);
          str(aktt/1000:2:0,buf);
          EatWhite(buf);
          OuttextXY(xh-(TextWidth(buf) div 2),Maxy-AxeHeight+10,buf);
        end;
      end;
    end;

  var s:byte;
  begin
    mint:=0;
    maxt:=1000;
    minf:=1350;
    maxf:=0;
    for n:=1 to akteditend do begin
      for s:=0 to MaxSynth do if DoSynth[s] then begin
        if sweep[n].f[s]>maxf then maxf:=sweep[n].f[s];
        if sweep[n].f[s]<minf then minf:=sweep[n].f[s];
      end;
      if sweep[n].t>maxt then maxt:=sweep[n].t;
      if sweep[n].t<mint then mint:=sweep[n].t;
    end;
    minf:=minf-0.05*(maxf-minf);
    maxf:=maxf+0.05*(maxf-minf);
    mint:=mint-0.05*(maxt-mint);
    maxt:=maxt+0.05*(maxt-mint);
    if maxf-minf<20 then maxf:=minf+20;
    if maxt-mint<100 then maxt:=mint+100;
    DrawAxes;
    SetColor(LightRed);
    Outtextxy(0,Maxy-TextHeight('H'),'H');
    SetColor(White);
    Outtextxy(TextWidth('H'),Maxy-TextHeight('H'),'elp');
    SetColor(Magenta);
    SetLineStyle(SolidLn,0,ThickWidth);
    for s:=0 to MaxSynth do if DoSynth[s] then begin
      hy:=Y(RFShieldFrequency[s]);
      if (hy<maxy-AxeHeight-1) and (hy>=0) then line(AxeWidth+1,hy,maxx,hy);
    end;
    SetColor(blue);
    hx:=x(sweep[aktend].t);
    if (hx<maxx) and (hx>=AxeWidth) then line(hx,0,hx,maxy-AxeHeight-1);
    if SweepTime>0 then begin
      SetColor(Yellow);
      hx:=x(SweepTime);
      if (hx<maxx) and (hx>=AxeWidth) then line(hx,0,hx,maxy-AxeHeight-1);
    end;
    if SecondSynthStartTime>0 then begin
      SetColor(brown);
      hx:=x(SecondSynthStartTime);
      if (hx<maxx) and (hx>=AxeWidth) then line(hx,0,hx,maxy-AxeHeight-1);
    end;
    SetColor(blue);
    SetLineStyle(SolidLn,0,ThickWidth);
    hy:=Y(804);
    if (hy<maxy-AxeHeight-1) and (hy>=0) then line(AxeWidth+1,hy,maxx,hy);
    hy:=Y(228);
    if (hy<maxy-AxeHeight-1) and (hy>=0) then line(AxeWidth+1,hy,maxx,hy);
    for s:=0 to MaxSynth do if DoSynth[s] then begin
      SetLineStyle(SolidLn,0,ThickWidth);
      SetColor(green);
      MoveTo(X(sweep[1].t),Y(sweep[1].f[s]));
      for n:=2 to akteditend do LineTo(X(sweep[n].t),Y(sweep[n].f[s]));
      for n:=1 to akteditend do begin
        hx:=X(sweep[n].t);
        hy:=Y(sweep[n].f[s]);
        if (aktedit=n) and (aktSweep=s) then begin
          if shiftmode then SetFillStyle(SolidFill,black)
          else SetFillStyle(SolidFill,red);
          Setcolor(red);
        end else begin
          SetFillStyle(SolidFill,white);
          setcolor(white);
        end;
        FillEllipse(hx,hy,5,5);
        setcolor(yellow);
        str(sweep[n].t/1000:4:2,buft);
        str(sweep[n].f[s]:4:1,buff);
        buft:='('+buft+' s /'+buff+' MHz)';
        tw:=TextWidth(buft);
        if (hx+tw+10)>Maxx then hx:=hx-tw-40;
        OutTextXY(hx+10,hy-10,buft);
        if n>1 then begin
          str((sweep[n].t-sweep[n-1].t)/1000:4:2,buft);
          buft:='(dt='+buft+' s)';
          OutTextXY(hx+10,hy-5+TextHeight(buf),buft);
        end;
      end;
    end;
    SetVisualPage(actscreen);
  end;

  procedure ShiftT(dt:double);
  var n:byte;
  begin
    if ((sweep[aktedit].t+dt)>=0) and ((aktedit=1)
       or (sweep[aktedit].t+dt>sweep[aktedit-1].t))
    then for n:=aktedit to akteditend do sweep[n].t:=sweep[n].t+dt;
  end;

  procedure ShiftF(df:double);
  begin
    if ((sweep[aktedit].f[aktSweep]+df)>=0) and ((sweep[aktedit].f[aktSweep]+df)<=1350)
    then sweep[aktedit].f[aktSweep]:=sweep[aktedit].f[aktSweep]+df;
  end;

  procedure Helpscreen;
  begin
    closegraph;
    TextBackGround(blue);
    TextColor(Yellow);
    Clrscr;
    writeln('*** Help ***');
    Writeln;
    Writeln('ENTER: Toggle between selection and move mode');
    Writeln('ESC  : Go back');
    Writeln;
    Writeln('In selection mode:');
    Writeln;
    Writeln('4,6  : Choose Point');
    Writeln('7,9  : Remove, add Point');
    Writeln('1,3  : Choose endpoint of RF sweep');
    Writeln('S    : Change sweep');
    Writeln;
    Writeln('In move mode use NumPad and NumPad in combination with SHIFT to move point');
    repeat until keypressed;
    GraphOn;
  end;

begin
  if not GraphOn then exit;
  Shiftmode:=false;
  AktSweep:=0;
  repeat
    InitScreen;
    DrawMe;
    repeat until keypressed;
    ein:=readkey;
    if ein=#0 then begin
      ein:=readkey;
      if shiftmode then begin
        case ein of
          #80:ShiftF(-10);
          #72:ShiftF(10);
          #79:ShiftF(-100);
          #71:ShiftF(100);
          #81:ShiftF(-1);
          #73:ShiftF(1);
          #75:ShiftT(-100);
          #77:ShiftT(100);
        end;
      end else begin
        case ein of
          #75:if aktedit>1 then dec(aktedit);
          #77:if aktedit<akteditend then inc(aktedit);
          #73:begin
            if akteditend<MaxRFPoints then begin
              inc(akteditend);
              if sweep[akteditend].t<sweep[akteditend-1].t then begin
                sweep[akteditend].t:=sweep[akteditend-1].t+500;
                sweep[akteditend].f:=sweep[akteditend-1].f;
              end;
            end;
          end;
          #71:if akteditend>2 then dec(akteditend);
          #79:if aktend>1 then dec(aktend);
          #81:if aktend<akteditend then inc(aktend);
        end;
      end;
    end else begin
      if shiftmode then begin
        case ein of
          #52:ShiftT(-100);
          #54:ShiftT(100);
          #55:ShiftT(-1000);
          #57:ShiftT(1000);
          #49:ShiftT(-10);
          #51:ShiftT(10);
          #56:ShiftF(10);
          #50:ShiftF(-10);
          '+':ShiftF(0.1);
          '-':ShiftF(-0.1);
        end;
      end else begin
        case ein of
          #52:if aktedit>1 then dec(aktedit);
          #54:if aktedit<akteditend then inc(aktedit);
          #57:begin
            if akteditend<MaxRFPoints then begin
              inc(akteditend);
              if sweep[akteditend].t<sweep[akteditend-1].t then begin
                sweep[akteditend].t:=sweep[akteditend-1].t+500;
                sweep[akteditend].f:=sweep[akteditend-1].f;
              end;
            end;
          end;
          #55:if akteditend>2 then dec(akteditend);
          #49:if aktend>1 then dec(aktend);
          #51:if aktend<akteditend then inc(aktend);
        end;
      end;
      case ein of
        #13:shiftmode:=not shiftmode;
        'H','h':Helpscreen;
        'S','s':begin
          aktSweep:=aktSweep+1;
          if aktSweep>MaxSynth then aktSweep:=0;
        end;
      end;
    end;
    while keypressed do ein:=readkey;
  until ein=#27;
  closegraph;
end;

begin
  if (RegisterBGIDriver(@EGAVGAdriver)<0) then begin
    writeln('RFSweep : BGI driver not found',^G);
    delay(1000);
  end;
end.