{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}
PROGRAM SaveLeCroy;
{Program to save trace from LeCroy}

USES CRT,LeCroy;

const MaxPoints=2500;
TYPE
  pSig=^tSig;
  tSig=ARRAY[0..MaxPoints] OF real;

VAR
  PDSig,CSig:pSig;
  nPoints:INTEGER;
  fnumber:WORD;
  key:STRING;

PROCEDURE SetupOsc;
VAR
  s:STRING;
  gpiberr:integer;
BEGIN
  LeCroy_Init(TRUE,4,'9310');
END;

PROCEDURE ReadOsc(VAR PDSig,CSig:pSig;VAR nPoints:INTEGER);
VAR
  LeCroyFile:TEXT;
  Error:INTEGER;
  t,V,PD:real;
BEGIN
  Assign(LeCroyFile,'TEMP.EP');
  Rewrite(LeCroyFile);
  SaveFromScreen(MaxPoints,LeCroyFile,Error);
  Close(LeCroyFile);
  IF Error<>0 THEN BEGIN
    Writeln('LeCroy_SaveFromScreen:Error ',Error);
  END;
  Reset(LeCroyFile);
  nPoints:=0;

  WHILE NOT EOF(LeCroyFile) DO BEGIN
    {$I-}
    Readln(LeCroyFile,t,V,PD);
    IF IOResult=0 THEN BEGIN
      CSig^[nPoints]:=V;
      PDSig^[nPoints]:=PD;
      Inc(nPoints);
    END;
    {$I+}
  END;
  Close(LeCroyFile);

END;


PROCEDURE Save(VAR PDSig,Csig:pSig;nPoints:INTEGER;filenumber:WORD);
VAR
  CalFileName:STRING;
  numberstring:string[4];
  CalFile:TEXT;
  i:INTEGER;

BEGIN
  Str(filenumber,numberstring);

  CalFileName:='Spectre'+numberstring+'.LE';
  Assign(CalFile,CalFileName);
  Rewrite(CalFile);

  FOR i:=1 TO nPoints-2 DO
    WriteLn(CalFile,PDSig^[i]:12:8,CSig^[i]:12:8);
  Close(CalFile);
  WriteLn('--> trace saved as ',CalFileName);
END;


BEGIN
  new(PDSig);
  new(CSig);
  SetupOsc;

  ClrScr;
  WriteLn('Routine saves Lecroy traces to harddisk.');
  Write('Enter startindex of first file:');
  ReadLn(fnumber);

  WriteLn;
  WriteLn('enter x<return> to exit, <return> to save trace');
  ReadLn(key);

  WHILE key<>'x' DO BEGIN

  ReadOsc(PDSig,CSig,nPoints);

  Save(PDSig,CSig,nPoints,fnumber);

  WriteLn;
  WriteLn('enter x<return> to exit, <return> to save trace');
  ReadLn(key);

  fnumber:=fnumber+1;
  END;
  dispose(PDSig);
  dispose(CSig);
END.
