program testHP;
uses crt,IEEE;
const on=true;
      off=false;
      MaxRFLevel=19;
      MinRFLevel=-136;



const Marconi=0;
      old=1;
      HP=2;
      MaxSynth=1;
      GPIBAdress:array[0..MaxSynth] of byte=(2,0);
      SynthType:array[0..MaxSynth] of byte=(2,0);
      LastFrequ:array[0..MaxSynth] of double=(0,0);

procedure eatWhite(var buf:string);
begin
  while (buf[length(buf)]=' ') and (length(buf)>1) do buf:=copy(buf,1,length(buf)-1);
  while (buf[1]=' ') and (length(buf)>1) do buf:=copy(buf,2,length(buf)-1);
end;

const RFison:array[0..MaxSynth] of boolean=(false,false);

function RFOn(Synth:byte):boolean;
begin
  RFOn:=RFison[Synth];
end;

procedure SwitchRFOff(Synth:byte);
var status:integer;
begin
    case SynthType[Synth] of
      Marconi:Send(GPIBAdress[Synth],'RFLV:VALUE -144.0DBM;OFF;',status);
      old:Send(GPIBAdress[Synth],'LEVEL -140.0DBM;LEVEL:OFF;',status);
      HP:begin
        Send(GPIBAdress[Synth],':POW -136.0DBM',status);
        Send(GPIBAdress[Synth],':OUTP OFF',status);
      end;
    end;
  RFison[Synth]:=off;
end;

procedure SwitchRF(Synth:byte;Level:double;onoff:boolean);
var status:integer;
    buf:string;
begin
  RFison[Synth]:=onoff;
    str(level:5:1,buf);
    EatWhite(buf);
    if onoff then begin
      case SynthType[Synth] of
        Marconi:Send(GPIBAdress[Synth],'RFLV:VALUE '+buf+'DBM;ON;',status);
        old:Send(GPIBAdress[Synth],'LEVEL '+buf+'DBM; LEVEL:ON',status);
        HP:begin
          Send(GPIBAdress[Synth],':POW '+buf+'DBM',status);
          Send(GPIBAdress[Synth],':OUTP ON',status);
        end;
      end;
    end else begin
      case SynthType[Synth] of
        Marconi:Send(GPIBAdress[Synth],'RFLV:VALUE '+buf+'DBM;OFF;',status);
        old:Send(GPIBAdress[Synth],'LEVEL '+buf+'DBM; LEVEL:OFF',status);
        HP:begin
          Send(GPIBAdress[Synth],':POW '+buf+'DBM',status);
          Send(GPIBAdress[Synth],':OUTP OFF',status);
        end;
      end;
    end;
end;

procedure SetFrequency(Synth:byte;f:double);
var buf:string;
    status:integer;
begin
    str(f:4:4,buf);
    EatWhite(buf);
    case SynthType[Synth] of
      Marconi:Send(GPIBAdress[Synth],'CFRQ '+buf+'MHZ',status);
      old:Send(GPIBAdress[Synth],'RF '+buf+'MHZ',status);
      HP:Send(GPIBAdress[Synth],':FREQ '+buf+'MHZ',status);
    end;
    LastFrequ[Synth]:=f;
end;

procedure Sweep(Synth:byte;StartFrequency:double;StopFrequency:double;StepTime:double;Steps:double);
var bufstart:string;
    bufstop:string;
    buftime:string;
    bufnrstep:string;
    status,n:integer;
begin
    str(StartFrequency:4:4,bufstart);
    str(StopFrequency:4:4,bufstop);
    str(StepTime:4:4,buftime);
    str(Steps:4:0,bufnrstep);
    EatWhite(bufstart);
    EatWhite(bufstop);
    EatWhite(buftime);
    EatWhite(bufnrstep);
    case SynthType[Synth] of
      Marconi:begin
        Send(GPIBAdress[Synth],'IMODE SWEEPER',status);
        Send(GPIBAdress[Synth],'SWEEP:TYPE CFRQ',status);
        Send(GPIBAdress[Synth],'SWEEP:CFRQ:START '+bufstart+
          'MHZ',status);
        Send(GPIBAdress[Synth],'SWEEP:CFRQ:STOP '+bufstop+'MHZ',status);
        Send(GPIBAdress[Synth],'SWEEP:CFRQ:STEP '+bufnrstep,status);
        Send(GPIBAdress[Synth],'SWEEP:CFRQ:TIME '+buftime+'MS',status);
        Send(GPIBAdress[Synth],'SWEEP:MODE SNGL',status);
        Send(GPIBAdress[Synth],'SWEEP:GO',status);
      end;
      HP:begin
        Send(GPIBAdress[Synth],':FREQ:MODE LIST',status);
        Send(GPIBAdress[Synth],':LIST:TYPE STEP',status);
        Send(GPIBAdress[Synth],':FREQ:START '+bufstart+' MHZ',status);
        Send(GPIBAdress[Synth],':FREQ:STOP '+bufstop+' MHZ',status);
        Send(GPIBAdress[Synth],':SWE:POIN '+bufnrstep,status);
        Send(GPIBAdress[Synth],':SWE:DWEL '+buftime+' MS',status);
      end;
    end;
    LastFrequ[Synth]:=StopFrequency;
end;

procedure InitMarconi(Synth:byte);
var status:integer;
begin
    case SynthType[Synth] of
      Marconi: begin
        Send(GPIBAdress[Synth],'*RST',status);
        if (status<>0) then begin
          writeln('Marconi: Error talking to Synthesizer Nr ',Synth);
          delay(500);
        end else begin
          Send(GPIBAdress[Synth],'SWEEP:SNGL',status);
          if (status<>0) then begin
            writeln('Marconi: Error in command SWEEP:SNGL Synth Nr ',Synth);
            delay(500);
          end;
          SwitchRF(Synth,MinRFLevel,off);
        end;
      end;
      old:;
      HP: begin
        Send(GPIBAdress[Synth],'*RST',status);
        if (status<>0) then begin
          writeln('HP: Error talking to Synthesizer Nr ',Synth);
          delay(500);
        end else begin
          Send(GPIBAdress[Synth],':OUTP:MOD OFF',status);
          SwitchRF(Synth,MinRFLevel,off);
        end;
      end;
    end;
end;

var status:integer;
begin
  InitMarconi(0);
  SwitchRF(0,-30,on);

  Sweep(0,1000,800,1,400);



  SetFrequency(0,700);

  Send(GPIBAdress[0],':FREQ:MODE LIST',status);
  Send(GPIBAdress[0],':INIT',status);
end.