program TestMarconi;

uses crt,IEEE;
const on=true;
      off=false;
      MaxRFLevel=19;
      MinRFLevel=-140;

const MaxSynth=1;
      Marconi2030:array[0..MaxSynth] of byte=(2,0);
      LastFrequ:array[0..MaxSynth] of double=(0,0);




procedure eatWhite(var buf:string);
begin
  while (buf[length(buf)]=' ') and (length(buf)>1) do buf:=copy(buf,1,length(buf)-1);
  while (buf[1]=' ') and (length(buf)>1) do buf:=copy(buf,2,length(buf)-1);
end;

const RFison:array[0..MaxSynth] of boolean=(false,false);

function RFOn(Synth:byte):boolean;
begin
  RFOn:=RFison[Synth];
end;

procedure SwitchRFOff(Synth:byte);
var status:integer;
begin
    Send(Marconi2030[Synth],'RFLV:VALUE -144.0DBM;OFF;',status);
     {Send(Marconi2030,'LEVEL -140.0DBM;LEVEL:OFF;',status);}
  RFison[Synth]:=off;
end;

procedure SwitchRF(Synth:byte;Level:double;onoff:boolean);
var status:integer;
    buf:string;
begin
  RFison[Synth]:=onoff;
    str(level:5:1,buf);
    EatWhite(buf);
    if onoff then begin
      Send(Marconi2030[Synth],'RFLV:VALUE '+buf+'DBM;ON;',status);
    end else begin
      Send(Marconi2030[Synth],'RFLV:VALUE '+buf+'DBM;OFF;',status);
    end;
    {if onoff then begin
      Send(Marconi2030,'LEVEL '+buf+'DBM; LEVEL:ON',status);
      SetRFSweepCopyFrequency(lastFrequ);
    end else begin
      Send(Marconi2030,'LEVEL '+buf+'DBM; LEVEL:OFF',status);
      SetRFSweepCopyFrequency(0);
    end;}
end;

procedure SetFrequency(Synth:byte;f:double);
var buf:string;
    status:integer;
begin
    str(f:4:4,buf);
    EatWhite(buf);
    Send(Marconi2030[Synth],'CFRQ '+buf+'MHZ',status);
    {Send(Marconi2030,'RF '+buf+'MHZ',status);}
    LastFrequ[Synth]:=f;
end;

procedure PrepareSweep(Synth:byte;StartFrequency:double;StopFrequency:double;
  StepTime:double;Steps:double);
var bufstart:string;
    bufstop:string;
    buftime:string;
    bufnrstep:string;
    status,n:integer;
begin
    str(StartFrequency:4:4,bufstart);
    str(StopFrequency:4:4,bufstop);
    str(StepTime:4:4,buftime);
    str(Steps:4:0,bufnrstep);
    EatWhite(bufstart);
    EatWhite(bufstop);
    EatWhite(buftime);
    EatWhite(bufnrstep);
    Send(Marconi2030[Synth],'IMODE SWEEPER',status);
    Send(Marconi2030[Synth],'SWEEP:TYPE CFRQ',status);
    Send(Marconi2030[Synth],'SWEEP:CFRQ:START '+bufstart+
      'MHZ',status);
    Send(Marconi2030[Synth],'SWEEP:CFRQ:STOP '+bufstop+'MHZ',status);
    Send(Marconi2030[Synth],'SWEEP:CFRQ:STEP '+bufnrstep,status);
    Send(Marconi2030[Synth],'SWEEP:CFRQ:TIME '+buftime+'MS',status);
    Send(Marconi2030[Synth],'SWEEP:MODE SNGL',status);
    Send(Marconi2030[Synth],'SWEEP:CALC',status);
end;

procedure SignalGeneratorMode(Synth:byte);
var status:integer;
begin
  Send(Marconi2030[Synth],'IMODE NORMAL',status);
end;

procedure SweepMode(Synth:byte);
var status:integer;
begin
  Send(Marconi2030[Synth],'IMODE SWEEPER',status);
end;


procedure DoSweep(Synth:byte);
var status:integer;
begin
  Send(Marconi2030[Synth],'SWEEP:GO',status);
end;

procedure InitMarconi(Synth:byte);
var status:integer;
begin
    Send(Marconi2030[Synth],'*RST',status);
    if (status<>0) then begin
      writeln('Marconi: Error talking to Synthesizer Nr ',Synth);
      delay(500);
    end else begin
      Send(Marconi2030[Synth],'SWEEP:SNGL',status);
      if (status<>0) then begin
        writeln('Marconi: Error in command SWEEP:SNGL Synth Nr ',Synth);
        delay(500);
      end;
      SwitchRF(Synth,MinRFLevel,off);
    end;
end;

var status:integer;
begin
  InitMarconi(1);
  SwitchRF(1,-30,on);
  PrepareSweep(1,1000,800,1,100);

  Send(Marconi2030[1],':STO:SWEEP 0',status);

  SignalGeneratorMode(1);

  SetFrequency(1,700);

  SweepMode(1);

  Send(Marconi2030[1],':RCL:SWEEP 0',status);

  DoSweep(1);
  SwitchRF(1,-30,off);
end.