program testmultiout;
uses crt;

Const NumbDig=4;
Const NumbAna=12;

Const DigAdr:array[0..NumbDig-1] of byte=(0,1,2,3);
      AnaAdr:array[0..NumbAna-1] of byte=(4,5,6,7,8,9,10,11,12,13,14,15);



CONST
  {DAS-1601 registers:}
  adr=$310;
  ad0=adr+$0;
  ad1=adr+$1;
  mux=adr+$2;
  dio=adr+$3;
  da0lb=adr+$4;
  da0hb=adr+$5;
  da1lb=adr+$6;
  da1hb=adr+$7;
  statusa=adr+$8;
  ctrl=adr+$9;
  cnten=adr+$A;
  gain=adr+$B;
  timer0=adr+$C;
  timer1=adr+$D;
  timer2=adr+$E;
  timerctl=adr+$F;
  piopa=adr+$400;
  piopb=adr+$401;
  piopc=adr+$402;
  pioctl=adr+$403;
  disarm=adr+$404;
  bmden=adr+$405;
  mden1600=adr+$406;
  statusb=adr+$407;
  BUS1=128;
  BUS2=64;
  RW=32;

procedure WritePort(channel:byte;value:word);
var n:byte;
begin
  port[piopa]:=Lo(value);
  port[piopb]:=Hi(value);
  port[piopc]:=channel+BUS1+BUS2+RW;
  port[piopc]:=channel+BUS1+BUS2;
  port[piopc]:=channel+BUS1+BUS2+RW;
end;

procedure MultiOutdigitalOut(channel:byte;value:word);
begin
  if (channel<NumbDig) then WritePort(DigAdr[channel],value)
  else writeln('MultiOut : digitalOut : wrong channel ',channel);
end;

procedure MultiOutanalogOut(channel:byte;value:word);
begin
  if (channel<NumbAna) then WritePort(AnaAdr[channel],value)
  else writeln('MultiOut : analogOut : wrong channel ',channel);
end;

procedure MultiOutInit;
var n:byte;
begin
  port[pioctl]:=128;
  port[piopc]:=32+BUS1+BUS2;
  for n:=0 to NumbDig-1 do MultiOutdigitalOut(n,0);
  for n:=0 to NumbAna-1 do MultiOutanalogOut(n,0);
end;

var n:word;
    m:word;
    p:byte;
    i:byte;
    ein:char;
    dir:boolean;

begin
  MultiOutInit;
  dir:=true;
  m:=1;
  n:=0;
  p:=31;
  i:=0;

  WritePort(30,$ffff);
  WritePort(12,$ffff);
  WritePort(13,$ffff);
  WritePort(14,$ffff);
  WritePort(15,$ffff);
  readln;
  repeat
  for n:=0 to 65535 do WritePort(30,n);
  readln;
  until false;
  repeat
    for i:=0 to 16 do begin
      WritePort(30,$ffff shl i);
      writeln($ffff shl i);
      delay(100);
    end;
    delay(1000);
    WritePort(30,$ffff);
    delay(500);
  until keypressed;
  readln;
{  WritePort(21,0);
  delay(5000);
  WritePort(21,30000);
  delay(5000);
  WritePort(21,33000);
  delay(5000);
  WritePort(21,65000);
  delay(5000);}
  repeat
  writeln(p);
  repeat
    if dir then if n<32767 then n:=n+1 else dir:=false;
    if not dir then if n>0 then n:=n-1 else dir:=true;
    if m<5000 then m:=m+1 else begin
      m:=0;
      i:=i+1;
      if i>15 then i:=0;
    end;
    WritePort(p,n);
    WritePort(29,1 shl i);
    WritePort(30,not (1 shl i));
    WritePort(31,1 shl i);
    WritePort(12,n);
    WritePort(13,32767-n);
    WritePort(14,n);
    WritePort(15,32767-n);
    WritePort(24,n);
    WritePort(25,32767-n);
    WritePort(26,n);
    WritePort(27,32767-n);
    WritePort(20,n);
    WritePort(21,32767-n);
    WritePort(22,n);
    WritePort(23,32767-n);
  until keypressed;
  while keypressed do ein:=readkey;
  p:=p-1;
  until (ein=#27) or (p=0);
end.
