unit unimess;
interface
uses Register,menu,serial,crt,strings;

const Maxvars=4;
type PUniMess=^TUniMess;
     TUniMess=object
		 next:PUniMess;
		 Name:stringPtr;
		 nrvars:integer;
		 start,ende:array[1..Maxvars] of double;
		 nr:array[1..Maxvars] of integer;
		 vars:array[1..Maxvars] of PRegDouble;
		 Registry:PRegistry;
		 VisionCommand:stringPtr;
		 BigMeasurement:boolean;
		 Repetitions:integer;
		 myChoice:integer;
		 constructor init(anext:PUniMess;aRegistry:PRegistry);
		 destructor done;
		 procedure EditUniMess;
		 function LoadNextUniMess(var inp:text):boolean;
		 procedure Save(aname:string);
		 procedure SaveNextUniMess(var out:text);
		 procedure SelectUniMessDialog(var UniMeasure:PUniMess);
                 procedure NextSelectUniMessDialog(Menu:PMenuInfo;var aende:PUniMess;var endcode:integer;anr:byte);
                 procedure UniMessDialog(code:integer);
		 procedure SendVariables(port:byte);
                 function GetUniMessFromName(aname:string):PUniMess;
	  end;

function LoadUniMess(aname:string;Registry:PRegistry):PUniMess;

implementation
uses Exp,Vision;

constructor TUniMess.init(anext:PUniMess;aRegistry:PRegistry);
var n:byte;
begin
  Name:=NewString('Name');
  nrvars:=1;
  for n:=1 to Maxvars do begin
	 start[n]:=0;
	 ende[n]:=1;
	 nr[n]:=1;
	 vars[n]:=NIL;
  end;
  Registry:=aRegistry;
  VisionCommand:=NewString('');
  BigMeasurement:=false;
  myChoice:=0;
  next:=anext;
  Repetitions:=1;
end;

destructor TUniMess.done;
begin
  if next<>NIL then dispose(next,done);
  DeleteString(VisionCommand);
  DeleteString(Name);
end;

procedure TUniMess.EditUniMess;
Var
  iParam,iBack,Dummy:integer;
  iSParam:array[1..MaxVars] of integer;
  MenuInfo:PMenuInfo;
  Choice:integer;
  Rep:char;
  buf:string;
  n:byte;

  procedure ParamDialog;
  var InfoDialog   : PDialogInfo;
		UpdateDialog : boolean;
  begin
	 NewDialog(InfoDialog);
	 AddS(yellow,InfoDialog,Name^,'Name of this measurement','Name of this measurement');
	 AddI(yellow,InfoDialog,nrvars,'Number of variables [1..4]','Number of Variables',1,4);
	 AddS(yellow,InfoDialog,VisionCommand^,'Vision command to execute after measurement',
           'Vision command to execute after measurement');
	 AddB(yellow,InfoDialog,BigMeasurement,'BigMeasurement [Yes/No]','Is this measurement a Big Measurement?');
	 BackupVars(InfoDialog);
	 DoDialog(InfoDialog,' Universal measurement Parametres ',UpdateDialog);
  end;

begin
  choice:=-1;
  repeat
    NewMenu(MenuInfo);
    AddChoice(yellow,' ',yellow,MenuInfo,'Edit Parameters                              [F]',
	   'Name, NrVars, VisionCommand','P',iParam);
    for n:=1 to nrvars do begin
	   str(n:1,buf);
	   AddChoice(yellow,' ',yellow,MenuInfo,'Select Parameter Nr. '+buf+'                       ['+buf+']',
		   'Select Parameter',' ',iSParam[n]);
    end;
    AddChoice(yellow,' ',yellow,MenuInfo,'Back                                         [B]',
	   'Back','B',iBack);
    AddText(yellow,MenuInfo,
	   '',Dummy);
    for n:=1 to nrvars do begin
	   if vars[n]<>NIL then AddText(yellow,MenuInfo,vars[n]^.GetName,Dummy);
    end;
    AddText(yellow,MenuInfo,
	   '',Dummy);

    DoMenu(MenuInfo,' Create Universal Measurement Menu ',Choice);
    if Choice=iParam then ParamDialog;
    for n:=1 to nrvars do begin
      if Choice=iSParam[n] then vars[n]:=PRegDouble(MakeSelectMenu);
    end;
    DeleteMenu(MenuInfo);
  until (Choice=iBack) or (choice=0);
end;

function LoadUniMess(aname:string;Registry:PRegistry):PUniMess;
var inp:text;
    buf:string;
    h,help:PUniMess;
begin
  assign(inp,aname);
  {$I-}
  reset(inp);
  {$I+}
  help:=nil;
  if ioresult=0 then begin
    while not eof(inp) do begin
      h:=new(PUniMess,init(help,Registry));
      if not h^.LoadNextUniMess(inp) then dispose(h,done)
      else help:=h;
    end;
    LoadUniMess:=help;
    close(inp);
  end else begin
	 writeln('UniMess : couldn''t load ',aname);
         LoadUniMess:=NIL;
  end;
end;

function TUniMess.LoadNextUniMess(var inp:text):boolean;
var n:byte;
    buf:string;
    h:PUniMess;
    sbuf:string;
begin
  readln(inp,sbuf);
  ChangeString(name,sbuf);
  readln(inp,nrvars);
  for n:=1 to nrvars do begin
	 readln(inp,buf);
         if buf='NIL' then vars[n]:=NIL
	 else vars[n]:=PRegDouble(Registry^.GetRegister(buf));
	 readln(inp,start[n]);
	 readln(inp,ende[n]);
	 readln(inp,nr[n]);
  end;
  readln(inp,Repetitions);
  readln(inp,buf);
  BigMeasurement:=buf='Big';
  if not eof(inp) then begin
    readln(inp,sbuf);
    ChangeString(VisionCommand,sbuf);
    LoadNextUniMess:=true;
  end else LoadNextUniMess:=false;
end;

procedure TUniMess.Save(aname:string);
var out:text;
begin
  assign(out,aname);
  rewrite(out);
  SaveNextUniMess(out);
  close(out);
end;

procedure TUniMess.SaveNextUniMess(var out:text);
var n:byte;
    buf:string;
begin
  if next<>NIL then next^.SaveNextUniMess(out);
  writeln(out,name^);
  writeln(out,nrvars);
  for n:=1 to nrvars do begin
	 if vars[n]<>nil then writeln(out,vars[n]^.GetName)
         else writeln(out,'NIL');
	 writeln(out,start[n]);
	 writeln(out,ende[n]);
	 writeln(out,nr[n]);
  end;
  writeln(out,Repetitions);
  if BigMeasurement then writeln(out,'Big') else writeln(out,'Small');
  writeln(out,VisionCommand^);
end;

procedure TUniMess.SelectUniMessDialog(var UniMeasure:PUniMess);
Var
  iCreate,iBack,Dummy:integer;
  MenuInfo:PMenuInfo;
  Choice:integer;
  buf:string;
  endcode:integer;
  aende:PUniMess;
begin
  choice:=-1;
  repeat
    NewMenu(MenuInfo);
    NextSelectUniMessDialog(MenuInfo,aende,endcode,0);
    AddChoice(yellow,' ',yellow,MenuInfo,'Create new measurement                       [C]',
      'Create','C',iCreate);
    AddChoice(yellow,' ',yellow,MenuInfo,'Back                                         [B]',
      'Back','B',iBack);
    DoMenu(MenuInfo,' Select Universal Measurement ',Choice);
    DeleteMenu(MenuInfo);
    if Choice=iCreate then begin
      UniMeasure:=new(PUniMess,init(UniMeasure,Registry));
      UniMeasure^.SelectUniMessDialog(UniMeasure);
      exit;
    end else if Choice=endcode then begin
      aende^.SelectUniMessDialog(UniMeasure);
      exit;
    end;
    UniMessDialog(choice);
  until (Choice=iBack) or (choice=0);
end;

procedure TUniMess.NextSelectUniMessDialog(Menu:PMenuInfo;var aende:PUniMess;var endcode:integer;anr:byte);
begin
  if anr<22 then begin
	 AddChoice(yellow,' ',yellow,Menu,name^,name^,'*',mychoice);
	 if next<>NIL then next^.NextSelectUniMessDialog(Menu,aende,endcode,anr+1);
  end else begin
	 aende:=@self;
	 AddChoice(yellow,' ',yellow,Menu,'Next universal Measurements                  [N]',
		'Next','N',endcode);
  end;
end;

procedure TUniMess.UniMessDialog(code:integer);
Var
  iParams,iDoIt,iBack,iEdit,iQueue,Dummy:integer;
  MenuInfo:PMenuInfo;
  Choice:integer;

  procedure UniMessParamsDialog;
  var InfoDialog   : PDialogInfo;
      UpdateDialog : boolean;
      n:byte;
      aname,description,buf1,buf2:string;
      min,max:double;
  begin
	 NewDialog(InfoDialog);
	 for n:=1 to nrvars do begin
		if vars[n]<>nil then begin
                  vars[n]^.GetData(aname,min,max,description);
                  str(min:2:2,buf1);
                  str(max:2:2,buf2);
  	  	  AddR(yellow,InfoDialog,start[n],aname+' Start value ['+buf1+'..'+buf2+']',description,min,max,1);
		  AddR(yellow,InfoDialog,ende[n],aname+' End value ['+buf1+'..'+buf2+']',description,min,max,1);
  		  AddI(yellow,InfoDialog,nr[n],aname+' number of points',description,1,100);
                end;
	 end;
    AddI(yellow,InfoDialog,repetitions,'number of repetitions','number of repetitions',1,100);
	 BackupVars(InfoDialog);
	 DoDialog(InfoDialog,' '+name^+' measurement Parameters ',UpdateDialog);
  end;

begin
  if code=mychoice then begin
    choice:=-1;
    repeat
      NewMenu(MenuInfo);
      AddChoice(yellow,' ',yellow,MenuInfo,'Edit measurement                             [E]',
	     'Edit','E',iEdit);
      AddChoice(yellow,' ',yellow,MenuInfo,'Do measurement                               [D]',
	     'Go!','D',iDoit);
      AddChoice(yellow,' ',yellow,MenuInfo,'Queue measurement                            [Q]',
	     'Store this measurement in Queue','Q',iQueue);
      AddChoice(yellow,' ',yellow,MenuInfo,'Parameters                                   [P]',
	     'Parameter menu','P',iParams);
      AddChoice(yellow,' ',yellow,MenuInfo,'Back                                         [B]',
	     'Back','B',iBack);
      DoMenu(MenuInfo,' '+name^+' Measurement ',Choice);
      DeleteMenu(MenuInfo);
      if Choice=iDoit then DoUniMess(@self)
      else if Choice=iQueue then QueueUniMess(@self)
      else if Choice=iEdit then EditUniMess
      else if Choice=iParams then UniMessParamsDialog;
    until (Choice=iBack) or (choice=0);
  end else if next<>nil then next^.UniMessDialog(code);
end;

procedure PutLine (Pt:byte;OutStr: string);
var i : integer;
begin
  PutChar (Pt,'*');
  for i:= 1 to length(OutStr) do PutChar (Pt,OutStr[i]);
  PutChar (Pt,'#');
end;

procedure TUniMess.SendVariables(port:byte);
var buf,buf2:string;
    n:byte;
begin
  PutLine(port,name^+' Universal Measurement');
  str(nrvars,buf);
  PutLine(port,'NrParams='+buf);
  for n:=1 to nrvars do begin
    if vars[n]<>nil then begin
      str(start[n],buf);
      str(ende[n],buf2);
      buf:=buf+' to '+buf2;
      str(nr[n],buf2);
      buf:=buf+' in '+buf2+' steps';
      PutLine(port,vars[n]^.GetName+' '+buf)
    end;
  end;
  str(Repetitions,buf);
  PutLine(port,buf);
  if BigMeasurement then Putline(port,'Big measurement')
  else PutLine(Port,'Small measurement');
  Putline(port,VisionCommand^);
end;

function TuniMess.GetUniMessFromName(aname:string):PUniMess;
begin
  if name^=aname then GetUniMessFromName:=@self
  else if next<>nil then GetUniMessFromName:=next^.GetUniMessFromName(aname)
  else GetUniMessFromName:=nil;
end;

end.